var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", {value: true});
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[Object.keys(cb)[0]])((mod = {exports: {}}).exports, mod), mod.exports;
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, {get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable});
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? {get: () => module2.default, enumerable: true} : {value: module2, enumerable: true})), module2);
};

// node_modules/@cirru/parser.ts/lib/types.js
var require_types = __commonJS({
  "node_modules/@cirru/parser.ts/lib/types.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", {value: true});
    exports2.ELexControl = exports2.ELexState = void 0;
    var ELexState;
    (function(ELexState2) {
      ELexState2[ELexState2["space"] = 0] = "space";
      ELexState2[ELexState2["token"] = 1] = "token";
      ELexState2[ELexState2["escape"] = 2] = "escape";
      ELexState2[ELexState2["indent"] = 3] = "indent";
      ELexState2[ELexState2["string"] = 4] = "string";
    })(ELexState = exports2.ELexState || (exports2.ELexState = {}));
    var ELexControl;
    (function(ELexControl2) {
      ELexControl2[ELexControl2["open"] = -1e3] = "open";
      ELexControl2[ELexControl2["close"] = -2e3] = "close";
    })(ELexControl = exports2.ELexControl || (exports2.ELexControl = {}));
  }
});

// node_modules/@cirru/parser.ts/lib/tree.js
var require_tree = __commonJS({
  "node_modules/@cirru/parser.ts/lib/tree.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", {value: true});
    exports2.resolveDollar = exports2.resolveComma = exports2.isOdd = exports2.isNumber = exports2.isString = exports2.notEmpty = exports2.isEmpty = exports2.isArray = exports2.pushToList = void 0;
    var pushToList = (acc, xs, ys, zs) => {
      let result = acc;
      xs.forEach((x) => {
        result.push(x);
      });
      if (ys != null) {
        ys.forEach((y) => {
          result.push(y);
        });
      }
      if (zs != null) {
        zs.forEach((y) => {
          result.push(y);
        });
      }
      return result;
    };
    exports2.pushToList = pushToList;
    exports2.isArray = Array.isArray;
    var isEmpty = (xs) => xs.length === 0;
    exports2.isEmpty = isEmpty;
    var notEmpty = (xs) => xs.length > 0;
    exports2.notEmpty = notEmpty;
    var isString = (x) => typeof x === "string";
    exports2.isString = isString;
    var isNumber = (x) => typeof x === "number";
    exports2.isNumber = isNumber;
    var isOdd = (x) => x % 2 === 1;
    exports2.isOdd = isOdd;
    var resolveComma = (xs) => {
      if (exports2.isEmpty(xs)) {
        return [];
      } else {
        return commaHelper(xs);
      }
    };
    exports2.resolveComma = resolveComma;
    var commaHelper = (intialAfter) => {
      let before = [];
      let after = intialAfter;
      let pointer = 0;
      while (true) {
        if (pointer >= after.length) {
          return before;
        }
        let cursor = after[pointer];
        if (exports2.isArray(cursor) && exports2.notEmpty(cursor)) {
          let head2 = cursor[0];
          if (exports2.isArray(head2)) {
            before.push(exports2.resolveComma(cursor));
            pointer += 1;
          } else if (head2 === ",") {
            exports2.pushToList(before, exports2.resolveComma(cursor.slice(1)));
            pointer += 1;
          } else {
            before.push(exports2.resolveComma(cursor));
            pointer += 1;
          }
        } else {
          before.push(cursor);
          pointer += 1;
        }
      }
    };
    var resolveDollar = (xs) => {
      if (exports2.isEmpty(xs)) {
        return [];
      } else {
        return dollarHelper(xs);
      }
    };
    exports2.resolveDollar = resolveDollar;
    var dollarHelper = (initialAfter) => {
      let before = [];
      let after = initialAfter;
      let pointer = 0;
      while (true) {
        if (pointer >= after.length) {
          return before;
        } else {
          let cursor = after[pointer];
          if (exports2.isArray(cursor)) {
            before.push(exports2.resolveDollar(cursor));
            pointer += 1;
          } else if (cursor === "$") {
            before.push(exports2.resolveDollar(after.slice(pointer + 1)));
            pointer = after.length;
          } else {
            before.push(cursor);
            pointer += 1;
          }
        }
      }
    };
  }
});

// node_modules/@cirru/parser.ts/lib/index.js
var require_lib = __commonJS({
  "node_modules/@cirru/parser.ts/lib/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", {value: true});
    exports2.parse = void 0;
    var types_1 = require_types();
    var tree_1 = require_tree();
    var graspeExprs = (pullToken) => {
      let acc = [];
      let pointer = acc;
      let pointerStack = [];
      while (true) {
        let cursor = pullToken();
        switch (cursor) {
          case types_1.ELexControl.close:
            if (pointerStack.length === 0) {
              return pointer;
            }
            let collected = pointer;
            pointer = pointerStack.pop();
            pointer.push(collected);
            break;
          case types_1.ELexControl.open:
            pointerStack.push(pointer);
            pointer = [];
            break;
          case types_1.ELexControl.close:
            throw new Error("Unexpected close token");
          default:
            if (tree_1.isString(cursor)) {
              pointer.push(cursor);
              break;
            } else {
              console.log(JSON.stringify(cursor));
              throw new Error("Unknown cursor");
            }
        }
      }
    };
    var buildExprs = (pullToken) => {
      let acc = [];
      while (true) {
        let chunk = pullToken();
        if (chunk === types_1.ELexControl.open) {
          let expr = graspeExprs(pullToken);
          acc.push(expr);
          continue;
        } else if (chunk == null) {
          return acc;
        } else if (chunk === types_1.ELexControl.close) {
          throw new Error(`Unexpected ")"`);
        } else {
          throw new Error(`Unexpected chunk ${JSON.stringify(chunk)}`);
        }
      }
    };
    var parseIndentation = (buffer) => {
      let size = buffer.length;
      if (tree_1.isOdd(size)) {
        throw new Error(`Invalid indentation size ${size}`);
      }
      return size / 2;
    };
    var lex = (initialCode) => {
      let acc = [];
      let state = types_1.ELexState.indent;
      let buffer = "";
      let code = initialCode;
      let pointer = 0;
      while (true) {
        if (pointer >= code.length) {
          switch (state) {
            case types_1.ELexState.space:
              return acc;
            case types_1.ELexState.token:
              acc.push(buffer);
              return acc;
              break;
            case types_1.ELexState.escape:
              throw new Error("Should not be escape");
            case types_1.ELexState.indent:
              return acc;
            case types_1.ELexState.string:
              throw new Error("Should not be string");
            default:
              console.log(state);
              throw new Error("Unkown state");
          }
        } else {
          let c = code[pointer];
          pointer += 1;
          switch (state) {
            case types_1.ELexState.space:
              switch (c) {
                case " ":
                  [acc, state, buffer] = [acc, types_1.ELexState.space, ""];
                  break;
                case "\n":
                  [acc, state, buffer] = [acc, types_1.ELexState.indent, ""];
                  break;
                case "(":
                  acc.push(types_1.ELexControl.open);
                  [state, buffer] = [types_1.ELexState.space, ""];
                  break;
                case ")":
                  acc.push(types_1.ELexControl.close);
                  [state, buffer] = [types_1.ELexState.space, ""];
                  break;
                case '"':
                  [acc, state, buffer] = [acc, types_1.ELexState.string, ""];
                  break;
                default:
                  [acc, state, buffer] = [acc, types_1.ELexState.token, c];
                  break;
              }
              break;
            case types_1.ELexState.token:
              switch (c) {
                case " ":
                  acc.push(buffer);
                  [state, buffer] = [types_1.ELexState.space, ""];
                  break;
                case '"':
                  acc.push(buffer);
                  [state, buffer] = [types_1.ELexState.string, ""];
                  break;
                case "\n":
                  acc.push(buffer);
                  [state, buffer] = [types_1.ELexState.indent, ""];
                  break;
                case "(":
                  acc.push(buffer, types_1.ELexControl.open);
                  [state, buffer] = [types_1.ELexState.space, ""];
                  break;
                case ")":
                  acc.push(buffer, types_1.ELexControl.close);
                  [state, buffer] = [types_1.ELexState.space, ""];
                  break;
                default:
                  [acc, state, buffer] = [acc, types_1.ELexState.token, `${buffer}${c}`];
                  break;
              }
              break;
            case types_1.ELexState.string:
              switch (c) {
                case '"':
                  acc.push(buffer);
                  [state, buffer] = [types_1.ELexState.space, ""];
                  break;
                case "\\":
                  [acc, state, buffer] = [acc, types_1.ELexState.escape, buffer];
                  break;
                case "\n":
                  throw new Error("Expected newline in string");
                default:
                  [acc, state, buffer] = [acc, types_1.ELexState.string, `${buffer}${c}`];
                  break;
              }
              break;
            case types_1.ELexState.escape:
              switch (c) {
                case '"':
                  [acc, state, buffer] = [acc, types_1.ELexState.string, `${buffer}"`];
                  break;
                case "'":
                  [acc, state, buffer] = [acc, types_1.ELexState.string, `${buffer}'`];
                  break;
                case "t":
                  [acc, state, buffer] = [acc, types_1.ELexState.string, `${buffer}	`];
                  break;
                case "n":
                  [acc, state, buffer] = [acc, types_1.ELexState.string, `${buffer}
`];
                  break;
                case "\\":
                  [acc, state, buffer] = [acc, types_1.ELexState.string, `${buffer}\\`];
                  break;
                default:
                  throw new Error(`Unknown ${c} in escape`);
              }
              break;
            case types_1.ELexState.indent:
              switch (c) {
                case " ":
                  [acc, state, buffer] = [acc, types_1.ELexState.indent, `${buffer}${c}`];
                  break;
                case "\n":
                  [acc, state, buffer] = [acc, types_1.ELexState.indent, ""];
                  break;
                case '"':
                  acc.push(parseIndentation(buffer));
                  [state, buffer] = [types_1.ELexState.string, ""];
                  break;
                case "(":
                  acc.push(parseIndentation(buffer), types_1.ELexControl.open);
                  [state, buffer] = [types_1.ELexState.space, ""];
                  break;
                default:
                  acc.push(parseIndentation(buffer));
                  [state, buffer] = [types_1.ELexState.token, c];
                  break;
              }
              break;
            default:
              console.log("Unknown state:", c);
              return acc;
          }
        }
      }
      return acc;
    };
    var repeat = (times, x) => {
      let xs = [];
      for (let i = 1; i <= times; i++) {
        xs.push(x);
      }
      return xs;
    };
    var resolveIndentations = (initialTokens) => {
      let acc = [];
      let level = 0;
      let tokens = initialTokens;
      let pointer = 0;
      while (true) {
        if (pointer >= tokens.length) {
          if (tree_1.isEmpty(acc)) {
            return [];
          } else {
            acc.unshift(types_1.ELexControl.open);
            tree_1.pushToList(acc, repeat(level, types_1.ELexControl.close), [types_1.ELexControl.close]);
            return acc;
          }
        } else {
          let cursor = tokens[pointer];
          if (typeof cursor === "string") {
            acc.push(cursor);
            pointer += 1;
            [level] = [level];
          } else if (cursor === types_1.ELexControl.open || cursor === types_1.ELexControl.close) {
            acc.push(cursor);
            pointer += 1;
            [level] = [level];
          } else if (typeof cursor === "number") {
            if (cursor > level) {
              let delta = cursor - level;
              tree_1.pushToList(acc, repeat(delta, types_1.ELexControl.open));
              pointer += 1;
              [level] = [cursor];
            } else if (cursor < level) {
              let delta = level - cursor;
              tree_1.pushToList(acc, repeat(delta, types_1.ELexControl.close), [types_1.ELexControl.close, types_1.ELexControl.open]);
              pointer += 1;
              [level] = [cursor];
            } else {
              if (tree_1.isEmpty(acc)) {
                acc = [];
              } else {
                acc.push(types_1.ELexControl.close, types_1.ELexControl.open);
              }
              pointer += 1;
              [level] = [level];
            }
          } else {
            console.log(cursor);
            throw new Error("Unknown token");
          }
        }
      }
    };
    var parse2 = (code) => {
      let tokens = resolveIndentations(lex(code));
      let pointer = 0;
      let pullToken = () => {
        let c = tokens[pointer];
        pointer += 1;
        return c;
      };
      return tree_1.resolveComma(tree_1.resolveDollar(buildExprs(pullToken)));
    };
    exports2.parse = parse2;
  }
});

// node_modules/@cirru/writer.ts/lib/types.js
var require_types2 = __commonJS({
  "node_modules/@cirru/writer.ts/lib/types.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", {value: true});
    exports2.isSimpleExpr = exports2.WriterNodeKind = void 0;
    var WriterNodeKind;
    (function(WriterNodeKind2) {
      WriterNodeKind2["writerKindNil"] = "nil";
      WriterNodeKind2["writerKindLeaf"] = "leaf";
      WriterNodeKind2["writerKindSimpleExpr"] = "simple";
      WriterNodeKind2["writerKindBoxedExpr"] = "boxed";
      WriterNodeKind2["writerKindExpr"] = "expr";
    })(WriterNodeKind = exports2.WriterNodeKind || (exports2.WriterNodeKind = {}));
    function isSimpleExpr(xs) {
      if (Array.isArray(xs)) {
        for (let x of xs) {
          if (typeof x !== "string") {
            return false;
          }
        }
        return true;
      } else {
        return false;
      }
    }
    exports2.isSimpleExpr = isSimpleExpr;
  }
});

// node_modules/@cirru/writer.ts/lib/str-util.js
var require_str_util = __commonJS({
  "node_modules/@cirru/writer.ts/lib/str-util.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", {value: true});
    exports2.isALetter = exports2.isADigit = void 0;
    function isADigit(c) {
      let n = c.charCodeAt(0);
      return n >= 48 && n <= 57;
    }
    exports2.isADigit = isADigit;
    function isALetter(c) {
      let n = c.charCodeAt(0);
      if (n >= 65 && n <= 90) {
        return true;
      }
      if (n >= 97 && n <= 122) {
        return true;
      }
      return false;
    }
    exports2.isALetter = isALetter;
  }
});

// node_modules/@cirru/writer.ts/lib/writer.js
var require_writer = __commonJS({
  "node_modules/@cirru/writer.ts/lib/writer.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", {value: true});
    exports2.writeCirruCode = void 0;
    var types_1 = require_types2();
    var str_util_1 = require_str_util();
    var allowedChars = "-~_@#$&%!?^*=+|\\/<>[]{}.,:;'";
    function isBoxed(xs) {
      if (Array.isArray(xs)) {
        for (let x of xs) {
          if (typeof x === "string") {
            return false;
          }
        }
        return true;
      } else {
        return false;
      }
    }
    function isSimpleChar(x) {
      return str_util_1.isADigit(x) || str_util_1.isALetter(x);
    }
    function isCharAllowed(x) {
      if (isSimpleChar(x)) {
        return true;
      }
      if (allowedChars.includes(x)) {
        return true;
      }
      return false;
    }
    var charClose = ")";
    var charOpen = "(";
    var charSpace = " ";
    function generateLeaf(xs) {
      if (Array.isArray(xs)) {
        if (xs.length === 0) {
          return "()";
        } else {
          throw new Error("Unexpect list in leaf");
        }
      } else {
        let allAllowed = true;
        for (let x of xs) {
          if (!isCharAllowed(x)) {
            allAllowed = false;
            break;
          }
        }
        if (allAllowed) {
          return xs;
        } else {
          return JSON.stringify(xs);
        }
      }
    }
    function generateInlineExpr(xs) {
      let result = charOpen;
      if (Array.isArray(xs)) {
        for (let idx = 0; idx < xs.length; idx++) {
          let x = xs[idx];
          if (idx > 0) {
            result = result + charSpace;
          }
          let childForm = typeof x === "string" ? generateLeaf(x) : generateInlineExpr(x);
          result = result + childForm;
        }
      } else {
        throw new Error("Unexpect token in gen list");
      }
      return result + charClose;
    }
    function renderSpaces(n) {
      let result = "";
      for (let i = 0; i < n; i++) {
        result = result + "  ";
      }
      return result;
    }
    function renderNewline(n) {
      return "\n" + renderSpaces(n);
    }
    function getNodeKind(cursor) {
      if (typeof cursor === "string") {
        return types_1.WriterNodeKind.writerKindLeaf;
      } else {
        if (cursor.length === 0) {
          return types_1.WriterNodeKind.writerKindLeaf;
        } else if (types_1.isSimpleExpr(cursor)) {
          return types_1.WriterNodeKind.writerKindSimpleExpr;
        } else if (isBoxed(cursor)) {
          return types_1.WriterNodeKind.writerKindBoxedExpr;
        } else {
          return types_1.WriterNodeKind.writerKindExpr;
        }
      }
    }
    function generateTree(xs, insistHead, options, baseLevel, inTail) {
      let prevKind = types_1.WriterNodeKind.writerKindNil;
      let bendedSize = 0;
      let level = baseLevel;
      let result = "";
      if (typeof xs === "string") {
        throw new Error("expects a list");
      }
      for (let idx = 0; idx < xs.length; idx++) {
        let cursor = xs[idx];
        let kind = getNodeKind(cursor);
        let nextLevel = level + 1;
        let childInsistHead = prevKind === types_1.WriterNodeKind.writerKindBoxedExpr || prevKind === types_1.WriterNodeKind.writerKindExpr;
        let atTail = idx != 0 && !inTail && prevKind === types_1.WriterNodeKind.writerKindLeaf && idx === xs.length - 1 && Array.isArray(cursor);
        let child;
        if (atTail) {
          if (typeof cursor === "string") {
            throw new Error("Expected list");
          }
          if (cursor.length === 0) {
            child = "$";
          } else {
            child = "$ " + generateTree(cursor, false, options, level, atTail);
          }
        } else if (kind === types_1.WriterNodeKind.writerKindLeaf) {
          child = generateLeaf(cursor);
        } else if (idx === 0 && insistHead) {
          child = generateInlineExpr(cursor);
        } else if (kind === types_1.WriterNodeKind.writerKindSimpleExpr) {
          if (prevKind === types_1.WriterNodeKind.writerKindLeaf) {
            child = generateInlineExpr(cursor);
          } else if (options.useInline && prevKind === types_1.WriterNodeKind.writerKindSimpleExpr) {
            child = " " + generateInlineExpr(cursor);
          } else {
            child = renderNewline(nextLevel) + generateTree(cursor, childInsistHead, options, nextLevel, false);
          }
        } else if (kind === types_1.WriterNodeKind.writerKindExpr) {
          let content = generateTree(cursor, childInsistHead, options, nextLevel, false);
          if (content.startsWith("\n")) {
            child = content;
          } else {
            child = renderNewline(nextLevel) + content;
          }
        } else if (kind === types_1.WriterNodeKind.writerKindBoxedExpr) {
          let content = generateTree(cursor, childInsistHead, options, nextLevel, false);
          if (prevKind === types_1.WriterNodeKind.writerKindNil || prevKind === types_1.WriterNodeKind.writerKindLeaf || prevKind === types_1.WriterNodeKind.writerKindSimpleExpr) {
            child = content;
          } else {
            child = renderNewline(nextLevel) + content;
          }
        } else {
          throw new Error("Unpected condition");
        }
        let bended = kind === types_1.WriterNodeKind.writerKindLeaf && (prevKind === types_1.WriterNodeKind.writerKindBoxedExpr || prevKind === types_1.WriterNodeKind.writerKindExpr);
        let chunk;
        if (atTail) {
          chunk = " " + child;
        } else if (prevKind === types_1.WriterNodeKind.writerKindLeaf && kind === types_1.WriterNodeKind.writerKindLeaf) {
          chunk = " " + child;
        } else if (prevKind === types_1.WriterNodeKind.writerKindLeaf && kind === types_1.WriterNodeKind.writerKindSimpleExpr) {
          chunk = " " + child;
        } else if (prevKind === types_1.WriterNodeKind.writerKindSimpleExpr && kind === types_1.WriterNodeKind.writerKindLeaf) {
          chunk = " " + child;
        } else if (bended) {
          chunk = renderNewline(nextLevel) + ", " + child;
        } else {
          chunk = child;
        }
        result = result + chunk;
        if (kind === types_1.WriterNodeKind.writerKindSimpleExpr) {
          if (idx === 0 && insistHead) {
            prevKind = types_1.WriterNodeKind.writerKindSimpleExpr;
          } else if (options.useInline) {
            if (prevKind === types_1.WriterNodeKind.writerKindLeaf || prevKind === types_1.WriterNodeKind.writerKindSimpleExpr) {
              prevKind = types_1.WriterNodeKind.writerKindSimpleExpr;
            } else {
              prevKind = types_1.WriterNodeKind.writerKindExpr;
            }
          } else {
            if (prevKind === types_1.WriterNodeKind.writerKindLeaf) {
              prevKind = types_1.WriterNodeKind.writerKindSimpleExpr;
            } else {
              prevKind = types_1.WriterNodeKind.writerKindExpr;
            }
          }
        } else {
          prevKind = kind;
        }
        if (bended) {
          bendedSize = bendedSize + 1;
          level = level + 1;
        }
      }
      return result;
    }
    function generateStatements(xs, options) {
      if (typeof xs === "string") {
        throw new Error("Unexpected item");
      }
      return xs.map((x) => {
        return "\n" + generateTree(x, true, options, 0, false) + "\n";
      }).join("");
    }
    function writeCirruCode2(xs, options = {useInline: false}) {
      return generateStatements(xs, options);
    }
    exports2.writeCirruCode = writeCirruCode2;
  }
});

// node_modules/color-name/index.js
var require_color_name = __commonJS({
  "node_modules/color-name/index.js"(exports2, module2) {
    "use strict";
    module2.exports = {
      "aliceblue": [240, 248, 255],
      "antiquewhite": [250, 235, 215],
      "aqua": [0, 255, 255],
      "aquamarine": [127, 255, 212],
      "azure": [240, 255, 255],
      "beige": [245, 245, 220],
      "bisque": [255, 228, 196],
      "black": [0, 0, 0],
      "blanchedalmond": [255, 235, 205],
      "blue": [0, 0, 255],
      "blueviolet": [138, 43, 226],
      "brown": [165, 42, 42],
      "burlywood": [222, 184, 135],
      "cadetblue": [95, 158, 160],
      "chartreuse": [127, 255, 0],
      "chocolate": [210, 105, 30],
      "coral": [255, 127, 80],
      "cornflowerblue": [100, 149, 237],
      "cornsilk": [255, 248, 220],
      "crimson": [220, 20, 60],
      "cyan": [0, 255, 255],
      "darkblue": [0, 0, 139],
      "darkcyan": [0, 139, 139],
      "darkgoldenrod": [184, 134, 11],
      "darkgray": [169, 169, 169],
      "darkgreen": [0, 100, 0],
      "darkgrey": [169, 169, 169],
      "darkkhaki": [189, 183, 107],
      "darkmagenta": [139, 0, 139],
      "darkolivegreen": [85, 107, 47],
      "darkorange": [255, 140, 0],
      "darkorchid": [153, 50, 204],
      "darkred": [139, 0, 0],
      "darksalmon": [233, 150, 122],
      "darkseagreen": [143, 188, 143],
      "darkslateblue": [72, 61, 139],
      "darkslategray": [47, 79, 79],
      "darkslategrey": [47, 79, 79],
      "darkturquoise": [0, 206, 209],
      "darkviolet": [148, 0, 211],
      "deeppink": [255, 20, 147],
      "deepskyblue": [0, 191, 255],
      "dimgray": [105, 105, 105],
      "dimgrey": [105, 105, 105],
      "dodgerblue": [30, 144, 255],
      "firebrick": [178, 34, 34],
      "floralwhite": [255, 250, 240],
      "forestgreen": [34, 139, 34],
      "fuchsia": [255, 0, 255],
      "gainsboro": [220, 220, 220],
      "ghostwhite": [248, 248, 255],
      "gold": [255, 215, 0],
      "goldenrod": [218, 165, 32],
      "gray": [128, 128, 128],
      "green": [0, 128, 0],
      "greenyellow": [173, 255, 47],
      "grey": [128, 128, 128],
      "honeydew": [240, 255, 240],
      "hotpink": [255, 105, 180],
      "indianred": [205, 92, 92],
      "indigo": [75, 0, 130],
      "ivory": [255, 255, 240],
      "khaki": [240, 230, 140],
      "lavender": [230, 230, 250],
      "lavenderblush": [255, 240, 245],
      "lawngreen": [124, 252, 0],
      "lemonchiffon": [255, 250, 205],
      "lightblue": [173, 216, 230],
      "lightcoral": [240, 128, 128],
      "lightcyan": [224, 255, 255],
      "lightgoldenrodyellow": [250, 250, 210],
      "lightgray": [211, 211, 211],
      "lightgreen": [144, 238, 144],
      "lightgrey": [211, 211, 211],
      "lightpink": [255, 182, 193],
      "lightsalmon": [255, 160, 122],
      "lightseagreen": [32, 178, 170],
      "lightskyblue": [135, 206, 250],
      "lightslategray": [119, 136, 153],
      "lightslategrey": [119, 136, 153],
      "lightsteelblue": [176, 196, 222],
      "lightyellow": [255, 255, 224],
      "lime": [0, 255, 0],
      "limegreen": [50, 205, 50],
      "linen": [250, 240, 230],
      "magenta": [255, 0, 255],
      "maroon": [128, 0, 0],
      "mediumaquamarine": [102, 205, 170],
      "mediumblue": [0, 0, 205],
      "mediumorchid": [186, 85, 211],
      "mediumpurple": [147, 112, 219],
      "mediumseagreen": [60, 179, 113],
      "mediumslateblue": [123, 104, 238],
      "mediumspringgreen": [0, 250, 154],
      "mediumturquoise": [72, 209, 204],
      "mediumvioletred": [199, 21, 133],
      "midnightblue": [25, 25, 112],
      "mintcream": [245, 255, 250],
      "mistyrose": [255, 228, 225],
      "moccasin": [255, 228, 181],
      "navajowhite": [255, 222, 173],
      "navy": [0, 0, 128],
      "oldlace": [253, 245, 230],
      "olive": [128, 128, 0],
      "olivedrab": [107, 142, 35],
      "orange": [255, 165, 0],
      "orangered": [255, 69, 0],
      "orchid": [218, 112, 214],
      "palegoldenrod": [238, 232, 170],
      "palegreen": [152, 251, 152],
      "paleturquoise": [175, 238, 238],
      "palevioletred": [219, 112, 147],
      "papayawhip": [255, 239, 213],
      "peachpuff": [255, 218, 185],
      "peru": [205, 133, 63],
      "pink": [255, 192, 203],
      "plum": [221, 160, 221],
      "powderblue": [176, 224, 230],
      "purple": [128, 0, 128],
      "rebeccapurple": [102, 51, 153],
      "red": [255, 0, 0],
      "rosybrown": [188, 143, 143],
      "royalblue": [65, 105, 225],
      "saddlebrown": [139, 69, 19],
      "salmon": [250, 128, 114],
      "sandybrown": [244, 164, 96],
      "seagreen": [46, 139, 87],
      "seashell": [255, 245, 238],
      "sienna": [160, 82, 45],
      "silver": [192, 192, 192],
      "skyblue": [135, 206, 235],
      "slateblue": [106, 90, 205],
      "slategray": [112, 128, 144],
      "slategrey": [112, 128, 144],
      "snow": [255, 250, 250],
      "springgreen": [0, 255, 127],
      "steelblue": [70, 130, 180],
      "tan": [210, 180, 140],
      "teal": [0, 128, 128],
      "thistle": [216, 191, 216],
      "tomato": [255, 99, 71],
      "turquoise": [64, 224, 208],
      "violet": [238, 130, 238],
      "wheat": [245, 222, 179],
      "white": [255, 255, 255],
      "whitesmoke": [245, 245, 245],
      "yellow": [255, 255, 0],
      "yellowgreen": [154, 205, 50]
    };
  }
});

// node_modules/color-convert/conversions.js
var require_conversions = __commonJS({
  "node_modules/color-convert/conversions.js"(exports2, module2) {
    var cssKeywords = require_color_name();
    var reverseKeywords = {};
    for (const key of Object.keys(cssKeywords)) {
      reverseKeywords[cssKeywords[key]] = key;
    }
    var convert = {
      rgb: {channels: 3, labels: "rgb"},
      hsl: {channels: 3, labels: "hsl"},
      hsv: {channels: 3, labels: "hsv"},
      hwb: {channels: 3, labels: "hwb"},
      cmyk: {channels: 4, labels: "cmyk"},
      xyz: {channels: 3, labels: "xyz"},
      lab: {channels: 3, labels: "lab"},
      lch: {channels: 3, labels: "lch"},
      hex: {channels: 1, labels: ["hex"]},
      keyword: {channels: 1, labels: ["keyword"]},
      ansi16: {channels: 1, labels: ["ansi16"]},
      ansi256: {channels: 1, labels: ["ansi256"]},
      hcg: {channels: 3, labels: ["h", "c", "g"]},
      apple: {channels: 3, labels: ["r16", "g16", "b16"]},
      gray: {channels: 1, labels: ["gray"]}
    };
    module2.exports = convert;
    for (const model of Object.keys(convert)) {
      if (!("channels" in convert[model])) {
        throw new Error("missing channels property: " + model);
      }
      if (!("labels" in convert[model])) {
        throw new Error("missing channel labels property: " + model);
      }
      if (convert[model].labels.length !== convert[model].channels) {
        throw new Error("channel and label counts mismatch: " + model);
      }
      const {channels, labels} = convert[model];
      delete convert[model].channels;
      delete convert[model].labels;
      Object.defineProperty(convert[model], "channels", {value: channels});
      Object.defineProperty(convert[model], "labels", {value: labels});
    }
    convert.rgb.hsl = function(rgb) {
      const r = rgb[0] / 255;
      const g = rgb[1] / 255;
      const b = rgb[2] / 255;
      const min2 = Math.min(r, g, b);
      const max2 = Math.max(r, g, b);
      const delta = max2 - min2;
      let h;
      let s;
      if (max2 === min2) {
        h = 0;
      } else if (r === max2) {
        h = (g - b) / delta;
      } else if (g === max2) {
        h = 2 + (b - r) / delta;
      } else if (b === max2) {
        h = 4 + (r - g) / delta;
      }
      h = Math.min(h * 60, 360);
      if (h < 0) {
        h += 360;
      }
      const l = (min2 + max2) / 2;
      if (max2 === min2) {
        s = 0;
      } else if (l <= 0.5) {
        s = delta / (max2 + min2);
      } else {
        s = delta / (2 - max2 - min2);
      }
      return [h, s * 100, l * 100];
    };
    convert.rgb.hsv = function(rgb) {
      let rdif;
      let gdif;
      let bdif;
      let h;
      let s;
      const r = rgb[0] / 255;
      const g = rgb[1] / 255;
      const b = rgb[2] / 255;
      const v = Math.max(r, g, b);
      const diff = v - Math.min(r, g, b);
      const diffc = function(c) {
        return (v - c) / 6 / diff + 1 / 2;
      };
      if (diff === 0) {
        h = 0;
        s = 0;
      } else {
        s = diff / v;
        rdif = diffc(r);
        gdif = diffc(g);
        bdif = diffc(b);
        if (r === v) {
          h = bdif - gdif;
        } else if (g === v) {
          h = 1 / 3 + rdif - bdif;
        } else if (b === v) {
          h = 2 / 3 + gdif - rdif;
        }
        if (h < 0) {
          h += 1;
        } else if (h > 1) {
          h -= 1;
        }
      }
      return [
        h * 360,
        s * 100,
        v * 100
      ];
    };
    convert.rgb.hwb = function(rgb) {
      const r = rgb[0];
      const g = rgb[1];
      let b = rgb[2];
      const h = convert.rgb.hsl(rgb)[0];
      const w = 1 / 255 * Math.min(r, Math.min(g, b));
      b = 1 - 1 / 255 * Math.max(r, Math.max(g, b));
      return [h, w * 100, b * 100];
    };
    convert.rgb.cmyk = function(rgb) {
      const r = rgb[0] / 255;
      const g = rgb[1] / 255;
      const b = rgb[2] / 255;
      const k = Math.min(1 - r, 1 - g, 1 - b);
      const c = (1 - r - k) / (1 - k) || 0;
      const m = (1 - g - k) / (1 - k) || 0;
      const y = (1 - b - k) / (1 - k) || 0;
      return [c * 100, m * 100, y * 100, k * 100];
    };
    function comparativeDistance(x, y) {
      return (x[0] - y[0]) ** 2 + (x[1] - y[1]) ** 2 + (x[2] - y[2]) ** 2;
    }
    convert.rgb.keyword = function(rgb) {
      const reversed = reverseKeywords[rgb];
      if (reversed) {
        return reversed;
      }
      let currentClosestDistance = Infinity;
      let currentClosestKeyword;
      for (const keyword of Object.keys(cssKeywords)) {
        const value = cssKeywords[keyword];
        const distance = comparativeDistance(rgb, value);
        if (distance < currentClosestDistance) {
          currentClosestDistance = distance;
          currentClosestKeyword = keyword;
        }
      }
      return currentClosestKeyword;
    };
    convert.keyword.rgb = function(keyword) {
      return cssKeywords[keyword];
    };
    convert.rgb.xyz = function(rgb) {
      let r = rgb[0] / 255;
      let g = rgb[1] / 255;
      let b = rgb[2] / 255;
      r = r > 0.04045 ? ((r + 0.055) / 1.055) ** 2.4 : r / 12.92;
      g = g > 0.04045 ? ((g + 0.055) / 1.055) ** 2.4 : g / 12.92;
      b = b > 0.04045 ? ((b + 0.055) / 1.055) ** 2.4 : b / 12.92;
      const x = r * 0.4124 + g * 0.3576 + b * 0.1805;
      const y = r * 0.2126 + g * 0.7152 + b * 0.0722;
      const z = r * 0.0193 + g * 0.1192 + b * 0.9505;
      return [x * 100, y * 100, z * 100];
    };
    convert.rgb.lab = function(rgb) {
      const xyz = convert.rgb.xyz(rgb);
      let x = xyz[0];
      let y = xyz[1];
      let z = xyz[2];
      x /= 95.047;
      y /= 100;
      z /= 108.883;
      x = x > 8856e-6 ? x ** (1 / 3) : 7.787 * x + 16 / 116;
      y = y > 8856e-6 ? y ** (1 / 3) : 7.787 * y + 16 / 116;
      z = z > 8856e-6 ? z ** (1 / 3) : 7.787 * z + 16 / 116;
      const l = 116 * y - 16;
      const a2 = 500 * (x - y);
      const b = 200 * (y - z);
      return [l, a2, b];
    };
    convert.hsl.rgb = function(hsl2) {
      const h = hsl2[0] / 360;
      const s = hsl2[1] / 100;
      const l = hsl2[2] / 100;
      let t2;
      let t3;
      let val;
      if (s === 0) {
        val = l * 255;
        return [val, val, val];
      }
      if (l < 0.5) {
        t2 = l * (1 + s);
      } else {
        t2 = l + s - l * s;
      }
      const t1 = 2 * l - t2;
      const rgb = [0, 0, 0];
      for (let i = 0; i < 3; i++) {
        t3 = h + 1 / 3 * -(i - 1);
        if (t3 < 0) {
          t3++;
        }
        if (t3 > 1) {
          t3--;
        }
        if (6 * t3 < 1) {
          val = t1 + (t2 - t1) * 6 * t3;
        } else if (2 * t3 < 1) {
          val = t2;
        } else if (3 * t3 < 2) {
          val = t1 + (t2 - t1) * (2 / 3 - t3) * 6;
        } else {
          val = t1;
        }
        rgb[i] = val * 255;
      }
      return rgb;
    };
    convert.hsl.hsv = function(hsl2) {
      const h = hsl2[0];
      let s = hsl2[1] / 100;
      let l = hsl2[2] / 100;
      let smin = s;
      const lmin = Math.max(l, 0.01);
      l *= 2;
      s *= l <= 1 ? l : 2 - l;
      smin *= lmin <= 1 ? lmin : 2 - lmin;
      const v = (l + s) / 2;
      const sv = l === 0 ? 2 * smin / (lmin + smin) : 2 * s / (l + s);
      return [h, sv * 100, v * 100];
    };
    convert.hsv.rgb = function(hsv) {
      const h = hsv[0] / 60;
      const s = hsv[1] / 100;
      let v = hsv[2] / 100;
      const hi = Math.floor(h) % 6;
      const f = h - Math.floor(h);
      const p = 255 * v * (1 - s);
      const q = 255 * v * (1 - s * f);
      const t = 255 * v * (1 - s * (1 - f));
      v *= 255;
      switch (hi) {
        case 0:
          return [v, t, p];
        case 1:
          return [q, v, p];
        case 2:
          return [p, v, t];
        case 3:
          return [p, q, v];
        case 4:
          return [t, p, v];
        case 5:
          return [v, p, q];
      }
    };
    convert.hsv.hsl = function(hsv) {
      const h = hsv[0];
      const s = hsv[1] / 100;
      const v = hsv[2] / 100;
      const vmin = Math.max(v, 0.01);
      let sl;
      let l;
      l = (2 - s) * v;
      const lmin = (2 - s) * vmin;
      sl = s * vmin;
      sl /= lmin <= 1 ? lmin : 2 - lmin;
      sl = sl || 0;
      l /= 2;
      return [h, sl * 100, l * 100];
    };
    convert.hwb.rgb = function(hwb) {
      const h = hwb[0] / 360;
      let wh = hwb[1] / 100;
      let bl = hwb[2] / 100;
      const ratio = wh + bl;
      let f;
      if (ratio > 1) {
        wh /= ratio;
        bl /= ratio;
      }
      const i = Math.floor(6 * h);
      const v = 1 - bl;
      f = 6 * h - i;
      if ((i & 1) !== 0) {
        f = 1 - f;
      }
      const n = wh + f * (v - wh);
      let r;
      let g;
      let b;
      switch (i) {
        default:
        case 6:
        case 0:
          r = v;
          g = n;
          b = wh;
          break;
        case 1:
          r = n;
          g = v;
          b = wh;
          break;
        case 2:
          r = wh;
          g = v;
          b = n;
          break;
        case 3:
          r = wh;
          g = n;
          b = v;
          break;
        case 4:
          r = n;
          g = wh;
          b = v;
          break;
        case 5:
          r = v;
          g = wh;
          b = n;
          break;
      }
      return [r * 255, g * 255, b * 255];
    };
    convert.cmyk.rgb = function(cmyk) {
      const c = cmyk[0] / 100;
      const m = cmyk[1] / 100;
      const y = cmyk[2] / 100;
      const k = cmyk[3] / 100;
      const r = 1 - Math.min(1, c * (1 - k) + k);
      const g = 1 - Math.min(1, m * (1 - k) + k);
      const b = 1 - Math.min(1, y * (1 - k) + k);
      return [r * 255, g * 255, b * 255];
    };
    convert.xyz.rgb = function(xyz) {
      const x = xyz[0] / 100;
      const y = xyz[1] / 100;
      const z = xyz[2] / 100;
      let r;
      let g;
      let b;
      r = x * 3.2406 + y * -1.5372 + z * -0.4986;
      g = x * -0.9689 + y * 1.8758 + z * 0.0415;
      b = x * 0.0557 + y * -0.204 + z * 1.057;
      r = r > 31308e-7 ? 1.055 * r ** (1 / 2.4) - 0.055 : r * 12.92;
      g = g > 31308e-7 ? 1.055 * g ** (1 / 2.4) - 0.055 : g * 12.92;
      b = b > 31308e-7 ? 1.055 * b ** (1 / 2.4) - 0.055 : b * 12.92;
      r = Math.min(Math.max(0, r), 1);
      g = Math.min(Math.max(0, g), 1);
      b = Math.min(Math.max(0, b), 1);
      return [r * 255, g * 255, b * 255];
    };
    convert.xyz.lab = function(xyz) {
      let x = xyz[0];
      let y = xyz[1];
      let z = xyz[2];
      x /= 95.047;
      y /= 100;
      z /= 108.883;
      x = x > 8856e-6 ? x ** (1 / 3) : 7.787 * x + 16 / 116;
      y = y > 8856e-6 ? y ** (1 / 3) : 7.787 * y + 16 / 116;
      z = z > 8856e-6 ? z ** (1 / 3) : 7.787 * z + 16 / 116;
      const l = 116 * y - 16;
      const a2 = 500 * (x - y);
      const b = 200 * (y - z);
      return [l, a2, b];
    };
    convert.lab.xyz = function(lab) {
      const l = lab[0];
      const a2 = lab[1];
      const b = lab[2];
      let x;
      let y;
      let z;
      y = (l + 16) / 116;
      x = a2 / 500 + y;
      z = y - b / 200;
      const y2 = y ** 3;
      const x2 = x ** 3;
      const z2 = z ** 3;
      y = y2 > 8856e-6 ? y2 : (y - 16 / 116) / 7.787;
      x = x2 > 8856e-6 ? x2 : (x - 16 / 116) / 7.787;
      z = z2 > 8856e-6 ? z2 : (z - 16 / 116) / 7.787;
      x *= 95.047;
      y *= 100;
      z *= 108.883;
      return [x, y, z];
    };
    convert.lab.lch = function(lab) {
      const l = lab[0];
      const a2 = lab[1];
      const b = lab[2];
      let h;
      const hr = Math.atan2(b, a2);
      h = hr * 360 / 2 / Math.PI;
      if (h < 0) {
        h += 360;
      }
      const c = Math.sqrt(a2 * a2 + b * b);
      return [l, c, h];
    };
    convert.lch.lab = function(lch) {
      const l = lch[0];
      const c = lch[1];
      const h = lch[2];
      const hr = h / 360 * 2 * Math.PI;
      const a2 = c * Math.cos(hr);
      const b = c * Math.sin(hr);
      return [l, a2, b];
    };
    convert.rgb.ansi16 = function(args, saturation = null) {
      const [r, g, b] = args;
      let value = saturation === null ? convert.rgb.hsv(args)[2] : saturation;
      value = Math.round(value / 50);
      if (value === 0) {
        return 30;
      }
      let ansi = 30 + (Math.round(b / 255) << 2 | Math.round(g / 255) << 1 | Math.round(r / 255));
      if (value === 2) {
        ansi += 60;
      }
      return ansi;
    };
    convert.hsv.ansi16 = function(args) {
      return convert.rgb.ansi16(convert.hsv.rgb(args), args[2]);
    };
    convert.rgb.ansi256 = function(args) {
      const r = args[0];
      const g = args[1];
      const b = args[2];
      if (r === g && g === b) {
        if (r < 8) {
          return 16;
        }
        if (r > 248) {
          return 231;
        }
        return Math.round((r - 8) / 247 * 24) + 232;
      }
      const ansi = 16 + 36 * Math.round(r / 255 * 5) + 6 * Math.round(g / 255 * 5) + Math.round(b / 255 * 5);
      return ansi;
    };
    convert.ansi16.rgb = function(args) {
      let color = args % 10;
      if (color === 0 || color === 7) {
        if (args > 50) {
          color += 3.5;
        }
        color = color / 10.5 * 255;
        return [color, color, color];
      }
      const mult = (~~(args > 50) + 1) * 0.5;
      const r = (color & 1) * mult * 255;
      const g = (color >> 1 & 1) * mult * 255;
      const b = (color >> 2 & 1) * mult * 255;
      return [r, g, b];
    };
    convert.ansi256.rgb = function(args) {
      if (args >= 232) {
        const c = (args - 232) * 10 + 8;
        return [c, c, c];
      }
      args -= 16;
      let rem;
      const r = Math.floor(args / 36) / 5 * 255;
      const g = Math.floor((rem = args % 36) / 6) / 5 * 255;
      const b = rem % 6 / 5 * 255;
      return [r, g, b];
    };
    convert.rgb.hex = function(args) {
      const integer = ((Math.round(args[0]) & 255) << 16) + ((Math.round(args[1]) & 255) << 8) + (Math.round(args[2]) & 255);
      const string = integer.toString(16).toUpperCase();
      return "000000".substring(string.length) + string;
    };
    convert.hex.rgb = function(args) {
      const match = args.toString(16).match(/[a-f0-9]{6}|[a-f0-9]{3}/i);
      if (!match) {
        return [0, 0, 0];
      }
      let colorString = match[0];
      if (match[0].length === 3) {
        colorString = colorString.split("").map((char) => {
          return char + char;
        }).join("");
      }
      const integer = parseInt(colorString, 16);
      const r = integer >> 16 & 255;
      const g = integer >> 8 & 255;
      const b = integer & 255;
      return [r, g, b];
    };
    convert.rgb.hcg = function(rgb) {
      const r = rgb[0] / 255;
      const g = rgb[1] / 255;
      const b = rgb[2] / 255;
      const max2 = Math.max(Math.max(r, g), b);
      const min2 = Math.min(Math.min(r, g), b);
      const chroma = max2 - min2;
      let grayscale;
      let hue;
      if (chroma < 1) {
        grayscale = min2 / (1 - chroma);
      } else {
        grayscale = 0;
      }
      if (chroma <= 0) {
        hue = 0;
      } else if (max2 === r) {
        hue = (g - b) / chroma % 6;
      } else if (max2 === g) {
        hue = 2 + (b - r) / chroma;
      } else {
        hue = 4 + (r - g) / chroma;
      }
      hue /= 6;
      hue %= 1;
      return [hue * 360, chroma * 100, grayscale * 100];
    };
    convert.hsl.hcg = function(hsl2) {
      const s = hsl2[1] / 100;
      const l = hsl2[2] / 100;
      const c = l < 0.5 ? 2 * s * l : 2 * s * (1 - l);
      let f = 0;
      if (c < 1) {
        f = (l - 0.5 * c) / (1 - c);
      }
      return [hsl2[0], c * 100, f * 100];
    };
    convert.hsv.hcg = function(hsv) {
      const s = hsv[1] / 100;
      const v = hsv[2] / 100;
      const c = s * v;
      let f = 0;
      if (c < 1) {
        f = (v - c) / (1 - c);
      }
      return [hsv[0], c * 100, f * 100];
    };
    convert.hcg.rgb = function(hcg) {
      const h = hcg[0] / 360;
      const c = hcg[1] / 100;
      const g = hcg[2] / 100;
      if (c === 0) {
        return [g * 255, g * 255, g * 255];
      }
      const pure = [0, 0, 0];
      const hi = h % 1 * 6;
      const v = hi % 1;
      const w = 1 - v;
      let mg = 0;
      switch (Math.floor(hi)) {
        case 0:
          pure[0] = 1;
          pure[1] = v;
          pure[2] = 0;
          break;
        case 1:
          pure[0] = w;
          pure[1] = 1;
          pure[2] = 0;
          break;
        case 2:
          pure[0] = 0;
          pure[1] = 1;
          pure[2] = v;
          break;
        case 3:
          pure[0] = 0;
          pure[1] = w;
          pure[2] = 1;
          break;
        case 4:
          pure[0] = v;
          pure[1] = 0;
          pure[2] = 1;
          break;
        default:
          pure[0] = 1;
          pure[1] = 0;
          pure[2] = w;
      }
      mg = (1 - c) * g;
      return [
        (c * pure[0] + mg) * 255,
        (c * pure[1] + mg) * 255,
        (c * pure[2] + mg) * 255
      ];
    };
    convert.hcg.hsv = function(hcg) {
      const c = hcg[1] / 100;
      const g = hcg[2] / 100;
      const v = c + g * (1 - c);
      let f = 0;
      if (v > 0) {
        f = c / v;
      }
      return [hcg[0], f * 100, v * 100];
    };
    convert.hcg.hsl = function(hcg) {
      const c = hcg[1] / 100;
      const g = hcg[2] / 100;
      const l = g * (1 - c) + 0.5 * c;
      let s = 0;
      if (l > 0 && l < 0.5) {
        s = c / (2 * l);
      } else if (l >= 0.5 && l < 1) {
        s = c / (2 * (1 - l));
      }
      return [hcg[0], s * 100, l * 100];
    };
    convert.hcg.hwb = function(hcg) {
      const c = hcg[1] / 100;
      const g = hcg[2] / 100;
      const v = c + g * (1 - c);
      return [hcg[0], (v - c) * 100, (1 - v) * 100];
    };
    convert.hwb.hcg = function(hwb) {
      const w = hwb[1] / 100;
      const b = hwb[2] / 100;
      const v = 1 - b;
      const c = v - w;
      let g = 0;
      if (c < 1) {
        g = (v - c) / (1 - c);
      }
      return [hwb[0], c * 100, g * 100];
    };
    convert.apple.rgb = function(apple) {
      return [apple[0] / 65535 * 255, apple[1] / 65535 * 255, apple[2] / 65535 * 255];
    };
    convert.rgb.apple = function(rgb) {
      return [rgb[0] / 255 * 65535, rgb[1] / 255 * 65535, rgb[2] / 255 * 65535];
    };
    convert.gray.rgb = function(args) {
      return [args[0] / 100 * 255, args[0] / 100 * 255, args[0] / 100 * 255];
    };
    convert.gray.hsl = function(args) {
      return [0, 0, args[0]];
    };
    convert.gray.hsv = convert.gray.hsl;
    convert.gray.hwb = function(gray) {
      return [0, 100, gray[0]];
    };
    convert.gray.cmyk = function(gray) {
      return [0, 0, 0, gray[0]];
    };
    convert.gray.lab = function(gray) {
      return [gray[0], 0, 0];
    };
    convert.gray.hex = function(gray) {
      const val = Math.round(gray[0] / 100 * 255) & 255;
      const integer = (val << 16) + (val << 8) + val;
      const string = integer.toString(16).toUpperCase();
      return "000000".substring(string.length) + string;
    };
    convert.rgb.gray = function(rgb) {
      const val = (rgb[0] + rgb[1] + rgb[2]) / 3;
      return [val / 255 * 100];
    };
  }
});

// node_modules/color-convert/route.js
var require_route = __commonJS({
  "node_modules/color-convert/route.js"(exports2, module2) {
    var conversions = require_conversions();
    function buildGraph() {
      const graph = {};
      const models = Object.keys(conversions);
      for (let len = models.length, i = 0; i < len; i++) {
        graph[models[i]] = {
          distance: -1,
          parent: null
        };
      }
      return graph;
    }
    function deriveBFS(fromModel) {
      const graph = buildGraph();
      const queue = [fromModel];
      graph[fromModel].distance = 0;
      while (queue.length) {
        const current = queue.pop();
        const adjacents = Object.keys(conversions[current]);
        for (let len = adjacents.length, i = 0; i < len; i++) {
          const adjacent = adjacents[i];
          const node = graph[adjacent];
          if (node.distance === -1) {
            node.distance = graph[current].distance + 1;
            node.parent = current;
            queue.unshift(adjacent);
          }
        }
      }
      return graph;
    }
    function link2(from, to) {
      return function(args) {
        return to(from(args));
      };
    }
    function wrapConversion(toModel, graph) {
      const path = [graph[toModel].parent, toModel];
      let fn2 = conversions[graph[toModel].parent][toModel];
      let cur = graph[toModel].parent;
      while (graph[cur].parent) {
        path.unshift(graph[cur].parent);
        fn2 = link2(conversions[graph[cur].parent][cur], fn2);
        cur = graph[cur].parent;
      }
      fn2.conversion = path;
      return fn2;
    }
    module2.exports = function(fromModel) {
      const graph = deriveBFS(fromModel);
      const conversion = {};
      const models = Object.keys(graph);
      for (let len = models.length, i = 0; i < len; i++) {
        const toModel = models[i];
        const node = graph[toModel];
        if (node.parent === null) {
          continue;
        }
        conversion[toModel] = wrapConversion(toModel, graph);
      }
      return conversion;
    };
  }
});

// node_modules/color-convert/index.js
var require_color_convert = __commonJS({
  "node_modules/color-convert/index.js"(exports2, module2) {
    var conversions = require_conversions();
    var route = require_route();
    var convert = {};
    var models = Object.keys(conversions);
    function wrapRaw(fn2) {
      const wrappedFn = function(...args) {
        const arg0 = args[0];
        if (arg0 === void 0 || arg0 === null) {
          return arg0;
        }
        if (arg0.length > 1) {
          args = arg0;
        }
        return fn2(args);
      };
      if ("conversion" in fn2) {
        wrappedFn.conversion = fn2.conversion;
      }
      return wrappedFn;
    }
    function wrapRounded(fn2) {
      const wrappedFn = function(...args) {
        const arg0 = args[0];
        if (arg0 === void 0 || arg0 === null) {
          return arg0;
        }
        if (arg0.length > 1) {
          args = arg0;
        }
        const result = fn2(args);
        if (typeof result === "object") {
          for (let len = result.length, i = 0; i < len; i++) {
            result[i] = Math.round(result[i]);
          }
        }
        return result;
      };
      if ("conversion" in fn2) {
        wrappedFn.conversion = fn2.conversion;
      }
      return wrappedFn;
    }
    models.forEach((fromModel) => {
      convert[fromModel] = {};
      Object.defineProperty(convert[fromModel], "channels", {value: conversions[fromModel].channels});
      Object.defineProperty(convert[fromModel], "labels", {value: conversions[fromModel].labels});
      const routes = route(fromModel);
      const routeModels = Object.keys(routes);
      routeModels.forEach((toModel) => {
        const fn2 = routes[toModel];
        convert[fromModel][toModel] = wrapRounded(fn2);
        convert[fromModel][toModel].raw = wrapRaw(fn2);
      });
    });
    module2.exports = convert;
  }
});

// node_modules/ansi-styles/index.js
var require_ansi_styles = __commonJS({
  "node_modules/ansi-styles/index.js"(exports2, module2) {
    "use strict";
    var wrapAnsi16 = (fn2, offset) => (...args) => {
      const code = fn2(...args);
      return `[${code + offset}m`;
    };
    var wrapAnsi256 = (fn2, offset) => (...args) => {
      const code = fn2(...args);
      return `[${38 + offset};5;${code}m`;
    };
    var wrapAnsi16m = (fn2, offset) => (...args) => {
      const rgb = fn2(...args);
      return `[${38 + offset};2;${rgb[0]};${rgb[1]};${rgb[2]}m`;
    };
    var ansi2ansi = (n) => n;
    var rgb2rgb = (r, g, b) => [r, g, b];
    var setLazyProperty = (object, property, get2) => {
      Object.defineProperty(object, property, {
        get: () => {
          const value = get2();
          Object.defineProperty(object, property, {
            value,
            enumerable: true,
            configurable: true
          });
          return value;
        },
        enumerable: true,
        configurable: true
      });
    };
    var colorConvert;
    var makeDynamicStyles = (wrap, targetSpace, identity, isBackground) => {
      if (colorConvert === void 0) {
        colorConvert = require_color_convert();
      }
      const offset = isBackground ? 10 : 0;
      const styles = {};
      for (const [sourceSpace, suite] of Object.entries(colorConvert)) {
        const name = sourceSpace === "ansi16" ? "ansi" : sourceSpace;
        if (sourceSpace === targetSpace) {
          styles[name] = wrap(identity, offset);
        } else if (typeof suite === "object") {
          styles[name] = wrap(suite[targetSpace], offset);
        }
      }
      return styles;
    };
    function assembleStyles() {
      const codes = new Map();
      const styles = {
        modifier: {
          reset: [0, 0],
          bold: [1, 22],
          dim: [2, 22],
          italic: [3, 23],
          underline: [4, 24],
          inverse: [7, 27],
          hidden: [8, 28],
          strikethrough: [9, 29]
        },
        color: {
          black: [30, 39],
          red: [31, 39],
          green: [32, 39],
          yellow: [33, 39],
          blue: [34, 39],
          magenta: [35, 39],
          cyan: [36, 39],
          white: [37, 39],
          blackBright: [90, 39],
          redBright: [91, 39],
          greenBright: [92, 39],
          yellowBright: [93, 39],
          blueBright: [94, 39],
          magentaBright: [95, 39],
          cyanBright: [96, 39],
          whiteBright: [97, 39]
        },
        bgColor: {
          bgBlack: [40, 49],
          bgRed: [41, 49],
          bgGreen: [42, 49],
          bgYellow: [43, 49],
          bgBlue: [44, 49],
          bgMagenta: [45, 49],
          bgCyan: [46, 49],
          bgWhite: [47, 49],
          bgBlackBright: [100, 49],
          bgRedBright: [101, 49],
          bgGreenBright: [102, 49],
          bgYellowBright: [103, 49],
          bgBlueBright: [104, 49],
          bgMagentaBright: [105, 49],
          bgCyanBright: [106, 49],
          bgWhiteBright: [107, 49]
        }
      };
      styles.color.gray = styles.color.blackBright;
      styles.bgColor.bgGray = styles.bgColor.bgBlackBright;
      styles.color.grey = styles.color.blackBright;
      styles.bgColor.bgGrey = styles.bgColor.bgBlackBright;
      for (const [groupName, group] of Object.entries(styles)) {
        for (const [styleName, style] of Object.entries(group)) {
          styles[styleName] = {
            open: `[${style[0]}m`,
            close: `[${style[1]}m`
          };
          group[styleName] = styles[styleName];
          codes.set(style[0], style[1]);
        }
        Object.defineProperty(styles, groupName, {
          value: group,
          enumerable: false
        });
      }
      Object.defineProperty(styles, "codes", {
        value: codes,
        enumerable: false
      });
      styles.color.close = "[39m";
      styles.bgColor.close = "[49m";
      setLazyProperty(styles.color, "ansi", () => makeDynamicStyles(wrapAnsi16, "ansi16", ansi2ansi, false));
      setLazyProperty(styles.color, "ansi256", () => makeDynamicStyles(wrapAnsi256, "ansi256", ansi2ansi, false));
      setLazyProperty(styles.color, "ansi16m", () => makeDynamicStyles(wrapAnsi16m, "rgb", rgb2rgb, false));
      setLazyProperty(styles.bgColor, "ansi", () => makeDynamicStyles(wrapAnsi16, "ansi16", ansi2ansi, true));
      setLazyProperty(styles.bgColor, "ansi256", () => makeDynamicStyles(wrapAnsi256, "ansi256", ansi2ansi, true));
      setLazyProperty(styles.bgColor, "ansi16m", () => makeDynamicStyles(wrapAnsi16m, "rgb", rgb2rgb, true));
      return styles;
    }
    Object.defineProperty(module2, "exports", {
      enumerable: true,
      get: assembleStyles
    });
  }
});

// node_modules/has-flag/index.js
var require_has_flag = __commonJS({
  "node_modules/has-flag/index.js"(exports2, module2) {
    "use strict";
    module2.exports = (flag, argv = process.argv) => {
      const prefix = flag.startsWith("-") ? "" : flag.length === 1 ? "-" : "--";
      const position = argv.indexOf(prefix + flag);
      const terminatorPosition = argv.indexOf("--");
      return position !== -1 && (terminatorPosition === -1 || position < terminatorPosition);
    };
  }
});

// node_modules/supports-color/index.js
var require_supports_color = __commonJS({
  "node_modules/supports-color/index.js"(exports2, module2) {
    "use strict";
    var os = require("os");
    var tty = require("tty");
    var hasFlag = require_has_flag();
    var {env} = process;
    var forceColor;
    if (hasFlag("no-color") || hasFlag("no-colors") || hasFlag("color=false") || hasFlag("color=never")) {
      forceColor = 0;
    } else if (hasFlag("color") || hasFlag("colors") || hasFlag("color=true") || hasFlag("color=always")) {
      forceColor = 1;
    }
    if ("FORCE_COLOR" in env) {
      if (env.FORCE_COLOR === "true") {
        forceColor = 1;
      } else if (env.FORCE_COLOR === "false") {
        forceColor = 0;
      } else {
        forceColor = env.FORCE_COLOR.length === 0 ? 1 : Math.min(parseInt(env.FORCE_COLOR, 10), 3);
      }
    }
    function translateLevel(level) {
      if (level === 0) {
        return false;
      }
      return {
        level,
        hasBasic: true,
        has256: level >= 2,
        has16m: level >= 3
      };
    }
    function supportsColor(haveStream, streamIsTTY) {
      if (forceColor === 0) {
        return 0;
      }
      if (hasFlag("color=16m") || hasFlag("color=full") || hasFlag("color=truecolor")) {
        return 3;
      }
      if (hasFlag("color=256")) {
        return 2;
      }
      if (haveStream && !streamIsTTY && forceColor === void 0) {
        return 0;
      }
      const min2 = forceColor || 0;
      if (env.TERM === "dumb") {
        return min2;
      }
      if (process.platform === "win32") {
        const osRelease = os.release().split(".");
        if (Number(osRelease[0]) >= 10 && Number(osRelease[2]) >= 10586) {
          return Number(osRelease[2]) >= 14931 ? 3 : 2;
        }
        return 1;
      }
      if ("CI" in env) {
        if (["TRAVIS", "CIRCLECI", "APPVEYOR", "GITLAB_CI"].some((sign) => sign in env) || env.CI_NAME === "codeship") {
          return 1;
        }
        return min2;
      }
      if ("TEAMCITY_VERSION" in env) {
        return /^(9\.(0*[1-9]\d*)\.|\d{2,}\.)/.test(env.TEAMCITY_VERSION) ? 1 : 0;
      }
      if ("GITHUB_ACTIONS" in env) {
        return 1;
      }
      if (env.COLORTERM === "truecolor") {
        return 3;
      }
      if ("TERM_PROGRAM" in env) {
        const version = parseInt((env.TERM_PROGRAM_VERSION || "").split(".")[0], 10);
        switch (env.TERM_PROGRAM) {
          case "iTerm.app":
            return version >= 3 ? 3 : 2;
          case "Apple_Terminal":
            return 2;
        }
      }
      if (/-256(color)?$/i.test(env.TERM)) {
        return 2;
      }
      if (/^screen|^xterm|^vt100|^vt220|^rxvt|color|ansi|cygwin|linux/i.test(env.TERM)) {
        return 1;
      }
      if ("COLORTERM" in env) {
        return 1;
      }
      return min2;
    }
    function getSupportLevel(stream) {
      const level = supportsColor(stream, stream && stream.isTTY);
      return translateLevel(level);
    }
    module2.exports = {
      supportsColor: getSupportLevel,
      stdout: translateLevel(supportsColor(true, tty.isatty(1))),
      stderr: translateLevel(supportsColor(true, tty.isatty(2)))
    };
  }
});

// node_modules/chalk/source/util.js
var require_util = __commonJS({
  "node_modules/chalk/source/util.js"(exports2, module2) {
    "use strict";
    var stringReplaceAll = (string, substring, replacer) => {
      let index = string.indexOf(substring);
      if (index === -1) {
        return string;
      }
      const substringLength = substring.length;
      let endIndex = 0;
      let returnValue = "";
      do {
        returnValue += string.substr(endIndex, index - endIndex) + substring + replacer;
        endIndex = index + substringLength;
        index = string.indexOf(substring, endIndex);
      } while (index !== -1);
      returnValue += string.substr(endIndex);
      return returnValue;
    };
    var stringEncaseCRLFWithFirstIndex = (string, prefix, postfix, index) => {
      let endIndex = 0;
      let returnValue = "";
      do {
        const gotCR = string[index - 1] === "\r";
        returnValue += string.substr(endIndex, (gotCR ? index - 1 : index) - endIndex) + prefix + (gotCR ? "\r\n" : "\n") + postfix;
        endIndex = index + 1;
        index = string.indexOf("\n", endIndex);
      } while (index !== -1);
      returnValue += string.substr(endIndex);
      return returnValue;
    };
    module2.exports = {
      stringReplaceAll,
      stringEncaseCRLFWithFirstIndex
    };
  }
});

// node_modules/chalk/source/templates.js
var require_templates = __commonJS({
  "node_modules/chalk/source/templates.js"(exports2, module2) {
    "use strict";
    var TEMPLATE_REGEX = /(?:\\(u(?:[a-f\d]{4}|\{[a-f\d]{1,6}\})|x[a-f\d]{2}|.))|(?:\{(~)?(\w+(?:\([^)]*\))?(?:\.\w+(?:\([^)]*\))?)*)(?:[ \t]|(?=\r?\n)))|(\})|((?:.|[\r\n\f])+?)/gi;
    var STYLE_REGEX = /(?:^|\.)(\w+)(?:\(([^)]*)\))?/g;
    var STRING_REGEX = /^(['"])((?:\\.|(?!\1)[^\\])*)\1$/;
    var ESCAPE_REGEX = /\\(u(?:[a-f\d]{4}|{[a-f\d]{1,6}})|x[a-f\d]{2}|.)|([^\\])/gi;
    var ESCAPES = new Map([
      ["n", "\n"],
      ["r", "\r"],
      ["t", "	"],
      ["b", "\b"],
      ["f", "\f"],
      ["v", "\v"],
      ["0", "\0"],
      ["\\", "\\"],
      ["e", ""],
      ["a", "\x07"]
    ]);
    function unescape(c) {
      const u = c[0] === "u";
      const bracket = c[1] === "{";
      if (u && !bracket && c.length === 5 || c[0] === "x" && c.length === 3) {
        return String.fromCharCode(parseInt(c.slice(1), 16));
      }
      if (u && bracket) {
        return String.fromCodePoint(parseInt(c.slice(2, -1), 16));
      }
      return ESCAPES.get(c) || c;
    }
    function parseArguments(name, arguments_) {
      const results = [];
      const chunks = arguments_.trim().split(/\s*,\s*/g);
      let matches;
      for (const chunk of chunks) {
        const number = Number(chunk);
        if (!Number.isNaN(number)) {
          results.push(number);
        } else if (matches = chunk.match(STRING_REGEX)) {
          results.push(matches[2].replace(ESCAPE_REGEX, (m, escape, character) => escape ? unescape(escape) : character));
        } else {
          throw new Error(`Invalid Chalk template style argument: ${chunk} (in style '${name}')`);
        }
      }
      return results;
    }
    function parseStyle(style) {
      STYLE_REGEX.lastIndex = 0;
      const results = [];
      let matches;
      while ((matches = STYLE_REGEX.exec(style)) !== null) {
        const name = matches[1];
        if (matches[2]) {
          const args = parseArguments(name, matches[2]);
          results.push([name].concat(args));
        } else {
          results.push([name]);
        }
      }
      return results;
    }
    function buildStyle(chalk, styles) {
      const enabled = {};
      for (const layer of styles) {
        for (const style of layer.styles) {
          enabled[style[0]] = layer.inverse ? null : style.slice(1);
        }
      }
      let current = chalk;
      for (const [styleName, styles2] of Object.entries(enabled)) {
        if (!Array.isArray(styles2)) {
          continue;
        }
        if (!(styleName in current)) {
          throw new Error(`Unknown Chalk style: ${styleName}`);
        }
        current = styles2.length > 0 ? current[styleName](...styles2) : current[styleName];
      }
      return current;
    }
    module2.exports = (chalk, temporary) => {
      const styles = [];
      const chunks = [];
      let chunk = [];
      temporary.replace(TEMPLATE_REGEX, (m, escapeCharacter, inverse, style, close, character) => {
        if (escapeCharacter) {
          chunk.push(unescape(escapeCharacter));
        } else if (style) {
          const string = chunk.join("");
          chunk = [];
          chunks.push(styles.length === 0 ? string : buildStyle(chalk, styles)(string));
          styles.push({inverse, styles: parseStyle(style)});
        } else if (close) {
          if (styles.length === 0) {
            throw new Error("Found extraneous } in Chalk template literal");
          }
          chunks.push(buildStyle(chalk, styles)(chunk.join("")));
          chunk = [];
          styles.pop();
        } else {
          chunk.push(character);
        }
      });
      chunks.push(chunk.join(""));
      if (styles.length > 0) {
        const errMessage = `Chalk template literal is missing ${styles.length} closing bracket${styles.length === 1 ? "" : "s"} (\`}\`)`;
        throw new Error(errMessage);
      }
      return chunks.join("");
    };
  }
});

// node_modules/chalk/source/index.js
var require_source = __commonJS({
  "node_modules/chalk/source/index.js"(exports2, module2) {
    "use strict";
    var ansiStyles = require_ansi_styles();
    var {stdout: stdoutColor, stderr: stderrColor} = require_supports_color();
    var {
      stringReplaceAll,
      stringEncaseCRLFWithFirstIndex
    } = require_util();
    var {isArray} = Array;
    var levelMapping = [
      "ansi",
      "ansi",
      "ansi256",
      "ansi16m"
    ];
    var styles = Object.create(null);
    var applyOptions = (object, options = {}) => {
      if (options.level && !(Number.isInteger(options.level) && options.level >= 0 && options.level <= 3)) {
        throw new Error("The `level` option should be an integer from 0 to 3");
      }
      const colorLevel = stdoutColor ? stdoutColor.level : 0;
      object.level = options.level === void 0 ? colorLevel : options.level;
    };
    var ChalkClass = class {
      constructor(options) {
        return chalkFactory(options);
      }
    };
    var chalkFactory = (options) => {
      const chalk2 = {};
      applyOptions(chalk2, options);
      chalk2.template = (...arguments_) => chalkTag(chalk2.template, ...arguments_);
      Object.setPrototypeOf(chalk2, Chalk.prototype);
      Object.setPrototypeOf(chalk2.template, chalk2);
      chalk2.template.constructor = () => {
        throw new Error("`chalk.constructor()` is deprecated. Use `new chalk.Instance()` instead.");
      };
      chalk2.template.Instance = ChalkClass;
      return chalk2.template;
    };
    function Chalk(options) {
      return chalkFactory(options);
    }
    for (const [styleName, style] of Object.entries(ansiStyles)) {
      styles[styleName] = {
        get() {
          const builder = createBuilder(this, createStyler(style.open, style.close, this._styler), this._isEmpty);
          Object.defineProperty(this, styleName, {value: builder});
          return builder;
        }
      };
    }
    styles.visible = {
      get() {
        const builder = createBuilder(this, this._styler, true);
        Object.defineProperty(this, "visible", {value: builder});
        return builder;
      }
    };
    var usedModels = ["rgb", "hex", "keyword", "hsl", "hsv", "hwb", "ansi", "ansi256"];
    for (const model of usedModels) {
      styles[model] = {
        get() {
          const {level} = this;
          return function(...arguments_) {
            const styler = createStyler(ansiStyles.color[levelMapping[level]][model](...arguments_), ansiStyles.color.close, this._styler);
            return createBuilder(this, styler, this._isEmpty);
          };
        }
      };
    }
    for (const model of usedModels) {
      const bgModel = "bg" + model[0].toUpperCase() + model.slice(1);
      styles[bgModel] = {
        get() {
          const {level} = this;
          return function(...arguments_) {
            const styler = createStyler(ansiStyles.bgColor[levelMapping[level]][model](...arguments_), ansiStyles.bgColor.close, this._styler);
            return createBuilder(this, styler, this._isEmpty);
          };
        }
      };
    }
    var proto = Object.defineProperties(() => {
    }, {
      ...styles,
      level: {
        enumerable: true,
        get() {
          return this._generator.level;
        },
        set(level) {
          this._generator.level = level;
        }
      }
    });
    var createStyler = (open, close, parent) => {
      let openAll;
      let closeAll;
      if (parent === void 0) {
        openAll = open;
        closeAll = close;
      } else {
        openAll = parent.openAll + open;
        closeAll = close + parent.closeAll;
      }
      return {
        open,
        close,
        openAll,
        closeAll,
        parent
      };
    };
    var createBuilder = (self, _styler, _isEmpty) => {
      const builder = (...arguments_) => {
        if (isArray(arguments_[0]) && isArray(arguments_[0].raw)) {
          return applyStyle(builder, chalkTag(builder, ...arguments_));
        }
        return applyStyle(builder, arguments_.length === 1 ? "" + arguments_[0] : arguments_.join(" "));
      };
      Object.setPrototypeOf(builder, proto);
      builder._generator = self;
      builder._styler = _styler;
      builder._isEmpty = _isEmpty;
      return builder;
    };
    var applyStyle = (self, string) => {
      if (self.level <= 0 || !string) {
        return self._isEmpty ? "" : string;
      }
      let styler = self._styler;
      if (styler === void 0) {
        return string;
      }
      const {openAll, closeAll} = styler;
      if (string.indexOf("") !== -1) {
        while (styler !== void 0) {
          string = stringReplaceAll(string, styler.close, styler.open);
          styler = styler.parent;
        }
      }
      const lfIndex = string.indexOf("\n");
      if (lfIndex !== -1) {
        string = stringEncaseCRLFWithFirstIndex(string, closeAll, openAll, lfIndex);
      }
      return openAll + string + closeAll;
    };
    var template;
    var chalkTag = (chalk2, ...strings) => {
      const [firstString] = strings;
      if (!isArray(firstString) || !isArray(firstString.raw)) {
        return strings.join(" ");
      }
      const arguments_ = strings.slice(1);
      const parts = [firstString.raw[0]];
      for (let i = 1; i < firstString.length; i++) {
        parts.push(String(arguments_[i - 1]).replace(/[{}\\]/g, "\\$&"), String(firstString.raw[i]));
      }
      if (template === void 0) {
        template = require_templates();
      }
      return template(chalk2, parts.join(""));
    };
    Object.defineProperties(Chalk.prototype, styles);
    var chalk = Chalk();
    chalk.supportsColor = stdoutColor;
    chalk.stderr = Chalk({level: stderrColor ? stderrColor.level : 0});
    chalk.stderr.supportsColor = stderrColor;
    module2.exports = chalk;
  }
});

// node_modules/dayjs/dayjs.min.js
var require_dayjs_min = __commonJS({
  "node_modules/dayjs/dayjs.min.js"(exports2, module2) {
    !function(t, e) {
      typeof exports2 == "object" && typeof module2 != "undefined" ? module2.exports = e() : typeof define == "function" && define.amd ? define(e) : t.dayjs = e();
    }(exports2, function() {
      "use strict";
      var t = "millisecond", e = "second", n = "minute", r = "hour", i = "day", s = "week", u = "month", a2 = "quarter", o = "year", f = "date", h = /^(\d{4})[-/]?(\d{1,2})?[-/]?(\d{0,2})[^0-9]*(\d{1,2})?:?(\d{1,2})?:?(\d{1,2})?.?(\d{1,3})?$/, c = /\[([^\]]+)]|Y{2,4}|M{1,4}|D{1,2}|d{1,4}|H{1,2}|h{1,2}|a|A|m{1,2}|s{1,2}|Z{1,2}|SSS/g, d = function(t2, e2, n2) {
        var r2 = String(t2);
        return !r2 || r2.length >= e2 ? t2 : "" + Array(e2 + 1 - r2.length).join(n2) + t2;
      }, $ = {s: d, z: function(t2) {
        var e2 = -t2.utcOffset(), n2 = Math.abs(e2), r2 = Math.floor(n2 / 60), i2 = n2 % 60;
        return (e2 <= 0 ? "+" : "-") + d(r2, 2, "0") + ":" + d(i2, 2, "0");
      }, m: function t2(e2, n2) {
        if (e2.date() < n2.date())
          return -t2(n2, e2);
        var r2 = 12 * (n2.year() - e2.year()) + (n2.month() - e2.month()), i2 = e2.add(r2, u), s2 = n2 - i2 < 0, a3 = e2.add(r2 + (s2 ? -1 : 1), u);
        return +(-(r2 + (n2 - i2) / (s2 ? i2 - a3 : a3 - i2)) || 0);
      }, a: function(t2) {
        return t2 < 0 ? Math.ceil(t2) || 0 : Math.floor(t2);
      }, p: function(h2) {
        return {M: u, y: o, w: s, d: i, D: f, h: r, m: n, s: e, ms: t, Q: a2}[h2] || String(h2 || "").toLowerCase().replace(/s$/, "");
      }, u: function(t2) {
        return t2 === void 0;
      }}, l = {name: "en", weekdays: "Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"), months: "January_February_March_April_May_June_July_August_September_October_November_December".split("_")}, y = "en", M = {};
      M[y] = l;
      var m = function(t2) {
        return t2 instanceof S;
      }, D = function(t2, e2, n2) {
        var r2;
        if (!t2)
          return y;
        if (typeof t2 == "string")
          M[t2] && (r2 = t2), e2 && (M[t2] = e2, r2 = t2);
        else {
          var i2 = t2.name;
          M[i2] = t2, r2 = i2;
        }
        return !n2 && r2 && (y = r2), r2 || !n2 && y;
      }, v = function(t2, e2) {
        if (m(t2))
          return t2.clone();
        var n2 = typeof e2 == "object" ? e2 : {};
        return n2.date = t2, n2.args = arguments, new S(n2);
      }, g = $;
      g.l = D, g.i = m, g.w = function(t2, e2) {
        return v(t2, {locale: e2.$L, utc: e2.$u, $offset: e2.$offset});
      };
      var S = function() {
        function d2(t2) {
          this.$L = this.$L || D(t2.locale, null, true), this.parse(t2);
        }
        var $2 = d2.prototype;
        return $2.parse = function(t2) {
          this.$d = function(t3) {
            var e2 = t3.date, n2 = t3.utc;
            if (e2 === null)
              return new Date(NaN);
            if (g.u(e2))
              return new Date();
            if (e2 instanceof Date)
              return new Date(e2);
            if (typeof e2 == "string" && !/Z$/i.test(e2)) {
              var r2 = e2.match(h);
              if (r2) {
                var i2 = r2[2] - 1 || 0;
                return n2 ? new Date(Date.UTC(r2[1], i2, r2[3] || 1, r2[4] || 0, r2[5] || 0, r2[6] || 0, r2[7] || 0)) : new Date(r2[1], i2, r2[3] || 1, r2[4] || 0, r2[5] || 0, r2[6] || 0, r2[7] || 0);
              }
            }
            return new Date(e2);
          }(t2), this.init();
        }, $2.init = function() {
          var t2 = this.$d;
          this.$y = t2.getFullYear(), this.$M = t2.getMonth(), this.$D = t2.getDate(), this.$W = t2.getDay(), this.$H = t2.getHours(), this.$m = t2.getMinutes(), this.$s = t2.getSeconds(), this.$ms = t2.getMilliseconds();
        }, $2.$utils = function() {
          return g;
        }, $2.isValid = function() {
          return !(this.$d.toString() === "Invalid Date");
        }, $2.isSame = function(t2, e2) {
          var n2 = v(t2);
          return this.startOf(e2) <= n2 && n2 <= this.endOf(e2);
        }, $2.isAfter = function(t2, e2) {
          return v(t2) < this.startOf(e2);
        }, $2.isBefore = function(t2, e2) {
          return this.endOf(e2) < v(t2);
        }, $2.$g = function(t2, e2, n2) {
          return g.u(t2) ? this[e2] : this.set(n2, t2);
        }, $2.unix = function() {
          return Math.floor(this.valueOf() / 1e3);
        }, $2.valueOf = function() {
          return this.$d.getTime();
        }, $2.startOf = function(t2, a3) {
          var h2 = this, c2 = !!g.u(a3) || a3, d3 = g.p(t2), $3 = function(t3, e2) {
            var n2 = g.w(h2.$u ? Date.UTC(h2.$y, e2, t3) : new Date(h2.$y, e2, t3), h2);
            return c2 ? n2 : n2.endOf(i);
          }, l2 = function(t3, e2) {
            return g.w(h2.toDate()[t3].apply(h2.toDate("s"), (c2 ? [0, 0, 0, 0] : [23, 59, 59, 999]).slice(e2)), h2);
          }, y2 = this.$W, M2 = this.$M, m2 = this.$D, D2 = "set" + (this.$u ? "UTC" : "");
          switch (d3) {
            case o:
              return c2 ? $3(1, 0) : $3(31, 11);
            case u:
              return c2 ? $3(1, M2) : $3(0, M2 + 1);
            case s:
              var v2 = this.$locale().weekStart || 0, S2 = (y2 < v2 ? y2 + 7 : y2) - v2;
              return $3(c2 ? m2 - S2 : m2 + (6 - S2), M2);
            case i:
            case f:
              return l2(D2 + "Hours", 0);
            case r:
              return l2(D2 + "Minutes", 1);
            case n:
              return l2(D2 + "Seconds", 2);
            case e:
              return l2(D2 + "Milliseconds", 3);
            default:
              return this.clone();
          }
        }, $2.endOf = function(t2) {
          return this.startOf(t2, false);
        }, $2.$set = function(s2, a3) {
          var h2, c2 = g.p(s2), d3 = "set" + (this.$u ? "UTC" : ""), $3 = (h2 = {}, h2[i] = d3 + "Date", h2[f] = d3 + "Date", h2[u] = d3 + "Month", h2[o] = d3 + "FullYear", h2[r] = d3 + "Hours", h2[n] = d3 + "Minutes", h2[e] = d3 + "Seconds", h2[t] = d3 + "Milliseconds", h2)[c2], l2 = c2 === i ? this.$D + (a3 - this.$W) : a3;
          if (c2 === u || c2 === o) {
            var y2 = this.clone().set(f, 1);
            y2.$d[$3](l2), y2.init(), this.$d = y2.set(f, Math.min(this.$D, y2.daysInMonth())).$d;
          } else
            $3 && this.$d[$3](l2);
          return this.init(), this;
        }, $2.set = function(t2, e2) {
          return this.clone().$set(t2, e2);
        }, $2.get = function(t2) {
          return this[g.p(t2)]();
        }, $2.add = function(t2, a3) {
          var f2, h2 = this;
          t2 = Number(t2);
          var c2 = g.p(a3), d3 = function(e2) {
            var n2 = v(h2);
            return g.w(n2.date(n2.date() + Math.round(e2 * t2)), h2);
          };
          if (c2 === u)
            return this.set(u, this.$M + t2);
          if (c2 === o)
            return this.set(o, this.$y + t2);
          if (c2 === i)
            return d3(1);
          if (c2 === s)
            return d3(7);
          var $3 = (f2 = {}, f2[n] = 6e4, f2[r] = 36e5, f2[e] = 1e3, f2)[c2] || 1, l2 = this.$d.getTime() + t2 * $3;
          return g.w(l2, this);
        }, $2.subtract = function(t2, e2) {
          return this.add(-1 * t2, e2);
        }, $2.format = function(t2) {
          var e2 = this;
          if (!this.isValid())
            return "Invalid Date";
          var n2 = t2 || "YYYY-MM-DDTHH:mm:ssZ", r2 = g.z(this), i2 = this.$locale(), s2 = this.$H, u2 = this.$m, a3 = this.$M, o2 = i2.weekdays, f2 = i2.months, h2 = function(t3, r3, i3, s3) {
            return t3 && (t3[r3] || t3(e2, n2)) || i3[r3].substr(0, s3);
          }, d3 = function(t3) {
            return g.s(s2 % 12 || 12, t3, "0");
          }, $3 = i2.meridiem || function(t3, e3, n3) {
            var r3 = t3 < 12 ? "AM" : "PM";
            return n3 ? r3.toLowerCase() : r3;
          }, l2 = {YY: String(this.$y).slice(-2), YYYY: this.$y, M: a3 + 1, MM: g.s(a3 + 1, 2, "0"), MMM: h2(i2.monthsShort, a3, f2, 3), MMMM: h2(f2, a3), D: this.$D, DD: g.s(this.$D, 2, "0"), d: String(this.$W), dd: h2(i2.weekdaysMin, this.$W, o2, 2), ddd: h2(i2.weekdaysShort, this.$W, o2, 3), dddd: o2[this.$W], H: String(s2), HH: g.s(s2, 2, "0"), h: d3(1), hh: d3(2), a: $3(s2, u2, true), A: $3(s2, u2, false), m: String(u2), mm: g.s(u2, 2, "0"), s: String(this.$s), ss: g.s(this.$s, 2, "0"), SSS: g.s(this.$ms, 3, "0"), Z: r2};
          return n2.replace(c, function(t3, e3) {
            return e3 || l2[t3] || r2.replace(":", "");
          });
        }, $2.utcOffset = function() {
          return 15 * -Math.round(this.$d.getTimezoneOffset() / 15);
        }, $2.diff = function(t2, f2, h2) {
          var c2, d3 = g.p(f2), $3 = v(t2), l2 = 6e4 * ($3.utcOffset() - this.utcOffset()), y2 = this - $3, M2 = g.m(this, $3);
          return M2 = (c2 = {}, c2[o] = M2 / 12, c2[u] = M2, c2[a2] = M2 / 3, c2[s] = (y2 - l2) / 6048e5, c2[i] = (y2 - l2) / 864e5, c2[r] = y2 / 36e5, c2[n] = y2 / 6e4, c2[e] = y2 / 1e3, c2)[d3] || y2, h2 ? M2 : g.a(M2);
        }, $2.daysInMonth = function() {
          return this.endOf(u).$D;
        }, $2.$locale = function() {
          return M[this.$L];
        }, $2.locale = function(t2, e2) {
          if (!t2)
            return this.$L;
          var n2 = this.clone(), r2 = D(t2, e2, true);
          return r2 && (n2.$L = r2), n2;
        }, $2.clone = function() {
          return g.w(this.$d, this);
        }, $2.toDate = function() {
          return new Date(this.valueOf());
        }, $2.toJSON = function() {
          return this.isValid() ? this.toISOString() : null;
        }, $2.toISOString = function() {
          return this.$d.toISOString();
        }, $2.toString = function() {
          return this.$d.toUTCString();
        }, d2;
      }(), p = S.prototype;
      return v.prototype = p, [["$ms", t], ["$s", e], ["$m", n], ["$H", r], ["$W", i], ["$M", u], ["$y", o], ["$D", f]].forEach(function(t2) {
        p[t2[1]] = function(e2) {
          return this.$g(e2, t2[0], t2[1]);
        };
      }), v.extend = function(t2, e2) {
        return t2(e2, S, v), v;
      }, v.locale = D, v.isDayjs = m, v.unix = function(t2) {
        return v(1e3 * t2);
      }, v.en = M[y], v.Ls = M, v;
    });
  }
});

// node_modules/ms/index.js
var require_ms = __commonJS({
  "node_modules/ms/index.js"(exports2, module2) {
    var s = 1e3;
    var m = s * 60;
    var h = m * 60;
    var d = h * 24;
    var y = d * 365.25;
    module2.exports = function(val, options) {
      options = options || {};
      var type = typeof val;
      if (type === "string" && val.length > 0) {
        return parse2(val);
      } else if (type === "number" && isNaN(val) === false) {
        return options.long ? fmtLong(val) : fmtShort(val);
      }
      throw new Error("val is not a non-empty string or a valid number. val=" + JSON.stringify(val));
    };
    function parse2(str2) {
      str2 = String(str2);
      if (str2.length > 100) {
        return;
      }
      var match = /^((?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|years?|yrs?|y)?$/i.exec(str2);
      if (!match) {
        return;
      }
      var n = parseFloat(match[1]);
      var type = (match[2] || "ms").toLowerCase();
      switch (type) {
        case "years":
        case "year":
        case "yrs":
        case "yr":
        case "y":
          return n * y;
        case "days":
        case "day":
        case "d":
          return n * d;
        case "hours":
        case "hour":
        case "hrs":
        case "hr":
        case "h":
          return n * h;
        case "minutes":
        case "minute":
        case "mins":
        case "min":
        case "m":
          return n * m;
        case "seconds":
        case "second":
        case "secs":
        case "sec":
        case "s":
          return n * s;
        case "milliseconds":
        case "millisecond":
        case "msecs":
        case "msec":
        case "ms":
          return n;
        default:
          return void 0;
      }
    }
    function fmtShort(ms) {
      if (ms >= d) {
        return Math.round(ms / d) + "d";
      }
      if (ms >= h) {
        return Math.round(ms / h) + "h";
      }
      if (ms >= m) {
        return Math.round(ms / m) + "m";
      }
      if (ms >= s) {
        return Math.round(ms / s) + "s";
      }
      return ms + "ms";
    }
    function fmtLong(ms) {
      return plural(ms, d, "day") || plural(ms, h, "hour") || plural(ms, m, "minute") || plural(ms, s, "second") || ms + " ms";
    }
    function plural(ms, n, name) {
      if (ms < n) {
        return;
      }
      if (ms < n * 1.5) {
        return Math.floor(ms / n) + " " + name;
      }
      return Math.ceil(ms / n) + " " + name + "s";
    }
  }
});

// node_modules/debug/src/debug.js
var require_debug = __commonJS({
  "node_modules/debug/src/debug.js"(exports2, module2) {
    exports2 = module2.exports = createDebug.debug = createDebug["default"] = createDebug;
    exports2.coerce = coerce;
    exports2.disable = disable;
    exports2.enable = enable;
    exports2.enabled = enabled;
    exports2.humanize = require_ms();
    exports2.names = [];
    exports2.skips = [];
    exports2.formatters = {};
    var prevTime;
    function selectColor(namespace) {
      var hash = 0, i;
      for (i in namespace) {
        hash = (hash << 5) - hash + namespace.charCodeAt(i);
        hash |= 0;
      }
      return exports2.colors[Math.abs(hash) % exports2.colors.length];
    }
    function createDebug(namespace) {
      function debug() {
        if (!debug.enabled)
          return;
        var self = debug;
        var curr = +new Date();
        var ms = curr - (prevTime || curr);
        self.diff = ms;
        self.prev = prevTime;
        self.curr = curr;
        prevTime = curr;
        var args = new Array(arguments.length);
        for (var i = 0; i < args.length; i++) {
          args[i] = arguments[i];
        }
        args[0] = exports2.coerce(args[0]);
        if (typeof args[0] !== "string") {
          args.unshift("%O");
        }
        var index = 0;
        args[0] = args[0].replace(/%([a-zA-Z%])/g, function(match, format) {
          if (match === "%%")
            return match;
          index++;
          var formatter = exports2.formatters[format];
          if (typeof formatter === "function") {
            var val = args[index];
            match = formatter.call(self, val);
            args.splice(index, 1);
            index--;
          }
          return match;
        });
        exports2.formatArgs.call(self, args);
        var logFn = debug.log || exports2.log || console.log.bind(console);
        logFn.apply(self, args);
      }
      debug.namespace = namespace;
      debug.enabled = exports2.enabled(namespace);
      debug.useColors = exports2.useColors();
      debug.color = selectColor(namespace);
      if (typeof exports2.init === "function") {
        exports2.init(debug);
      }
      return debug;
    }
    function enable(namespaces) {
      exports2.save(namespaces);
      exports2.names = [];
      exports2.skips = [];
      var split2 = (typeof namespaces === "string" ? namespaces : "").split(/[\s,]+/);
      var len = split2.length;
      for (var i = 0; i < len; i++) {
        if (!split2[i])
          continue;
        namespaces = split2[i].replace(/\*/g, ".*?");
        if (namespaces[0] === "-") {
          exports2.skips.push(new RegExp("^" + namespaces.substr(1) + "$"));
        } else {
          exports2.names.push(new RegExp("^" + namespaces + "$"));
        }
      }
    }
    function disable() {
      exports2.enable("");
    }
    function enabled(name) {
      var i, len;
      for (i = 0, len = exports2.skips.length; i < len; i++) {
        if (exports2.skips[i].test(name)) {
          return false;
        }
      }
      for (i = 0, len = exports2.names.length; i < len; i++) {
        if (exports2.names[i].test(name)) {
          return true;
        }
      }
      return false;
    }
    function coerce(val) {
      if (val instanceof Error)
        return val.stack || val.message;
      return val;
    }
  }
});

// node_modules/debug/src/browser.js
var require_browser = __commonJS({
  "node_modules/debug/src/browser.js"(exports2, module2) {
    exports2 = module2.exports = require_debug();
    exports2.log = log2;
    exports2.formatArgs = formatArgs;
    exports2.save = save;
    exports2.load = load;
    exports2.useColors = useColors;
    exports2.storage = typeof chrome != "undefined" && typeof chrome.storage != "undefined" ? chrome.storage.local : localstorage();
    exports2.colors = [
      "lightseagreen",
      "forestgreen",
      "goldenrod",
      "dodgerblue",
      "darkorchid",
      "crimson"
    ];
    function useColors() {
      if (typeof window !== "undefined" && window.process && window.process.type === "renderer") {
        return true;
      }
      return typeof document !== "undefined" && document.documentElement && document.documentElement.style && document.documentElement.style.WebkitAppearance || typeof window !== "undefined" && window.console && (window.console.firebug || window.console.exception && window.console.table) || typeof navigator !== "undefined" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/) && parseInt(RegExp.$1, 10) >= 31 || typeof navigator !== "undefined" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/);
    }
    exports2.formatters.j = function(v) {
      try {
        return JSON.stringify(v);
      } catch (err) {
        return "[UnexpectedJSONParseError]: " + err.message;
      }
    };
    function formatArgs(args) {
      var useColors2 = this.useColors;
      args[0] = (useColors2 ? "%c" : "") + this.namespace + (useColors2 ? " %c" : " ") + args[0] + (useColors2 ? "%c " : " ") + "+" + exports2.humanize(this.diff);
      if (!useColors2)
        return;
      var c = "color: " + this.color;
      args.splice(1, 0, c, "color: inherit");
      var index = 0;
      var lastC = 0;
      args[0].replace(/%[a-zA-Z%]/g, function(match) {
        if (match === "%%")
          return;
        index++;
        if (match === "%c") {
          lastC = index;
        }
      });
      args.splice(lastC, 0, c);
    }
    function log2() {
      return typeof console === "object" && console.log && Function.prototype.apply.call(console.log, console, arguments);
    }
    function save(namespaces) {
      try {
        if (namespaces == null) {
          exports2.storage.removeItem("debug");
        } else {
          exports2.storage.debug = namespaces;
        }
      } catch (e) {
      }
    }
    function load() {
      var r;
      try {
        r = exports2.storage.debug;
      } catch (e) {
      }
      if (!r && typeof process !== "undefined" && "env" in process) {
        r = process.env.DEBUG;
      }
      return r;
    }
    exports2.enable(load());
    function localstorage() {
      try {
        return window.localStorage;
      } catch (e) {
      }
    }
  }
});

// node_modules/debug/src/node.js
var require_node = __commonJS({
  "node_modules/debug/src/node.js"(exports2, module2) {
    var tty = require("tty");
    var util = require("util");
    exports2 = module2.exports = require_debug();
    exports2.init = init;
    exports2.log = log2;
    exports2.formatArgs = formatArgs;
    exports2.save = save;
    exports2.load = load;
    exports2.useColors = useColors;
    exports2.colors = [6, 2, 3, 4, 5, 1];
    exports2.inspectOpts = Object.keys(process.env).filter(function(key) {
      return /^debug_/i.test(key);
    }).reduce(function(obj, key) {
      var prop = key.substring(6).toLowerCase().replace(/_([a-z])/g, function(_, k) {
        return k.toUpperCase();
      });
      var val = process.env[key];
      if (/^(yes|on|true|enabled)$/i.test(val))
        val = true;
      else if (/^(no|off|false|disabled)$/i.test(val))
        val = false;
      else if (val === "null")
        val = null;
      else
        val = Number(val);
      obj[prop] = val;
      return obj;
    }, {});
    var fd = parseInt(process.env.DEBUG_FD, 10) || 2;
    if (fd !== 1 && fd !== 2) {
      util.deprecate(function() {
      }, "except for stderr(2) and stdout(1), any other usage of DEBUG_FD is deprecated. Override debug.log if you want to use a different log function (https://git.io/debug_fd)")();
    }
    var stream = fd === 1 ? process.stdout : fd === 2 ? process.stderr : createWritableStdioStream(fd);
    function useColors() {
      return "colors" in exports2.inspectOpts ? Boolean(exports2.inspectOpts.colors) : tty.isatty(fd);
    }
    exports2.formatters.o = function(v) {
      this.inspectOpts.colors = this.useColors;
      return util.inspect(v, this.inspectOpts).split("\n").map(function(str2) {
        return str2.trim();
      }).join(" ");
    };
    exports2.formatters.O = function(v) {
      this.inspectOpts.colors = this.useColors;
      return util.inspect(v, this.inspectOpts);
    };
    function formatArgs(args) {
      var name = this.namespace;
      var useColors2 = this.useColors;
      if (useColors2) {
        var c = this.color;
        var prefix = "  [3" + c + ";1m" + name + " [0m";
        args[0] = prefix + args[0].split("\n").join("\n" + prefix);
        args.push("[3" + c + "m+" + exports2.humanize(this.diff) + "[0m");
      } else {
        args[0] = new Date().toUTCString() + " " + name + " " + args[0];
      }
    }
    function log2() {
      return stream.write(util.format.apply(util, arguments) + "\n");
    }
    function save(namespaces) {
      if (namespaces == null) {
        delete process.env.DEBUG;
      } else {
        process.env.DEBUG = namespaces;
      }
    }
    function load() {
      return process.env.DEBUG;
    }
    function createWritableStdioStream(fd2) {
      var stream2;
      var tty_wrap = process.binding("tty_wrap");
      switch (tty_wrap.guessHandleType(fd2)) {
        case "TTY":
          stream2 = new tty.WriteStream(fd2);
          stream2._type = "tty";
          if (stream2._handle && stream2._handle.unref) {
            stream2._handle.unref();
          }
          break;
        case "FILE":
          var fs = require("fs");
          stream2 = new fs.SyncWriteStream(fd2, {autoClose: false});
          stream2._type = "fs";
          break;
        case "PIPE":
        case "TCP":
          var net = require("net");
          stream2 = new net.Socket({
            fd: fd2,
            readable: false,
            writable: true
          });
          stream2.readable = false;
          stream2.read = null;
          stream2._type = "pipe";
          if (stream2._handle && stream2._handle.unref) {
            stream2._handle.unref();
          }
          break;
        default:
          throw new Error("Implement me. Unknown stream file type!");
      }
      stream2.fd = fd2;
      stream2._isStdio = true;
      return stream2;
    }
    function init(debug) {
      debug.inspectOpts = {};
      var keys2 = Object.keys(exports2.inspectOpts);
      for (var i = 0; i < keys2.length; i++) {
        debug.inspectOpts[keys2[i]] = exports2.inspectOpts[keys2[i]];
      }
    }
    exports2.enable(load());
  }
});

// node_modules/debug/src/index.js
var require_src = __commonJS({
  "node_modules/debug/src/index.js"(exports2, module2) {
    if (typeof process !== "undefined" && process.type === "renderer") {
      module2.exports = require_browser();
    } else {
      module2.exports = require_node();
    }
  }
});

// node_modules/encodeurl/index.js
var require_encodeurl = __commonJS({
  "node_modules/encodeurl/index.js"(exports2, module2) {
    "use strict";
    module2.exports = encodeUrl;
    var ENCODE_CHARS_REGEXP = /(?:[^\x21\x25\x26-\x3B\x3D\x3F-\x5B\x5D\x5F\x61-\x7A\x7E]|%(?:[^0-9A-Fa-f]|[0-9A-Fa-f][^0-9A-Fa-f]|$))+/g;
    var UNMATCHED_SURROGATE_PAIR_REGEXP = /(^|[^\uD800-\uDBFF])[\uDC00-\uDFFF]|[\uD800-\uDBFF]([^\uDC00-\uDFFF]|$)/g;
    var UNMATCHED_SURROGATE_PAIR_REPLACE = "$1\uFFFD$2";
    function encodeUrl(url) {
      return String(url).replace(UNMATCHED_SURROGATE_PAIR_REGEXP, UNMATCHED_SURROGATE_PAIR_REPLACE).replace(ENCODE_CHARS_REGEXP, encodeURI);
    }
  }
});

// node_modules/escape-html/index.js
var require_escape_html = __commonJS({
  "node_modules/escape-html/index.js"(exports2, module2) {
    "use strict";
    var matchHtmlRegExp = /["'&<>]/;
    module2.exports = escapeHtml;
    function escapeHtml(string) {
      var str2 = "" + string;
      var match = matchHtmlRegExp.exec(str2);
      if (!match) {
        return str2;
      }
      var escape;
      var html2 = "";
      var index = 0;
      var lastIndex = 0;
      for (index = match.index; index < str2.length; index++) {
        switch (str2.charCodeAt(index)) {
          case 34:
            escape = "&quot;";
            break;
          case 38:
            escape = "&amp;";
            break;
          case 39:
            escape = "&#39;";
            break;
          case 60:
            escape = "&lt;";
            break;
          case 62:
            escape = "&gt;";
            break;
          default:
            continue;
        }
        if (lastIndex !== index) {
          html2 += str2.substring(lastIndex, index);
        }
        lastIndex = index + 1;
        html2 += escape;
      }
      return lastIndex !== index ? html2 + str2.substring(lastIndex, index) : html2;
    }
  }
});

// node_modules/ee-first/index.js
var require_ee_first = __commonJS({
  "node_modules/ee-first/index.js"(exports2, module2) {
    "use strict";
    module2.exports = first3;
    function first3(stuff, done) {
      if (!Array.isArray(stuff))
        throw new TypeError("arg must be an array of [ee, events...] arrays");
      var cleanups = [];
      for (var i = 0; i < stuff.length; i++) {
        var arr = stuff[i];
        if (!Array.isArray(arr) || arr.length < 2)
          throw new TypeError("each array member must be [ee, events...]");
        var ee = arr[0];
        for (var j = 1; j < arr.length; j++) {
          var event = arr[j];
          var fn2 = listener(event, callback);
          ee.on(event, fn2);
          cleanups.push({
            ee,
            event,
            fn: fn2
          });
        }
      }
      function callback() {
        cleanup();
        done.apply(null, arguments);
      }
      function cleanup() {
        var x;
        for (var i2 = 0; i2 < cleanups.length; i2++) {
          x = cleanups[i2];
          x.ee.removeListener(x.event, x.fn);
        }
      }
      function thunk(fn3) {
        done = fn3;
      }
      thunk.cancel = cleanup;
      return thunk;
    }
    function listener(event, done) {
      return function onevent(arg1) {
        var args = new Array(arguments.length);
        var ee = this;
        var err = event === "error" ? arg1 : null;
        for (var i = 0; i < args.length; i++) {
          args[i] = arguments[i];
        }
        done(err, ee, event, args);
      };
    }
  }
});

// node_modules/on-finished/index.js
var require_on_finished = __commonJS({
  "node_modules/on-finished/index.js"(exports2, module2) {
    "use strict";
    module2.exports = onFinished;
    module2.exports.isFinished = isFinished;
    var first3 = require_ee_first();
    var defer = typeof setImmediate === "function" ? setImmediate : function(fn2) {
      process.nextTick(fn2.bind.apply(fn2, arguments));
    };
    function onFinished(msg, listener) {
      if (isFinished(msg) !== false) {
        defer(listener, null, msg);
        return msg;
      }
      attachListener(msg, listener);
      return msg;
    }
    function isFinished(msg) {
      var socket = msg.socket;
      if (typeof msg.finished === "boolean") {
        return Boolean(msg.finished || socket && !socket.writable);
      }
      if (typeof msg.complete === "boolean") {
        return Boolean(msg.upgrade || !socket || !socket.readable || msg.complete && !msg.readable);
      }
      return void 0;
    }
    function attachFinishedListener(msg, callback) {
      var eeMsg;
      var eeSocket;
      var finished = false;
      function onFinish(error) {
        eeMsg.cancel();
        eeSocket.cancel();
        finished = true;
        callback(error);
      }
      eeMsg = eeSocket = first3([[msg, "end", "finish"]], onFinish);
      function onSocket(socket) {
        msg.removeListener("socket", onSocket);
        if (finished)
          return;
        if (eeMsg !== eeSocket)
          return;
        eeSocket = first3([[socket, "error", "close"]], onFinish);
      }
      if (msg.socket) {
        onSocket(msg.socket);
        return;
      }
      msg.on("socket", onSocket);
      if (msg.socket === void 0) {
        patchAssignSocket(msg, onSocket);
      }
    }
    function attachListener(msg, listener) {
      var attached = msg.__onFinished;
      if (!attached || !attached.queue) {
        attached = msg.__onFinished = createListener(msg);
        attachFinishedListener(msg, attached);
      }
      attached.queue.push(listener);
    }
    function createListener(msg) {
      function listener(err) {
        if (msg.__onFinished === listener)
          msg.__onFinished = null;
        if (!listener.queue)
          return;
        var queue = listener.queue;
        listener.queue = null;
        for (var i = 0; i < queue.length; i++) {
          queue[i](err, msg);
        }
      }
      listener.queue = [];
      return listener;
    }
    function patchAssignSocket(res, callback) {
      var assignSocket = res.assignSocket;
      if (typeof assignSocket !== "function")
        return;
      res.assignSocket = function _assignSocket(socket) {
        assignSocket.call(this, socket);
        callback(socket);
      };
    }
  }
});

// node_modules/parseurl/index.js
var require_parseurl = __commonJS({
  "node_modules/parseurl/index.js"(exports2, module2) {
    "use strict";
    var url = require("url");
    var parse2 = url.parse;
    var Url = url.Url;
    module2.exports = parseurl;
    module2.exports.original = originalurl;
    function parseurl(req) {
      var url2 = req.url;
      if (url2 === void 0) {
        return void 0;
      }
      var parsed = req._parsedUrl;
      if (fresh(url2, parsed)) {
        return parsed;
      }
      parsed = fastparse(url2);
      parsed._raw = url2;
      return req._parsedUrl = parsed;
    }
    function originalurl(req) {
      var url2 = req.originalUrl;
      if (typeof url2 !== "string") {
        return parseurl(req);
      }
      var parsed = req._parsedOriginalUrl;
      if (fresh(url2, parsed)) {
        return parsed;
      }
      parsed = fastparse(url2);
      parsed._raw = url2;
      return req._parsedOriginalUrl = parsed;
    }
    function fastparse(str2) {
      if (typeof str2 !== "string" || str2.charCodeAt(0) !== 47) {
        return parse2(str2);
      }
      var pathname = str2;
      var query = null;
      var search = null;
      for (var i = 1; i < str2.length; i++) {
        switch (str2.charCodeAt(i)) {
          case 63:
            if (search === null) {
              pathname = str2.substring(0, i);
              query = str2.substring(i + 1);
              search = str2.substring(i);
            }
            break;
          case 9:
          case 10:
          case 12:
          case 13:
          case 32:
          case 35:
          case 160:
          case 65279:
            return parse2(str2);
        }
      }
      var url2 = Url !== void 0 ? new Url() : {};
      url2.path = str2;
      url2.href = str2;
      url2.pathname = pathname;
      if (search !== null) {
        url2.query = query;
        url2.search = search;
      }
      return url2;
    }
    function fresh(url2, parsedUrl) {
      return typeof parsedUrl === "object" && parsedUrl !== null && (Url === void 0 || parsedUrl instanceof Url) && parsedUrl._raw === url2;
    }
  }
});

// node_modules/statuses/codes.json
var require_codes = __commonJS({
  "node_modules/statuses/codes.json"(exports2, module2) {
    module2.exports = {
      "100": "Continue",
      "101": "Switching Protocols",
      "102": "Processing",
      "103": "Early Hints",
      "200": "OK",
      "201": "Created",
      "202": "Accepted",
      "203": "Non-Authoritative Information",
      "204": "No Content",
      "205": "Reset Content",
      "206": "Partial Content",
      "207": "Multi-Status",
      "208": "Already Reported",
      "226": "IM Used",
      "300": "Multiple Choices",
      "301": "Moved Permanently",
      "302": "Found",
      "303": "See Other",
      "304": "Not Modified",
      "305": "Use Proxy",
      "306": "(Unused)",
      "307": "Temporary Redirect",
      "308": "Permanent Redirect",
      "400": "Bad Request",
      "401": "Unauthorized",
      "402": "Payment Required",
      "403": "Forbidden",
      "404": "Not Found",
      "405": "Method Not Allowed",
      "406": "Not Acceptable",
      "407": "Proxy Authentication Required",
      "408": "Request Timeout",
      "409": "Conflict",
      "410": "Gone",
      "411": "Length Required",
      "412": "Precondition Failed",
      "413": "Payload Too Large",
      "414": "URI Too Long",
      "415": "Unsupported Media Type",
      "416": "Range Not Satisfiable",
      "417": "Expectation Failed",
      "418": "I'm a teapot",
      "421": "Misdirected Request",
      "422": "Unprocessable Entity",
      "423": "Locked",
      "424": "Failed Dependency",
      "425": "Unordered Collection",
      "426": "Upgrade Required",
      "428": "Precondition Required",
      "429": "Too Many Requests",
      "431": "Request Header Fields Too Large",
      "451": "Unavailable For Legal Reasons",
      "500": "Internal Server Error",
      "501": "Not Implemented",
      "502": "Bad Gateway",
      "503": "Service Unavailable",
      "504": "Gateway Timeout",
      "505": "HTTP Version Not Supported",
      "506": "Variant Also Negotiates",
      "507": "Insufficient Storage",
      "508": "Loop Detected",
      "509": "Bandwidth Limit Exceeded",
      "510": "Not Extended",
      "511": "Network Authentication Required"
    };
  }
});

// node_modules/statuses/index.js
var require_statuses = __commonJS({
  "node_modules/statuses/index.js"(exports2, module2) {
    "use strict";
    var codes = require_codes();
    module2.exports = status;
    status.STATUS_CODES = codes;
    status.codes = populateStatusesMap(status, codes);
    status.redirect = {
      300: true,
      301: true,
      302: true,
      303: true,
      305: true,
      307: true,
      308: true
    };
    status.empty = {
      204: true,
      205: true,
      304: true
    };
    status.retry = {
      502: true,
      503: true,
      504: true
    };
    function populateStatusesMap(statuses, codes2) {
      var arr = [];
      Object.keys(codes2).forEach(function forEachCode(code) {
        var message = codes2[code];
        var status2 = Number(code);
        statuses[status2] = message;
        statuses[message] = status2;
        statuses[message.toLowerCase()] = status2;
        arr.push(status2);
      });
      return arr;
    }
    function status(code) {
      if (typeof code === "number") {
        if (!status[code])
          throw new Error("invalid status code: " + code);
        return code;
      }
      if (typeof code !== "string") {
        throw new TypeError("code must be a number or string");
      }
      var n = parseInt(code, 10);
      if (!isNaN(n)) {
        if (!status[n])
          throw new Error("invalid status code: " + n);
        return n;
      }
      n = status[code.toLowerCase()];
      if (!n)
        throw new Error('invalid status message: "' + code + '"');
      return n;
    }
  }
});

// node_modules/unpipe/index.js
var require_unpipe = __commonJS({
  "node_modules/unpipe/index.js"(exports2, module2) {
    "use strict";
    module2.exports = unpipe;
    function hasPipeDataListeners(stream) {
      var listeners = stream.listeners("data");
      for (var i = 0; i < listeners.length; i++) {
        if (listeners[i].name === "ondata") {
          return true;
        }
      }
      return false;
    }
    function unpipe(stream) {
      if (!stream) {
        throw new TypeError("argument stream is required");
      }
      if (typeof stream.unpipe === "function") {
        stream.unpipe();
        return;
      }
      if (!hasPipeDataListeners(stream)) {
        return;
      }
      var listener;
      var listeners = stream.listeners("close");
      for (var i = 0; i < listeners.length; i++) {
        listener = listeners[i];
        if (listener.name !== "cleanup" && listener.name !== "onclose") {
          continue;
        }
        listener.call(stream);
      }
    }
  }
});

// node_modules/finalhandler/index.js
var require_finalhandler = __commonJS({
  "node_modules/finalhandler/index.js"(exports2, module2) {
    "use strict";
    var debug = require_src()("finalhandler");
    var encodeUrl = require_encodeurl();
    var escapeHtml = require_escape_html();
    var onFinished = require_on_finished();
    var parseUrl = require_parseurl();
    var statuses = require_statuses();
    var unpipe = require_unpipe();
    var DOUBLE_SPACE_REGEXP = /\x20{2}/g;
    var NEWLINE_REGEXP = /\n/g;
    var defer = typeof setImmediate === "function" ? setImmediate : function(fn2) {
      process.nextTick(fn2.bind.apply(fn2, arguments));
    };
    var isFinished = onFinished.isFinished;
    function createHtmlDocument(message) {
      var body2 = escapeHtml(message).replace(NEWLINE_REGEXP, "<br>").replace(DOUBLE_SPACE_REGEXP, " &nbsp;");
      return '<!DOCTYPE html>\n<html lang="en">\n<head>\n<meta charset="utf-8">\n<title>Error</title>\n</head>\n<body>\n<pre>' + body2 + "</pre>\n</body>\n</html>\n";
    }
    module2.exports = finalhandler2;
    function finalhandler2(req, res, options) {
      var opts = options || {};
      var env = opts.env || process.env.NODE_ENV || "development";
      var onerror = opts.onerror;
      return function(err) {
        var headers;
        var msg;
        var status;
        if (!err && headersSent(res)) {
          debug("cannot 404 after headers sent");
          return;
        }
        if (err) {
          status = getErrorStatusCode(err);
          if (status === void 0) {
            status = getResponseStatusCode(res);
          } else {
            headers = getErrorHeaders(err);
          }
          msg = getErrorMessage(err, status, env);
        } else {
          status = 404;
          msg = "Cannot " + req.method + " " + encodeUrl(getResourceName(req));
        }
        debug("default %s", status);
        if (err && onerror) {
          defer(onerror, err, req, res);
        }
        if (headersSent(res)) {
          debug("cannot %d after headers sent", status);
          req.socket.destroy();
          return;
        }
        send(req, res, status, headers, msg);
      };
    }
    function getErrorHeaders(err) {
      if (!err.headers || typeof err.headers !== "object") {
        return void 0;
      }
      var headers = Object.create(null);
      var keys2 = Object.keys(err.headers);
      for (var i = 0; i < keys2.length; i++) {
        var key = keys2[i];
        headers[key] = err.headers[key];
      }
      return headers;
    }
    function getErrorMessage(err, status, env) {
      var msg;
      if (env !== "production") {
        msg = err.stack;
        if (!msg && typeof err.toString === "function") {
          msg = err.toString();
        }
      }
      return msg || statuses[status];
    }
    function getErrorStatusCode(err) {
      if (typeof err.status === "number" && err.status >= 400 && err.status < 600) {
        return err.status;
      }
      if (typeof err.statusCode === "number" && err.statusCode >= 400 && err.statusCode < 600) {
        return err.statusCode;
      }
      return void 0;
    }
    function getResourceName(req) {
      try {
        return parseUrl.original(req).pathname;
      } catch (e) {
        return "resource";
      }
    }
    function getResponseStatusCode(res) {
      var status = res.statusCode;
      if (typeof status !== "number" || status < 400 || status > 599) {
        status = 500;
      }
      return status;
    }
    function headersSent(res) {
      return typeof res.headersSent !== "boolean" ? Boolean(res._header) : res.headersSent;
    }
    function send(req, res, status, headers, message) {
      function write() {
        var body2 = createHtmlDocument(message);
        res.statusCode = status;
        res.statusMessage = statuses[status];
        setHeaders(res, headers);
        res.setHeader("Content-Security-Policy", "default-src 'none'");
        res.setHeader("X-Content-Type-Options", "nosniff");
        res.setHeader("Content-Type", "text/html; charset=utf-8");
        res.setHeader("Content-Length", Buffer.byteLength(body2, "utf8"));
        if (req.method === "HEAD") {
          res.end();
          return;
        }
        res.end(body2, "utf8");
      }
      if (isFinished(req)) {
        write();
        return;
      }
      unpipe(req);
      onFinished(req, write);
      req.resume();
    }
    function setHeaders(res, headers) {
      if (!headers) {
        return;
      }
      var keys2 = Object.keys(headers);
      for (var i = 0; i < keys2.length; i++) {
        var key = keys2[i];
        res.setHeader(key, headers[key]);
      }
    }
  }
});

// node_modules/formidable/lib/file.js
var require_file = __commonJS({
  "node_modules/formidable/lib/file.js"(exports2, module2) {
    if (global.GENTLY)
      require = GENTLY.hijack(require);
    var util = require("util");
    var fs = require("fs");
    var EventEmitter = require("events").EventEmitter;
    var crypto = require("crypto");
    function File(properties) {
      EventEmitter.call(this);
      this.size = 0;
      this.path = null;
      this.name = null;
      this.type = null;
      this.hash = null;
      this.lastModifiedDate = null;
      this._writeStream = null;
      for (var key in properties) {
        this[key] = properties[key];
      }
      if (typeof this.hash === "string") {
        this.hash = crypto.createHash(properties.hash);
      } else {
        this.hash = null;
      }
    }
    module2.exports = File;
    util.inherits(File, EventEmitter);
    File.prototype.open = function() {
      this._writeStream = new fs.WriteStream(this.path);
    };
    File.prototype.toJSON = function() {
      var json = {
        size: this.size,
        path: this.path,
        name: this.name,
        type: this.type,
        mtime: this.lastModifiedDate,
        length: this.length,
        filename: this.filename,
        mime: this.mime
      };
      if (this.hash && this.hash != "") {
        json.hash = this.hash;
      }
      return json;
    };
    File.prototype.write = function(buffer, cb) {
      var self = this;
      if (self.hash) {
        self.hash.update(buffer);
      }
      if (this._writeStream.closed) {
        return cb();
      }
      this._writeStream.write(buffer, function() {
        self.lastModifiedDate = new Date();
        self.size += buffer.length;
        self.emit("progress", self.size);
        cb();
      });
    };
    File.prototype.end = function(cb) {
      var self = this;
      if (self.hash) {
        self.hash = self.hash.digest("hex");
      }
      this._writeStream.end(function() {
        self.emit("end");
        cb();
      });
    };
  }
});

// node_modules/formidable/lib/multipart_parser.js
var require_multipart_parser = __commonJS({
  "node_modules/formidable/lib/multipart_parser.js"(exports2) {
    var Buffer2 = require("buffer").Buffer;
    var s = 0;
    var S = {
      PARSER_UNINITIALIZED: s++,
      START: s++,
      START_BOUNDARY: s++,
      HEADER_FIELD_START: s++,
      HEADER_FIELD: s++,
      HEADER_VALUE_START: s++,
      HEADER_VALUE: s++,
      HEADER_VALUE_ALMOST_DONE: s++,
      HEADERS_ALMOST_DONE: s++,
      PART_DATA_START: s++,
      PART_DATA: s++,
      PART_END: s++,
      END: s++
    };
    var f = 1;
    var F = {
      PART_BOUNDARY: f,
      LAST_BOUNDARY: f *= 2
    };
    var LF = 10;
    var CR = 13;
    var SPACE = 32;
    var HYPHEN = 45;
    var COLON = 58;
    var A = 97;
    var Z = 122;
    var lower = function(c) {
      return c | 32;
    };
    for (s in S) {
      exports2[s] = S[s];
    }
    function MultipartParser() {
      this.boundary = null;
      this.boundaryChars = null;
      this.lookbehind = null;
      this.state = S.PARSER_UNINITIALIZED;
      this.index = null;
      this.flags = 0;
    }
    exports2.MultipartParser = MultipartParser;
    MultipartParser.stateToString = function(stateNumber) {
      for (var state in S) {
        var number = S[state];
        if (number === stateNumber)
          return state;
      }
    };
    MultipartParser.prototype.initWithBoundary = function(str2) {
      this.boundary = new Buffer2(str2.length + 4);
      this.boundary.write("\r\n--", 0);
      this.boundary.write(str2, 4);
      this.lookbehind = new Buffer2(this.boundary.length + 8);
      this.state = S.START;
      this.boundaryChars = {};
      for (var i = 0; i < this.boundary.length; i++) {
        this.boundaryChars[this.boundary[i]] = true;
      }
    };
    MultipartParser.prototype.write = function(buffer) {
      var self = this, i = 0, len = buffer.length, prevIndex = this.index, index = this.index, state = this.state, flags = this.flags, lookbehind = this.lookbehind, boundary = this.boundary, boundaryChars = this.boundaryChars, boundaryLength = this.boundary.length, boundaryEnd = boundaryLength - 1, bufferLength = buffer.length, c, cl, mark = function(name) {
        self[name + "Mark"] = i;
      }, clear = function(name) {
        delete self[name + "Mark"];
      }, callback = function(name, buffer2, start, end) {
        if (start !== void 0 && start === end) {
          return;
        }
        var callbackSymbol = "on" + name.substr(0, 1).toUpperCase() + name.substr(1);
        if (callbackSymbol in self) {
          self[callbackSymbol](buffer2, start, end);
        }
      }, dataCallback = function(name, clear2) {
        var markSymbol = name + "Mark";
        if (!(markSymbol in self)) {
          return;
        }
        if (!clear2) {
          callback(name, buffer, self[markSymbol], buffer.length);
          self[markSymbol] = 0;
        } else {
          callback(name, buffer, self[markSymbol], i);
          delete self[markSymbol];
        }
      };
      for (i = 0; i < len; i++) {
        c = buffer[i];
        switch (state) {
          case S.PARSER_UNINITIALIZED:
            return i;
          case S.START:
            index = 0;
            state = S.START_BOUNDARY;
          case S.START_BOUNDARY:
            if (index == boundary.length - 2) {
              if (c == HYPHEN) {
                flags |= F.LAST_BOUNDARY;
              } else if (c != CR) {
                return i;
              }
              index++;
              break;
            } else if (index - 1 == boundary.length - 2) {
              if (flags & F.LAST_BOUNDARY && c == HYPHEN) {
                callback("end");
                state = S.END;
                flags = 0;
              } else if (!(flags & F.LAST_BOUNDARY) && c == LF) {
                index = 0;
                callback("partBegin");
                state = S.HEADER_FIELD_START;
              } else {
                return i;
              }
              break;
            }
            if (c != boundary[index + 2]) {
              index = -2;
            }
            if (c == boundary[index + 2]) {
              index++;
            }
            break;
          case S.HEADER_FIELD_START:
            state = S.HEADER_FIELD;
            mark("headerField");
            index = 0;
          case S.HEADER_FIELD:
            if (c == CR) {
              clear("headerField");
              state = S.HEADERS_ALMOST_DONE;
              break;
            }
            index++;
            if (c == HYPHEN) {
              break;
            }
            if (c == COLON) {
              if (index == 1) {
                return i;
              }
              dataCallback("headerField", true);
              state = S.HEADER_VALUE_START;
              break;
            }
            cl = lower(c);
            if (cl < A || cl > Z) {
              return i;
            }
            break;
          case S.HEADER_VALUE_START:
            if (c == SPACE) {
              break;
            }
            mark("headerValue");
            state = S.HEADER_VALUE;
          case S.HEADER_VALUE:
            if (c == CR) {
              dataCallback("headerValue", true);
              callback("headerEnd");
              state = S.HEADER_VALUE_ALMOST_DONE;
            }
            break;
          case S.HEADER_VALUE_ALMOST_DONE:
            if (c != LF) {
              return i;
            }
            state = S.HEADER_FIELD_START;
            break;
          case S.HEADERS_ALMOST_DONE:
            if (c != LF) {
              return i;
            }
            callback("headersEnd");
            state = S.PART_DATA_START;
            break;
          case S.PART_DATA_START:
            state = S.PART_DATA;
            mark("partData");
          case S.PART_DATA:
            prevIndex = index;
            if (index === 0) {
              i += boundaryEnd;
              while (i < bufferLength && !(buffer[i] in boundaryChars)) {
                i += boundaryLength;
              }
              i -= boundaryEnd;
              c = buffer[i];
            }
            if (index < boundary.length) {
              if (boundary[index] == c) {
                if (index === 0) {
                  dataCallback("partData", true);
                }
                index++;
              } else {
                index = 0;
              }
            } else if (index == boundary.length) {
              index++;
              if (c == CR) {
                flags |= F.PART_BOUNDARY;
              } else if (c == HYPHEN) {
                flags |= F.LAST_BOUNDARY;
              } else {
                index = 0;
              }
            } else if (index - 1 == boundary.length) {
              if (flags & F.PART_BOUNDARY) {
                index = 0;
                if (c == LF) {
                  flags &= ~F.PART_BOUNDARY;
                  callback("partEnd");
                  callback("partBegin");
                  state = S.HEADER_FIELD_START;
                  break;
                }
              } else if (flags & F.LAST_BOUNDARY) {
                if (c == HYPHEN) {
                  callback("partEnd");
                  callback("end");
                  state = S.END;
                  flags = 0;
                } else {
                  index = 0;
                }
              } else {
                index = 0;
              }
            }
            if (index > 0) {
              lookbehind[index - 1] = c;
            } else if (prevIndex > 0) {
              callback("partData", lookbehind, 0, prevIndex);
              prevIndex = 0;
              mark("partData");
              i--;
            }
            break;
          case S.END:
            break;
          default:
            return i;
        }
      }
      dataCallback("headerField");
      dataCallback("headerValue");
      dataCallback("partData");
      this.index = index;
      this.state = state;
      this.flags = flags;
      return len;
    };
    MultipartParser.prototype.end = function() {
      var callback = function(self, name) {
        var callbackSymbol = "on" + name.substr(0, 1).toUpperCase() + name.substr(1);
        if (callbackSymbol in self) {
          self[callbackSymbol]();
        }
      };
      if (this.state == S.HEADER_FIELD_START && this.index === 0 || this.state == S.PART_DATA && this.index == this.boundary.length) {
        callback(this, "partEnd");
        callback(this, "end");
      } else if (this.state != S.END) {
        return new Error("MultipartParser.end(): stream ended unexpectedly: " + this.explain());
      }
    };
    MultipartParser.prototype.explain = function() {
      return "state = " + MultipartParser.stateToString(this.state);
    };
  }
});

// node_modules/formidable/lib/querystring_parser.js
var require_querystring_parser = __commonJS({
  "node_modules/formidable/lib/querystring_parser.js"(exports2) {
    if (global.GENTLY)
      require = GENTLY.hijack(require);
    var querystring = require("querystring");
    function QuerystringParser(maxKeys) {
      this.maxKeys = maxKeys;
      this.buffer = "";
    }
    exports2.QuerystringParser = QuerystringParser;
    QuerystringParser.prototype.write = function(buffer) {
      this.buffer += buffer.toString("ascii");
      return buffer.length;
    };
    QuerystringParser.prototype.end = function() {
      var fields = querystring.parse(this.buffer, "&", "=", {maxKeys: this.maxKeys});
      for (var field in fields) {
        this.onField(field, fields[field]);
      }
      this.buffer = "";
      this.onEnd();
    };
  }
});

// node_modules/formidable/lib/octet_parser.js
var require_octet_parser = __commonJS({
  "node_modules/formidable/lib/octet_parser.js"(exports2) {
    var EventEmitter = require("events").EventEmitter;
    var util = require("util");
    function OctetParser(options) {
      if (!(this instanceof OctetParser))
        return new OctetParser(options);
      EventEmitter.call(this);
    }
    util.inherits(OctetParser, EventEmitter);
    exports2.OctetParser = OctetParser;
    OctetParser.prototype.write = function(buffer) {
      this.emit("data", buffer);
      return buffer.length;
    };
    OctetParser.prototype.end = function() {
      this.emit("end");
    };
  }
});

// node_modules/formidable/lib/json_parser.js
var require_json_parser = __commonJS({
  "node_modules/formidable/lib/json_parser.js"(exports2) {
    if (global.GENTLY)
      require = GENTLY.hijack(require);
    var Buffer2 = require("buffer").Buffer;
    function JSONParser(parent) {
      this.parent = parent;
      this.chunks = [];
      this.bytesWritten = 0;
    }
    exports2.JSONParser = JSONParser;
    JSONParser.prototype.write = function(buffer) {
      this.bytesWritten += buffer.length;
      this.chunks.push(buffer);
      return buffer.length;
    };
    JSONParser.prototype.end = function() {
      try {
        var fields = JSON.parse(Buffer2.concat(this.chunks));
        for (var field in fields) {
          this.onField(field, fields[field]);
        }
      } catch (e) {
        this.parent.emit("error", e);
      }
      this.data = null;
      this.onEnd();
    };
  }
});

// node_modules/formidable/lib/incoming_form.js
var require_incoming_form = __commonJS({
  "node_modules/formidable/lib/incoming_form.js"(exports2) {
    if (global.GENTLY)
      require = GENTLY.hijack(require);
    var crypto = require("crypto");
    var fs = require("fs");
    var util = require("util");
    var path = require("path");
    var File = require_file();
    var MultipartParser = require_multipart_parser().MultipartParser;
    var QuerystringParser = require_querystring_parser().QuerystringParser;
    var OctetParser = require_octet_parser().OctetParser;
    var JSONParser = require_json_parser().JSONParser;
    var StringDecoder = require("string_decoder").StringDecoder;
    var EventEmitter = require("events").EventEmitter;
    var Stream = require("stream").Stream;
    var os = require("os");
    function IncomingForm2(opts) {
      if (!(this instanceof IncomingForm2))
        return new IncomingForm2(opts);
      EventEmitter.call(this);
      opts = opts || {};
      this.error = null;
      this.ended = false;
      this.maxFields = opts.maxFields || 1e3;
      this.maxFieldsSize = opts.maxFieldsSize || 20 * 1024 * 1024;
      this.maxFileSize = opts.maxFileSize || 200 * 1024 * 1024;
      this.keepExtensions = opts.keepExtensions || false;
      this.uploadDir = opts.uploadDir || os.tmpdir && os.tmpdir() || os.tmpDir();
      this.encoding = opts.encoding || "utf-8";
      this.headers = null;
      this.type = null;
      this.hash = opts.hash || false;
      this.multiples = opts.multiples || false;
      this.bytesReceived = null;
      this.bytesExpected = null;
      this._parser = null;
      this._flushing = 0;
      this._fieldsSize = 0;
      this._fileSize = 0;
      this.openedFiles = [];
      return this;
    }
    util.inherits(IncomingForm2, EventEmitter);
    exports2.IncomingForm = IncomingForm2;
    IncomingForm2.prototype.parse = function(req, cb) {
      this.pause = function() {
        try {
          req.pause();
        } catch (err) {
          if (!this.ended) {
            this._error(err);
          }
          return false;
        }
        return true;
      };
      this.resume = function() {
        try {
          req.resume();
        } catch (err) {
          if (!this.ended) {
            this._error(err);
          }
          return false;
        }
        return true;
      };
      if (cb) {
        var fields = {}, files = {};
        this.on("field", function(name, value) {
          fields[name] = value;
        }).on("file", function(name, file) {
          if (this.multiples) {
            if (files[name]) {
              if (!Array.isArray(files[name])) {
                files[name] = [files[name]];
              }
              files[name].push(file);
            } else {
              files[name] = file;
            }
          } else {
            files[name] = file;
          }
        }).on("error", function(err) {
          cb(err, fields, files);
        }).on("end", function() {
          cb(null, fields, files);
        });
      }
      this.writeHeaders(req.headers);
      var self = this;
      req.on("error", function(err) {
        self._error(err);
      }).on("aborted", function() {
        self.emit("aborted");
        self._error(new Error("Request aborted"));
      }).on("data", function(buffer) {
        self.write(buffer);
      }).on("end", function() {
        if (self.error) {
          return;
        }
        var err = self._parser.end();
        if (err) {
          self._error(err);
        }
      });
      return this;
    };
    IncomingForm2.prototype.writeHeaders = function(headers) {
      this.headers = headers;
      this._parseContentLength();
      this._parseContentType();
    };
    IncomingForm2.prototype.write = function(buffer) {
      if (this.error) {
        return;
      }
      if (!this._parser) {
        this._error(new Error("uninitialized parser"));
        return;
      }
      this.bytesReceived += buffer.length;
      this.emit("progress", this.bytesReceived, this.bytesExpected);
      var bytesParsed = this._parser.write(buffer);
      if (bytesParsed !== buffer.length) {
        this._error(new Error("parser error, " + bytesParsed + " of " + buffer.length + " bytes parsed"));
      }
      return bytesParsed;
    };
    IncomingForm2.prototype.pause = function() {
      return false;
    };
    IncomingForm2.prototype.resume = function() {
      return false;
    };
    IncomingForm2.prototype.onPart = function(part) {
      this.handlePart(part);
    };
    IncomingForm2.prototype.handlePart = function(part) {
      var self = this;
      if (part.filename === void 0) {
        var value = "", decoder = new StringDecoder(this.encoding);
        part.on("data", function(buffer) {
          self._fieldsSize += buffer.length;
          if (self._fieldsSize > self.maxFieldsSize) {
            self._error(new Error("maxFieldsSize exceeded, received " + self._fieldsSize + " bytes of field data"));
            return;
          }
          value += decoder.write(buffer);
        });
        part.on("end", function() {
          self.emit("field", part.name, value);
        });
        return;
      }
      this._flushing++;
      var file = new File({
        path: this._uploadPath(part.filename),
        name: part.filename,
        type: part.mime,
        hash: self.hash
      });
      this.emit("fileBegin", part.name, file);
      file.open();
      this.openedFiles.push(file);
      part.on("data", function(buffer) {
        self._fileSize += buffer.length;
        if (self._fileSize > self.maxFileSize) {
          self._error(new Error("maxFileSize exceeded, received " + self._fileSize + " bytes of file data"));
          return;
        }
        if (buffer.length == 0) {
          return;
        }
        self.pause();
        file.write(buffer, function() {
          self.resume();
        });
      });
      part.on("end", function() {
        file.end(function() {
          self._flushing--;
          self.emit("file", part.name, file);
          self._maybeEnd();
        });
      });
    };
    function dummyParser(self) {
      return {
        end: function() {
          self.ended = true;
          self._maybeEnd();
          return null;
        }
      };
    }
    IncomingForm2.prototype._parseContentType = function() {
      if (this.bytesExpected === 0) {
        this._parser = dummyParser(this);
        return;
      }
      if (!this.headers["content-type"]) {
        this._error(new Error("bad content-type header, no content-type"));
        return;
      }
      if (this.headers["content-type"].match(/octet-stream/i)) {
        this._initOctetStream();
        return;
      }
      if (this.headers["content-type"].match(/urlencoded/i)) {
        this._initUrlencoded();
        return;
      }
      if (this.headers["content-type"].match(/multipart/i)) {
        var m = this.headers["content-type"].match(/boundary=(?:"([^"]+)"|([^;]+))/i);
        if (m) {
          this._initMultipart(m[1] || m[2]);
        } else {
          this._error(new Error("bad content-type header, no multipart boundary"));
        }
        return;
      }
      if (this.headers["content-type"].match(/json/i)) {
        this._initJSONencoded();
        return;
      }
      this._error(new Error("bad content-type header, unknown content-type: " + this.headers["content-type"]));
    };
    IncomingForm2.prototype._error = function(err) {
      if (this.error || this.ended) {
        return;
      }
      this.error = err;
      this.emit("error", err);
      if (Array.isArray(this.openedFiles)) {
        this.openedFiles.forEach(function(file) {
          file._writeStream.destroy();
          setTimeout(fs.unlink, 0, file.path, function(error) {
          });
        });
      }
    };
    IncomingForm2.prototype._parseContentLength = function() {
      this.bytesReceived = 0;
      if (this.headers["content-length"]) {
        this.bytesExpected = parseInt(this.headers["content-length"], 10);
      } else if (this.headers["transfer-encoding"] === void 0) {
        this.bytesExpected = 0;
      }
      if (this.bytesExpected !== null) {
        this.emit("progress", this.bytesReceived, this.bytesExpected);
      }
    };
    IncomingForm2.prototype._newParser = function() {
      return new MultipartParser();
    };
    IncomingForm2.prototype._initMultipart = function(boundary) {
      this.type = "multipart";
      var parser = new MultipartParser(), self = this, headerField, headerValue, part;
      parser.initWithBoundary(boundary);
      parser.onPartBegin = function() {
        part = new Stream();
        part.readable = true;
        part.headers = {};
        part.name = null;
        part.filename = null;
        part.mime = null;
        part.transferEncoding = "binary";
        part.transferBuffer = "";
        headerField = "";
        headerValue = "";
      };
      parser.onHeaderField = function(b, start, end) {
        headerField += b.toString(self.encoding, start, end);
      };
      parser.onHeaderValue = function(b, start, end) {
        headerValue += b.toString(self.encoding, start, end);
      };
      parser.onHeaderEnd = function() {
        headerField = headerField.toLowerCase();
        part.headers[headerField] = headerValue;
        var m = headerValue.match(/\bname=("([^"]*)"|([^\(\)<>@,;:\\"\/\[\]\?=\{\}\s\t/]+))/i);
        if (headerField == "content-disposition") {
          if (m) {
            part.name = m[2] || m[3] || "";
          }
          part.filename = self._fileName(headerValue);
        } else if (headerField == "content-type") {
          part.mime = headerValue;
        } else if (headerField == "content-transfer-encoding") {
          part.transferEncoding = headerValue.toLowerCase();
        }
        headerField = "";
        headerValue = "";
      };
      parser.onHeadersEnd = function() {
        switch (part.transferEncoding) {
          case "binary":
          case "7bit":
          case "8bit":
            parser.onPartData = function(b, start, end) {
              part.emit("data", b.slice(start, end));
            };
            parser.onPartEnd = function() {
              part.emit("end");
            };
            break;
          case "base64":
            parser.onPartData = function(b, start, end) {
              part.transferBuffer += b.slice(start, end).toString("ascii");
              var offset = parseInt(part.transferBuffer.length / 4, 10) * 4;
              part.emit("data", new Buffer(part.transferBuffer.substring(0, offset), "base64"));
              part.transferBuffer = part.transferBuffer.substring(offset);
            };
            parser.onPartEnd = function() {
              part.emit("data", new Buffer(part.transferBuffer, "base64"));
              part.emit("end");
            };
            break;
          default:
            return self._error(new Error("unknown transfer-encoding"));
        }
        self.onPart(part);
      };
      parser.onEnd = function() {
        self.ended = true;
        self._maybeEnd();
      };
      this._parser = parser;
    };
    IncomingForm2.prototype._fileName = function(headerValue) {
      var m = headerValue.match(/\bfilename=("(.*?)"|([^\(\)<>@,;:\\"\/\[\]\?=\{\}\s\t/]+))($|;\s)/i);
      if (!m)
        return;
      var match = m[2] || m[3] || "";
      var filename = match.substr(match.lastIndexOf("\\") + 1);
      filename = filename.replace(/%22/g, '"');
      filename = filename.replace(/&#([\d]{4});/g, function(m2, code) {
        return String.fromCharCode(code);
      });
      return filename;
    };
    IncomingForm2.prototype._initUrlencoded = function() {
      this.type = "urlencoded";
      var parser = new QuerystringParser(this.maxFields), self = this;
      parser.onField = function(key, val) {
        self.emit("field", key, val);
      };
      parser.onEnd = function() {
        self.ended = true;
        self._maybeEnd();
      };
      this._parser = parser;
    };
    IncomingForm2.prototype._initOctetStream = function() {
      this.type = "octet-stream";
      var filename = this.headers["x-file-name"];
      var mime = this.headers["content-type"];
      var file = new File({
        path: this._uploadPath(filename),
        name: filename,
        type: mime
      });
      this.emit("fileBegin", filename, file);
      file.open();
      this.openedFiles.push(file);
      this._flushing++;
      var self = this;
      self._parser = new OctetParser();
      var outstandingWrites = 0;
      self._parser.on("data", function(buffer) {
        self.pause();
        outstandingWrites++;
        file.write(buffer, function() {
          outstandingWrites--;
          self.resume();
          if (self.ended) {
            self._parser.emit("doneWritingFile");
          }
        });
      });
      self._parser.on("end", function() {
        self._flushing--;
        self.ended = true;
        var done = function() {
          file.end(function() {
            self.emit("file", "file", file);
            self._maybeEnd();
          });
        };
        if (outstandingWrites === 0) {
          done();
        } else {
          self._parser.once("doneWritingFile", done);
        }
      });
    };
    IncomingForm2.prototype._initJSONencoded = function() {
      this.type = "json";
      var parser = new JSONParser(this), self = this;
      parser.onField = function(key, val) {
        self.emit("field", key, val);
      };
      parser.onEnd = function() {
        self.ended = true;
        self._maybeEnd();
      };
      this._parser = parser;
    };
    IncomingForm2.prototype._uploadPath = function(filename) {
      var buf = crypto.randomBytes(16);
      var name = "upload_" + buf.toString("hex");
      if (this.keepExtensions) {
        var ext = path.extname(filename);
        ext = ext.replace(/(\.[a-z0-9]+).*/i, "$1");
        name += ext;
      }
      return path.join(this.uploadDir, name);
    };
    IncomingForm2.prototype._maybeEnd = function() {
      if (!this.ended || this._flushing || this.error) {
        return;
      }
      this.emit("end");
    };
  }
});

// node_modules/formidable/lib/index.js
var require_lib2 = __commonJS({
  "node_modules/formidable/lib/index.js"(exports2, module2) {
    var IncomingForm2 = require_incoming_form().IncomingForm;
    IncomingForm2.IncomingForm = IncomingForm2;
    module2.exports = IncomingForm2;
  }
});

// node_modules/ip/lib/ip.js
var require_ip = __commonJS({
  "node_modules/ip/lib/ip.js"(exports2) {
    "use strict";
    var ip = exports2;
    var Buffer2 = require("buffer").Buffer;
    var os = require("os");
    ip.toBuffer = function(ip2, buff, offset) {
      offset = ~~offset;
      var result;
      if (this.isV4Format(ip2)) {
        result = buff || new Buffer2(offset + 4);
        ip2.split(/\./g).map(function(byte) {
          result[offset++] = parseInt(byte, 10) & 255;
        });
      } else if (this.isV6Format(ip2)) {
        var sections = ip2.split(":", 8);
        var i;
        for (i = 0; i < sections.length; i++) {
          var isv4 = this.isV4Format(sections[i]);
          var v4Buffer;
          if (isv4) {
            v4Buffer = this.toBuffer(sections[i]);
            sections[i] = v4Buffer.slice(0, 2).toString("hex");
          }
          if (v4Buffer && ++i < 8) {
            sections.splice(i, 0, v4Buffer.slice(2, 4).toString("hex"));
          }
        }
        if (sections[0] === "") {
          while (sections.length < 8)
            sections.unshift("0");
        } else if (sections[sections.length - 1] === "") {
          while (sections.length < 8)
            sections.push("0");
        } else if (sections.length < 8) {
          for (i = 0; i < sections.length && sections[i] !== ""; i++)
            ;
          var argv = [i, 1];
          for (i = 9 - sections.length; i > 0; i--) {
            argv.push("0");
          }
          sections.splice.apply(sections, argv);
        }
        result = buff || new Buffer2(offset + 16);
        for (i = 0; i < sections.length; i++) {
          var word = parseInt(sections[i], 16);
          result[offset++] = word >> 8 & 255;
          result[offset++] = word & 255;
        }
      }
      if (!result) {
        throw Error("Invalid ip address: " + ip2);
      }
      return result;
    };
    ip.toString = function(buff, offset, length) {
      offset = ~~offset;
      length = length || buff.length - offset;
      var result = [];
      if (length === 4) {
        for (var i = 0; i < length; i++) {
          result.push(buff[offset + i]);
        }
        result = result.join(".");
      } else if (length === 16) {
        for (var i = 0; i < length; i += 2) {
          result.push(buff.readUInt16BE(offset + i).toString(16));
        }
        result = result.join(":");
        result = result.replace(/(^|:)0(:0)*:0(:|$)/, "$1::$3");
        result = result.replace(/:{3,4}/, "::");
      }
      return result;
    };
    var ipv4Regex = /^(\d{1,3}\.){3,3}\d{1,3}$/;
    var ipv6Regex = /^(::)?(((\d{1,3}\.){3}(\d{1,3}){1})?([0-9a-f]){0,4}:{0,2}){1,8}(::)?$/i;
    ip.isV4Format = function(ip2) {
      return ipv4Regex.test(ip2);
    };
    ip.isV6Format = function(ip2) {
      return ipv6Regex.test(ip2);
    };
    function _normalizeFamily(family) {
      return family ? family.toLowerCase() : "ipv4";
    }
    ip.fromPrefixLen = function(prefixlen, family) {
      if (prefixlen > 32) {
        family = "ipv6";
      } else {
        family = _normalizeFamily(family);
      }
      var len = 4;
      if (family === "ipv6") {
        len = 16;
      }
      var buff = new Buffer2(len);
      for (var i = 0, n = buff.length; i < n; ++i) {
        var bits = 8;
        if (prefixlen < 8) {
          bits = prefixlen;
        }
        prefixlen -= bits;
        buff[i] = ~(255 >> bits) & 255;
      }
      return ip.toString(buff);
    };
    ip.mask = function(addr, mask) {
      addr = ip.toBuffer(addr);
      mask = ip.toBuffer(mask);
      var result = new Buffer2(Math.max(addr.length, mask.length));
      var i = 0;
      if (addr.length === mask.length) {
        for (i = 0; i < addr.length; i++) {
          result[i] = addr[i] & mask[i];
        }
      } else if (mask.length === 4) {
        for (i = 0; i < mask.length; i++) {
          result[i] = addr[addr.length - 4 + i] & mask[i];
        }
      } else {
        for (var i = 0; i < result.length - 6; i++) {
          result[i] = 0;
        }
        result[10] = 255;
        result[11] = 255;
        for (i = 0; i < addr.length; i++) {
          result[i + 12] = addr[i] & mask[i + 12];
        }
        i = i + 12;
      }
      for (; i < result.length; i++)
        result[i] = 0;
      return ip.toString(result);
    };
    ip.cidr = function(cidrString) {
      var cidrParts = cidrString.split("/");
      var addr = cidrParts[0];
      if (cidrParts.length !== 2)
        throw new Error("invalid CIDR subnet: " + addr);
      var mask = ip.fromPrefixLen(parseInt(cidrParts[1], 10));
      return ip.mask(addr, mask);
    };
    ip.subnet = function(addr, mask) {
      var networkAddress = ip.toLong(ip.mask(addr, mask));
      var maskBuffer = ip.toBuffer(mask);
      var maskLength = 0;
      for (var i = 0; i < maskBuffer.length; i++) {
        if (maskBuffer[i] === 255) {
          maskLength += 8;
        } else {
          var octet = maskBuffer[i] & 255;
          while (octet) {
            octet = octet << 1 & 255;
            maskLength++;
          }
        }
      }
      var numberOfAddresses = Math.pow(2, 32 - maskLength);
      return {
        networkAddress: ip.fromLong(networkAddress),
        firstAddress: numberOfAddresses <= 2 ? ip.fromLong(networkAddress) : ip.fromLong(networkAddress + 1),
        lastAddress: numberOfAddresses <= 2 ? ip.fromLong(networkAddress + numberOfAddresses - 1) : ip.fromLong(networkAddress + numberOfAddresses - 2),
        broadcastAddress: ip.fromLong(networkAddress + numberOfAddresses - 1),
        subnetMask: mask,
        subnetMaskLength: maskLength,
        numHosts: numberOfAddresses <= 2 ? numberOfAddresses : numberOfAddresses - 2,
        length: numberOfAddresses,
        contains: function(other) {
          return networkAddress === ip.toLong(ip.mask(other, mask));
        }
      };
    };
    ip.cidrSubnet = function(cidrString) {
      var cidrParts = cidrString.split("/");
      var addr = cidrParts[0];
      if (cidrParts.length !== 2)
        throw new Error("invalid CIDR subnet: " + addr);
      var mask = ip.fromPrefixLen(parseInt(cidrParts[1], 10));
      return ip.subnet(addr, mask);
    };
    ip.not = function(addr) {
      var buff = ip.toBuffer(addr);
      for (var i = 0; i < buff.length; i++) {
        buff[i] = 255 ^ buff[i];
      }
      return ip.toString(buff);
    };
    ip.or = function(a2, b) {
      a2 = ip.toBuffer(a2);
      b = ip.toBuffer(b);
      if (a2.length === b.length) {
        for (var i = 0; i < a2.length; ++i) {
          a2[i] |= b[i];
        }
        return ip.toString(a2);
      } else {
        var buff = a2;
        var other = b;
        if (b.length > a2.length) {
          buff = b;
          other = a2;
        }
        var offset = buff.length - other.length;
        for (var i = offset; i < buff.length; ++i) {
          buff[i] |= other[i - offset];
        }
        return ip.toString(buff);
      }
    };
    ip.isEqual = function(a2, b) {
      a2 = ip.toBuffer(a2);
      b = ip.toBuffer(b);
      if (a2.length === b.length) {
        for (var i = 0; i < a2.length; i++) {
          if (a2[i] !== b[i])
            return false;
        }
        return true;
      }
      if (b.length === 4) {
        var t = b;
        b = a2;
        a2 = t;
      }
      for (var i = 0; i < 10; i++) {
        if (b[i] !== 0)
          return false;
      }
      var word = b.readUInt16BE(10);
      if (word !== 0 && word !== 65535)
        return false;
      for (var i = 0; i < 4; i++) {
        if (a2[i] !== b[i + 12])
          return false;
      }
      return true;
    };
    ip.isPrivate = function(addr) {
      return /^(::f{4}:)?10\.([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})$/i.test(addr) || /^(::f{4}:)?192\.168\.([0-9]{1,3})\.([0-9]{1,3})$/i.test(addr) || /^(::f{4}:)?172\.(1[6-9]|2\d|30|31)\.([0-9]{1,3})\.([0-9]{1,3})$/i.test(addr) || /^(::f{4}:)?127\.([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})$/i.test(addr) || /^(::f{4}:)?169\.254\.([0-9]{1,3})\.([0-9]{1,3})$/i.test(addr) || /^f[cd][0-9a-f]{2}:/i.test(addr) || /^fe80:/i.test(addr) || /^::1$/.test(addr) || /^::$/.test(addr);
    };
    ip.isPublic = function(addr) {
      return !ip.isPrivate(addr);
    };
    ip.isLoopback = function(addr) {
      return /^(::f{4}:)?127\.([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})/.test(addr) || /^fe80::1$/.test(addr) || /^::1$/.test(addr) || /^::$/.test(addr);
    };
    ip.loopback = function(family) {
      family = _normalizeFamily(family);
      if (family !== "ipv4" && family !== "ipv6") {
        throw new Error("family must be ipv4 or ipv6");
      }
      return family === "ipv4" ? "127.0.0.1" : "fe80::1";
    };
    ip.address = function(name, family) {
      var interfaces = os.networkInterfaces();
      var all;
      family = _normalizeFamily(family);
      if (name && name !== "private" && name !== "public") {
        var res = interfaces[name].filter(function(details) {
          var itemFamily = details.family.toLowerCase();
          return itemFamily === family;
        });
        if (res.length === 0)
          return void 0;
        return res[0].address;
      }
      var all = Object.keys(interfaces).map(function(nic) {
        var addresses = interfaces[nic].filter(function(details) {
          details.family = details.family.toLowerCase();
          if (details.family !== family || ip.isLoopback(details.address)) {
            return false;
          } else if (!name) {
            return true;
          }
          return name === "public" ? ip.isPrivate(details.address) : ip.isPublic(details.address);
        });
        return addresses.length ? addresses[0].address : void 0;
      }).filter(Boolean);
      return !all.length ? ip.loopback(family) : all[0];
    };
    ip.toLong = function(ip2) {
      var ipl = 0;
      ip2.split(".").forEach(function(octet) {
        ipl <<= 8;
        ipl += parseInt(octet);
      });
      return ipl >>> 0;
    };
    ip.fromLong = function(ipl) {
      return (ipl >>> 24) + "." + (ipl >> 16 & 255) + "." + (ipl >> 8 & 255) + "." + (ipl & 255);
    };
  }
});

// node_modules/got/package.json
var require_package = __commonJS({
  "node_modules/got/package.json"(exports2, module2) {
    module2.exports = {
      name: "got",
      version: "9.6.0",
      description: "Simplified HTTP requests",
      license: "MIT",
      repository: "sindresorhus/got",
      main: "source",
      engines: {
        node: ">=8.6"
      },
      scripts: {
        test: "xo && nyc ava",
        release: "np"
      },
      files: [
        "source"
      ],
      keywords: [
        "http",
        "https",
        "get",
        "got",
        "url",
        "uri",
        "request",
        "util",
        "utility",
        "simple",
        "curl",
        "wget",
        "fetch",
        "net",
        "network",
        "electron"
      ],
      dependencies: {
        "@sindresorhus/is": "^0.14.0",
        "@szmarczak/http-timer": "^1.1.2",
        "cacheable-request": "^6.0.0",
        "decompress-response": "^3.3.0",
        duplexer3: "^0.1.4",
        "get-stream": "^4.1.0",
        "lowercase-keys": "^1.0.1",
        "mimic-response": "^1.0.1",
        "p-cancelable": "^1.0.0",
        "to-readable-stream": "^1.0.0",
        "url-parse-lax": "^3.0.0"
      },
      devDependencies: {
        ava: "^1.1.0",
        coveralls: "^3.0.0",
        delay: "^4.1.0",
        "form-data": "^2.3.3",
        "get-port": "^4.0.0",
        np: "^3.1.0",
        nyc: "^13.1.0",
        "p-event": "^2.1.0",
        pem: "^1.13.2",
        proxyquire: "^2.0.1",
        sinon: "^7.2.2",
        "slow-stream": "0.0.4",
        tempfile: "^2.0.0",
        tempy: "^0.2.1",
        "tough-cookie": "^3.0.0",
        xo: "^0.24.0"
      },
      ava: {
        concurrency: 4
      },
      browser: {
        "decompress-response": false,
        electron: false
      }
    };
  }
});

// node_modules/p-cancelable/index.js
var require_p_cancelable = __commonJS({
  "node_modules/p-cancelable/index.js"(exports2, module2) {
    "use strict";
    var CancelError = class extends Error {
      constructor(reason) {
        super(reason || "Promise was canceled");
        this.name = "CancelError";
      }
      get isCanceled() {
        return true;
      }
    };
    var PCancelable = class {
      static fn(userFn) {
        return (...args) => {
          return new PCancelable((resolve, reject, onCancel) => {
            args.push(onCancel);
            userFn(...args).then(resolve, reject);
          });
        };
      }
      constructor(executor) {
        this._cancelHandlers = [];
        this._isPending = true;
        this._isCanceled = false;
        this._rejectOnCancel = true;
        this._promise = new Promise((resolve, reject) => {
          this._reject = reject;
          const onResolve = (value) => {
            this._isPending = false;
            resolve(value);
          };
          const onReject = (error) => {
            this._isPending = false;
            reject(error);
          };
          const onCancel = (handler) => {
            this._cancelHandlers.push(handler);
          };
          Object.defineProperties(onCancel, {
            shouldReject: {
              get: () => this._rejectOnCancel,
              set: (bool) => {
                this._rejectOnCancel = bool;
              }
            }
          });
          return executor(onResolve, onReject, onCancel);
        });
      }
      then(onFulfilled, onRejected) {
        return this._promise.then(onFulfilled, onRejected);
      }
      catch(onRejected) {
        return this._promise.catch(onRejected);
      }
      finally(onFinally) {
        return this._promise.finally(onFinally);
      }
      cancel(reason) {
        if (!this._isPending || this._isCanceled) {
          return;
        }
        if (this._cancelHandlers.length > 0) {
          try {
            for (const handler of this._cancelHandlers) {
              handler();
            }
          } catch (error) {
            this._reject(error);
          }
        }
        this._isCanceled = true;
        if (this._rejectOnCancel) {
          this._reject(new CancelError(reason));
        }
      }
      get isCanceled() {
        return this._isCanceled;
      }
    };
    Object.setPrototypeOf(PCancelable.prototype, Promise.prototype);
    module2.exports = PCancelable;
    module2.exports.default = PCancelable;
    module2.exports.CancelError = CancelError;
  }
});

// node_modules/@sindresorhus/is/dist/index.js
var require_dist = __commonJS({
  "node_modules/@sindresorhus/is/dist/index.js"(exports2, module2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", {value: true});
    var URLGlobal = typeof URL === "undefined" ? require("url").URL : URL;
    var toString2 = Object.prototype.toString;
    var isOfType = (type) => (value) => typeof value === type;
    var isBuffer = (input) => !is.nullOrUndefined(input) && !is.nullOrUndefined(input.constructor) && is.function_(input.constructor.isBuffer) && input.constructor.isBuffer(input);
    var getObjectType = (value) => {
      const objectName = toString2.call(value).slice(8, -1);
      if (objectName) {
        return objectName;
      }
      return null;
    };
    var isObjectOfType = (type) => (value) => getObjectType(value) === type;
    function is(value) {
      switch (value) {
        case null:
          return "null";
        case true:
        case false:
          return "boolean";
        default:
      }
      switch (typeof value) {
        case "undefined":
          return "undefined";
        case "string":
          return "string";
        case "number":
          return "number";
        case "symbol":
          return "symbol";
        default:
      }
      if (is.function_(value)) {
        return "Function";
      }
      if (is.observable(value)) {
        return "Observable";
      }
      if (Array.isArray(value)) {
        return "Array";
      }
      if (isBuffer(value)) {
        return "Buffer";
      }
      const tagType = getObjectType(value);
      if (tagType) {
        return tagType;
      }
      if (value instanceof String || value instanceof Boolean || value instanceof Number) {
        throw new TypeError("Please don't use object wrappers for primitive types");
      }
      return "Object";
    }
    (function(is2) {
      const isObject = (value) => typeof value === "object";
      is2.undefined = isOfType("undefined");
      is2.string = isOfType("string");
      is2.number = isOfType("number");
      is2.function_ = isOfType("function");
      is2.null_ = (value) => value === null;
      is2.class_ = (value) => is2.function_(value) && value.toString().startsWith("class ");
      is2.boolean = (value) => value === true || value === false;
      is2.symbol = isOfType("symbol");
      is2.numericString = (value) => is2.string(value) && value.length > 0 && !Number.isNaN(Number(value));
      is2.array = Array.isArray;
      is2.buffer = isBuffer;
      is2.nullOrUndefined = (value) => is2.null_(value) || is2.undefined(value);
      is2.object = (value) => !is2.nullOrUndefined(value) && (is2.function_(value) || isObject(value));
      is2.iterable = (value) => !is2.nullOrUndefined(value) && is2.function_(value[Symbol.iterator]);
      is2.asyncIterable = (value) => !is2.nullOrUndefined(value) && is2.function_(value[Symbol.asyncIterator]);
      is2.generator = (value) => is2.iterable(value) && is2.function_(value.next) && is2.function_(value.throw);
      is2.nativePromise = (value) => isObjectOfType("Promise")(value);
      const hasPromiseAPI = (value) => !is2.null_(value) && isObject(value) && is2.function_(value.then) && is2.function_(value.catch);
      is2.promise = (value) => is2.nativePromise(value) || hasPromiseAPI(value);
      is2.generatorFunction = isObjectOfType("GeneratorFunction");
      is2.asyncFunction = isObjectOfType("AsyncFunction");
      is2.boundFunction = (value) => is2.function_(value) && !value.hasOwnProperty("prototype");
      is2.regExp = isObjectOfType("RegExp");
      is2.date = isObjectOfType("Date");
      is2.error = isObjectOfType("Error");
      is2.map = (value) => isObjectOfType("Map")(value);
      is2.set = (value) => isObjectOfType("Set")(value);
      is2.weakMap = (value) => isObjectOfType("WeakMap")(value);
      is2.weakSet = (value) => isObjectOfType("WeakSet")(value);
      is2.int8Array = isObjectOfType("Int8Array");
      is2.uint8Array = isObjectOfType("Uint8Array");
      is2.uint8ClampedArray = isObjectOfType("Uint8ClampedArray");
      is2.int16Array = isObjectOfType("Int16Array");
      is2.uint16Array = isObjectOfType("Uint16Array");
      is2.int32Array = isObjectOfType("Int32Array");
      is2.uint32Array = isObjectOfType("Uint32Array");
      is2.float32Array = isObjectOfType("Float32Array");
      is2.float64Array = isObjectOfType("Float64Array");
      is2.arrayBuffer = isObjectOfType("ArrayBuffer");
      is2.sharedArrayBuffer = isObjectOfType("SharedArrayBuffer");
      is2.dataView = isObjectOfType("DataView");
      is2.directInstanceOf = (instance, klass) => Object.getPrototypeOf(instance) === klass.prototype;
      is2.urlInstance = (value) => isObjectOfType("URL")(value);
      is2.urlString = (value) => {
        if (!is2.string(value)) {
          return false;
        }
        try {
          new URLGlobal(value);
          return true;
        } catch (_a2) {
          return false;
        }
      };
      is2.truthy = (value) => Boolean(value);
      is2.falsy = (value) => !value;
      is2.nan = (value) => Number.isNaN(value);
      const primitiveTypes = new Set([
        "undefined",
        "string",
        "number",
        "boolean",
        "symbol"
      ]);
      is2.primitive = (value) => is2.null_(value) || primitiveTypes.has(typeof value);
      is2.integer = (value) => Number.isInteger(value);
      is2.safeInteger = (value) => Number.isSafeInteger(value);
      is2.plainObject = (value) => {
        let prototype;
        return getObjectType(value) === "Object" && (prototype = Object.getPrototypeOf(value), prototype === null || prototype === Object.getPrototypeOf({}));
      };
      const typedArrayTypes = new Set([
        "Int8Array",
        "Uint8Array",
        "Uint8ClampedArray",
        "Int16Array",
        "Uint16Array",
        "Int32Array",
        "Uint32Array",
        "Float32Array",
        "Float64Array"
      ]);
      is2.typedArray = (value) => {
        const objectType = getObjectType(value);
        if (objectType === null) {
          return false;
        }
        return typedArrayTypes.has(objectType);
      };
      const isValidLength = (value) => is2.safeInteger(value) && value > -1;
      is2.arrayLike = (value) => !is2.nullOrUndefined(value) && !is2.function_(value) && isValidLength(value.length);
      is2.inRange = (value, range) => {
        if (is2.number(range)) {
          return value >= Math.min(0, range) && value <= Math.max(range, 0);
        }
        if (is2.array(range) && range.length === 2) {
          return value >= Math.min(...range) && value <= Math.max(...range);
        }
        throw new TypeError(`Invalid range: ${JSON.stringify(range)}`);
      };
      const NODE_TYPE_ELEMENT = 1;
      const DOM_PROPERTIES_TO_CHECK = [
        "innerHTML",
        "ownerDocument",
        "style",
        "attributes",
        "nodeValue"
      ];
      is2.domElement = (value) => is2.object(value) && value.nodeType === NODE_TYPE_ELEMENT && is2.string(value.nodeName) && !is2.plainObject(value) && DOM_PROPERTIES_TO_CHECK.every((property) => property in value);
      is2.observable = (value) => {
        if (!value) {
          return false;
        }
        if (value[Symbol.observable] && value === value[Symbol.observable]()) {
          return true;
        }
        if (value["@@observable"] && value === value["@@observable"]()) {
          return true;
        }
        return false;
      };
      is2.nodeStream = (value) => !is2.nullOrUndefined(value) && isObject(value) && is2.function_(value.pipe) && !is2.observable(value);
      is2.infinite = (value) => value === Infinity || value === -Infinity;
      const isAbsoluteMod2 = (rem) => (value) => is2.integer(value) && Math.abs(value % 2) === rem;
      is2.even = isAbsoluteMod2(0);
      is2.odd = isAbsoluteMod2(1);
      const isWhiteSpaceString = (value) => is2.string(value) && /\S/.test(value) === false;
      is2.emptyArray = (value) => is2.array(value) && value.length === 0;
      is2.nonEmptyArray = (value) => is2.array(value) && value.length > 0;
      is2.emptyString = (value) => is2.string(value) && value.length === 0;
      is2.nonEmptyString = (value) => is2.string(value) && value.length > 0;
      is2.emptyStringOrWhitespace = (value) => is2.emptyString(value) || isWhiteSpaceString(value);
      is2.emptyObject = (value) => is2.object(value) && !is2.map(value) && !is2.set(value) && Object.keys(value).length === 0;
      is2.nonEmptyObject = (value) => is2.object(value) && !is2.map(value) && !is2.set(value) && Object.keys(value).length > 0;
      is2.emptySet = (value) => is2.set(value) && value.size === 0;
      is2.nonEmptySet = (value) => is2.set(value) && value.size > 0;
      is2.emptyMap = (value) => is2.map(value) && value.size === 0;
      is2.nonEmptyMap = (value) => is2.map(value) && value.size > 0;
      const predicateOnArray = (method, predicate, values) => {
        if (is2.function_(predicate) === false) {
          throw new TypeError(`Invalid predicate: ${JSON.stringify(predicate)}`);
        }
        if (values.length === 0) {
          throw new TypeError("Invalid number of values");
        }
        return method.call(values, predicate);
      };
      is2.any = (predicate, ...values) => predicateOnArray(Array.prototype.some, predicate, values);
      is2.all = (predicate, ...values) => predicateOnArray(Array.prototype.every, predicate, values);
    })(is || (is = {}));
    Object.defineProperties(is, {
      class: {
        value: is.class_
      },
      function: {
        value: is.function_
      },
      null: {
        value: is.null_
      }
    });
    exports2.default = is;
    module2.exports = is;
    module2.exports.default = is;
  }
});

// node_modules/got/source/errors.js
var require_errors = __commonJS({
  "node_modules/got/source/errors.js"(exports2, module2) {
    "use strict";
    var urlLib = require("url");
    var http = require("http");
    var PCancelable = require_p_cancelable();
    var is = require_dist();
    var GotError = class extends Error {
      constructor(message, error, options) {
        super(message);
        Error.captureStackTrace(this, this.constructor);
        this.name = "GotError";
        if (!is.undefined(error.code)) {
          this.code = error.code;
        }
        Object.assign(this, {
          host: options.host,
          hostname: options.hostname,
          method: options.method,
          path: options.path,
          socketPath: options.socketPath,
          protocol: options.protocol,
          url: options.href,
          gotOptions: options
        });
      }
    };
    module2.exports.GotError = GotError;
    module2.exports.CacheError = class extends GotError {
      constructor(error, options) {
        super(error.message, error, options);
        this.name = "CacheError";
      }
    };
    module2.exports.RequestError = class extends GotError {
      constructor(error, options) {
        super(error.message, error, options);
        this.name = "RequestError";
      }
    };
    module2.exports.ReadError = class extends GotError {
      constructor(error, options) {
        super(error.message, error, options);
        this.name = "ReadError";
      }
    };
    module2.exports.ParseError = class extends GotError {
      constructor(error, statusCode, options, data) {
        super(`${error.message} in "${urlLib.format(options)}": 
${data.slice(0, 77)}...`, error, options);
        this.name = "ParseError";
        this.statusCode = statusCode;
        this.statusMessage = http.STATUS_CODES[this.statusCode];
      }
    };
    module2.exports.HTTPError = class extends GotError {
      constructor(response, options) {
        const {statusCode} = response;
        let {statusMessage} = response;
        if (statusMessage) {
          statusMessage = statusMessage.replace(/\r?\n/g, " ").trim();
        } else {
          statusMessage = http.STATUS_CODES[statusCode];
        }
        super(`Response code ${statusCode} (${statusMessage})`, {}, options);
        this.name = "HTTPError";
        this.statusCode = statusCode;
        this.statusMessage = statusMessage;
        this.headers = response.headers;
        this.body = response.body;
      }
    };
    module2.exports.MaxRedirectsError = class extends GotError {
      constructor(statusCode, redirectUrls, options) {
        super("Redirected 10 times. Aborting.", {}, options);
        this.name = "MaxRedirectsError";
        this.statusCode = statusCode;
        this.statusMessage = http.STATUS_CODES[this.statusCode];
        this.redirectUrls = redirectUrls;
      }
    };
    module2.exports.UnsupportedProtocolError = class extends GotError {
      constructor(options) {
        super(`Unsupported protocol "${options.protocol}"`, {}, options);
        this.name = "UnsupportedProtocolError";
      }
    };
    module2.exports.TimeoutError = class extends GotError {
      constructor(error, options) {
        super(error.message, {code: "ETIMEDOUT"}, options);
        this.name = "TimeoutError";
        this.event = error.event;
      }
    };
    module2.exports.CancelError = PCancelable.CancelError;
  }
});

// node_modules/duplexer3/index.js
var require_duplexer3 = __commonJS({
  "node_modules/duplexer3/index.js"(exports2, module2) {
    "use strict";
    var stream = require("stream");
    function DuplexWrapper(options, writable, readable) {
      if (typeof readable === "undefined") {
        readable = writable;
        writable = options;
        options = null;
      }
      stream.Duplex.call(this, options);
      if (typeof readable.read !== "function") {
        readable = new stream.Readable(options).wrap(readable);
      }
      this._writable = writable;
      this._readable = readable;
      this._waiting = false;
      var self = this;
      writable.once("finish", function() {
        self.end();
      });
      this.once("finish", function() {
        writable.end();
      });
      readable.on("readable", function() {
        if (self._waiting) {
          self._waiting = false;
          self._read();
        }
      });
      readable.once("end", function() {
        self.push(null);
      });
      if (!options || typeof options.bubbleErrors === "undefined" || options.bubbleErrors) {
        writable.on("error", function(err) {
          self.emit("error", err);
        });
        readable.on("error", function(err) {
          self.emit("error", err);
        });
      }
    }
    DuplexWrapper.prototype = Object.create(stream.Duplex.prototype, {constructor: {value: DuplexWrapper}});
    DuplexWrapper.prototype._write = function _write(input, encoding, done) {
      this._writable.write(input, encoding, done);
    };
    DuplexWrapper.prototype._read = function _read() {
      var buf;
      var reads = 0;
      while ((buf = this._readable.read()) !== null) {
        this.push(buf);
        reads++;
      }
      if (reads === 0) {
        this._waiting = true;
      }
    };
    module2.exports = function duplex2(options, writable, readable) {
      return new DuplexWrapper(options, writable, readable);
    };
    module2.exports.DuplexWrapper = DuplexWrapper;
  }
});

// node_modules/normalize-url/index.js
var require_normalize_url = __commonJS({
  "node_modules/normalize-url/index.js"(exports2, module2) {
    "use strict";
    var URLParser = typeof URL === "undefined" ? require("url").URL : URL;
    var DATA_URL_DEFAULT_MIME_TYPE = "text/plain";
    var DATA_URL_DEFAULT_CHARSET = "us-ascii";
    var testParameter = (name, filters) => {
      return filters.some((filter2) => filter2 instanceof RegExp ? filter2.test(name) : filter2 === name);
    };
    var normalizeDataURL = (urlString, {stripHash}) => {
      const parts = urlString.match(/^data:([^,]*?),([^#]*?)(?:#(.*))?$/);
      if (!parts) {
        throw new Error(`Invalid URL: ${urlString}`);
      }
      const mediaType = parts[1].split(";");
      const body2 = parts[2];
      const hash = stripHash ? "" : parts[3];
      let base64 = false;
      if (mediaType[mediaType.length - 1] === "base64") {
        mediaType.pop();
        base64 = true;
      }
      const mimeType = (mediaType.shift() || "").toLowerCase();
      const attributes = mediaType.map((attribute) => {
        let [key, value = ""] = attribute.split("=").map((string) => string.trim());
        if (key === "charset") {
          value = value.toLowerCase();
          if (value === DATA_URL_DEFAULT_CHARSET) {
            return "";
          }
        }
        return `${key}${value ? `=${value}` : ""}`;
      }).filter(Boolean);
      const normalizedMediaType = [
        ...attributes
      ];
      if (base64) {
        normalizedMediaType.push("base64");
      }
      if (normalizedMediaType.length !== 0 || mimeType && mimeType !== DATA_URL_DEFAULT_MIME_TYPE) {
        normalizedMediaType.unshift(mimeType);
      }
      return `data:${normalizedMediaType.join(";")},${base64 ? body2.trim() : body2}${hash ? `#${hash}` : ""}`;
    };
    var normalizeUrl = (urlString, options) => {
      options = {
        defaultProtocol: "http:",
        normalizeProtocol: true,
        forceHttp: false,
        forceHttps: false,
        stripAuthentication: true,
        stripHash: false,
        stripWWW: true,
        removeQueryParameters: [/^utm_\w+/i],
        removeTrailingSlash: true,
        removeDirectoryIndex: false,
        sortQueryParameters: true,
        ...options
      };
      if (Reflect.has(options, "normalizeHttps")) {
        throw new Error("options.normalizeHttps is renamed to options.forceHttp");
      }
      if (Reflect.has(options, "normalizeHttp")) {
        throw new Error("options.normalizeHttp is renamed to options.forceHttps");
      }
      if (Reflect.has(options, "stripFragment")) {
        throw new Error("options.stripFragment is renamed to options.stripHash");
      }
      urlString = urlString.trim();
      if (/^data:/i.test(urlString)) {
        return normalizeDataURL(urlString, options);
      }
      const hasRelativeProtocol = urlString.startsWith("//");
      const isRelativeUrl = !hasRelativeProtocol && /^\.*\//.test(urlString);
      if (!isRelativeUrl) {
        urlString = urlString.replace(/^(?!(?:\w+:)?\/\/)|^\/\//, options.defaultProtocol);
      }
      const urlObj = new URLParser(urlString);
      if (options.forceHttp && options.forceHttps) {
        throw new Error("The `forceHttp` and `forceHttps` options cannot be used together");
      }
      if (options.forceHttp && urlObj.protocol === "https:") {
        urlObj.protocol = "http:";
      }
      if (options.forceHttps && urlObj.protocol === "http:") {
        urlObj.protocol = "https:";
      }
      if (options.stripAuthentication) {
        urlObj.username = "";
        urlObj.password = "";
      }
      if (options.stripHash) {
        urlObj.hash = "";
      }
      if (urlObj.pathname) {
        urlObj.pathname = urlObj.pathname.replace(/((?!:).|^)\/{2,}/g, (_, p1) => {
          if (/^(?!\/)/g.test(p1)) {
            return `${p1}/`;
          }
          return "/";
        });
      }
      if (urlObj.pathname) {
        urlObj.pathname = decodeURI(urlObj.pathname);
      }
      if (options.removeDirectoryIndex === true) {
        options.removeDirectoryIndex = [/^index\.[a-z]+$/];
      }
      if (Array.isArray(options.removeDirectoryIndex) && options.removeDirectoryIndex.length > 0) {
        let pathComponents = urlObj.pathname.split("/");
        const lastComponent = pathComponents[pathComponents.length - 1];
        if (testParameter(lastComponent, options.removeDirectoryIndex)) {
          pathComponents = pathComponents.slice(0, pathComponents.length - 1);
          urlObj.pathname = pathComponents.slice(1).join("/") + "/";
        }
      }
      if (urlObj.hostname) {
        urlObj.hostname = urlObj.hostname.replace(/\.$/, "");
        if (options.stripWWW && /^www\.([a-z\-\d]{2,63})\.([a-z.]{2,5})$/.test(urlObj.hostname)) {
          urlObj.hostname = urlObj.hostname.replace(/^www\./, "");
        }
      }
      if (Array.isArray(options.removeQueryParameters)) {
        for (const key of [...urlObj.searchParams.keys()]) {
          if (testParameter(key, options.removeQueryParameters)) {
            urlObj.searchParams.delete(key);
          }
        }
      }
      if (options.sortQueryParameters) {
        urlObj.searchParams.sort();
      }
      if (options.removeTrailingSlash) {
        urlObj.pathname = urlObj.pathname.replace(/\/$/, "");
      }
      urlString = urlObj.toString();
      if ((options.removeTrailingSlash || urlObj.pathname === "/") && urlObj.hash === "") {
        urlString = urlString.replace(/\/$/, "");
      }
      if (hasRelativeProtocol && !options.normalizeProtocol) {
        urlString = urlString.replace(/^http:\/\//, "//");
      }
      if (options.stripProtocol) {
        urlString = urlString.replace(/^(?:https?:)?\/\//, "");
      }
      return urlString;
    };
    module2.exports = normalizeUrl;
    module2.exports.default = normalizeUrl;
  }
});

// node_modules/wrappy/wrappy.js
var require_wrappy = __commonJS({
  "node_modules/wrappy/wrappy.js"(exports2, module2) {
    module2.exports = wrappy;
    function wrappy(fn2, cb) {
      if (fn2 && cb)
        return wrappy(fn2)(cb);
      if (typeof fn2 !== "function")
        throw new TypeError("need wrapper function");
      Object.keys(fn2).forEach(function(k) {
        wrapper[k] = fn2[k];
      });
      return wrapper;
      function wrapper() {
        var args = new Array(arguments.length);
        for (var i = 0; i < args.length; i++) {
          args[i] = arguments[i];
        }
        var ret = fn2.apply(this, args);
        var cb2 = args[args.length - 1];
        if (typeof ret === "function" && ret !== cb2) {
          Object.keys(cb2).forEach(function(k) {
            ret[k] = cb2[k];
          });
        }
        return ret;
      }
    }
  }
});

// node_modules/once/once.js
var require_once = __commonJS({
  "node_modules/once/once.js"(exports2, module2) {
    var wrappy = require_wrappy();
    module2.exports = wrappy(once);
    module2.exports.strict = wrappy(onceStrict);
    once.proto = once(function() {
      Object.defineProperty(Function.prototype, "once", {
        value: function() {
          return once(this);
        },
        configurable: true
      });
      Object.defineProperty(Function.prototype, "onceStrict", {
        value: function() {
          return onceStrict(this);
        },
        configurable: true
      });
    });
    function once(fn2) {
      var f = function() {
        if (f.called)
          return f.value;
        f.called = true;
        return f.value = fn2.apply(this, arguments);
      };
      f.called = false;
      return f;
    }
    function onceStrict(fn2) {
      var f = function() {
        if (f.called)
          throw new Error(f.onceError);
        f.called = true;
        return f.value = fn2.apply(this, arguments);
      };
      var name = fn2.name || "Function wrapped with `once`";
      f.onceError = name + " shouldn't be called more than once";
      f.called = false;
      return f;
    }
  }
});

// node_modules/end-of-stream/index.js
var require_end_of_stream = __commonJS({
  "node_modules/end-of-stream/index.js"(exports2, module2) {
    var once = require_once();
    var noop = function() {
    };
    var isRequest = function(stream) {
      return stream.setHeader && typeof stream.abort === "function";
    };
    var isChildProcess = function(stream) {
      return stream.stdio && Array.isArray(stream.stdio) && stream.stdio.length === 3;
    };
    var eos = function(stream, opts, callback) {
      if (typeof opts === "function")
        return eos(stream, null, opts);
      if (!opts)
        opts = {};
      callback = once(callback || noop);
      var ws = stream._writableState;
      var rs = stream._readableState;
      var readable = opts.readable || opts.readable !== false && stream.readable;
      var writable = opts.writable || opts.writable !== false && stream.writable;
      var cancelled = false;
      var onlegacyfinish = function() {
        if (!stream.writable)
          onfinish();
      };
      var onfinish = function() {
        writable = false;
        if (!readable)
          callback.call(stream);
      };
      var onend = function() {
        readable = false;
        if (!writable)
          callback.call(stream);
      };
      var onexit = function(exitCode) {
        callback.call(stream, exitCode ? new Error("exited with error code: " + exitCode) : null);
      };
      var onerror = function(err) {
        callback.call(stream, err);
      };
      var onclose = function() {
        process.nextTick(onclosenexttick);
      };
      var onclosenexttick = function() {
        if (cancelled)
          return;
        if (readable && !(rs && (rs.ended && !rs.destroyed)))
          return callback.call(stream, new Error("premature close"));
        if (writable && !(ws && (ws.ended && !ws.destroyed)))
          return callback.call(stream, new Error("premature close"));
      };
      var onrequest = function() {
        stream.req.on("finish", onfinish);
      };
      if (isRequest(stream)) {
        stream.on("complete", onfinish);
        stream.on("abort", onclose);
        if (stream.req)
          onrequest();
        else
          stream.on("request", onrequest);
      } else if (writable && !ws) {
        stream.on("end", onlegacyfinish);
        stream.on("close", onlegacyfinish);
      }
      if (isChildProcess(stream))
        stream.on("exit", onexit);
      stream.on("end", onend);
      stream.on("finish", onfinish);
      if (opts.error !== false)
        stream.on("error", onerror);
      stream.on("close", onclose);
      return function() {
        cancelled = true;
        stream.removeListener("complete", onfinish);
        stream.removeListener("abort", onclose);
        stream.removeListener("request", onrequest);
        if (stream.req)
          stream.req.removeListener("finish", onfinish);
        stream.removeListener("end", onlegacyfinish);
        stream.removeListener("close", onlegacyfinish);
        stream.removeListener("finish", onfinish);
        stream.removeListener("exit", onexit);
        stream.removeListener("end", onend);
        stream.removeListener("error", onerror);
        stream.removeListener("close", onclose);
      };
    };
    module2.exports = eos;
  }
});

// node_modules/pump/index.js
var require_pump = __commonJS({
  "node_modules/pump/index.js"(exports2, module2) {
    var once = require_once();
    var eos = require_end_of_stream();
    var fs = require("fs");
    var noop = function() {
    };
    var ancient = /^v?\.0/.test(process.version);
    var isFn = function(fn2) {
      return typeof fn2 === "function";
    };
    var isFS = function(stream) {
      if (!ancient)
        return false;
      if (!fs)
        return false;
      return (stream instanceof (fs.ReadStream || noop) || stream instanceof (fs.WriteStream || noop)) && isFn(stream.close);
    };
    var isRequest = function(stream) {
      return stream.setHeader && isFn(stream.abort);
    };
    var destroyer = function(stream, reading, writing, callback) {
      callback = once(callback);
      var closed = false;
      stream.on("close", function() {
        closed = true;
      });
      eos(stream, {readable: reading, writable: writing}, function(err) {
        if (err)
          return callback(err);
        closed = true;
        callback();
      });
      var destroyed = false;
      return function(err) {
        if (closed)
          return;
        if (destroyed)
          return;
        destroyed = true;
        if (isFS(stream))
          return stream.close(noop);
        if (isRequest(stream))
          return stream.abort();
        if (isFn(stream.destroy))
          return stream.destroy();
        callback(err || new Error("stream was destroyed"));
      };
    };
    var call = function(fn2) {
      fn2();
    };
    var pipe = function(from, to) {
      return from.pipe(to);
    };
    var pump = function() {
      var streams = Array.prototype.slice.call(arguments);
      var callback = isFn(streams[streams.length - 1] || noop) && streams.pop() || noop;
      if (Array.isArray(streams[0]))
        streams = streams[0];
      if (streams.length < 2)
        throw new Error("pump requires two streams per minimum");
      var error;
      var destroys = streams.map(function(stream, i) {
        var reading = i < streams.length - 1;
        var writing = i > 0;
        return destroyer(stream, reading, writing, function(err) {
          if (!error)
            error = err;
          if (err)
            destroys.forEach(call);
          if (reading)
            return;
          destroys.forEach(call);
          callback(error);
        });
      });
      return streams.reduce(pipe);
    };
    module2.exports = pump;
  }
});

// node_modules/cacheable-request/node_modules/get-stream/buffer-stream.js
var require_buffer_stream = __commonJS({
  "node_modules/cacheable-request/node_modules/get-stream/buffer-stream.js"(exports2, module2) {
    "use strict";
    var {PassThrough: PassThroughStream} = require("stream");
    module2.exports = (options) => {
      options = {...options};
      const {array} = options;
      let {encoding} = options;
      const isBuffer = encoding === "buffer";
      let objectMode = false;
      if (array) {
        objectMode = !(encoding || isBuffer);
      } else {
        encoding = encoding || "utf8";
      }
      if (isBuffer) {
        encoding = null;
      }
      const stream = new PassThroughStream({objectMode});
      if (encoding) {
        stream.setEncoding(encoding);
      }
      let length = 0;
      const chunks = [];
      stream.on("data", (chunk) => {
        chunks.push(chunk);
        if (objectMode) {
          length = chunks.length;
        } else {
          length += chunk.length;
        }
      });
      stream.getBufferedValue = () => {
        if (array) {
          return chunks;
        }
        return isBuffer ? Buffer.concat(chunks, length) : chunks.join("");
      };
      stream.getBufferedLength = () => length;
      return stream;
    };
  }
});

// node_modules/cacheable-request/node_modules/get-stream/index.js
var require_get_stream = __commonJS({
  "node_modules/cacheable-request/node_modules/get-stream/index.js"(exports2, module2) {
    "use strict";
    var {constants: BufferConstants} = require("buffer");
    var pump = require_pump();
    var bufferStream = require_buffer_stream();
    var MaxBufferError = class extends Error {
      constructor() {
        super("maxBuffer exceeded");
        this.name = "MaxBufferError";
      }
    };
    async function getStream(inputStream, options) {
      if (!inputStream) {
        return Promise.reject(new Error("Expected a stream"));
      }
      options = {
        maxBuffer: Infinity,
        ...options
      };
      const {maxBuffer} = options;
      let stream;
      await new Promise((resolve, reject) => {
        const rejectPromise = (error) => {
          if (error && stream.getBufferedLength() <= BufferConstants.MAX_LENGTH) {
            error.bufferedData = stream.getBufferedValue();
          }
          reject(error);
        };
        stream = pump(inputStream, bufferStream(options), (error) => {
          if (error) {
            rejectPromise(error);
            return;
          }
          resolve();
        });
        stream.on("data", () => {
          if (stream.getBufferedLength() > maxBuffer) {
            rejectPromise(new MaxBufferError());
          }
        });
      });
      return stream.getBufferedValue();
    }
    module2.exports = getStream;
    module2.exports.default = getStream;
    module2.exports.buffer = (stream, options) => getStream(stream, {...options, encoding: "buffer"});
    module2.exports.array = (stream, options) => getStream(stream, {...options, array: true});
    module2.exports.MaxBufferError = MaxBufferError;
  }
});

// node_modules/http-cache-semantics/index.js
var require_http_cache_semantics = __commonJS({
  "node_modules/http-cache-semantics/index.js"(exports2, module2) {
    "use strict";
    var statusCodeCacheableByDefault = new Set([
      200,
      203,
      204,
      206,
      300,
      301,
      404,
      405,
      410,
      414,
      501
    ]);
    var understoodStatuses = new Set([
      200,
      203,
      204,
      300,
      301,
      302,
      303,
      307,
      308,
      404,
      405,
      410,
      414,
      501
    ]);
    var errorStatusCodes = new Set([
      500,
      502,
      503,
      504
    ]);
    var hopByHopHeaders = {
      date: true,
      connection: true,
      "keep-alive": true,
      "proxy-authenticate": true,
      "proxy-authorization": true,
      te: true,
      trailer: true,
      "transfer-encoding": true,
      upgrade: true
    };
    var excludedFromRevalidationUpdate = {
      "content-length": true,
      "content-encoding": true,
      "transfer-encoding": true,
      "content-range": true
    };
    function toNumberOrZero(s) {
      const n = parseInt(s, 10);
      return isFinite(n) ? n : 0;
    }
    function isErrorResponse(response) {
      if (!response) {
        return true;
      }
      return errorStatusCodes.has(response.status);
    }
    function parseCacheControl(header) {
      const cc = {};
      if (!header)
        return cc;
      const parts = header.trim().split(/\s*,\s*/);
      for (const part of parts) {
        const [k, v] = part.split(/\s*=\s*/, 2);
        cc[k] = v === void 0 ? true : v.replace(/^"|"$/g, "");
      }
      return cc;
    }
    function formatCacheControl(cc) {
      let parts = [];
      for (const k in cc) {
        const v = cc[k];
        parts.push(v === true ? k : k + "=" + v);
      }
      if (!parts.length) {
        return void 0;
      }
      return parts.join(", ");
    }
    module2.exports = class CachePolicy {
      constructor(req, res, {
        shared,
        cacheHeuristic,
        immutableMinTimeToLive,
        ignoreCargoCult,
        _fromObject
      } = {}) {
        if (_fromObject) {
          this._fromObject(_fromObject);
          return;
        }
        if (!res || !res.headers) {
          throw Error("Response headers missing");
        }
        this._assertRequestHasHeaders(req);
        this._responseTime = this.now();
        this._isShared = shared !== false;
        this._cacheHeuristic = cacheHeuristic !== void 0 ? cacheHeuristic : 0.1;
        this._immutableMinTtl = immutableMinTimeToLive !== void 0 ? immutableMinTimeToLive : 24 * 3600 * 1e3;
        this._status = "status" in res ? res.status : 200;
        this._resHeaders = res.headers;
        this._rescc = parseCacheControl(res.headers["cache-control"]);
        this._method = "method" in req ? req.method : "GET";
        this._url = req.url;
        this._host = req.headers.host;
        this._noAuthorization = !req.headers.authorization;
        this._reqHeaders = res.headers.vary ? req.headers : null;
        this._reqcc = parseCacheControl(req.headers["cache-control"]);
        if (ignoreCargoCult && "pre-check" in this._rescc && "post-check" in this._rescc) {
          delete this._rescc["pre-check"];
          delete this._rescc["post-check"];
          delete this._rescc["no-cache"];
          delete this._rescc["no-store"];
          delete this._rescc["must-revalidate"];
          this._resHeaders = Object.assign({}, this._resHeaders, {
            "cache-control": formatCacheControl(this._rescc)
          });
          delete this._resHeaders.expires;
          delete this._resHeaders.pragma;
        }
        if (res.headers["cache-control"] == null && /no-cache/.test(res.headers.pragma)) {
          this._rescc["no-cache"] = true;
        }
      }
      now() {
        return Date.now();
      }
      storable() {
        return !!(!this._reqcc["no-store"] && (this._method === "GET" || this._method === "HEAD" || this._method === "POST" && this._hasExplicitExpiration()) && understoodStatuses.has(this._status) && !this._rescc["no-store"] && (!this._isShared || !this._rescc.private) && (!this._isShared || this._noAuthorization || this._allowsStoringAuthenticated()) && (this._resHeaders.expires || this._rescc["max-age"] || this._isShared && this._rescc["s-maxage"] || this._rescc.public || statusCodeCacheableByDefault.has(this._status)));
      }
      _hasExplicitExpiration() {
        return this._isShared && this._rescc["s-maxage"] || this._rescc["max-age"] || this._resHeaders.expires;
      }
      _assertRequestHasHeaders(req) {
        if (!req || !req.headers) {
          throw Error("Request headers missing");
        }
      }
      satisfiesWithoutRevalidation(req) {
        this._assertRequestHasHeaders(req);
        const requestCC = parseCacheControl(req.headers["cache-control"]);
        if (requestCC["no-cache"] || /no-cache/.test(req.headers.pragma)) {
          return false;
        }
        if (requestCC["max-age"] && this.age() > requestCC["max-age"]) {
          return false;
        }
        if (requestCC["min-fresh"] && this.timeToLive() < 1e3 * requestCC["min-fresh"]) {
          return false;
        }
        if (this.stale()) {
          const allowsStale = requestCC["max-stale"] && !this._rescc["must-revalidate"] && (requestCC["max-stale"] === true || requestCC["max-stale"] > this.age() - this.maxAge());
          if (!allowsStale) {
            return false;
          }
        }
        return this._requestMatches(req, false);
      }
      _requestMatches(req, allowHeadMethod) {
        return (!this._url || this._url === req.url) && this._host === req.headers.host && (!req.method || this._method === req.method || allowHeadMethod && req.method === "HEAD") && this._varyMatches(req);
      }
      _allowsStoringAuthenticated() {
        return this._rescc["must-revalidate"] || this._rescc.public || this._rescc["s-maxage"];
      }
      _varyMatches(req) {
        if (!this._resHeaders.vary) {
          return true;
        }
        if (this._resHeaders.vary === "*") {
          return false;
        }
        const fields = this._resHeaders.vary.trim().toLowerCase().split(/\s*,\s*/);
        for (const name of fields) {
          if (req.headers[name] !== this._reqHeaders[name])
            return false;
        }
        return true;
      }
      _copyWithoutHopByHopHeaders(inHeaders) {
        const headers = {};
        for (const name in inHeaders) {
          if (hopByHopHeaders[name])
            continue;
          headers[name] = inHeaders[name];
        }
        if (inHeaders.connection) {
          const tokens = inHeaders.connection.trim().split(/\s*,\s*/);
          for (const name of tokens) {
            delete headers[name];
          }
        }
        if (headers.warning) {
          const warnings = headers.warning.split(/,/).filter((warning) => {
            return !/^\s*1[0-9][0-9]/.test(warning);
          });
          if (!warnings.length) {
            delete headers.warning;
          } else {
            headers.warning = warnings.join(",").trim();
          }
        }
        return headers;
      }
      responseHeaders() {
        const headers = this._copyWithoutHopByHopHeaders(this._resHeaders);
        const age = this.age();
        if (age > 3600 * 24 && !this._hasExplicitExpiration() && this.maxAge() > 3600 * 24) {
          headers.warning = (headers.warning ? `${headers.warning}, ` : "") + '113 - "rfc7234 5.5.4"';
        }
        headers.age = `${Math.round(age)}`;
        headers.date = new Date(this.now()).toUTCString();
        return headers;
      }
      date() {
        const serverDate = Date.parse(this._resHeaders.date);
        if (isFinite(serverDate)) {
          return serverDate;
        }
        return this._responseTime;
      }
      age() {
        let age = this._ageValue();
        const residentTime = (this.now() - this._responseTime) / 1e3;
        return age + residentTime;
      }
      _ageValue() {
        return toNumberOrZero(this._resHeaders.age);
      }
      maxAge() {
        if (!this.storable() || this._rescc["no-cache"]) {
          return 0;
        }
        if (this._isShared && (this._resHeaders["set-cookie"] && !this._rescc.public && !this._rescc.immutable)) {
          return 0;
        }
        if (this._resHeaders.vary === "*") {
          return 0;
        }
        if (this._isShared) {
          if (this._rescc["proxy-revalidate"]) {
            return 0;
          }
          if (this._rescc["s-maxage"]) {
            return toNumberOrZero(this._rescc["s-maxage"]);
          }
        }
        if (this._rescc["max-age"]) {
          return toNumberOrZero(this._rescc["max-age"]);
        }
        const defaultMinTtl = this._rescc.immutable ? this._immutableMinTtl : 0;
        const serverDate = this.date();
        if (this._resHeaders.expires) {
          const expires = Date.parse(this._resHeaders.expires);
          if (Number.isNaN(expires) || expires < serverDate) {
            return 0;
          }
          return Math.max(defaultMinTtl, (expires - serverDate) / 1e3);
        }
        if (this._resHeaders["last-modified"]) {
          const lastModified = Date.parse(this._resHeaders["last-modified"]);
          if (isFinite(lastModified) && serverDate > lastModified) {
            return Math.max(defaultMinTtl, (serverDate - lastModified) / 1e3 * this._cacheHeuristic);
          }
        }
        return defaultMinTtl;
      }
      timeToLive() {
        const age = this.maxAge() - this.age();
        const staleIfErrorAge = age + toNumberOrZero(this._rescc["stale-if-error"]);
        const staleWhileRevalidateAge = age + toNumberOrZero(this._rescc["stale-while-revalidate"]);
        return Math.max(0, age, staleIfErrorAge, staleWhileRevalidateAge) * 1e3;
      }
      stale() {
        return this.maxAge() <= this.age();
      }
      _useStaleIfError() {
        return this.maxAge() + toNumberOrZero(this._rescc["stale-if-error"]) > this.age();
      }
      useStaleWhileRevalidate() {
        return this.maxAge() + toNumberOrZero(this._rescc["stale-while-revalidate"]) > this.age();
      }
      static fromObject(obj) {
        return new this(void 0, void 0, {_fromObject: obj});
      }
      _fromObject(obj) {
        if (this._responseTime)
          throw Error("Reinitialized");
        if (!obj || obj.v !== 1)
          throw Error("Invalid serialization");
        this._responseTime = obj.t;
        this._isShared = obj.sh;
        this._cacheHeuristic = obj.ch;
        this._immutableMinTtl = obj.imm !== void 0 ? obj.imm : 24 * 3600 * 1e3;
        this._status = obj.st;
        this._resHeaders = obj.resh;
        this._rescc = obj.rescc;
        this._method = obj.m;
        this._url = obj.u;
        this._host = obj.h;
        this._noAuthorization = obj.a;
        this._reqHeaders = obj.reqh;
        this._reqcc = obj.reqcc;
      }
      toObject() {
        return {
          v: 1,
          t: this._responseTime,
          sh: this._isShared,
          ch: this._cacheHeuristic,
          imm: this._immutableMinTtl,
          st: this._status,
          resh: this._resHeaders,
          rescc: this._rescc,
          m: this._method,
          u: this._url,
          h: this._host,
          a: this._noAuthorization,
          reqh: this._reqHeaders,
          reqcc: this._reqcc
        };
      }
      revalidationHeaders(incomingReq) {
        this._assertRequestHasHeaders(incomingReq);
        const headers = this._copyWithoutHopByHopHeaders(incomingReq.headers);
        delete headers["if-range"];
        if (!this._requestMatches(incomingReq, true) || !this.storable()) {
          delete headers["if-none-match"];
          delete headers["if-modified-since"];
          return headers;
        }
        if (this._resHeaders.etag) {
          headers["if-none-match"] = headers["if-none-match"] ? `${headers["if-none-match"]}, ${this._resHeaders.etag}` : this._resHeaders.etag;
        }
        const forbidsWeakValidators = headers["accept-ranges"] || headers["if-match"] || headers["if-unmodified-since"] || this._method && this._method != "GET";
        if (forbidsWeakValidators) {
          delete headers["if-modified-since"];
          if (headers["if-none-match"]) {
            const etags = headers["if-none-match"].split(/,/).filter((etag) => {
              return !/^\s*W\//.test(etag);
            });
            if (!etags.length) {
              delete headers["if-none-match"];
            } else {
              headers["if-none-match"] = etags.join(",").trim();
            }
          }
        } else if (this._resHeaders["last-modified"] && !headers["if-modified-since"]) {
          headers["if-modified-since"] = this._resHeaders["last-modified"];
        }
        return headers;
      }
      revalidatedPolicy(request, response) {
        this._assertRequestHasHeaders(request);
        if (this._useStaleIfError() && isErrorResponse(response)) {
          return {
            modified: false,
            matches: false,
            policy: this
          };
        }
        if (!response || !response.headers) {
          throw Error("Response headers missing");
        }
        let matches = false;
        if (response.status !== void 0 && response.status != 304) {
          matches = false;
        } else if (response.headers.etag && !/^\s*W\//.test(response.headers.etag)) {
          matches = this._resHeaders.etag && this._resHeaders.etag.replace(/^\s*W\//, "") === response.headers.etag;
        } else if (this._resHeaders.etag && response.headers.etag) {
          matches = this._resHeaders.etag.replace(/^\s*W\//, "") === response.headers.etag.replace(/^\s*W\//, "");
        } else if (this._resHeaders["last-modified"]) {
          matches = this._resHeaders["last-modified"] === response.headers["last-modified"];
        } else {
          if (!this._resHeaders.etag && !this._resHeaders["last-modified"] && !response.headers.etag && !response.headers["last-modified"]) {
            matches = true;
          }
        }
        if (!matches) {
          return {
            policy: new this.constructor(request, response),
            modified: response.status != 304,
            matches: false
          };
        }
        const headers = {};
        for (const k in this._resHeaders) {
          headers[k] = k in response.headers && !excludedFromRevalidationUpdate[k] ? response.headers[k] : this._resHeaders[k];
        }
        const newResponse = Object.assign({}, response, {
          status: this._status,
          method: this._method,
          headers
        });
        return {
          policy: new this.constructor(request, newResponse, {
            shared: this._isShared,
            cacheHeuristic: this._cacheHeuristic,
            immutableMinTimeToLive: this._immutableMinTtl
          }),
          modified: false,
          matches: true
        };
      }
    };
  }
});

// node_modules/lowercase-keys/index.js
var require_lowercase_keys = __commonJS({
  "node_modules/lowercase-keys/index.js"(exports2, module2) {
    "use strict";
    module2.exports = function(obj) {
      var ret = {};
      var keys2 = Object.keys(Object(obj));
      for (var i = 0; i < keys2.length; i++) {
        ret[keys2[i].toLowerCase()] = obj[keys2[i]];
      }
      return ret;
    };
  }
});

// node_modules/responselike/src/index.js
var require_src2 = __commonJS({
  "node_modules/responselike/src/index.js"(exports2, module2) {
    "use strict";
    var Readable = require("stream").Readable;
    var lowercaseKeys = require_lowercase_keys();
    var Response = class extends Readable {
      constructor(statusCode, headers, body2, url) {
        if (typeof statusCode !== "number") {
          throw new TypeError("Argument `statusCode` should be a number");
        }
        if (typeof headers !== "object") {
          throw new TypeError("Argument `headers` should be an object");
        }
        if (!(body2 instanceof Buffer)) {
          throw new TypeError("Argument `body` should be a buffer");
        }
        if (typeof url !== "string") {
          throw new TypeError("Argument `url` should be a string");
        }
        super();
        this.statusCode = statusCode;
        this.headers = lowercaseKeys(headers);
        this.body = body2;
        this.url = url;
      }
      _read() {
        this.push(this.body);
        this.push(null);
      }
    };
    module2.exports = Response;
  }
});

// node_modules/cacheable-request/node_modules/lowercase-keys/index.js
var require_lowercase_keys2 = __commonJS({
  "node_modules/cacheable-request/node_modules/lowercase-keys/index.js"(exports2, module2) {
    "use strict";
    module2.exports = (object) => {
      const result = {};
      for (const [key, value] of Object.entries(object)) {
        result[key.toLowerCase()] = value;
      }
      return result;
    };
  }
});

// node_modules/mimic-response/index.js
var require_mimic_response = __commonJS({
  "node_modules/mimic-response/index.js"(exports2, module2) {
    "use strict";
    var knownProps = [
      "destroy",
      "setTimeout",
      "socket",
      "headers",
      "trailers",
      "rawHeaders",
      "statusCode",
      "httpVersion",
      "httpVersionMinor",
      "httpVersionMajor",
      "rawTrailers",
      "statusMessage"
    ];
    module2.exports = (fromStream, toStream) => {
      const fromProps = new Set(Object.keys(fromStream).concat(knownProps));
      for (const prop of fromProps) {
        if (prop in toStream) {
          continue;
        }
        toStream[prop] = typeof fromStream[prop] === "function" ? fromStream[prop].bind(fromStream) : fromStream[prop];
      }
    };
  }
});

// node_modules/clone-response/src/index.js
var require_src3 = __commonJS({
  "node_modules/clone-response/src/index.js"(exports2, module2) {
    "use strict";
    var PassThrough = require("stream").PassThrough;
    var mimicResponse = require_mimic_response();
    var cloneResponse = (response) => {
      if (!(response && response.pipe)) {
        throw new TypeError("Parameter `response` must be a response stream.");
      }
      const clone = new PassThrough();
      mimicResponse(response, clone);
      return response.pipe(clone);
    };
    module2.exports = cloneResponse;
  }
});

// node_modules/json-buffer/index.js
var require_json_buffer = __commonJS({
  "node_modules/json-buffer/index.js"(exports2) {
    exports2.stringify = function stringify(o) {
      if (typeof o == "undefined")
        return o;
      if (o && Buffer.isBuffer(o))
        return JSON.stringify(":base64:" + o.toString("base64"));
      if (o && o.toJSON)
        o = o.toJSON();
      if (o && typeof o === "object") {
        var s = "";
        var array = Array.isArray(o);
        s = array ? "[" : "{";
        var first3 = true;
        for (var k in o) {
          var ignore = typeof o[k] == "function" || !array && typeof o[k] === "undefined";
          if (Object.hasOwnProperty.call(o, k) && !ignore) {
            if (!first3)
              s += ",";
            first3 = false;
            if (array) {
              if (o[k] == void 0)
                s += "null";
              else
                s += stringify(o[k]);
            } else if (o[k] !== void 0) {
              s += stringify(k) + ":" + stringify(o[k]);
            }
          }
        }
        s += array ? "]" : "}";
        return s;
      } else if (typeof o === "string") {
        return JSON.stringify(/^:/.test(o) ? ":" + o : o);
      } else if (typeof o === "undefined") {
        return "null";
      } else
        return JSON.stringify(o);
    };
    exports2.parse = function(s) {
      return JSON.parse(s, function(key, value) {
        if (typeof value === "string") {
          if (/^:base64:/.test(value))
            return new Buffer(value.substring(8), "base64");
          else
            return /^:/.test(value) ? value.substring(1) : value;
        }
        return value;
      });
    };
  }
});

// node_modules/keyv/src/index.js
var require_src4 = __commonJS({
  "node_modules/keyv/src/index.js"(exports2, module2) {
    "use strict";
    var EventEmitter = require("events");
    var JSONB = require_json_buffer();
    var loadStore = (opts) => {
      const adapters = {
        redis: "@keyv/redis",
        mongodb: "@keyv/mongo",
        mongo: "@keyv/mongo",
        sqlite: "@keyv/sqlite",
        postgresql: "@keyv/postgres",
        postgres: "@keyv/postgres",
        mysql: "@keyv/mysql"
      };
      if (opts.adapter || opts.uri) {
        const adapter = opts.adapter || /^[^:]*/.exec(opts.uri)[0];
        return new (require(adapters[adapter]))(opts);
      }
      return new Map();
    };
    var Keyv = class extends EventEmitter {
      constructor(uri, opts) {
        super();
        this.opts = Object.assign({
          namespace: "keyv",
          serialize: JSONB.stringify,
          deserialize: JSONB.parse
        }, typeof uri === "string" ? {uri} : uri, opts);
        if (!this.opts.store) {
          const adapterOpts = Object.assign({}, this.opts);
          this.opts.store = loadStore(adapterOpts);
        }
        if (typeof this.opts.store.on === "function") {
          this.opts.store.on("error", (err) => this.emit("error", err));
        }
        this.opts.store.namespace = this.opts.namespace;
      }
      _getKeyPrefix(key) {
        return `${this.opts.namespace}:${key}`;
      }
      get(key) {
        key = this._getKeyPrefix(key);
        const store = this.opts.store;
        return Promise.resolve().then(() => store.get(key)).then((data) => {
          data = typeof data === "string" ? this.opts.deserialize(data) : data;
          if (data === void 0) {
            return void 0;
          }
          if (typeof data.expires === "number" && Date.now() > data.expires) {
            this.delete(key);
            return void 0;
          }
          return data.value;
        });
      }
      set(key, value, ttl) {
        key = this._getKeyPrefix(key);
        if (typeof ttl === "undefined") {
          ttl = this.opts.ttl;
        }
        if (ttl === 0) {
          ttl = void 0;
        }
        const store = this.opts.store;
        return Promise.resolve().then(() => {
          const expires = typeof ttl === "number" ? Date.now() + ttl : null;
          value = {value, expires};
          return store.set(key, this.opts.serialize(value), ttl);
        }).then(() => true);
      }
      delete(key) {
        key = this._getKeyPrefix(key);
        const store = this.opts.store;
        return Promise.resolve().then(() => store.delete(key));
      }
      clear() {
        const store = this.opts.store;
        return Promise.resolve().then(() => store.clear());
      }
    };
    module2.exports = Keyv;
  }
});

// node_modules/cacheable-request/src/index.js
var require_src5 = __commonJS({
  "node_modules/cacheable-request/src/index.js"(exports2, module2) {
    "use strict";
    var EventEmitter = require("events");
    var urlLib = require("url");
    var normalizeUrl = require_normalize_url();
    var getStream = require_get_stream();
    var CachePolicy = require_http_cache_semantics();
    var Response = require_src2();
    var lowercaseKeys = require_lowercase_keys2();
    var cloneResponse = require_src3();
    var Keyv = require_src4();
    var CacheableRequest = class {
      constructor(request, cacheAdapter) {
        if (typeof request !== "function") {
          throw new TypeError("Parameter `request` must be a function");
        }
        this.cache = new Keyv({
          uri: typeof cacheAdapter === "string" && cacheAdapter,
          store: typeof cacheAdapter !== "string" && cacheAdapter,
          namespace: "cacheable-request"
        });
        return this.createCacheableRequest(request);
      }
      createCacheableRequest(request) {
        return (opts, cb) => {
          let url;
          if (typeof opts === "string") {
            url = normalizeUrlObject(urlLib.parse(opts));
            opts = {};
          } else if (opts instanceof urlLib.URL) {
            url = normalizeUrlObject(urlLib.parse(opts.toString()));
            opts = {};
          } else {
            const [pathname, ...searchParts] = (opts.path || "").split("?");
            const search = searchParts.length > 0 ? `?${searchParts.join("?")}` : "";
            url = normalizeUrlObject({...opts, pathname, search});
          }
          opts = {
            headers: {},
            method: "GET",
            cache: true,
            strictTtl: false,
            automaticFailover: false,
            ...opts,
            ...urlObjectToRequestOptions(url)
          };
          opts.headers = lowercaseKeys(opts.headers);
          const ee = new EventEmitter();
          const normalizedUrlString = normalizeUrl(urlLib.format(url), {
            stripWWW: false,
            removeTrailingSlash: false,
            stripAuthentication: false
          });
          const key = `${opts.method}:${normalizedUrlString}`;
          let revalidate = false;
          let madeRequest = false;
          const makeRequest = (opts2) => {
            madeRequest = true;
            let requestErrored = false;
            let requestErrorCallback;
            const requestErrorPromise = new Promise((resolve) => {
              requestErrorCallback = () => {
                if (!requestErrored) {
                  requestErrored = true;
                  resolve();
                }
              };
            });
            const handler = (response) => {
              if (revalidate && !opts2.forceRefresh) {
                response.status = response.statusCode;
                const revalidatedPolicy = CachePolicy.fromObject(revalidate.cachePolicy).revalidatedPolicy(opts2, response);
                if (!revalidatedPolicy.modified) {
                  const headers = revalidatedPolicy.policy.responseHeaders();
                  response = new Response(revalidate.statusCode, headers, revalidate.body, revalidate.url);
                  response.cachePolicy = revalidatedPolicy.policy;
                  response.fromCache = true;
                }
              }
              if (!response.fromCache) {
                response.cachePolicy = new CachePolicy(opts2, response, opts2);
                response.fromCache = false;
              }
              let clonedResponse;
              if (opts2.cache && response.cachePolicy.storable()) {
                clonedResponse = cloneResponse(response);
                (async () => {
                  try {
                    const bodyPromise = getStream.buffer(response);
                    await Promise.race([
                      requestErrorPromise,
                      new Promise((resolve) => response.once("end", resolve))
                    ]);
                    if (requestErrored) {
                      return;
                    }
                    const body2 = await bodyPromise;
                    const value = {
                      cachePolicy: response.cachePolicy.toObject(),
                      url: response.url,
                      statusCode: response.fromCache ? revalidate.statusCode : response.statusCode,
                      body: body2
                    };
                    let ttl = opts2.strictTtl ? response.cachePolicy.timeToLive() : void 0;
                    if (opts2.maxTtl) {
                      ttl = ttl ? Math.min(ttl, opts2.maxTtl) : opts2.maxTtl;
                    }
                    await this.cache.set(key, value, ttl);
                  } catch (error) {
                    ee.emit("error", new CacheableRequest.CacheError(error));
                  }
                })();
              } else if (opts2.cache && revalidate) {
                (async () => {
                  try {
                    await this.cache.delete(key);
                  } catch (error) {
                    ee.emit("error", new CacheableRequest.CacheError(error));
                  }
                })();
              }
              ee.emit("response", clonedResponse || response);
              if (typeof cb === "function") {
                cb(clonedResponse || response);
              }
            };
            try {
              const req = request(opts2, handler);
              req.once("error", requestErrorCallback);
              req.once("abort", requestErrorCallback);
              ee.emit("request", req);
            } catch (error) {
              ee.emit("error", new CacheableRequest.RequestError(error));
            }
          };
          (async () => {
            const get2 = async (opts2) => {
              await Promise.resolve();
              const cacheEntry = opts2.cache ? await this.cache.get(key) : void 0;
              if (typeof cacheEntry === "undefined") {
                return makeRequest(opts2);
              }
              const policy = CachePolicy.fromObject(cacheEntry.cachePolicy);
              if (policy.satisfiesWithoutRevalidation(opts2) && !opts2.forceRefresh) {
                const headers = policy.responseHeaders();
                const response = new Response(cacheEntry.statusCode, headers, cacheEntry.body, cacheEntry.url);
                response.cachePolicy = policy;
                response.fromCache = true;
                ee.emit("response", response);
                if (typeof cb === "function") {
                  cb(response);
                }
              } else {
                revalidate = cacheEntry;
                opts2.headers = policy.revalidationHeaders(opts2);
                makeRequest(opts2);
              }
            };
            const errorHandler = (error) => ee.emit("error", new CacheableRequest.CacheError(error));
            this.cache.once("error", errorHandler);
            ee.on("response", () => this.cache.removeListener("error", errorHandler));
            try {
              await get2(opts);
            } catch (error) {
              if (opts.automaticFailover && !madeRequest) {
                makeRequest(opts);
              }
              ee.emit("error", new CacheableRequest.CacheError(error));
            }
          })();
          return ee;
        };
      }
    };
    function urlObjectToRequestOptions(url) {
      const options = {...url};
      options.path = `${url.pathname || "/"}${url.search || ""}`;
      delete options.pathname;
      delete options.search;
      return options;
    }
    function normalizeUrlObject(url) {
      return {
        protocol: url.protocol,
        auth: url.auth,
        hostname: url.hostname || url.host || "localhost",
        port: url.port,
        pathname: url.pathname,
        search: url.search
      };
    }
    CacheableRequest.RequestError = class extends Error {
      constructor(error) {
        super(error.message);
        this.name = "RequestError";
        Object.assign(this, error);
      }
    };
    CacheableRequest.CacheError = class extends Error {
      constructor(error) {
        super(error.message);
        this.name = "CacheError";
        Object.assign(this, error);
      }
    };
    module2.exports = CacheableRequest;
  }
});

// node_modules/to-readable-stream/index.js
var require_to_readable_stream = __commonJS({
  "node_modules/to-readable-stream/index.js"(exports2, module2) {
    "use strict";
    var {Readable} = require("stream");
    module2.exports = (input) => new Readable({
      read() {
        this.push(input);
        this.push(null);
      }
    });
  }
});

// node_modules/defer-to-connect/dist/index.js
var require_dist2 = __commonJS({
  "node_modules/defer-to-connect/dist/index.js"(exports2, module2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", {value: true});
    var tls_1 = require("tls");
    var deferToConnect = (socket, fn2) => {
      let listeners;
      if (typeof fn2 === "function") {
        const connect = fn2;
        listeners = {connect};
      } else {
        listeners = fn2;
      }
      const hasConnectListener = typeof listeners.connect === "function";
      const hasSecureConnectListener = typeof listeners.secureConnect === "function";
      const hasCloseListener = typeof listeners.close === "function";
      const onConnect = () => {
        if (hasConnectListener) {
          listeners.connect();
        }
        if (socket instanceof tls_1.TLSSocket && hasSecureConnectListener) {
          if (socket.authorized) {
            listeners.secureConnect();
          } else if (!socket.authorizationError) {
            socket.once("secureConnect", listeners.secureConnect);
          }
        }
        if (hasCloseListener) {
          socket.once("close", listeners.close);
        }
      };
      if (socket.writable && !socket.connecting) {
        onConnect();
      } else if (socket.connecting) {
        socket.once("connect", onConnect);
      } else if (socket.destroyed && hasCloseListener) {
        listeners.close(socket._hadError);
      }
    };
    exports2.default = deferToConnect;
    module2.exports = deferToConnect;
    module2.exports.default = deferToConnect;
  }
});

// node_modules/@szmarczak/http-timer/source/index.js
var require_source2 = __commonJS({
  "node_modules/@szmarczak/http-timer/source/index.js"(exports2, module2) {
    "use strict";
    var deferToConnect = require_dist2();
    module2.exports = (request) => {
      const timings = {
        start: Date.now(),
        socket: null,
        lookup: null,
        connect: null,
        upload: null,
        response: null,
        end: null,
        error: null,
        phases: {
          wait: null,
          dns: null,
          tcp: null,
          request: null,
          firstByte: null,
          download: null,
          total: null
        }
      };
      const handleError = (origin) => {
        const emit = origin.emit.bind(origin);
        origin.emit = (event, ...args) => {
          if (event === "error") {
            timings.error = Date.now();
            timings.phases.total = timings.error - timings.start;
            origin.emit = emit;
          }
          return emit(event, ...args);
        };
      };
      let uploadFinished = false;
      const onUpload = () => {
        timings.upload = Date.now();
        timings.phases.request = timings.upload - timings.connect;
      };
      handleError(request);
      request.once("socket", (socket) => {
        timings.socket = Date.now();
        timings.phases.wait = timings.socket - timings.start;
        const lookupListener = () => {
          timings.lookup = Date.now();
          timings.phases.dns = timings.lookup - timings.socket;
        };
        socket.once("lookup", lookupListener);
        deferToConnect(socket, () => {
          timings.connect = Date.now();
          if (timings.lookup === null) {
            socket.removeListener("lookup", lookupListener);
            timings.lookup = timings.connect;
            timings.phases.dns = timings.lookup - timings.socket;
          }
          timings.phases.tcp = timings.connect - timings.lookup;
          if (uploadFinished && !timings.upload) {
            onUpload();
          }
        });
      });
      request.once("finish", () => {
        uploadFinished = true;
        if (timings.connect) {
          onUpload();
        }
      });
      request.once("response", (response) => {
        timings.response = Date.now();
        timings.phases.firstByte = timings.response - timings.upload;
        handleError(response);
        response.once("end", () => {
          timings.end = Date.now();
          timings.phases.download = timings.end - timings.response;
          timings.phases.total = timings.end - timings.start;
        });
      });
      return timings;
    };
  }
});

// node_modules/got/source/utils/timed-out.js
var require_timed_out = __commonJS({
  "node_modules/got/source/utils/timed-out.js"(exports2, module2) {
    "use strict";
    var net = require("net");
    var TimeoutError = class extends Error {
      constructor(threshold, event) {
        super(`Timeout awaiting '${event}' for ${threshold}ms`);
        this.name = "TimeoutError";
        this.code = "ETIMEDOUT";
        this.event = event;
      }
    };
    var reentry = Symbol("reentry");
    var noop = () => {
    };
    module2.exports = (request, delays, options) => {
      if (request[reentry]) {
        return;
      }
      request[reentry] = true;
      let stopNewTimeouts = false;
      const addTimeout = (delay, callback, ...args) => {
        if (stopNewTimeouts) {
          return noop;
        }
        let immediate;
        const timeout = setTimeout(() => {
          immediate = setImmediate(callback, delay, ...args);
          if (immediate.unref) {
            immediate.unref();
          }
        }, delay);
        if (timeout.unref) {
          timeout.unref();
        }
        const cancel = () => {
          clearTimeout(timeout);
          clearImmediate(immediate);
        };
        cancelers.push(cancel);
        return cancel;
      };
      const {host, hostname} = options;
      const timeoutHandler = (delay, event) => {
        request.emit("error", new TimeoutError(delay, event));
        request.once("error", () => {
        });
        request.abort();
      };
      const cancelers = [];
      const cancelTimeouts = () => {
        stopNewTimeouts = true;
        cancelers.forEach((cancelTimeout) => cancelTimeout());
      };
      request.once("error", cancelTimeouts);
      request.once("response", (response) => {
        response.once("end", cancelTimeouts);
      });
      if (delays.request !== void 0) {
        addTimeout(delays.request, timeoutHandler, "request");
      }
      if (delays.socket !== void 0) {
        const socketTimeoutHandler = () => {
          timeoutHandler(delays.socket, "socket");
        };
        request.setTimeout(delays.socket, socketTimeoutHandler);
        cancelers.push(() => request.removeListener("timeout", socketTimeoutHandler));
      }
      if (delays.lookup !== void 0 && !request.socketPath && !net.isIP(hostname || host)) {
        request.once("socket", (socket) => {
          if (socket.connecting) {
            const cancelTimeout = addTimeout(delays.lookup, timeoutHandler, "lookup");
            socket.once("lookup", cancelTimeout);
          }
        });
      }
      if (delays.connect !== void 0) {
        request.once("socket", (socket) => {
          if (socket.connecting) {
            const timeConnect = () => addTimeout(delays.connect, timeoutHandler, "connect");
            if (request.socketPath || net.isIP(hostname || host)) {
              socket.once("connect", timeConnect());
            } else {
              socket.once("lookup", (error) => {
                if (error === null) {
                  socket.once("connect", timeConnect());
                }
              });
            }
          }
        });
      }
      if (delays.secureConnect !== void 0 && options.protocol === "https:") {
        request.once("socket", (socket) => {
          if (socket.connecting) {
            socket.once("connect", () => {
              const cancelTimeout = addTimeout(delays.secureConnect, timeoutHandler, "secureConnect");
              socket.once("secureConnect", cancelTimeout);
            });
          }
        });
      }
      if (delays.send !== void 0) {
        request.once("socket", (socket) => {
          const timeRequest = () => addTimeout(delays.send, timeoutHandler, "send");
          if (socket.connecting) {
            socket.once("connect", () => {
              request.once("upload-complete", timeRequest());
            });
          } else {
            request.once("upload-complete", timeRequest());
          }
        });
      }
      if (delays.response !== void 0) {
        request.once("upload-complete", () => {
          const cancelTimeout = addTimeout(delays.response, timeoutHandler, "response");
          request.once("response", cancelTimeout);
        });
      }
    };
    module2.exports.TimeoutError = TimeoutError;
  }
});

// node_modules/got/source/utils/is-form-data.js
var require_is_form_data = __commonJS({
  "node_modules/got/source/utils/is-form-data.js"(exports2, module2) {
    "use strict";
    var is = require_dist();
    module2.exports = (body2) => is.nodeStream(body2) && is.function(body2.getBoundary);
  }
});

// node_modules/got/source/utils/get-body-size.js
var require_get_body_size = __commonJS({
  "node_modules/got/source/utils/get-body-size.js"(exports2, module2) {
    "use strict";
    var fs = require("fs");
    var util = require("util");
    var is = require_dist();
    var isFormData = require_is_form_data();
    module2.exports = async (options) => {
      const {body: body2} = options;
      if (options.headers["content-length"]) {
        return Number(options.headers["content-length"]);
      }
      if (!body2 && !options.stream) {
        return 0;
      }
      if (is.string(body2)) {
        return Buffer.byteLength(body2);
      }
      if (isFormData(body2)) {
        return util.promisify(body2.getLength.bind(body2))();
      }
      if (body2 instanceof fs.ReadStream) {
        const {size} = await util.promisify(fs.stat)(body2.path);
        return size;
      }
      return null;
    };
  }
});

// node_modules/decompress-response/index.js
var require_decompress_response = __commonJS({
  "node_modules/decompress-response/index.js"(exports2, module2) {
    "use strict";
    var PassThrough = require("stream").PassThrough;
    var zlib = require("zlib");
    var mimicResponse = require_mimic_response();
    module2.exports = (response) => {
      if (["gzip", "deflate"].indexOf(response.headers["content-encoding"]) === -1) {
        return response;
      }
      const unzip = zlib.createUnzip();
      const stream = new PassThrough();
      mimicResponse(response, stream);
      unzip.on("error", (err) => {
        if (err.code === "Z_BUF_ERROR") {
          stream.end();
          return;
        }
        stream.emit("error", err);
      });
      response.pipe(unzip).pipe(stream);
      return stream;
    };
  }
});

// node_modules/got/source/progress.js
var require_progress = __commonJS({
  "node_modules/got/source/progress.js"(exports2, module2) {
    "use strict";
    var {Transform} = require("stream");
    module2.exports = {
      download(response, emitter, downloadBodySize) {
        let downloaded = 0;
        return new Transform({
          transform(chunk, encoding, callback) {
            downloaded += chunk.length;
            const percent = downloadBodySize ? downloaded / downloadBodySize : 0;
            if (percent < 1) {
              emitter.emit("downloadProgress", {
                percent,
                transferred: downloaded,
                total: downloadBodySize
              });
            }
            callback(null, chunk);
          },
          flush(callback) {
            emitter.emit("downloadProgress", {
              percent: 1,
              transferred: downloaded,
              total: downloadBodySize
            });
            callback();
          }
        });
      },
      upload(request, emitter, uploadBodySize) {
        const uploadEventFrequency = 150;
        let uploaded = 0;
        let progressInterval;
        emitter.emit("uploadProgress", {
          percent: 0,
          transferred: 0,
          total: uploadBodySize
        });
        request.once("error", () => {
          clearInterval(progressInterval);
        });
        request.once("response", () => {
          clearInterval(progressInterval);
          emitter.emit("uploadProgress", {
            percent: 1,
            transferred: uploaded,
            total: uploadBodySize
          });
        });
        request.once("socket", (socket) => {
          const onSocketConnect = () => {
            progressInterval = setInterval(() => {
              const lastUploaded = uploaded;
              const headersSize = request._header ? Buffer.byteLength(request._header) : 0;
              uploaded = socket.bytesWritten - headersSize;
              if (uploaded === lastUploaded || uploaded === uploadBodySize) {
                return;
              }
              emitter.emit("uploadProgress", {
                percent: uploadBodySize ? uploaded / uploadBodySize : 0,
                transferred: uploaded,
                total: uploadBodySize
              });
            }, uploadEventFrequency);
          };
          if (socket.connecting) {
            socket.once("connect", onSocketConnect);
          } else if (socket.writable) {
            onSocketConnect();
          }
        });
      }
    };
  }
});

// node_modules/got/source/get-response.js
var require_get_response = __commonJS({
  "node_modules/got/source/get-response.js"(exports2, module2) {
    "use strict";
    var decompressResponse = require_decompress_response();
    var is = require_dist();
    var mimicResponse = require_mimic_response();
    var progress = require_progress();
    module2.exports = (response, options, emitter) => {
      const downloadBodySize = Number(response.headers["content-length"]) || null;
      const progressStream = progress.download(response, emitter, downloadBodySize);
      mimicResponse(response, progressStream);
      const newResponse = options.decompress === true && is.function(decompressResponse) && options.method !== "HEAD" ? decompressResponse(progressStream) : progressStream;
      if (!options.decompress && ["gzip", "deflate"].includes(response.headers["content-encoding"])) {
        options.encoding = null;
      }
      emitter.emit("response", newResponse);
      emitter.emit("downloadProgress", {
        percent: 0,
        transferred: 0,
        total: downloadBodySize
      });
      response.pipe(progressStream);
    };
  }
});

// node_modules/got/source/utils/url-to-options.js
var require_url_to_options = __commonJS({
  "node_modules/got/source/utils/url-to-options.js"(exports2, module2) {
    "use strict";
    var is = require_dist();
    module2.exports = (url) => {
      const options = {
        protocol: url.protocol,
        hostname: url.hostname.startsWith("[") ? url.hostname.slice(1, -1) : url.hostname,
        hash: url.hash,
        search: url.search,
        pathname: url.pathname,
        href: url.href
      };
      if (is.string(url.port) && url.port.length > 0) {
        options.port = Number(url.port);
      }
      if (url.username || url.password) {
        options.auth = `${url.username}:${url.password}`;
      }
      options.path = is.null(url.search) ? url.pathname : `${url.pathname}${url.search}`;
      return options;
    };
  }
});

// node_modules/got/source/request-as-event-emitter.js
var require_request_as_event_emitter = __commonJS({
  "node_modules/got/source/request-as-event-emitter.js"(exports2, module2) {
    "use strict";
    var {URL: URL2} = require("url");
    var util = require("util");
    var EventEmitter = require("events");
    var http = require("http");
    var https = require("https");
    var urlLib = require("url");
    var CacheableRequest = require_src5();
    var toReadableStream = require_to_readable_stream();
    var is = require_dist();
    var timer = require_source2();
    var timedOut = require_timed_out();
    var getBodySize = require_get_body_size();
    var getResponse = require_get_response();
    var progress = require_progress();
    var {CacheError, UnsupportedProtocolError, MaxRedirectsError, RequestError, TimeoutError} = require_errors();
    var urlToOptions = require_url_to_options();
    var getMethodRedirectCodes = new Set([300, 301, 302, 303, 304, 305, 307, 308]);
    var allMethodRedirectCodes = new Set([300, 303, 307, 308]);
    module2.exports = (options, input) => {
      const emitter = new EventEmitter();
      const redirects = [];
      let currentRequest;
      let requestUrl;
      let redirectString;
      let uploadBodySize;
      let retryCount = 0;
      let shouldAbort = false;
      const setCookie = options.cookieJar ? util.promisify(options.cookieJar.setCookie.bind(options.cookieJar)) : null;
      const getCookieString = options.cookieJar ? util.promisify(options.cookieJar.getCookieString.bind(options.cookieJar)) : null;
      const agents = is.object(options.agent) ? options.agent : null;
      const emitError = async (error) => {
        try {
          for (const hook of options.hooks.beforeError) {
            error = await hook(error);
          }
          emitter.emit("error", error);
        } catch (error2) {
          emitter.emit("error", error2);
        }
      };
      const get2 = async (options2) => {
        const currentUrl = redirectString || requestUrl;
        if (options2.protocol !== "http:" && options2.protocol !== "https:") {
          throw new UnsupportedProtocolError(options2);
        }
        decodeURI(currentUrl);
        let fn2;
        if (is.function(options2.request)) {
          fn2 = {request: options2.request};
        } else {
          fn2 = options2.protocol === "https:" ? https : http;
        }
        if (agents) {
          const protocolName = options2.protocol === "https:" ? "https" : "http";
          options2.agent = agents[protocolName] || options2.agent;
        }
        if (options2.useElectronNet && process.versions.electron) {
          const r = {x: require}["yx".slice(1)];
          const electron = r("electron");
          fn2 = electron.net || electron.remote.net;
        }
        if (options2.cookieJar) {
          const cookieString = await getCookieString(currentUrl, {});
          if (is.nonEmptyString(cookieString)) {
            options2.headers.cookie = cookieString;
          }
        }
        let timings;
        const handleResponse = async (response) => {
          try {
            if (options2.useElectronNet) {
              response = new Proxy(response, {
                get: (target, name) => {
                  if (name === "trailers" || name === "rawTrailers") {
                    return [];
                  }
                  const value = target[name];
                  return is.function(value) ? value.bind(target) : value;
                }
              });
            }
            const {statusCode} = response;
            response.url = currentUrl;
            response.requestUrl = requestUrl;
            response.retryCount = retryCount;
            response.timings = timings;
            response.redirectUrls = redirects;
            response.request = {
              gotOptions: options2
            };
            const rawCookies = response.headers["set-cookie"];
            if (options2.cookieJar && rawCookies) {
              await Promise.all(rawCookies.map((rawCookie) => setCookie(rawCookie, response.url)));
            }
            if (options2.followRedirect && "location" in response.headers) {
              if (allMethodRedirectCodes.has(statusCode) || getMethodRedirectCodes.has(statusCode) && (options2.method === "GET" || options2.method === "HEAD")) {
                response.resume();
                if (statusCode === 303) {
                  options2.method = "GET";
                }
                if (redirects.length >= 10) {
                  throw new MaxRedirectsError(statusCode, redirects, options2);
                }
                const redirectBuffer = Buffer.from(response.headers.location, "binary").toString();
                const redirectURL = new URL2(redirectBuffer, currentUrl);
                redirectString = redirectURL.toString();
                redirects.push(redirectString);
                const redirectOptions = {
                  ...options2,
                  ...urlToOptions(redirectURL)
                };
                for (const hook of options2.hooks.beforeRedirect) {
                  await hook(redirectOptions);
                }
                emitter.emit("redirect", response, redirectOptions);
                await get2(redirectOptions);
                return;
              }
            }
            getResponse(response, options2, emitter);
          } catch (error) {
            emitError(error);
          }
        };
        const handleRequest = (request) => {
          if (shouldAbort) {
            request.once("error", () => {
            });
            request.abort();
            return;
          }
          currentRequest = request;
          request.once("error", (error) => {
            if (request.aborted) {
              return;
            }
            if (error instanceof timedOut.TimeoutError) {
              error = new TimeoutError(error, options2);
            } else {
              error = new RequestError(error, options2);
            }
            if (emitter.retry(error) === false) {
              emitError(error);
            }
          });
          timings = timer(request);
          progress.upload(request, emitter, uploadBodySize);
          if (options2.gotTimeout) {
            timedOut(request, options2.gotTimeout, options2);
          }
          emitter.emit("request", request);
          const uploadComplete = () => {
            request.emit("upload-complete");
          };
          try {
            if (is.nodeStream(options2.body)) {
              options2.body.once("end", uploadComplete);
              options2.body.pipe(request);
              options2.body = void 0;
            } else if (options2.body) {
              request.end(options2.body, uploadComplete);
            } else if (input && (options2.method === "POST" || options2.method === "PUT" || options2.method === "PATCH")) {
              input.once("end", uploadComplete);
              input.pipe(request);
            } else {
              request.end(uploadComplete);
            }
          } catch (error) {
            emitError(new RequestError(error, options2));
          }
        };
        if (options2.cache) {
          const cacheableRequest = new CacheableRequest(fn2.request, options2.cache);
          const cacheRequest = cacheableRequest(options2, handleResponse);
          cacheRequest.once("error", (error) => {
            if (error instanceof CacheableRequest.RequestError) {
              emitError(new RequestError(error, options2));
            } else {
              emitError(new CacheError(error, options2));
            }
          });
          cacheRequest.once("request", handleRequest);
        } else {
          try {
            handleRequest(fn2.request(options2, handleResponse));
          } catch (error) {
            emitError(new RequestError(error, options2));
          }
        }
      };
      emitter.retry = (error) => {
        let backoff;
        try {
          backoff = options.retry.retries(++retryCount, error);
        } catch (error2) {
          emitError(error2);
          return;
        }
        if (backoff) {
          const retry = async (options2) => {
            try {
              for (const hook of options2.hooks.beforeRetry) {
                await hook(options2, error, retryCount);
              }
              await get2(options2);
            } catch (error2) {
              emitError(error2);
            }
          };
          setTimeout(retry, backoff, {...options, forceRefresh: true});
          return true;
        }
        return false;
      };
      emitter.abort = () => {
        if (currentRequest) {
          currentRequest.once("error", () => {
          });
          currentRequest.abort();
        } else {
          shouldAbort = true;
        }
      };
      setImmediate(async () => {
        try {
          const {body: body2} = options;
          if (is.buffer(body2)) {
            options.body = toReadableStream(body2);
            uploadBodySize = body2.length;
          } else {
            uploadBodySize = await getBodySize(options);
          }
          if (is.undefined(options.headers["content-length"]) && is.undefined(options.headers["transfer-encoding"])) {
            if ((uploadBodySize > 0 || options.method === "PUT") && !is.null(uploadBodySize)) {
              options.headers["content-length"] = uploadBodySize;
            }
          }
          for (const hook of options.hooks.beforeRequest) {
            await hook(options);
          }
          requestUrl = options.href || new URL2(options.path, urlLib.format(options)).toString();
          await get2(options);
        } catch (error) {
          emitError(error);
        }
      });
      return emitter;
    };
  }
});

// node_modules/got/source/as-stream.js
var require_as_stream = __commonJS({
  "node_modules/got/source/as-stream.js"(exports2, module2) {
    "use strict";
    var {PassThrough} = require("stream");
    var duplexer3 = require_duplexer3();
    var requestAsEventEmitter = require_request_as_event_emitter();
    var {HTTPError, ReadError} = require_errors();
    module2.exports = (options) => {
      const input = new PassThrough();
      const output = new PassThrough();
      const proxy = duplexer3(input, output);
      const piped = new Set();
      let isFinished = false;
      options.retry.retries = () => 0;
      if (options.body) {
        proxy.write = () => {
          throw new Error("Got's stream is not writable when the `body` option is used");
        };
      }
      const emitter = requestAsEventEmitter(options, input);
      proxy._destroy = emitter.abort;
      emitter.on("response", (response) => {
        const {statusCode} = response;
        response.on("error", (error) => {
          proxy.emit("error", new ReadError(error, options));
        });
        if (options.throwHttpErrors && statusCode !== 304 && (statusCode < 200 || statusCode > 299)) {
          proxy.emit("error", new HTTPError(response, options), null, response);
          return;
        }
        isFinished = true;
        response.pipe(output);
        for (const destination of piped) {
          if (destination.headersSent) {
            continue;
          }
          for (const [key, value] of Object.entries(response.headers)) {
            const allowed = options.decompress ? key !== "content-encoding" : true;
            if (allowed) {
              destination.setHeader(key, value);
            }
          }
          destination.statusCode = response.statusCode;
        }
        proxy.emit("response", response);
      });
      [
        "error",
        "request",
        "redirect",
        "uploadProgress",
        "downloadProgress"
      ].forEach((event) => emitter.on(event, (...args) => proxy.emit(event, ...args)));
      const pipe = proxy.pipe.bind(proxy);
      const unpipe = proxy.unpipe.bind(proxy);
      proxy.pipe = (destination, options2) => {
        if (isFinished) {
          throw new Error("Failed to pipe. The response has been emitted already.");
        }
        const result = pipe(destination, options2);
        if (Reflect.has(destination, "setHeader")) {
          piped.add(destination);
        }
        return result;
      };
      proxy.unpipe = (stream) => {
        piped.delete(stream);
        return unpipe(stream);
      };
      return proxy;
    };
  }
});

// node_modules/get-stream/buffer-stream.js
var require_buffer_stream2 = __commonJS({
  "node_modules/get-stream/buffer-stream.js"(exports2, module2) {
    "use strict";
    var {PassThrough} = require("stream");
    module2.exports = (options) => {
      options = Object.assign({}, options);
      const {array} = options;
      let {encoding} = options;
      const buffer = encoding === "buffer";
      let objectMode = false;
      if (array) {
        objectMode = !(encoding || buffer);
      } else {
        encoding = encoding || "utf8";
      }
      if (buffer) {
        encoding = null;
      }
      let len = 0;
      const ret = [];
      const stream = new PassThrough({objectMode});
      if (encoding) {
        stream.setEncoding(encoding);
      }
      stream.on("data", (chunk) => {
        ret.push(chunk);
        if (objectMode) {
          len = ret.length;
        } else {
          len += chunk.length;
        }
      });
      stream.getBufferedValue = () => {
        if (array) {
          return ret;
        }
        return buffer ? Buffer.concat(ret, len) : ret.join("");
      };
      stream.getBufferedLength = () => len;
      return stream;
    };
  }
});

// node_modules/get-stream/index.js
var require_get_stream2 = __commonJS({
  "node_modules/get-stream/index.js"(exports2, module2) {
    "use strict";
    var pump = require_pump();
    var bufferStream = require_buffer_stream2();
    var MaxBufferError = class extends Error {
      constructor() {
        super("maxBuffer exceeded");
        this.name = "MaxBufferError";
      }
    };
    function getStream(inputStream, options) {
      if (!inputStream) {
        return Promise.reject(new Error("Expected a stream"));
      }
      options = Object.assign({maxBuffer: Infinity}, options);
      const {maxBuffer} = options;
      let stream;
      return new Promise((resolve, reject) => {
        const rejectPromise = (error) => {
          if (error) {
            error.bufferedData = stream.getBufferedValue();
          }
          reject(error);
        };
        stream = pump(inputStream, bufferStream(options), (error) => {
          if (error) {
            rejectPromise(error);
            return;
          }
          resolve();
        });
        stream.on("data", () => {
          if (stream.getBufferedLength() > maxBuffer) {
            rejectPromise(new MaxBufferError());
          }
        });
      }).then(() => stream.getBufferedValue());
    }
    module2.exports = getStream;
    module2.exports.buffer = (stream, options) => getStream(stream, Object.assign({}, options, {encoding: "buffer"}));
    module2.exports.array = (stream, options) => getStream(stream, Object.assign({}, options, {array: true}));
    module2.exports.MaxBufferError = MaxBufferError;
  }
});

// node_modules/got/source/known-hook-events.js
var require_known_hook_events = __commonJS({
  "node_modules/got/source/known-hook-events.js"(exports2, module2) {
    "use strict";
    module2.exports = [
      "beforeError",
      "init",
      "beforeRequest",
      "beforeRedirect",
      "beforeRetry",
      "afterResponse"
    ];
  }
});

// node_modules/got/source/merge.js
var require_merge = __commonJS({
  "node_modules/got/source/merge.js"(exports2, module2) {
    "use strict";
    var {URL: URL2} = require("url");
    var is = require_dist();
    var knownHookEvents = require_known_hook_events();
    var merge2 = (target, ...sources) => {
      for (const source of sources) {
        for (const [key, sourceValue] of Object.entries(source)) {
          if (is.undefined(sourceValue)) {
            continue;
          }
          const targetValue = target[key];
          if (is.urlInstance(targetValue) && (is.urlInstance(sourceValue) || is.string(sourceValue))) {
            target[key] = new URL2(sourceValue, targetValue);
          } else if (is.plainObject(sourceValue)) {
            if (is.plainObject(targetValue)) {
              target[key] = merge2({}, targetValue, sourceValue);
            } else {
              target[key] = merge2({}, sourceValue);
            }
          } else if (is.array(sourceValue)) {
            target[key] = merge2([], sourceValue);
          } else {
            target[key] = sourceValue;
          }
        }
      }
      return target;
    };
    var mergeOptions = (...sources) => {
      sources = sources.map((source) => source || {});
      const merged = merge2({}, ...sources);
      const hooks = {};
      for (const hook of knownHookEvents) {
        hooks[hook] = [];
      }
      for (const source of sources) {
        if (source.hooks) {
          for (const hook of knownHookEvents) {
            hooks[hook] = hooks[hook].concat(source.hooks[hook]);
          }
        }
      }
      merged.hooks = hooks;
      return merged;
    };
    var mergeInstances = (instances, methods) => {
      const handlers = instances.map((instance) => instance.defaults.handler);
      const size = instances.length - 1;
      return {
        methods,
        options: mergeOptions(...instances.map((instance) => instance.defaults.options)),
        handler: (options, next) => {
          let iteration = -1;
          const iterate = (options2) => handlers[++iteration](options2, iteration === size ? next : iterate);
          return iterate(options);
        }
      };
    };
    module2.exports = merge2;
    module2.exports.options = mergeOptions;
    module2.exports.instances = mergeInstances;
  }
});

// node_modules/prepend-http/index.js
var require_prepend_http = __commonJS({
  "node_modules/prepend-http/index.js"(exports2, module2) {
    "use strict";
    module2.exports = (url, opts) => {
      if (typeof url !== "string") {
        throw new TypeError(`Expected \`url\` to be of type \`string\`, got \`${typeof url}\``);
      }
      url = url.trim();
      opts = Object.assign({https: false}, opts);
      if (/^\.*\/|^(?!localhost)\w+:/.test(url)) {
        return url;
      }
      return url.replace(/^(?!(?:\w+:)?\/\/)/, opts.https ? "https://" : "http://");
    };
  }
});

// node_modules/url-parse-lax/index.js
var require_url_parse_lax = __commonJS({
  "node_modules/url-parse-lax/index.js"(exports2, module2) {
    "use strict";
    var url = require("url");
    var prependHttp = require_prepend_http();
    module2.exports = (input, options) => {
      if (typeof input !== "string") {
        throw new TypeError(`Expected \`url\` to be of type \`string\`, got \`${typeof input}\` instead.`);
      }
      const finalUrl = prependHttp(input, Object.assign({https: true}, options));
      return url.parse(finalUrl);
    };
  }
});

// node_modules/got/source/normalize-arguments.js
var require_normalize_arguments = __commonJS({
  "node_modules/got/source/normalize-arguments.js"(exports2, module2) {
    "use strict";
    var {URL: URL2, URLSearchParams: URLSearchParams2} = require("url");
    var urlLib = require("url");
    var is = require_dist();
    var urlParseLax = require_url_parse_lax();
    var lowercaseKeys = require_lowercase_keys();
    var urlToOptions = require_url_to_options();
    var isFormData = require_is_form_data();
    var merge2 = require_merge();
    var knownHookEvents = require_known_hook_events();
    var retryAfterStatusCodes = new Set([413, 429, 503]);
    var preNormalize = (options, defaults) => {
      if (is.nullOrUndefined(options.headers)) {
        options.headers = {};
      } else {
        options.headers = lowercaseKeys(options.headers);
      }
      if (options.baseUrl && !options.baseUrl.toString().endsWith("/")) {
        options.baseUrl += "/";
      }
      if (options.stream) {
        options.json = false;
      }
      if (is.nullOrUndefined(options.hooks)) {
        options.hooks = {};
      } else if (!is.object(options.hooks)) {
        throw new TypeError(`Parameter \`hooks\` must be an object, not ${is(options.hooks)}`);
      }
      for (const event of knownHookEvents) {
        if (is.nullOrUndefined(options.hooks[event])) {
          if (defaults) {
            options.hooks[event] = [...defaults.hooks[event]];
          } else {
            options.hooks[event] = [];
          }
        }
      }
      if (is.number(options.timeout)) {
        options.gotTimeout = {request: options.timeout};
      } else if (is.object(options.timeout)) {
        options.gotTimeout = options.timeout;
      }
      delete options.timeout;
      const {retry} = options;
      options.retry = {
        retries: 0,
        methods: [],
        statusCodes: [],
        errorCodes: []
      };
      if (is.nonEmptyObject(defaults) && retry !== false) {
        options.retry = {...defaults.retry};
      }
      if (retry !== false) {
        if (is.number(retry)) {
          options.retry.retries = retry;
        } else {
          options.retry = {...options.retry, ...retry};
        }
      }
      if (options.gotTimeout) {
        options.retry.maxRetryAfter = Math.min(...[options.gotTimeout.request, options.gotTimeout.connection].filter((n) => !is.nullOrUndefined(n)));
      }
      if (is.array(options.retry.methods)) {
        options.retry.methods = new Set(options.retry.methods.map((method) => method.toUpperCase()));
      }
      if (is.array(options.retry.statusCodes)) {
        options.retry.statusCodes = new Set(options.retry.statusCodes);
      }
      if (is.array(options.retry.errorCodes)) {
        options.retry.errorCodes = new Set(options.retry.errorCodes);
      }
      return options;
    };
    var normalize = (url, options, defaults) => {
      if (is.plainObject(url)) {
        options = {...url, ...options};
        url = options.url || {};
        delete options.url;
      }
      if (defaults) {
        options = merge2({}, defaults.options, options ? preNormalize(options, defaults.options) : {});
      } else {
        options = merge2({}, preNormalize(options));
      }
      if (!is.string(url) && !is.object(url)) {
        throw new TypeError(`Parameter \`url\` must be a string or object, not ${is(url)}`);
      }
      if (is.string(url)) {
        if (options.baseUrl) {
          if (url.toString().startsWith("/")) {
            url = url.toString().slice(1);
          }
          url = urlToOptions(new URL2(url, options.baseUrl));
        } else {
          url = url.replace(/^unix:/, "http://$&");
          url = urlParseLax(url);
        }
      } else if (is(url) === "URL") {
        url = urlToOptions(url);
      }
      options = merge2({path: ""}, url, {protocol: url.protocol || "https:"}, options);
      for (const hook of options.hooks.init) {
        const called = hook(options);
        if (is.promise(called)) {
          throw new TypeError("The `init` hook must be a synchronous function");
        }
      }
      const {baseUrl} = options;
      Object.defineProperty(options, "baseUrl", {
        set: () => {
          throw new Error("Failed to set baseUrl. Options are normalized already.");
        },
        get: () => baseUrl
      });
      const {query} = options;
      if (is.nonEmptyString(query) || is.nonEmptyObject(query) || query instanceof URLSearchParams2) {
        if (!is.string(query)) {
          options.query = new URLSearchParams2(query).toString();
        }
        options.path = `${options.path.split("?")[0]}?${options.query}`;
        delete options.query;
      }
      if (options.hostname === "unix") {
        const matches = /(.+?):(.+)/.exec(options.path);
        if (matches) {
          const [, socketPath, path] = matches;
          options = {
            ...options,
            socketPath,
            path,
            host: null
          };
        }
      }
      const {headers} = options;
      for (const [key, value] of Object.entries(headers)) {
        if (is.nullOrUndefined(value)) {
          delete headers[key];
        }
      }
      if (options.json && is.undefined(headers.accept)) {
        headers.accept = "application/json";
      }
      if (options.decompress && is.undefined(headers["accept-encoding"])) {
        headers["accept-encoding"] = "gzip, deflate";
      }
      const {body: body2} = options;
      if (is.nullOrUndefined(body2)) {
        options.method = options.method ? options.method.toUpperCase() : "GET";
      } else {
        const isObject = is.object(body2) && !is.buffer(body2) && !is.nodeStream(body2);
        if (!is.nodeStream(body2) && !is.string(body2) && !is.buffer(body2) && !(options.form || options.json)) {
          throw new TypeError("The `body` option must be a stream.Readable, string or Buffer");
        }
        if (options.json && !(isObject || is.array(body2))) {
          throw new TypeError("The `body` option must be an Object or Array when the `json` option is used");
        }
        if (options.form && !isObject) {
          throw new TypeError("The `body` option must be an Object when the `form` option is used");
        }
        if (isFormData(body2)) {
          headers["content-type"] = headers["content-type"] || `multipart/form-data; boundary=${body2.getBoundary()}`;
        } else if (options.form) {
          headers["content-type"] = headers["content-type"] || "application/x-www-form-urlencoded";
          options.body = new URLSearchParams2(body2).toString();
        } else if (options.json) {
          headers["content-type"] = headers["content-type"] || "application/json";
          options.body = JSON.stringify(body2);
        }
        options.method = options.method ? options.method.toUpperCase() : "POST";
      }
      if (!is.function(options.retry.retries)) {
        const {retries} = options.retry;
        options.retry.retries = (iteration, error) => {
          if (iteration > retries) {
            return 0;
          }
          if ((!error || !options.retry.errorCodes.has(error.code)) && (!options.retry.methods.has(error.method) || !options.retry.statusCodes.has(error.statusCode))) {
            return 0;
          }
          if (Reflect.has(error, "headers") && Reflect.has(error.headers, "retry-after") && retryAfterStatusCodes.has(error.statusCode)) {
            let after = Number(error.headers["retry-after"]);
            if (is.nan(after)) {
              after = Date.parse(error.headers["retry-after"]) - Date.now();
            } else {
              after *= 1e3;
            }
            if (after > options.retry.maxRetryAfter) {
              return 0;
            }
            return after;
          }
          if (error.statusCode === 413) {
            return 0;
          }
          const noise = Math.random() * 100;
          return 2 ** (iteration - 1) * 1e3 + noise;
        };
      }
      return options;
    };
    var reNormalize = (options) => normalize(urlLib.format(options), options);
    module2.exports = normalize;
    module2.exports.preNormalize = preNormalize;
    module2.exports.reNormalize = reNormalize;
  }
});

// node_modules/got/source/as-promise.js
var require_as_promise = __commonJS({
  "node_modules/got/source/as-promise.js"(exports2, module2) {
    "use strict";
    var EventEmitter = require("events");
    var getStream = require_get_stream2();
    var is = require_dist();
    var PCancelable = require_p_cancelable();
    var requestAsEventEmitter = require_request_as_event_emitter();
    var {HTTPError, ParseError, ReadError} = require_errors();
    var {options: mergeOptions} = require_merge();
    var {reNormalize} = require_normalize_arguments();
    var asPromise = (options) => {
      const proxy = new EventEmitter();
      const promise = new PCancelable((resolve, reject, onCancel) => {
        const emitter = requestAsEventEmitter(options);
        onCancel(emitter.abort);
        emitter.on("response", async (response) => {
          proxy.emit("response", response);
          const stream = is.null(options.encoding) ? getStream.buffer(response) : getStream(response, options);
          let data;
          try {
            data = await stream;
          } catch (error) {
            reject(new ReadError(error, options));
            return;
          }
          const limitStatusCode = options.followRedirect ? 299 : 399;
          response.body = data;
          try {
            for (const [index, hook] of Object.entries(options.hooks.afterResponse)) {
              response = await hook(response, (updatedOptions) => {
                updatedOptions = reNormalize(mergeOptions(options, {
                  ...updatedOptions,
                  retry: 0,
                  throwHttpErrors: false
                }));
                updatedOptions.hooks.afterResponse = options.hooks.afterResponse.slice(0, index);
                return asPromise(updatedOptions);
              });
            }
          } catch (error) {
            reject(error);
            return;
          }
          const {statusCode} = response;
          if (options.json && response.body) {
            try {
              response.body = JSON.parse(response.body);
            } catch (error) {
              if (statusCode >= 200 && statusCode < 300) {
                const parseError = new ParseError(error, statusCode, options, data);
                Object.defineProperty(parseError, "response", {value: response});
                reject(parseError);
                return;
              }
            }
          }
          if (statusCode !== 304 && (statusCode < 200 || statusCode > limitStatusCode)) {
            const error = new HTTPError(response, options);
            Object.defineProperty(error, "response", {value: response});
            if (emitter.retry(error) === false) {
              if (options.throwHttpErrors) {
                reject(error);
                return;
              }
              resolve(response);
            }
            return;
          }
          resolve(response);
        });
        emitter.once("error", reject);
        [
          "request",
          "redirect",
          "uploadProgress",
          "downloadProgress"
        ].forEach((event) => emitter.on(event, (...args) => proxy.emit(event, ...args)));
      });
      promise.on = (name, fn2) => {
        proxy.on(name, fn2);
        return promise;
      };
      return promise;
    };
    module2.exports = asPromise;
  }
});

// node_modules/got/source/utils/deep-freeze.js
var require_deep_freeze = __commonJS({
  "node_modules/got/source/utils/deep-freeze.js"(exports2, module2) {
    "use strict";
    var is = require_dist();
    module2.exports = function deepFreeze(object) {
      for (const [key, value] of Object.entries(object)) {
        if (is.plainObject(value) || is.array(value)) {
          deepFreeze(object[key]);
        }
      }
      return Object.freeze(object);
    };
  }
});

// node_modules/got/source/create.js
var require_create = __commonJS({
  "node_modules/got/source/create.js"(exports2, module2) {
    "use strict";
    var errors = require_errors();
    var asStream = require_as_stream();
    var asPromise = require_as_promise();
    var normalizeArguments = require_normalize_arguments();
    var merge2 = require_merge();
    var deepFreeze = require_deep_freeze();
    var getPromiseOrStream = (options) => options.stream ? asStream(options) : asPromise(options);
    var aliases = [
      "get",
      "post",
      "put",
      "patch",
      "head",
      "delete"
    ];
    var create = (defaults) => {
      defaults = merge2({}, defaults);
      normalizeArguments.preNormalize(defaults.options);
      if (!defaults.handler) {
        defaults.handler = (options, next) => next(options);
      }
      function got(url, options) {
        try {
          return defaults.handler(normalizeArguments(url, options, defaults), getPromiseOrStream);
        } catch (error) {
          if (options && options.stream) {
            throw error;
          } else {
            return Promise.reject(error);
          }
        }
      }
      got.create = create;
      got.extend = (options) => {
        let mutableDefaults;
        if (options && Reflect.has(options, "mutableDefaults")) {
          mutableDefaults = options.mutableDefaults;
          delete options.mutableDefaults;
        } else {
          mutableDefaults = defaults.mutableDefaults;
        }
        return create({
          options: merge2.options(defaults.options, options),
          handler: defaults.handler,
          mutableDefaults
        });
      };
      got.mergeInstances = (...args) => create(merge2.instances(args));
      got.stream = (url, options) => got(url, {...options, stream: true});
      for (const method of aliases) {
        got[method] = (url, options) => got(url, {...options, method});
        got.stream[method] = (url, options) => got.stream(url, {...options, method});
      }
      Object.assign(got, {...errors, mergeOptions: merge2.options});
      Object.defineProperty(got, "defaults", {
        value: defaults.mutableDefaults ? defaults : deepFreeze(defaults),
        writable: defaults.mutableDefaults,
        configurable: defaults.mutableDefaults,
        enumerable: true
      });
      return got;
    };
    module2.exports = create;
  }
});

// node_modules/got/source/index.js
var require_source3 = __commonJS({
  "node_modules/got/source/index.js"(exports2, module2) {
    "use strict";
    var pkg = require_package();
    var create = require_create();
    var defaults = {
      options: {
        retry: {
          retries: 2,
          methods: [
            "GET",
            "PUT",
            "HEAD",
            "DELETE",
            "OPTIONS",
            "TRACE"
          ],
          statusCodes: [
            408,
            413,
            429,
            500,
            502,
            503,
            504
          ],
          errorCodes: [
            "ETIMEDOUT",
            "ECONNRESET",
            "EADDRINUSE",
            "ECONNREFUSED",
            "EPIPE",
            "ENOTFOUND",
            "ENETUNREACH",
            "EAI_AGAIN"
          ]
        },
        headers: {
          "user-agent": `${pkg.name}/${pkg.version} (https://github.com/sindresorhus/got)`
        },
        hooks: {
          beforeRequest: [],
          beforeRedirect: [],
          beforeRetry: [],
          afterResponse: []
        },
        decompress: true,
        throwHttpErrors: true,
        followRedirect: true,
        stream: false,
        form: false,
        json: false,
        cache: false,
        useElectronNet: false
      },
      mutableDefaults: false
    };
    var got = create(defaults);
    module2.exports = got;
  }
});

// node_modules/ini/ini.js
var require_ini = __commonJS({
  "node_modules/ini/ini.js"(exports2) {
    exports2.parse = exports2.decode = decode;
    exports2.stringify = exports2.encode = encode;
    exports2.safe = safe;
    exports2.unsafe = unsafe;
    var eol = typeof process !== "undefined" && process.platform === "win32" ? "\r\n" : "\n";
    function encode(obj, opt) {
      var children = [];
      var out = "";
      if (typeof opt === "string") {
        opt = {
          section: opt,
          whitespace: false
        };
      } else {
        opt = opt || {};
        opt.whitespace = opt.whitespace === true;
      }
      var separator = opt.whitespace ? " = " : "=";
      Object.keys(obj).forEach(function(k, _, __) {
        var val = obj[k];
        if (val && Array.isArray(val)) {
          val.forEach(function(item) {
            out += safe(k + "[]") + separator + safe(item) + "\n";
          });
        } else if (val && typeof val === "object")
          children.push(k);
        else
          out += safe(k) + separator + safe(val) + eol;
      });
      if (opt.section && out.length)
        out = "[" + safe(opt.section) + "]" + eol + out;
      children.forEach(function(k, _, __) {
        var nk = dotSplit(k).join("\\.");
        var section = (opt.section ? opt.section + "." : "") + nk;
        var child = encode(obj[k], {
          section,
          whitespace: opt.whitespace
        });
        if (out.length && child.length)
          out += eol;
        out += child;
      });
      return out;
    }
    function dotSplit(str2) {
      return str2.replace(/\1/g, "LITERAL\\1LITERAL").replace(/\\\./g, "").split(/\./).map(function(part) {
        return part.replace(/\1/g, "\\.").replace(/\2LITERAL\\1LITERAL\2/g, "");
      });
    }
    function decode(str2) {
      var out = {};
      var p = out;
      var section = null;
      var re = /^\[([^\]]*)\]$|^([^=]+)(=(.*))?$/i;
      var lines = str2.split(/[\r\n]+/g);
      lines.forEach(function(line, _, __) {
        if (!line || line.match(/^\s*[;#]/))
          return;
        var match = line.match(re);
        if (!match)
          return;
        if (match[1] !== void 0) {
          section = unsafe(match[1]);
          if (section === "__proto__") {
            p = {};
            return;
          }
          p = out[section] = out[section] || {};
          return;
        }
        var key = unsafe(match[2]);
        if (key === "__proto__")
          return;
        var value = match[3] ? unsafe(match[4]) : true;
        switch (value) {
          case "true":
          case "false":
          case "null":
            value = JSON.parse(value);
        }
        if (key.length > 2 && key.slice(-2) === "[]") {
          key = key.substring(0, key.length - 2);
          if (key === "__proto__")
            return;
          if (!p[key])
            p[key] = [];
          else if (!Array.isArray(p[key]))
            p[key] = [p[key]];
        }
        if (Array.isArray(p[key]))
          p[key].push(value);
        else
          p[key] = value;
      });
      Object.keys(out).filter(function(k, _, __) {
        if (!out[k] || typeof out[k] !== "object" || Array.isArray(out[k]))
          return false;
        var parts = dotSplit(k);
        var p2 = out;
        var l = parts.pop();
        var nl = l.replace(/\\\./g, ".");
        parts.forEach(function(part, _2, __2) {
          if (part === "__proto__")
            return;
          if (!p2[part] || typeof p2[part] !== "object")
            p2[part] = {};
          p2 = p2[part];
        });
        if (p2 === out && nl === l)
          return false;
        p2[nl] = out[k];
        return true;
      }).forEach(function(del, _, __) {
        delete out[del];
      });
      return out;
    }
    function isQuoted(val) {
      return val.charAt(0) === '"' && val.slice(-1) === '"' || val.charAt(0) === "'" && val.slice(-1) === "'";
    }
    function safe(val) {
      return typeof val !== "string" || val.match(/[=\r\n]/) || val.match(/^\[/) || val.length > 1 && isQuoted(val) || val !== val.trim() ? JSON.stringify(val) : val.replace(/;/g, "\\;").replace(/#/g, "\\#");
    }
    function unsafe(val, doUnesc) {
      val = (val || "").trim();
      if (isQuoted(val)) {
        if (val.charAt(0) === "'")
          val = val.substr(1, val.length - 2);
        try {
          val = JSON.parse(val);
        } catch (_) {
        }
      } else {
        var esc = false;
        var unesc = "";
        for (var i = 0, l = val.length; i < l; i++) {
          var c = val.charAt(i);
          if (esc) {
            if ("\\;#".indexOf(c) !== -1)
              unesc += c;
            else
              unesc += "\\" + c;
            esc = false;
          } else if (";#".indexOf(c) !== -1)
            break;
          else if (c === "\\")
            esc = true;
          else
            unesc += c;
        }
        if (esc)
          unesc += "\\";
        return unesc.trim();
      }
      return val;
    }
  }
});

// node_modules/strip-json-comments/index.js
var require_strip_json_comments = __commonJS({
  "node_modules/strip-json-comments/index.js"(exports2, module2) {
    "use strict";
    var singleComment = 1;
    var multiComment = 2;
    function stripWithoutWhitespace() {
      return "";
    }
    function stripWithWhitespace(str2, start, end) {
      return str2.slice(start, end).replace(/\S/g, " ");
    }
    module2.exports = function(str2, opts) {
      opts = opts || {};
      var currentChar;
      var nextChar;
      var insideString = false;
      var insideComment = false;
      var offset = 0;
      var ret = "";
      var strip = opts.whitespace === false ? stripWithoutWhitespace : stripWithWhitespace;
      for (var i = 0; i < str2.length; i++) {
        currentChar = str2[i];
        nextChar = str2[i + 1];
        if (!insideComment && currentChar === '"') {
          var escaped = str2[i - 1] === "\\" && str2[i - 2] !== "\\";
          if (!escaped) {
            insideString = !insideString;
          }
        }
        if (insideString) {
          continue;
        }
        if (!insideComment && currentChar + nextChar === "//") {
          ret += str2.slice(offset, i);
          offset = i;
          insideComment = singleComment;
          i++;
        } else if (insideComment === singleComment && currentChar + nextChar === "\r\n") {
          i++;
          insideComment = false;
          ret += strip(str2, offset, i);
          offset = i;
          continue;
        } else if (insideComment === singleComment && currentChar === "\n") {
          insideComment = false;
          ret += strip(str2, offset, i);
          offset = i;
        } else if (!insideComment && currentChar + nextChar === "/*") {
          ret += str2.slice(offset, i);
          offset = i;
          insideComment = multiComment;
          i++;
          continue;
        } else if (insideComment === multiComment && currentChar + nextChar === "*/") {
          i++;
          insideComment = false;
          ret += strip(str2, offset, i + 1);
          offset = i + 1;
          continue;
        }
      }
      return ret + (insideComment ? strip(str2.substr(offset)) : str2.substr(offset));
    };
  }
});

// node_modules/rc/lib/utils.js
var require_utils = __commonJS({
  "node_modules/rc/lib/utils.js"(exports2) {
    "use strict";
    var fs = require("fs");
    var ini = require_ini();
    var path = require("path");
    var stripJsonComments = require_strip_json_comments();
    var parse2 = exports2.parse = function(content) {
      if (/^\s*{/.test(content))
        return JSON.parse(stripJsonComments(content));
      return ini.parse(content);
    };
    var file = exports2.file = function() {
      var args = [].slice.call(arguments).filter(function(arg) {
        return arg != null;
      });
      for (var i in args)
        if (typeof args[i] !== "string")
          return;
      var file2 = path.join.apply(null, args);
      var content;
      try {
        return fs.readFileSync(file2, "utf-8");
      } catch (err) {
        return;
      }
    };
    var json = exports2.json = function() {
      var content = file.apply(null, arguments);
      return content ? parse2(content) : null;
    };
    var env = exports2.env = function(prefix, env2) {
      env2 = env2 || process.env;
      var obj = {};
      var l = prefix.length;
      for (var k in env2) {
        if (k.toLowerCase().indexOf(prefix.toLowerCase()) === 0) {
          var keypath = k.substring(l).split("__");
          var _emptyStringIndex;
          while ((_emptyStringIndex = keypath.indexOf("")) > -1) {
            keypath.splice(_emptyStringIndex, 1);
          }
          var cursor = obj;
          keypath.forEach(function _buildSubObj(_subkey, i) {
            if (!_subkey || typeof cursor !== "object")
              return;
            if (i === keypath.length - 1)
              cursor[_subkey] = env2[k];
            if (cursor[_subkey] === void 0)
              cursor[_subkey] = {};
            cursor = cursor[_subkey];
          });
        }
      }
      return obj;
    };
    var find = exports2.find = function() {
      var rel = path.join.apply(null, [].slice.call(arguments));
      function find2(start, rel2) {
        var file2 = path.join(start, rel2);
        try {
          fs.statSync(file2);
          return file2;
        } catch (err) {
          if (path.dirname(start) !== start)
            return find2(path.dirname(start), rel2);
        }
      }
      return find2(process.cwd(), rel);
    };
  }
});

// node_modules/deep-extend/lib/deep-extend.js
var require_deep_extend = __commonJS({
  "node_modules/deep-extend/lib/deep-extend.js"(exports2, module2) {
    "use strict";
    function isSpecificValue(val) {
      return val instanceof Buffer || val instanceof Date || val instanceof RegExp ? true : false;
    }
    function cloneSpecificValue(val) {
      if (val instanceof Buffer) {
        var x = Buffer.alloc ? Buffer.alloc(val.length) : new Buffer(val.length);
        val.copy(x);
        return x;
      } else if (val instanceof Date) {
        return new Date(val.getTime());
      } else if (val instanceof RegExp) {
        return new RegExp(val);
      } else {
        throw new Error("Unexpected situation");
      }
    }
    function deepCloneArray(arr) {
      var clone = [];
      arr.forEach(function(item, index) {
        if (typeof item === "object" && item !== null) {
          if (Array.isArray(item)) {
            clone[index] = deepCloneArray(item);
          } else if (isSpecificValue(item)) {
            clone[index] = cloneSpecificValue(item);
          } else {
            clone[index] = deepExtend({}, item);
          }
        } else {
          clone[index] = item;
        }
      });
      return clone;
    }
    function safeGetProperty(object, property) {
      return property === "__proto__" ? void 0 : object[property];
    }
    var deepExtend = module2.exports = function() {
      if (arguments.length < 1 || typeof arguments[0] !== "object") {
        return false;
      }
      if (arguments.length < 2) {
        return arguments[0];
      }
      var target = arguments[0];
      var args = Array.prototype.slice.call(arguments, 1);
      var val, src, clone;
      args.forEach(function(obj) {
        if (typeof obj !== "object" || obj === null || Array.isArray(obj)) {
          return;
        }
        Object.keys(obj).forEach(function(key) {
          src = safeGetProperty(target, key);
          val = safeGetProperty(obj, key);
          if (val === target) {
            return;
          } else if (typeof val !== "object" || val === null) {
            target[key] = val;
            return;
          } else if (Array.isArray(val)) {
            target[key] = deepCloneArray(val);
            return;
          } else if (isSpecificValue(val)) {
            target[key] = cloneSpecificValue(val);
            return;
          } else if (typeof src !== "object" || src === null || Array.isArray(src)) {
            target[key] = deepExtend({}, val);
            return;
          } else {
            target[key] = deepExtend(src, val);
            return;
          }
        });
      });
      return target;
    };
  }
});

// node_modules/minimist/index.js
var require_minimist = __commonJS({
  "node_modules/minimist/index.js"(exports2, module2) {
    module2.exports = function(args, opts) {
      if (!opts)
        opts = {};
      var flags = {bools: {}, strings: {}, unknownFn: null};
      if (typeof opts["unknown"] === "function") {
        flags.unknownFn = opts["unknown"];
      }
      if (typeof opts["boolean"] === "boolean" && opts["boolean"]) {
        flags.allBools = true;
      } else {
        [].concat(opts["boolean"]).filter(Boolean).forEach(function(key2) {
          flags.bools[key2] = true;
        });
      }
      var aliases = {};
      Object.keys(opts.alias || {}).forEach(function(key2) {
        aliases[key2] = [].concat(opts.alias[key2]);
        aliases[key2].forEach(function(x) {
          aliases[x] = [key2].concat(aliases[key2].filter(function(y) {
            return x !== y;
          }));
        });
      });
      [].concat(opts.string).filter(Boolean).forEach(function(key2) {
        flags.strings[key2] = true;
        if (aliases[key2]) {
          flags.strings[aliases[key2]] = true;
        }
      });
      var defaults = opts["default"] || {};
      var argv = {_: []};
      Object.keys(flags.bools).forEach(function(key2) {
        setArg(key2, defaults[key2] === void 0 ? false : defaults[key2]);
      });
      var notFlags = [];
      if (args.indexOf("--") !== -1) {
        notFlags = args.slice(args.indexOf("--") + 1);
        args = args.slice(0, args.indexOf("--"));
      }
      function argDefined(key2, arg2) {
        return flags.allBools && /^--[^=]+$/.test(arg2) || flags.strings[key2] || flags.bools[key2] || aliases[key2];
      }
      function setArg(key2, val, arg2) {
        if (arg2 && flags.unknownFn && !argDefined(key2, arg2)) {
          if (flags.unknownFn(arg2) === false)
            return;
        }
        var value2 = !flags.strings[key2] && isNumber(val) ? Number(val) : val;
        setKey(argv, key2.split("."), value2);
        (aliases[key2] || []).forEach(function(x) {
          setKey(argv, x.split("."), value2);
        });
      }
      function setKey(obj, keys2, value2) {
        var o = obj;
        for (var i2 = 0; i2 < keys2.length - 1; i2++) {
          var key2 = keys2[i2];
          if (key2 === "__proto__")
            return;
          if (o[key2] === void 0)
            o[key2] = {};
          if (o[key2] === Object.prototype || o[key2] === Number.prototype || o[key2] === String.prototype)
            o[key2] = {};
          if (o[key2] === Array.prototype)
            o[key2] = [];
          o = o[key2];
        }
        var key2 = keys2[keys2.length - 1];
        if (key2 === "__proto__")
          return;
        if (o === Object.prototype || o === Number.prototype || o === String.prototype)
          o = {};
        if (o === Array.prototype)
          o = [];
        if (o[key2] === void 0 || flags.bools[key2] || typeof o[key2] === "boolean") {
          o[key2] = value2;
        } else if (Array.isArray(o[key2])) {
          o[key2].push(value2);
        } else {
          o[key2] = [o[key2], value2];
        }
      }
      function aliasIsBoolean(key2) {
        return aliases[key2].some(function(x) {
          return flags.bools[x];
        });
      }
      for (var i = 0; i < args.length; i++) {
        var arg = args[i];
        if (/^--.+=/.test(arg)) {
          var m = arg.match(/^--([^=]+)=([\s\S]*)$/);
          var key = m[1];
          var value = m[2];
          if (flags.bools[key]) {
            value = value !== "false";
          }
          setArg(key, value, arg);
        } else if (/^--no-.+/.test(arg)) {
          var key = arg.match(/^--no-(.+)/)[1];
          setArg(key, false, arg);
        } else if (/^--.+/.test(arg)) {
          var key = arg.match(/^--(.+)/)[1];
          var next = args[i + 1];
          if (next !== void 0 && !/^-/.test(next) && !flags.bools[key] && !flags.allBools && (aliases[key] ? !aliasIsBoolean(key) : true)) {
            setArg(key, next, arg);
            i++;
          } else if (/^(true|false)$/.test(next)) {
            setArg(key, next === "true", arg);
            i++;
          } else {
            setArg(key, flags.strings[key] ? "" : true, arg);
          }
        } else if (/^-[^-]+/.test(arg)) {
          var letters = arg.slice(1, -1).split("");
          var broken = false;
          for (var j = 0; j < letters.length; j++) {
            var next = arg.slice(j + 2);
            if (next === "-") {
              setArg(letters[j], next, arg);
              continue;
            }
            if (/[A-Za-z]/.test(letters[j]) && /=/.test(next)) {
              setArg(letters[j], next.split("=")[1], arg);
              broken = true;
              break;
            }
            if (/[A-Za-z]/.test(letters[j]) && /-?\d+(\.\d*)?(e-?\d+)?$/.test(next)) {
              setArg(letters[j], next, arg);
              broken = true;
              break;
            }
            if (letters[j + 1] && letters[j + 1].match(/\W/)) {
              setArg(letters[j], arg.slice(j + 2), arg);
              broken = true;
              break;
            } else {
              setArg(letters[j], flags.strings[letters[j]] ? "" : true, arg);
            }
          }
          var key = arg.slice(-1)[0];
          if (!broken && key !== "-") {
            if (args[i + 1] && !/^(-|--)[^-]/.test(args[i + 1]) && !flags.bools[key] && (aliases[key] ? !aliasIsBoolean(key) : true)) {
              setArg(key, args[i + 1], arg);
              i++;
            } else if (args[i + 1] && /^(true|false)$/.test(args[i + 1])) {
              setArg(key, args[i + 1] === "true", arg);
              i++;
            } else {
              setArg(key, flags.strings[key] ? "" : true, arg);
            }
          }
        } else {
          if (!flags.unknownFn || flags.unknownFn(arg) !== false) {
            argv._.push(flags.strings["_"] || !isNumber(arg) ? arg : Number(arg));
          }
          if (opts.stopEarly) {
            argv._.push.apply(argv._, args.slice(i + 1));
            break;
          }
        }
      }
      Object.keys(defaults).forEach(function(key2) {
        if (!hasKey(argv, key2.split("."))) {
          setKey(argv, key2.split("."), defaults[key2]);
          (aliases[key2] || []).forEach(function(x) {
            setKey(argv, x.split("."), defaults[key2]);
          });
        }
      });
      if (opts["--"]) {
        argv["--"] = new Array();
        notFlags.forEach(function(key2) {
          argv["--"].push(key2);
        });
      } else {
        notFlags.forEach(function(key2) {
          argv._.push(key2);
        });
      }
      return argv;
    };
    function hasKey(obj, keys2) {
      var o = obj;
      keys2.slice(0, -1).forEach(function(key2) {
        o = o[key2] || {};
      });
      var key = keys2[keys2.length - 1];
      return key in o;
    }
    function isNumber(x) {
      if (typeof x === "number")
        return true;
      if (/^0x[0-9a-f]+$/i.test(x))
        return true;
      return /^[-+]?(?:\d+(?:\.\d*)?|\.\d+)(e[-+]?\d+)?$/.test(x);
    }
  }
});

// node_modules/rc/index.js
var require_rc = __commonJS({
  "node_modules/rc/index.js"(exports2, module2) {
    var cc = require_utils();
    var join3 = require("path").join;
    var deepExtend = require_deep_extend();
    var etc = "/etc";
    var win = process.platform === "win32";
    var home = win ? process.env.USERPROFILE : process.env.HOME;
    module2.exports = function(name, defaults, argv, parse2) {
      if (typeof name !== "string")
        throw new Error("rc(name): name *must* be string");
      if (!argv)
        argv = require_minimist()(process.argv.slice(2));
      defaults = (typeof defaults === "string" ? cc.json(defaults) : defaults) || {};
      parse2 = parse2 || cc.parse;
      var env = cc.env(name + "_");
      var configs = [defaults];
      var configFiles = [];
      function addConfigFile(file) {
        if (configFiles.indexOf(file) >= 0)
          return;
        var fileConfig = cc.file(file);
        if (fileConfig) {
          configs.push(parse2(fileConfig));
          configFiles.push(file);
        }
      }
      if (!win)
        [
          join3(etc, name, "config"),
          join3(etc, name + "rc")
        ].forEach(addConfigFile);
      if (home)
        [
          join3(home, ".config", name, "config"),
          join3(home, ".config", name),
          join3(home, "." + name, "config"),
          join3(home, "." + name + "rc")
        ].forEach(addConfigFile);
      addConfigFile(cc.find("." + name + "rc"));
      if (env.config)
        addConfigFile(env.config);
      if (argv.config)
        addConfigFile(argv.config);
      return deepExtend.apply(null, configs.concat([
        env,
        argv,
        configFiles.length ? {configs: configFiles, config: configFiles[configFiles.length - 1]} : void 0
      ]));
    };
  }
});

// node_modules/registry-url/index.js
var require_registry_url = __commonJS({
  "node_modules/registry-url/index.js"(exports2, module2) {
    "use strict";
    var rc = require_rc();
    var registryUrl = (scope) => {
      const result = rc("npm", {registry: "https://registry.npmjs.org/"});
      const url = result[`${scope}:registry`] || result.config_registry || result.registry;
      return url.slice(-1) === "/" ? url : `${url}/`;
    };
    module2.exports = registryUrl;
    module2.exports.default = registryUrl;
  }
});

// node_modules/registry-auth-token/base64.js
var require_base64 = __commonJS({
  "node_modules/registry-auth-token/base64.js"(exports2, module2) {
    function decodeBase64(base64) {
      return Buffer.from(base64, "base64").toString("utf8");
    }
    function encodeBase64(string) {
      return Buffer.from(string, "utf8").toString("base64");
    }
    module2.exports = {
      decodeBase64,
      encodeBase64
    };
  }
});

// node_modules/registry-auth-token/index.js
var require_registry_auth_token = __commonJS({
  "node_modules/registry-auth-token/index.js"(exports2, module2) {
    var url = require("url");
    var base64 = require_base64();
    var decodeBase64 = base64.decodeBase64;
    var encodeBase64 = base64.encodeBase64;
    var tokenKey = ":_authToken";
    var legacyTokenKey = ":_auth";
    var userKey = ":username";
    var passwordKey = ":_password";
    module2.exports = function() {
      var checkUrl;
      var options;
      if (arguments.length >= 2) {
        checkUrl = arguments[0];
        options = arguments[1];
      } else if (typeof arguments[0] === "string") {
        checkUrl = arguments[0];
      } else {
        options = arguments[0];
      }
      options = options || {};
      options.npmrc = options.npmrc || require_rc()("npm", {registry: "https://registry.npmjs.org/"}, {
        config: process.env.npm_config_userconfig || process.env.NPM_CONFIG_USERCONFIG
      });
      checkUrl = checkUrl || options.npmrc.registry;
      return getRegistryAuthInfo(checkUrl, options) || getLegacyAuthInfo(options.npmrc);
    };
    function getRegistryAuthInfo(checkUrl, options) {
      var parsed = url.parse(checkUrl, false, true);
      var pathname;
      while (pathname !== "/" && parsed.pathname !== pathname) {
        pathname = parsed.pathname || "/";
        var regUrl = "//" + parsed.host + pathname.replace(/\/$/, "");
        var authInfo = getAuthInfoForUrl(regUrl, options.npmrc);
        if (authInfo) {
          return authInfo;
        }
        if (!options.recursive) {
          return /\/$/.test(checkUrl) ? void 0 : getRegistryAuthInfo(url.resolve(checkUrl, "."), options);
        }
        parsed.pathname = url.resolve(normalizePath(pathname), "..") || "/";
      }
      return void 0;
    }
    function getLegacyAuthInfo(npmrc) {
      if (!npmrc._auth) {
        return void 0;
      }
      var token = replaceEnvironmentVariable(npmrc._auth);
      return {token, type: "Basic"};
    }
    function normalizePath(path) {
      return path[path.length - 1] === "/" ? path : path + "/";
    }
    function getAuthInfoForUrl(regUrl, npmrc) {
      var bearerAuth = getBearerToken(npmrc[regUrl + tokenKey] || npmrc[regUrl + "/" + tokenKey]);
      if (bearerAuth) {
        return bearerAuth;
      }
      var username = npmrc[regUrl + userKey] || npmrc[regUrl + "/" + userKey];
      var password = npmrc[regUrl + passwordKey] || npmrc[regUrl + "/" + passwordKey];
      var basicAuth = getTokenForUsernameAndPassword(username, password);
      if (basicAuth) {
        return basicAuth;
      }
      var basicAuthWithToken = getLegacyAuthToken(npmrc[regUrl + legacyTokenKey] || npmrc[regUrl + "/" + legacyTokenKey]);
      if (basicAuthWithToken) {
        return basicAuthWithToken;
      }
      return void 0;
    }
    function replaceEnvironmentVariable(token) {
      return token.replace(/^\$\{?([^}]*)\}?$/, function(fullMatch, envVar) {
        return process.env[envVar];
      });
    }
    function getBearerToken(tok) {
      if (!tok) {
        return void 0;
      }
      var token = replaceEnvironmentVariable(tok);
      return {token, type: "Bearer"};
    }
    function getTokenForUsernameAndPassword(username, password) {
      if (!username || !password) {
        return void 0;
      }
      var pass = decodeBase64(replaceEnvironmentVariable(password));
      var token = encodeBase64(username + ":" + pass);
      return {
        token,
        type: "Basic",
        password: pass,
        username
      };
    }
    function getLegacyAuthToken(tok) {
      if (!tok) {
        return void 0;
      }
      var token = replaceEnvironmentVariable(tok);
      return {token, type: "Basic"};
    }
  }
});

// node_modules/semver/semver.js
var require_semver = __commonJS({
  "node_modules/semver/semver.js"(exports2, module2) {
    exports2 = module2.exports = SemVer;
    var debug;
    if (typeof process === "object" && process.env && process.env.NODE_DEBUG && /\bsemver\b/i.test(process.env.NODE_DEBUG)) {
      debug = function() {
        var args = Array.prototype.slice.call(arguments, 0);
        args.unshift("SEMVER");
        console.log.apply(console, args);
      };
    } else {
      debug = function() {
      };
    }
    exports2.SEMVER_SPEC_VERSION = "2.0.0";
    var MAX_LENGTH = 256;
    var MAX_SAFE_INTEGER = Number.MAX_SAFE_INTEGER || 9007199254740991;
    var MAX_SAFE_COMPONENT_LENGTH = 16;
    var re = exports2.re = [];
    var src = exports2.src = [];
    var t = exports2.tokens = {};
    var R = 0;
    function tok(n) {
      t[n] = R++;
    }
    tok("NUMERICIDENTIFIER");
    src[t.NUMERICIDENTIFIER] = "0|[1-9]\\d*";
    tok("NUMERICIDENTIFIERLOOSE");
    src[t.NUMERICIDENTIFIERLOOSE] = "[0-9]+";
    tok("NONNUMERICIDENTIFIER");
    src[t.NONNUMERICIDENTIFIER] = "\\d*[a-zA-Z-][a-zA-Z0-9-]*";
    tok("MAINVERSION");
    src[t.MAINVERSION] = "(" + src[t.NUMERICIDENTIFIER] + ")\\.(" + src[t.NUMERICIDENTIFIER] + ")\\.(" + src[t.NUMERICIDENTIFIER] + ")";
    tok("MAINVERSIONLOOSE");
    src[t.MAINVERSIONLOOSE] = "(" + src[t.NUMERICIDENTIFIERLOOSE] + ")\\.(" + src[t.NUMERICIDENTIFIERLOOSE] + ")\\.(" + src[t.NUMERICIDENTIFIERLOOSE] + ")";
    tok("PRERELEASEIDENTIFIER");
    src[t.PRERELEASEIDENTIFIER] = "(?:" + src[t.NUMERICIDENTIFIER] + "|" + src[t.NONNUMERICIDENTIFIER] + ")";
    tok("PRERELEASEIDENTIFIERLOOSE");
    src[t.PRERELEASEIDENTIFIERLOOSE] = "(?:" + src[t.NUMERICIDENTIFIERLOOSE] + "|" + src[t.NONNUMERICIDENTIFIER] + ")";
    tok("PRERELEASE");
    src[t.PRERELEASE] = "(?:-(" + src[t.PRERELEASEIDENTIFIER] + "(?:\\." + src[t.PRERELEASEIDENTIFIER] + ")*))";
    tok("PRERELEASELOOSE");
    src[t.PRERELEASELOOSE] = "(?:-?(" + src[t.PRERELEASEIDENTIFIERLOOSE] + "(?:\\." + src[t.PRERELEASEIDENTIFIERLOOSE] + ")*))";
    tok("BUILDIDENTIFIER");
    src[t.BUILDIDENTIFIER] = "[0-9A-Za-z-]+";
    tok("BUILD");
    src[t.BUILD] = "(?:\\+(" + src[t.BUILDIDENTIFIER] + "(?:\\." + src[t.BUILDIDENTIFIER] + ")*))";
    tok("FULL");
    tok("FULLPLAIN");
    src[t.FULLPLAIN] = "v?" + src[t.MAINVERSION] + src[t.PRERELEASE] + "?" + src[t.BUILD] + "?";
    src[t.FULL] = "^" + src[t.FULLPLAIN] + "$";
    tok("LOOSEPLAIN");
    src[t.LOOSEPLAIN] = "[v=\\s]*" + src[t.MAINVERSIONLOOSE] + src[t.PRERELEASELOOSE] + "?" + src[t.BUILD] + "?";
    tok("LOOSE");
    src[t.LOOSE] = "^" + src[t.LOOSEPLAIN] + "$";
    tok("GTLT");
    src[t.GTLT] = "((?:<|>)?=?)";
    tok("XRANGEIDENTIFIERLOOSE");
    src[t.XRANGEIDENTIFIERLOOSE] = src[t.NUMERICIDENTIFIERLOOSE] + "|x|X|\\*";
    tok("XRANGEIDENTIFIER");
    src[t.XRANGEIDENTIFIER] = src[t.NUMERICIDENTIFIER] + "|x|X|\\*";
    tok("XRANGEPLAIN");
    src[t.XRANGEPLAIN] = "[v=\\s]*(" + src[t.XRANGEIDENTIFIER] + ")(?:\\.(" + src[t.XRANGEIDENTIFIER] + ")(?:\\.(" + src[t.XRANGEIDENTIFIER] + ")(?:" + src[t.PRERELEASE] + ")?" + src[t.BUILD] + "?)?)?";
    tok("XRANGEPLAINLOOSE");
    src[t.XRANGEPLAINLOOSE] = "[v=\\s]*(" + src[t.XRANGEIDENTIFIERLOOSE] + ")(?:\\.(" + src[t.XRANGEIDENTIFIERLOOSE] + ")(?:\\.(" + src[t.XRANGEIDENTIFIERLOOSE] + ")(?:" + src[t.PRERELEASELOOSE] + ")?" + src[t.BUILD] + "?)?)?";
    tok("XRANGE");
    src[t.XRANGE] = "^" + src[t.GTLT] + "\\s*" + src[t.XRANGEPLAIN] + "$";
    tok("XRANGELOOSE");
    src[t.XRANGELOOSE] = "^" + src[t.GTLT] + "\\s*" + src[t.XRANGEPLAINLOOSE] + "$";
    tok("COERCE");
    src[t.COERCE] = "(^|[^\\d])(\\d{1," + MAX_SAFE_COMPONENT_LENGTH + "})(?:\\.(\\d{1," + MAX_SAFE_COMPONENT_LENGTH + "}))?(?:\\.(\\d{1," + MAX_SAFE_COMPONENT_LENGTH + "}))?(?:$|[^\\d])";
    tok("COERCERTL");
    re[t.COERCERTL] = new RegExp(src[t.COERCE], "g");
    tok("LONETILDE");
    src[t.LONETILDE] = "(?:~>?)";
    tok("TILDETRIM");
    src[t.TILDETRIM] = "(\\s*)" + src[t.LONETILDE] + "\\s+";
    re[t.TILDETRIM] = new RegExp(src[t.TILDETRIM], "g");
    var tildeTrimReplace = "$1~";
    tok("TILDE");
    src[t.TILDE] = "^" + src[t.LONETILDE] + src[t.XRANGEPLAIN] + "$";
    tok("TILDELOOSE");
    src[t.TILDELOOSE] = "^" + src[t.LONETILDE] + src[t.XRANGEPLAINLOOSE] + "$";
    tok("LONECARET");
    src[t.LONECARET] = "(?:\\^)";
    tok("CARETTRIM");
    src[t.CARETTRIM] = "(\\s*)" + src[t.LONECARET] + "\\s+";
    re[t.CARETTRIM] = new RegExp(src[t.CARETTRIM], "g");
    var caretTrimReplace = "$1^";
    tok("CARET");
    src[t.CARET] = "^" + src[t.LONECARET] + src[t.XRANGEPLAIN] + "$";
    tok("CARETLOOSE");
    src[t.CARETLOOSE] = "^" + src[t.LONECARET] + src[t.XRANGEPLAINLOOSE] + "$";
    tok("COMPARATORLOOSE");
    src[t.COMPARATORLOOSE] = "^" + src[t.GTLT] + "\\s*(" + src[t.LOOSEPLAIN] + ")$|^$";
    tok("COMPARATOR");
    src[t.COMPARATOR] = "^" + src[t.GTLT] + "\\s*(" + src[t.FULLPLAIN] + ")$|^$";
    tok("COMPARATORTRIM");
    src[t.COMPARATORTRIM] = "(\\s*)" + src[t.GTLT] + "\\s*(" + src[t.LOOSEPLAIN] + "|" + src[t.XRANGEPLAIN] + ")";
    re[t.COMPARATORTRIM] = new RegExp(src[t.COMPARATORTRIM], "g");
    var comparatorTrimReplace = "$1$2$3";
    tok("HYPHENRANGE");
    src[t.HYPHENRANGE] = "^\\s*(" + src[t.XRANGEPLAIN] + ")\\s+-\\s+(" + src[t.XRANGEPLAIN] + ")\\s*$";
    tok("HYPHENRANGELOOSE");
    src[t.HYPHENRANGELOOSE] = "^\\s*(" + src[t.XRANGEPLAINLOOSE] + ")\\s+-\\s+(" + src[t.XRANGEPLAINLOOSE] + ")\\s*$";
    tok("STAR");
    src[t.STAR] = "(<|>)?=?\\s*\\*";
    for (var i = 0; i < R; i++) {
      debug(i, src[i]);
      if (!re[i]) {
        re[i] = new RegExp(src[i]);
      }
    }
    exports2.parse = parse2;
    function parse2(version, options) {
      if (!options || typeof options !== "object") {
        options = {
          loose: !!options,
          includePrerelease: false
        };
      }
      if (version instanceof SemVer) {
        return version;
      }
      if (typeof version !== "string") {
        return null;
      }
      if (version.length > MAX_LENGTH) {
        return null;
      }
      var r = options.loose ? re[t.LOOSE] : re[t.FULL];
      if (!r.test(version)) {
        return null;
      }
      try {
        return new SemVer(version, options);
      } catch (er) {
        return null;
      }
    }
    exports2.valid = valid;
    function valid(version, options) {
      var v = parse2(version, options);
      return v ? v.version : null;
    }
    exports2.clean = clean;
    function clean(version, options) {
      var s = parse2(version.trim().replace(/^[=v]+/, ""), options);
      return s ? s.version : null;
    }
    exports2.SemVer = SemVer;
    function SemVer(version, options) {
      if (!options || typeof options !== "object") {
        options = {
          loose: !!options,
          includePrerelease: false
        };
      }
      if (version instanceof SemVer) {
        if (version.loose === options.loose) {
          return version;
        } else {
          version = version.version;
        }
      } else if (typeof version !== "string") {
        throw new TypeError("Invalid Version: " + version);
      }
      if (version.length > MAX_LENGTH) {
        throw new TypeError("version is longer than " + MAX_LENGTH + " characters");
      }
      if (!(this instanceof SemVer)) {
        return new SemVer(version, options);
      }
      debug("SemVer", version, options);
      this.options = options;
      this.loose = !!options.loose;
      var m = version.trim().match(options.loose ? re[t.LOOSE] : re[t.FULL]);
      if (!m) {
        throw new TypeError("Invalid Version: " + version);
      }
      this.raw = version;
      this.major = +m[1];
      this.minor = +m[2];
      this.patch = +m[3];
      if (this.major > MAX_SAFE_INTEGER || this.major < 0) {
        throw new TypeError("Invalid major version");
      }
      if (this.minor > MAX_SAFE_INTEGER || this.minor < 0) {
        throw new TypeError("Invalid minor version");
      }
      if (this.patch > MAX_SAFE_INTEGER || this.patch < 0) {
        throw new TypeError("Invalid patch version");
      }
      if (!m[4]) {
        this.prerelease = [];
      } else {
        this.prerelease = m[4].split(".").map(function(id) {
          if (/^[0-9]+$/.test(id)) {
            var num = +id;
            if (num >= 0 && num < MAX_SAFE_INTEGER) {
              return num;
            }
          }
          return id;
        });
      }
      this.build = m[5] ? m[5].split(".") : [];
      this.format();
    }
    SemVer.prototype.format = function() {
      this.version = this.major + "." + this.minor + "." + this.patch;
      if (this.prerelease.length) {
        this.version += "-" + this.prerelease.join(".");
      }
      return this.version;
    };
    SemVer.prototype.toString = function() {
      return this.version;
    };
    SemVer.prototype.compare = function(other) {
      debug("SemVer.compare", this.version, this.options, other);
      if (!(other instanceof SemVer)) {
        other = new SemVer(other, this.options);
      }
      return this.compareMain(other) || this.comparePre(other);
    };
    SemVer.prototype.compareMain = function(other) {
      if (!(other instanceof SemVer)) {
        other = new SemVer(other, this.options);
      }
      return compareIdentifiers(this.major, other.major) || compareIdentifiers(this.minor, other.minor) || compareIdentifiers(this.patch, other.patch);
    };
    SemVer.prototype.comparePre = function(other) {
      if (!(other instanceof SemVer)) {
        other = new SemVer(other, this.options);
      }
      if (this.prerelease.length && !other.prerelease.length) {
        return -1;
      } else if (!this.prerelease.length && other.prerelease.length) {
        return 1;
      } else if (!this.prerelease.length && !other.prerelease.length) {
        return 0;
      }
      var i2 = 0;
      do {
        var a2 = this.prerelease[i2];
        var b = other.prerelease[i2];
        debug("prerelease compare", i2, a2, b);
        if (a2 === void 0 && b === void 0) {
          return 0;
        } else if (b === void 0) {
          return 1;
        } else if (a2 === void 0) {
          return -1;
        } else if (a2 === b) {
          continue;
        } else {
          return compareIdentifiers(a2, b);
        }
      } while (++i2);
    };
    SemVer.prototype.compareBuild = function(other) {
      if (!(other instanceof SemVer)) {
        other = new SemVer(other, this.options);
      }
      var i2 = 0;
      do {
        var a2 = this.build[i2];
        var b = other.build[i2];
        debug("prerelease compare", i2, a2, b);
        if (a2 === void 0 && b === void 0) {
          return 0;
        } else if (b === void 0) {
          return 1;
        } else if (a2 === void 0) {
          return -1;
        } else if (a2 === b) {
          continue;
        } else {
          return compareIdentifiers(a2, b);
        }
      } while (++i2);
    };
    SemVer.prototype.inc = function(release, identifier) {
      switch (release) {
        case "premajor":
          this.prerelease.length = 0;
          this.patch = 0;
          this.minor = 0;
          this.major++;
          this.inc("pre", identifier);
          break;
        case "preminor":
          this.prerelease.length = 0;
          this.patch = 0;
          this.minor++;
          this.inc("pre", identifier);
          break;
        case "prepatch":
          this.prerelease.length = 0;
          this.inc("patch", identifier);
          this.inc("pre", identifier);
          break;
        case "prerelease":
          if (this.prerelease.length === 0) {
            this.inc("patch", identifier);
          }
          this.inc("pre", identifier);
          break;
        case "major":
          if (this.minor !== 0 || this.patch !== 0 || this.prerelease.length === 0) {
            this.major++;
          }
          this.minor = 0;
          this.patch = 0;
          this.prerelease = [];
          break;
        case "minor":
          if (this.patch !== 0 || this.prerelease.length === 0) {
            this.minor++;
          }
          this.patch = 0;
          this.prerelease = [];
          break;
        case "patch":
          if (this.prerelease.length === 0) {
            this.patch++;
          }
          this.prerelease = [];
          break;
        case "pre":
          if (this.prerelease.length === 0) {
            this.prerelease = [0];
          } else {
            var i2 = this.prerelease.length;
            while (--i2 >= 0) {
              if (typeof this.prerelease[i2] === "number") {
                this.prerelease[i2]++;
                i2 = -2;
              }
            }
            if (i2 === -1) {
              this.prerelease.push(0);
            }
          }
          if (identifier) {
            if (this.prerelease[0] === identifier) {
              if (isNaN(this.prerelease[1])) {
                this.prerelease = [identifier, 0];
              }
            } else {
              this.prerelease = [identifier, 0];
            }
          }
          break;
        default:
          throw new Error("invalid increment argument: " + release);
      }
      this.format();
      this.raw = this.version;
      return this;
    };
    exports2.inc = inc2;
    function inc2(version, release, loose, identifier) {
      if (typeof loose === "string") {
        identifier = loose;
        loose = void 0;
      }
      try {
        return new SemVer(version, loose).inc(release, identifier).version;
      } catch (er) {
        return null;
      }
    }
    exports2.diff = diff;
    function diff(version1, version2) {
      if (eq(version1, version2)) {
        return null;
      } else {
        var v1 = parse2(version1);
        var v2 = parse2(version2);
        var prefix = "";
        if (v1.prerelease.length || v2.prerelease.length) {
          prefix = "pre";
          var defaultResult = "prerelease";
        }
        for (var key in v1) {
          if (key === "major" || key === "minor" || key === "patch") {
            if (v1[key] !== v2[key]) {
              return prefix + key;
            }
          }
        }
        return defaultResult;
      }
    }
    exports2.compareIdentifiers = compareIdentifiers;
    var numeric = /^[0-9]+$/;
    function compareIdentifiers(a2, b) {
      var anum = numeric.test(a2);
      var bnum = numeric.test(b);
      if (anum && bnum) {
        a2 = +a2;
        b = +b;
      }
      return a2 === b ? 0 : anum && !bnum ? -1 : bnum && !anum ? 1 : a2 < b ? -1 : 1;
    }
    exports2.rcompareIdentifiers = rcompareIdentifiers;
    function rcompareIdentifiers(a2, b) {
      return compareIdentifiers(b, a2);
    }
    exports2.major = major;
    function major(a2, loose) {
      return new SemVer(a2, loose).major;
    }
    exports2.minor = minor;
    function minor(a2, loose) {
      return new SemVer(a2, loose).minor;
    }
    exports2.patch = patch;
    function patch(a2, loose) {
      return new SemVer(a2, loose).patch;
    }
    exports2.compare = compare2;
    function compare2(a2, b, loose) {
      return new SemVer(a2, loose).compare(new SemVer(b, loose));
    }
    exports2.compareLoose = compareLoose;
    function compareLoose(a2, b) {
      return compare2(a2, b, true);
    }
    exports2.compareBuild = compareBuild;
    function compareBuild(a2, b, loose) {
      var versionA = new SemVer(a2, loose);
      var versionB = new SemVer(b, loose);
      return versionA.compare(versionB) || versionA.compareBuild(versionB);
    }
    exports2.rcompare = rcompare;
    function rcompare(a2, b, loose) {
      return compare2(b, a2, loose);
    }
    exports2.sort = sort3;
    function sort3(list, loose) {
      return list.sort(function(a2, b) {
        return exports2.compareBuild(a2, b, loose);
      });
    }
    exports2.rsort = rsort;
    function rsort(list, loose) {
      return list.sort(function(a2, b) {
        return exports2.compareBuild(b, a2, loose);
      });
    }
    exports2.gt = gt;
    function gt(a2, b, loose) {
      return compare2(a2, b, loose) > 0;
    }
    exports2.lt = lt;
    function lt(a2, b, loose) {
      return compare2(a2, b, loose) < 0;
    }
    exports2.eq = eq;
    function eq(a2, b, loose) {
      return compare2(a2, b, loose) === 0;
    }
    exports2.neq = neq;
    function neq(a2, b, loose) {
      return compare2(a2, b, loose) !== 0;
    }
    exports2.gte = gte;
    function gte(a2, b, loose) {
      return compare2(a2, b, loose) >= 0;
    }
    exports2.lte = lte;
    function lte(a2, b, loose) {
      return compare2(a2, b, loose) <= 0;
    }
    exports2.cmp = cmp2;
    function cmp2(a2, op, b, loose) {
      switch (op) {
        case "===":
          if (typeof a2 === "object")
            a2 = a2.version;
          if (typeof b === "object")
            b = b.version;
          return a2 === b;
        case "!==":
          if (typeof a2 === "object")
            a2 = a2.version;
          if (typeof b === "object")
            b = b.version;
          return a2 !== b;
        case "":
        case "=":
        case "==":
          return eq(a2, b, loose);
        case "!=":
          return neq(a2, b, loose);
        case ">":
          return gt(a2, b, loose);
        case ">=":
          return gte(a2, b, loose);
        case "<":
          return lt(a2, b, loose);
        case "<=":
          return lte(a2, b, loose);
        default:
          throw new TypeError("Invalid operator: " + op);
      }
    }
    exports2.Comparator = Comparator;
    function Comparator(comp, options) {
      if (!options || typeof options !== "object") {
        options = {
          loose: !!options,
          includePrerelease: false
        };
      }
      if (comp instanceof Comparator) {
        if (comp.loose === !!options.loose) {
          return comp;
        } else {
          comp = comp.value;
        }
      }
      if (!(this instanceof Comparator)) {
        return new Comparator(comp, options);
      }
      debug("comparator", comp, options);
      this.options = options;
      this.loose = !!options.loose;
      this.parse(comp);
      if (this.semver === ANY) {
        this.value = "";
      } else {
        this.value = this.operator + this.semver.version;
      }
      debug("comp", this);
    }
    var ANY = {};
    Comparator.prototype.parse = function(comp) {
      var r = this.options.loose ? re[t.COMPARATORLOOSE] : re[t.COMPARATOR];
      var m = comp.match(r);
      if (!m) {
        throw new TypeError("Invalid comparator: " + comp);
      }
      this.operator = m[1] !== void 0 ? m[1] : "";
      if (this.operator === "=") {
        this.operator = "";
      }
      if (!m[2]) {
        this.semver = ANY;
      } else {
        this.semver = new SemVer(m[2], this.options.loose);
      }
    };
    Comparator.prototype.toString = function() {
      return this.value;
    };
    Comparator.prototype.test = function(version) {
      debug("Comparator.test", version, this.options.loose);
      if (this.semver === ANY || version === ANY) {
        return true;
      }
      if (typeof version === "string") {
        try {
          version = new SemVer(version, this.options);
        } catch (er) {
          return false;
        }
      }
      return cmp2(version, this.operator, this.semver, this.options);
    };
    Comparator.prototype.intersects = function(comp, options) {
      if (!(comp instanceof Comparator)) {
        throw new TypeError("a Comparator is required");
      }
      if (!options || typeof options !== "object") {
        options = {
          loose: !!options,
          includePrerelease: false
        };
      }
      var rangeTmp;
      if (this.operator === "") {
        if (this.value === "") {
          return true;
        }
        rangeTmp = new Range(comp.value, options);
        return satisfies(this.value, rangeTmp, options);
      } else if (comp.operator === "") {
        if (comp.value === "") {
          return true;
        }
        rangeTmp = new Range(this.value, options);
        return satisfies(comp.semver, rangeTmp, options);
      }
      var sameDirectionIncreasing = (this.operator === ">=" || this.operator === ">") && (comp.operator === ">=" || comp.operator === ">");
      var sameDirectionDecreasing = (this.operator === "<=" || this.operator === "<") && (comp.operator === "<=" || comp.operator === "<");
      var sameSemVer = this.semver.version === comp.semver.version;
      var differentDirectionsInclusive = (this.operator === ">=" || this.operator === "<=") && (comp.operator === ">=" || comp.operator === "<=");
      var oppositeDirectionsLessThan = cmp2(this.semver, "<", comp.semver, options) && ((this.operator === ">=" || this.operator === ">") && (comp.operator === "<=" || comp.operator === "<"));
      var oppositeDirectionsGreaterThan = cmp2(this.semver, ">", comp.semver, options) && ((this.operator === "<=" || this.operator === "<") && (comp.operator === ">=" || comp.operator === ">"));
      return sameDirectionIncreasing || sameDirectionDecreasing || sameSemVer && differentDirectionsInclusive || oppositeDirectionsLessThan || oppositeDirectionsGreaterThan;
    };
    exports2.Range = Range;
    function Range(range, options) {
      if (!options || typeof options !== "object") {
        options = {
          loose: !!options,
          includePrerelease: false
        };
      }
      if (range instanceof Range) {
        if (range.loose === !!options.loose && range.includePrerelease === !!options.includePrerelease) {
          return range;
        } else {
          return new Range(range.raw, options);
        }
      }
      if (range instanceof Comparator) {
        return new Range(range.value, options);
      }
      if (!(this instanceof Range)) {
        return new Range(range, options);
      }
      this.options = options;
      this.loose = !!options.loose;
      this.includePrerelease = !!options.includePrerelease;
      this.raw = range;
      this.set = range.split(/\s*\|\|\s*/).map(function(range2) {
        return this.parseRange(range2.trim());
      }, this).filter(function(c) {
        return c.length;
      });
      if (!this.set.length) {
        throw new TypeError("Invalid SemVer Range: " + range);
      }
      this.format();
    }
    Range.prototype.format = function() {
      this.range = this.set.map(function(comps) {
        return comps.join(" ").trim();
      }).join("||").trim();
      return this.range;
    };
    Range.prototype.toString = function() {
      return this.range;
    };
    Range.prototype.parseRange = function(range) {
      var loose = this.options.loose;
      range = range.trim();
      var hr = loose ? re[t.HYPHENRANGELOOSE] : re[t.HYPHENRANGE];
      range = range.replace(hr, hyphenReplace);
      debug("hyphen replace", range);
      range = range.replace(re[t.COMPARATORTRIM], comparatorTrimReplace);
      debug("comparator trim", range, re[t.COMPARATORTRIM]);
      range = range.replace(re[t.TILDETRIM], tildeTrimReplace);
      range = range.replace(re[t.CARETTRIM], caretTrimReplace);
      range = range.split(/\s+/).join(" ");
      var compRe = loose ? re[t.COMPARATORLOOSE] : re[t.COMPARATOR];
      var set = range.split(" ").map(function(comp) {
        return parseComparator(comp, this.options);
      }, this).join(" ").split(/\s+/);
      if (this.options.loose) {
        set = set.filter(function(comp) {
          return !!comp.match(compRe);
        });
      }
      set = set.map(function(comp) {
        return new Comparator(comp, this.options);
      }, this);
      return set;
    };
    Range.prototype.intersects = function(range, options) {
      if (!(range instanceof Range)) {
        throw new TypeError("a Range is required");
      }
      return this.set.some(function(thisComparators) {
        return isSatisfiable(thisComparators, options) && range.set.some(function(rangeComparators) {
          return isSatisfiable(rangeComparators, options) && thisComparators.every(function(thisComparator) {
            return rangeComparators.every(function(rangeComparator) {
              return thisComparator.intersects(rangeComparator, options);
            });
          });
        });
      });
    };
    function isSatisfiable(comparators, options) {
      var result = true;
      var remainingComparators = comparators.slice();
      var testComparator = remainingComparators.pop();
      while (result && remainingComparators.length) {
        result = remainingComparators.every(function(otherComparator) {
          return testComparator.intersects(otherComparator, options);
        });
        testComparator = remainingComparators.pop();
      }
      return result;
    }
    exports2.toComparators = toComparators;
    function toComparators(range, options) {
      return new Range(range, options).set.map(function(comp) {
        return comp.map(function(c) {
          return c.value;
        }).join(" ").trim().split(" ");
      });
    }
    function parseComparator(comp, options) {
      debug("comp", comp, options);
      comp = replaceCarets(comp, options);
      debug("caret", comp);
      comp = replaceTildes(comp, options);
      debug("tildes", comp);
      comp = replaceXRanges(comp, options);
      debug("xrange", comp);
      comp = replaceStars(comp, options);
      debug("stars", comp);
      return comp;
    }
    function isX(id) {
      return !id || id.toLowerCase() === "x" || id === "*";
    }
    function replaceTildes(comp, options) {
      return comp.trim().split(/\s+/).map(function(comp2) {
        return replaceTilde(comp2, options);
      }).join(" ");
    }
    function replaceTilde(comp, options) {
      var r = options.loose ? re[t.TILDELOOSE] : re[t.TILDE];
      return comp.replace(r, function(_, M, m, p, pr) {
        debug("tilde", comp, _, M, m, p, pr);
        var ret;
        if (isX(M)) {
          ret = "";
        } else if (isX(m)) {
          ret = ">=" + M + ".0.0 <" + (+M + 1) + ".0.0";
        } else if (isX(p)) {
          ret = ">=" + M + "." + m + ".0 <" + M + "." + (+m + 1) + ".0";
        } else if (pr) {
          debug("replaceTilde pr", pr);
          ret = ">=" + M + "." + m + "." + p + "-" + pr + " <" + M + "." + (+m + 1) + ".0";
        } else {
          ret = ">=" + M + "." + m + "." + p + " <" + M + "." + (+m + 1) + ".0";
        }
        debug("tilde return", ret);
        return ret;
      });
    }
    function replaceCarets(comp, options) {
      return comp.trim().split(/\s+/).map(function(comp2) {
        return replaceCaret(comp2, options);
      }).join(" ");
    }
    function replaceCaret(comp, options) {
      debug("caret", comp, options);
      var r = options.loose ? re[t.CARETLOOSE] : re[t.CARET];
      return comp.replace(r, function(_, M, m, p, pr) {
        debug("caret", comp, _, M, m, p, pr);
        var ret;
        if (isX(M)) {
          ret = "";
        } else if (isX(m)) {
          ret = ">=" + M + ".0.0 <" + (+M + 1) + ".0.0";
        } else if (isX(p)) {
          if (M === "0") {
            ret = ">=" + M + "." + m + ".0 <" + M + "." + (+m + 1) + ".0";
          } else {
            ret = ">=" + M + "." + m + ".0 <" + (+M + 1) + ".0.0";
          }
        } else if (pr) {
          debug("replaceCaret pr", pr);
          if (M === "0") {
            if (m === "0") {
              ret = ">=" + M + "." + m + "." + p + "-" + pr + " <" + M + "." + m + "." + (+p + 1);
            } else {
              ret = ">=" + M + "." + m + "." + p + "-" + pr + " <" + M + "." + (+m + 1) + ".0";
            }
          } else {
            ret = ">=" + M + "." + m + "." + p + "-" + pr + " <" + (+M + 1) + ".0.0";
          }
        } else {
          debug("no pr");
          if (M === "0") {
            if (m === "0") {
              ret = ">=" + M + "." + m + "." + p + " <" + M + "." + m + "." + (+p + 1);
            } else {
              ret = ">=" + M + "." + m + "." + p + " <" + M + "." + (+m + 1) + ".0";
            }
          } else {
            ret = ">=" + M + "." + m + "." + p + " <" + (+M + 1) + ".0.0";
          }
        }
        debug("caret return", ret);
        return ret;
      });
    }
    function replaceXRanges(comp, options) {
      debug("replaceXRanges", comp, options);
      return comp.split(/\s+/).map(function(comp2) {
        return replaceXRange(comp2, options);
      }).join(" ");
    }
    function replaceXRange(comp, options) {
      comp = comp.trim();
      var r = options.loose ? re[t.XRANGELOOSE] : re[t.XRANGE];
      return comp.replace(r, function(ret, gtlt, M, m, p, pr) {
        debug("xRange", comp, ret, gtlt, M, m, p, pr);
        var xM = isX(M);
        var xm = xM || isX(m);
        var xp = xm || isX(p);
        var anyX = xp;
        if (gtlt === "=" && anyX) {
          gtlt = "";
        }
        pr = options.includePrerelease ? "-0" : "";
        if (xM) {
          if (gtlt === ">" || gtlt === "<") {
            ret = "<0.0.0-0";
          } else {
            ret = "*";
          }
        } else if (gtlt && anyX) {
          if (xm) {
            m = 0;
          }
          p = 0;
          if (gtlt === ">") {
            gtlt = ">=";
            if (xm) {
              M = +M + 1;
              m = 0;
              p = 0;
            } else {
              m = +m + 1;
              p = 0;
            }
          } else if (gtlt === "<=") {
            gtlt = "<";
            if (xm) {
              M = +M + 1;
            } else {
              m = +m + 1;
            }
          }
          ret = gtlt + M + "." + m + "." + p + pr;
        } else if (xm) {
          ret = ">=" + M + ".0.0" + pr + " <" + (+M + 1) + ".0.0" + pr;
        } else if (xp) {
          ret = ">=" + M + "." + m + ".0" + pr + " <" + M + "." + (+m + 1) + ".0" + pr;
        }
        debug("xRange return", ret);
        return ret;
      });
    }
    function replaceStars(comp, options) {
      debug("replaceStars", comp, options);
      return comp.trim().replace(re[t.STAR], "");
    }
    function hyphenReplace($0, from, fM, fm, fp, fpr, fb, to, tM, tm, tp, tpr, tb) {
      if (isX(fM)) {
        from = "";
      } else if (isX(fm)) {
        from = ">=" + fM + ".0.0";
      } else if (isX(fp)) {
        from = ">=" + fM + "." + fm + ".0";
      } else {
        from = ">=" + from;
      }
      if (isX(tM)) {
        to = "";
      } else if (isX(tm)) {
        to = "<" + (+tM + 1) + ".0.0";
      } else if (isX(tp)) {
        to = "<" + tM + "." + (+tm + 1) + ".0";
      } else if (tpr) {
        to = "<=" + tM + "." + tm + "." + tp + "-" + tpr;
      } else {
        to = "<=" + to;
      }
      return (from + " " + to).trim();
    }
    Range.prototype.test = function(version) {
      if (!version) {
        return false;
      }
      if (typeof version === "string") {
        try {
          version = new SemVer(version, this.options);
        } catch (er) {
          return false;
        }
      }
      for (var i2 = 0; i2 < this.set.length; i2++) {
        if (testSet(this.set[i2], version, this.options)) {
          return true;
        }
      }
      return false;
    };
    function testSet(set, version, options) {
      for (var i2 = 0; i2 < set.length; i2++) {
        if (!set[i2].test(version)) {
          return false;
        }
      }
      if (version.prerelease.length && !options.includePrerelease) {
        for (i2 = 0; i2 < set.length; i2++) {
          debug(set[i2].semver);
          if (set[i2].semver === ANY) {
            continue;
          }
          if (set[i2].semver.prerelease.length > 0) {
            var allowed = set[i2].semver;
            if (allowed.major === version.major && allowed.minor === version.minor && allowed.patch === version.patch) {
              return true;
            }
          }
        }
        return false;
      }
      return true;
    }
    exports2.satisfies = satisfies;
    function satisfies(version, range, options) {
      try {
        range = new Range(range, options);
      } catch (er) {
        return false;
      }
      return range.test(version);
    }
    exports2.maxSatisfying = maxSatisfying;
    function maxSatisfying(versions, range, options) {
      var max2 = null;
      var maxSV = null;
      try {
        var rangeObj = new Range(range, options);
      } catch (er) {
        return null;
      }
      versions.forEach(function(v) {
        if (rangeObj.test(v)) {
          if (!max2 || maxSV.compare(v) === -1) {
            max2 = v;
            maxSV = new SemVer(max2, options);
          }
        }
      });
      return max2;
    }
    exports2.minSatisfying = minSatisfying;
    function minSatisfying(versions, range, options) {
      var min2 = null;
      var minSV = null;
      try {
        var rangeObj = new Range(range, options);
      } catch (er) {
        return null;
      }
      versions.forEach(function(v) {
        if (rangeObj.test(v)) {
          if (!min2 || minSV.compare(v) === 1) {
            min2 = v;
            minSV = new SemVer(min2, options);
          }
        }
      });
      return min2;
    }
    exports2.minVersion = minVersion;
    function minVersion(range, loose) {
      range = new Range(range, loose);
      var minver = new SemVer("0.0.0");
      if (range.test(minver)) {
        return minver;
      }
      minver = new SemVer("0.0.0-0");
      if (range.test(minver)) {
        return minver;
      }
      minver = null;
      for (var i2 = 0; i2 < range.set.length; ++i2) {
        var comparators = range.set[i2];
        comparators.forEach(function(comparator) {
          var compver = new SemVer(comparator.semver.version);
          switch (comparator.operator) {
            case ">":
              if (compver.prerelease.length === 0) {
                compver.patch++;
              } else {
                compver.prerelease.push(0);
              }
              compver.raw = compver.format();
            case "":
            case ">=":
              if (!minver || gt(minver, compver)) {
                minver = compver;
              }
              break;
            case "<":
            case "<=":
              break;
            default:
              throw new Error("Unexpected operation: " + comparator.operator);
          }
        });
      }
      if (minver && range.test(minver)) {
        return minver;
      }
      return null;
    }
    exports2.validRange = validRange;
    function validRange(range, options) {
      try {
        return new Range(range, options).range || "*";
      } catch (er) {
        return null;
      }
    }
    exports2.ltr = ltr;
    function ltr(version, range, options) {
      return outside(version, range, "<", options);
    }
    exports2.gtr = gtr;
    function gtr(version, range, options) {
      return outside(version, range, ">", options);
    }
    exports2.outside = outside;
    function outside(version, range, hilo, options) {
      version = new SemVer(version, options);
      range = new Range(range, options);
      var gtfn, ltefn, ltfn, comp, ecomp;
      switch (hilo) {
        case ">":
          gtfn = gt;
          ltefn = lte;
          ltfn = lt;
          comp = ">";
          ecomp = ">=";
          break;
        case "<":
          gtfn = lt;
          ltefn = gte;
          ltfn = gt;
          comp = "<";
          ecomp = "<=";
          break;
        default:
          throw new TypeError('Must provide a hilo val of "<" or ">"');
      }
      if (satisfies(version, range, options)) {
        return false;
      }
      for (var i2 = 0; i2 < range.set.length; ++i2) {
        var comparators = range.set[i2];
        var high = null;
        var low = null;
        comparators.forEach(function(comparator) {
          if (comparator.semver === ANY) {
            comparator = new Comparator(">=0.0.0");
          }
          high = high || comparator;
          low = low || comparator;
          if (gtfn(comparator.semver, high.semver, options)) {
            high = comparator;
          } else if (ltfn(comparator.semver, low.semver, options)) {
            low = comparator;
          }
        });
        if (high.operator === comp || high.operator === ecomp) {
          return false;
        }
        if ((!low.operator || low.operator === comp) && ltefn(version, low.semver)) {
          return false;
        } else if (low.operator === ecomp && ltfn(version, low.semver)) {
          return false;
        }
      }
      return true;
    }
    exports2.prerelease = prerelease;
    function prerelease(version, options) {
      var parsed = parse2(version, options);
      return parsed && parsed.prerelease.length ? parsed.prerelease : null;
    }
    exports2.intersects = intersects;
    function intersects(r1, r2, options) {
      r1 = new Range(r1, options);
      r2 = new Range(r2, options);
      return r1.intersects(r2);
    }
    exports2.coerce = coerce;
    function coerce(version, options) {
      if (version instanceof SemVer) {
        return version;
      }
      if (typeof version === "number") {
        version = String(version);
      }
      if (typeof version !== "string") {
        return null;
      }
      options = options || {};
      var match = null;
      if (!options.rtl) {
        match = version.match(re[t.COERCE]);
      } else {
        var next;
        while ((next = re[t.COERCERTL].exec(version)) && (!match || match.index + match[0].length !== version.length)) {
          if (!match || next.index + next[0].length !== match.index + match[0].length) {
            match = next;
          }
          re[t.COERCERTL].lastIndex = next.index + next[1].length + next[2].length;
        }
        re[t.COERCERTL].lastIndex = -1;
      }
      if (match === null) {
        return null;
      }
      return parse2(match[2] + "." + (match[3] || "0") + "." + (match[4] || "0"), options);
    }
  }
});

// node_modules/package-json/index.js
var require_package_json = __commonJS({
  "node_modules/package-json/index.js"(exports2, module2) {
    "use strict";
    var {URL: URL2} = require("url");
    var {Agent: HttpAgent} = require("http");
    var {Agent: HttpsAgent} = require("https");
    var got = require_source3();
    var registryUrl = require_registry_url();
    var registryAuthToken = require_registry_auth_token();
    var semver = require_semver();
    var agentOptions = {
      keepAlive: true,
      maxSockets: 50
    };
    var httpAgent = new HttpAgent(agentOptions);
    var httpsAgent = new HttpsAgent(agentOptions);
    var PackageNotFoundError = class extends Error {
      constructor(packageName) {
        super(`Package \`${packageName}\` could not be found`);
        this.name = "PackageNotFoundError";
      }
    };
    var VersionNotFoundError = class extends Error {
      constructor(packageName, version) {
        super(`Version \`${version}\` for package \`${packageName}\` could not be found`);
        this.name = "VersionNotFoundError";
      }
    };
    var packageJson = async (packageName, options) => {
      options = {
        version: "latest",
        ...options
      };
      const scope = packageName.split("/")[0];
      const registryUrl_ = options.registryUrl || registryUrl(scope);
      const packageUrl = new URL2(encodeURIComponent(packageName).replace(/^%40/, "@"), registryUrl_);
      const authInfo = registryAuthToken(registryUrl_.toString(), {recursive: true});
      const headers = {
        accept: "application/vnd.npm.install-v1+json; q=1.0, application/json; q=0.8, */*"
      };
      if (options.fullMetadata) {
        delete headers.accept;
      }
      if (authInfo) {
        headers.authorization = `${authInfo.type} ${authInfo.token}`;
      }
      const gotOptions = {
        json: true,
        headers,
        agent: {
          http: httpAgent,
          https: httpsAgent
        }
      };
      if (options.agent) {
        gotOptions.agent = options.agent;
      }
      let response;
      try {
        response = await got(packageUrl, gotOptions);
      } catch (error) {
        if (error.statusCode === 404) {
          throw new PackageNotFoundError(packageName);
        }
        throw error;
      }
      let data = response.body;
      if (options.allVersions) {
        return data;
      }
      let {version} = options;
      const versionError = new VersionNotFoundError(packageName, version);
      if (data["dist-tags"][version]) {
        data = data.versions[data["dist-tags"][version]];
      } else if (version) {
        if (!data.versions[version]) {
          const versions = Object.keys(data.versions);
          version = semver.maxSatisfying(versions, version);
          if (!version) {
            throw versionError;
          }
        }
        data = data.versions[version];
        if (!data) {
          throw versionError;
        }
      }
      return data;
    };
    module2.exports = packageJson;
    module2.exports.default = packageJson;
    module2.exports.PackageNotFoundError = PackageNotFoundError;
    module2.exports.VersionNotFoundError = VersionNotFoundError;
  }
});

// node_modules/latest-version/index.js
var require_latest_version = __commonJS({
  "node_modules/latest-version/index.js"(exports2, module2) {
    "use strict";
    var packageJson = require_package_json();
    var lastestVersion = async (packageName, options) => {
      const {version} = await packageJson(packageName.toLowerCase(), options);
      return version;
    };
    module2.exports = lastestVersion;
    module2.exports.default = lastestVersion;
  }
});

// node_modules/prettysize/index.js
var require_prettysize = __commonJS({
  "node_modules/prettysize/index.js"(exports2, module2) {
    "use strict";
    var sizes = [
      "Bytes",
      "kB",
      "MB",
      "GB",
      "TB",
      "PB",
      "EB"
    ];
    module2.exports = function(size, nospace, one, places, numOnly) {
      if (typeof nospace === "object") {
        var opts = nospace;
        nospace = opts.nospace;
        one = opts.one;
        places = opts.places || 1;
        numOnly = opts.numOnly;
      } else {
        places = places || 1;
      }
      var mysize;
      for (var id = 0; id < sizes.length; ++id) {
        var unit = sizes[id];
        if (one) {
          unit = unit.slice(0, 1);
        }
        var s = Math.pow(1024, id);
        var fixed;
        if (size >= s) {
          fixed = String((size / s).toFixed(places));
          if (fixed.indexOf(".0") === fixed.length - 2) {
            fixed = fixed.slice(0, -2);
          }
          mysize = fixed + (nospace ? "" : " ") + unit;
        }
      }
      if (!mysize) {
        var _unit = one ? sizes[0].slice(0, 1) : sizes[0];
        mysize = "0" + (nospace ? "" : " ") + _unit;
      }
      if (numOnly) {
        mysize = Number.parseFloat(mysize);
      }
      return mysize;
    };
  }
});

// node_modules/qrcode-terminal/vendor/QRCode/QRMode.js
var require_QRMode = __commonJS({
  "node_modules/qrcode-terminal/vendor/QRCode/QRMode.js"(exports2, module2) {
    module2.exports = {
      MODE_NUMBER: 1 << 0,
      MODE_ALPHA_NUM: 1 << 1,
      MODE_8BIT_BYTE: 1 << 2,
      MODE_KANJI: 1 << 3
    };
  }
});

// node_modules/qrcode-terminal/vendor/QRCode/QR8bitByte.js
var require_QR8bitByte = __commonJS({
  "node_modules/qrcode-terminal/vendor/QRCode/QR8bitByte.js"(exports2, module2) {
    var QRMode = require_QRMode();
    function QR8bitByte(data) {
      this.mode = QRMode.MODE_8BIT_BYTE;
      this.data = data;
    }
    QR8bitByte.prototype = {
      getLength: function() {
        return this.data.length;
      },
      write: function(buffer) {
        for (var i = 0; i < this.data.length; i++) {
          buffer.put(this.data.charCodeAt(i), 8);
        }
      }
    };
    module2.exports = QR8bitByte;
  }
});

// node_modules/qrcode-terminal/vendor/QRCode/QRMath.js
var require_QRMath = __commonJS({
  "node_modules/qrcode-terminal/vendor/QRCode/QRMath.js"(exports2, module2) {
    var QRMath = {
      glog: function(n) {
        if (n < 1) {
          throw new Error("glog(" + n + ")");
        }
        return QRMath.LOG_TABLE[n];
      },
      gexp: function(n) {
        while (n < 0) {
          n += 255;
        }
        while (n >= 256) {
          n -= 255;
        }
        return QRMath.EXP_TABLE[n];
      },
      EXP_TABLE: new Array(256),
      LOG_TABLE: new Array(256)
    };
    for (var i = 0; i < 8; i++) {
      QRMath.EXP_TABLE[i] = 1 << i;
    }
    for (var i = 8; i < 256; i++) {
      QRMath.EXP_TABLE[i] = QRMath.EXP_TABLE[i - 4] ^ QRMath.EXP_TABLE[i - 5] ^ QRMath.EXP_TABLE[i - 6] ^ QRMath.EXP_TABLE[i - 8];
    }
    for (var i = 0; i < 255; i++) {
      QRMath.LOG_TABLE[QRMath.EXP_TABLE[i]] = i;
    }
    module2.exports = QRMath;
  }
});

// node_modules/qrcode-terminal/vendor/QRCode/QRPolynomial.js
var require_QRPolynomial = __commonJS({
  "node_modules/qrcode-terminal/vendor/QRCode/QRPolynomial.js"(exports2, module2) {
    var QRMath = require_QRMath();
    function QRPolynomial(num, shift) {
      if (num.length === void 0) {
        throw new Error(num.length + "/" + shift);
      }
      var offset = 0;
      while (offset < num.length && num[offset] === 0) {
        offset++;
      }
      this.num = new Array(num.length - offset + shift);
      for (var i = 0; i < num.length - offset; i++) {
        this.num[i] = num[i + offset];
      }
    }
    QRPolynomial.prototype = {
      get: function(index) {
        return this.num[index];
      },
      getLength: function() {
        return this.num.length;
      },
      multiply: function(e) {
        var num = new Array(this.getLength() + e.getLength() - 1);
        for (var i = 0; i < this.getLength(); i++) {
          for (var j = 0; j < e.getLength(); j++) {
            num[i + j] ^= QRMath.gexp(QRMath.glog(this.get(i)) + QRMath.glog(e.get(j)));
          }
        }
        return new QRPolynomial(num, 0);
      },
      mod: function(e) {
        if (this.getLength() - e.getLength() < 0) {
          return this;
        }
        var ratio = QRMath.glog(this.get(0)) - QRMath.glog(e.get(0));
        var num = new Array(this.getLength());
        for (var i = 0; i < this.getLength(); i++) {
          num[i] = this.get(i);
        }
        for (var x = 0; x < e.getLength(); x++) {
          num[x] ^= QRMath.gexp(QRMath.glog(e.get(x)) + ratio);
        }
        return new QRPolynomial(num, 0).mod(e);
      }
    };
    module2.exports = QRPolynomial;
  }
});

// node_modules/qrcode-terminal/vendor/QRCode/QRMaskPattern.js
var require_QRMaskPattern = __commonJS({
  "node_modules/qrcode-terminal/vendor/QRCode/QRMaskPattern.js"(exports2, module2) {
    module2.exports = {
      PATTERN000: 0,
      PATTERN001: 1,
      PATTERN010: 2,
      PATTERN011: 3,
      PATTERN100: 4,
      PATTERN101: 5,
      PATTERN110: 6,
      PATTERN111: 7
    };
  }
});

// node_modules/qrcode-terminal/vendor/QRCode/QRUtil.js
var require_QRUtil = __commonJS({
  "node_modules/qrcode-terminal/vendor/QRCode/QRUtil.js"(exports2, module2) {
    var QRMode = require_QRMode();
    var QRPolynomial = require_QRPolynomial();
    var QRMath = require_QRMath();
    var QRMaskPattern = require_QRMaskPattern();
    var QRUtil = {
      PATTERN_POSITION_TABLE: [
        [],
        [6, 18],
        [6, 22],
        [6, 26],
        [6, 30],
        [6, 34],
        [6, 22, 38],
        [6, 24, 42],
        [6, 26, 46],
        [6, 28, 50],
        [6, 30, 54],
        [6, 32, 58],
        [6, 34, 62],
        [6, 26, 46, 66],
        [6, 26, 48, 70],
        [6, 26, 50, 74],
        [6, 30, 54, 78],
        [6, 30, 56, 82],
        [6, 30, 58, 86],
        [6, 34, 62, 90],
        [6, 28, 50, 72, 94],
        [6, 26, 50, 74, 98],
        [6, 30, 54, 78, 102],
        [6, 28, 54, 80, 106],
        [6, 32, 58, 84, 110],
        [6, 30, 58, 86, 114],
        [6, 34, 62, 90, 118],
        [6, 26, 50, 74, 98, 122],
        [6, 30, 54, 78, 102, 126],
        [6, 26, 52, 78, 104, 130],
        [6, 30, 56, 82, 108, 134],
        [6, 34, 60, 86, 112, 138],
        [6, 30, 58, 86, 114, 142],
        [6, 34, 62, 90, 118, 146],
        [6, 30, 54, 78, 102, 126, 150],
        [6, 24, 50, 76, 102, 128, 154],
        [6, 28, 54, 80, 106, 132, 158],
        [6, 32, 58, 84, 110, 136, 162],
        [6, 26, 54, 82, 110, 138, 166],
        [6, 30, 58, 86, 114, 142, 170]
      ],
      G15: 1 << 10 | 1 << 8 | 1 << 5 | 1 << 4 | 1 << 2 | 1 << 1 | 1 << 0,
      G18: 1 << 12 | 1 << 11 | 1 << 10 | 1 << 9 | 1 << 8 | 1 << 5 | 1 << 2 | 1 << 0,
      G15_MASK: 1 << 14 | 1 << 12 | 1 << 10 | 1 << 4 | 1 << 1,
      getBCHTypeInfo: function(data) {
        var d = data << 10;
        while (QRUtil.getBCHDigit(d) - QRUtil.getBCHDigit(QRUtil.G15) >= 0) {
          d ^= QRUtil.G15 << QRUtil.getBCHDigit(d) - QRUtil.getBCHDigit(QRUtil.G15);
        }
        return (data << 10 | d) ^ QRUtil.G15_MASK;
      },
      getBCHTypeNumber: function(data) {
        var d = data << 12;
        while (QRUtil.getBCHDigit(d) - QRUtil.getBCHDigit(QRUtil.G18) >= 0) {
          d ^= QRUtil.G18 << QRUtil.getBCHDigit(d) - QRUtil.getBCHDigit(QRUtil.G18);
        }
        return data << 12 | d;
      },
      getBCHDigit: function(data) {
        var digit = 0;
        while (data !== 0) {
          digit++;
          data >>>= 1;
        }
        return digit;
      },
      getPatternPosition: function(typeNumber) {
        return QRUtil.PATTERN_POSITION_TABLE[typeNumber - 1];
      },
      getMask: function(maskPattern, i, j) {
        switch (maskPattern) {
          case QRMaskPattern.PATTERN000:
            return (i + j) % 2 === 0;
          case QRMaskPattern.PATTERN001:
            return i % 2 === 0;
          case QRMaskPattern.PATTERN010:
            return j % 3 === 0;
          case QRMaskPattern.PATTERN011:
            return (i + j) % 3 === 0;
          case QRMaskPattern.PATTERN100:
            return (Math.floor(i / 2) + Math.floor(j / 3)) % 2 === 0;
          case QRMaskPattern.PATTERN101:
            return i * j % 2 + i * j % 3 === 0;
          case QRMaskPattern.PATTERN110:
            return (i * j % 2 + i * j % 3) % 2 === 0;
          case QRMaskPattern.PATTERN111:
            return (i * j % 3 + (i + j) % 2) % 2 === 0;
          default:
            throw new Error("bad maskPattern:" + maskPattern);
        }
      },
      getErrorCorrectPolynomial: function(errorCorrectLength) {
        var a2 = new QRPolynomial([1], 0);
        for (var i = 0; i < errorCorrectLength; i++) {
          a2 = a2.multiply(new QRPolynomial([1, QRMath.gexp(i)], 0));
        }
        return a2;
      },
      getLengthInBits: function(mode, type) {
        if (1 <= type && type < 10) {
          switch (mode) {
            case QRMode.MODE_NUMBER:
              return 10;
            case QRMode.MODE_ALPHA_NUM:
              return 9;
            case QRMode.MODE_8BIT_BYTE:
              return 8;
            case QRMode.MODE_KANJI:
              return 8;
            default:
              throw new Error("mode:" + mode);
          }
        } else if (type < 27) {
          switch (mode) {
            case QRMode.MODE_NUMBER:
              return 12;
            case QRMode.MODE_ALPHA_NUM:
              return 11;
            case QRMode.MODE_8BIT_BYTE:
              return 16;
            case QRMode.MODE_KANJI:
              return 10;
            default:
              throw new Error("mode:" + mode);
          }
        } else if (type < 41) {
          switch (mode) {
            case QRMode.MODE_NUMBER:
              return 14;
            case QRMode.MODE_ALPHA_NUM:
              return 13;
            case QRMode.MODE_8BIT_BYTE:
              return 16;
            case QRMode.MODE_KANJI:
              return 12;
            default:
              throw new Error("mode:" + mode);
          }
        } else {
          throw new Error("type:" + type);
        }
      },
      getLostPoint: function(qrCode) {
        var moduleCount = qrCode.getModuleCount();
        var lostPoint = 0;
        var row2 = 0;
        var col = 0;
        for (row2 = 0; row2 < moduleCount; row2++) {
          for (col = 0; col < moduleCount; col++) {
            var sameCount = 0;
            var dark = qrCode.isDark(row2, col);
            for (var r = -1; r <= 1; r++) {
              if (row2 + r < 0 || moduleCount <= row2 + r) {
                continue;
              }
              for (var c = -1; c <= 1; c++) {
                if (col + c < 0 || moduleCount <= col + c) {
                  continue;
                }
                if (r === 0 && c === 0) {
                  continue;
                }
                if (dark === qrCode.isDark(row2 + r, col + c)) {
                  sameCount++;
                }
              }
            }
            if (sameCount > 5) {
              lostPoint += 3 + sameCount - 5;
            }
          }
        }
        for (row2 = 0; row2 < moduleCount - 1; row2++) {
          for (col = 0; col < moduleCount - 1; col++) {
            var count2 = 0;
            if (qrCode.isDark(row2, col))
              count2++;
            if (qrCode.isDark(row2 + 1, col))
              count2++;
            if (qrCode.isDark(row2, col + 1))
              count2++;
            if (qrCode.isDark(row2 + 1, col + 1))
              count2++;
            if (count2 === 0 || count2 === 4) {
              lostPoint += 3;
            }
          }
        }
        for (row2 = 0; row2 < moduleCount; row2++) {
          for (col = 0; col < moduleCount - 6; col++) {
            if (qrCode.isDark(row2, col) && !qrCode.isDark(row2, col + 1) && qrCode.isDark(row2, col + 2) && qrCode.isDark(row2, col + 3) && qrCode.isDark(row2, col + 4) && !qrCode.isDark(row2, col + 5) && qrCode.isDark(row2, col + 6)) {
              lostPoint += 40;
            }
          }
        }
        for (col = 0; col < moduleCount; col++) {
          for (row2 = 0; row2 < moduleCount - 6; row2++) {
            if (qrCode.isDark(row2, col) && !qrCode.isDark(row2 + 1, col) && qrCode.isDark(row2 + 2, col) && qrCode.isDark(row2 + 3, col) && qrCode.isDark(row2 + 4, col) && !qrCode.isDark(row2 + 5, col) && qrCode.isDark(row2 + 6, col)) {
              lostPoint += 40;
            }
          }
        }
        var darkCount = 0;
        for (col = 0; col < moduleCount; col++) {
          for (row2 = 0; row2 < moduleCount; row2++) {
            if (qrCode.isDark(row2, col)) {
              darkCount++;
            }
          }
        }
        var ratio = Math.abs(100 * darkCount / moduleCount / moduleCount - 50) / 5;
        lostPoint += ratio * 10;
        return lostPoint;
      }
    };
    module2.exports = QRUtil;
  }
});

// node_modules/qrcode-terminal/vendor/QRCode/QRErrorCorrectLevel.js
var require_QRErrorCorrectLevel = __commonJS({
  "node_modules/qrcode-terminal/vendor/QRCode/QRErrorCorrectLevel.js"(exports2, module2) {
    module2.exports = {
      L: 1,
      M: 0,
      Q: 3,
      H: 2
    };
  }
});

// node_modules/qrcode-terminal/vendor/QRCode/QRRSBlock.js
var require_QRRSBlock = __commonJS({
  "node_modules/qrcode-terminal/vendor/QRCode/QRRSBlock.js"(exports2, module2) {
    var QRErrorCorrectLevel = require_QRErrorCorrectLevel();
    function QRRSBlock(totalCount, dataCount) {
      this.totalCount = totalCount;
      this.dataCount = dataCount;
    }
    QRRSBlock.RS_BLOCK_TABLE = [
      [1, 26, 19],
      [1, 26, 16],
      [1, 26, 13],
      [1, 26, 9],
      [1, 44, 34],
      [1, 44, 28],
      [1, 44, 22],
      [1, 44, 16],
      [1, 70, 55],
      [1, 70, 44],
      [2, 35, 17],
      [2, 35, 13],
      [1, 100, 80],
      [2, 50, 32],
      [2, 50, 24],
      [4, 25, 9],
      [1, 134, 108],
      [2, 67, 43],
      [2, 33, 15, 2, 34, 16],
      [2, 33, 11, 2, 34, 12],
      [2, 86, 68],
      [4, 43, 27],
      [4, 43, 19],
      [4, 43, 15],
      [2, 98, 78],
      [4, 49, 31],
      [2, 32, 14, 4, 33, 15],
      [4, 39, 13, 1, 40, 14],
      [2, 121, 97],
      [2, 60, 38, 2, 61, 39],
      [4, 40, 18, 2, 41, 19],
      [4, 40, 14, 2, 41, 15],
      [2, 146, 116],
      [3, 58, 36, 2, 59, 37],
      [4, 36, 16, 4, 37, 17],
      [4, 36, 12, 4, 37, 13],
      [2, 86, 68, 2, 87, 69],
      [4, 69, 43, 1, 70, 44],
      [6, 43, 19, 2, 44, 20],
      [6, 43, 15, 2, 44, 16],
      [4, 101, 81],
      [1, 80, 50, 4, 81, 51],
      [4, 50, 22, 4, 51, 23],
      [3, 36, 12, 8, 37, 13],
      [2, 116, 92, 2, 117, 93],
      [6, 58, 36, 2, 59, 37],
      [4, 46, 20, 6, 47, 21],
      [7, 42, 14, 4, 43, 15],
      [4, 133, 107],
      [8, 59, 37, 1, 60, 38],
      [8, 44, 20, 4, 45, 21],
      [12, 33, 11, 4, 34, 12],
      [3, 145, 115, 1, 146, 116],
      [4, 64, 40, 5, 65, 41],
      [11, 36, 16, 5, 37, 17],
      [11, 36, 12, 5, 37, 13],
      [5, 109, 87, 1, 110, 88],
      [5, 65, 41, 5, 66, 42],
      [5, 54, 24, 7, 55, 25],
      [11, 36, 12],
      [5, 122, 98, 1, 123, 99],
      [7, 73, 45, 3, 74, 46],
      [15, 43, 19, 2, 44, 20],
      [3, 45, 15, 13, 46, 16],
      [1, 135, 107, 5, 136, 108],
      [10, 74, 46, 1, 75, 47],
      [1, 50, 22, 15, 51, 23],
      [2, 42, 14, 17, 43, 15],
      [5, 150, 120, 1, 151, 121],
      [9, 69, 43, 4, 70, 44],
      [17, 50, 22, 1, 51, 23],
      [2, 42, 14, 19, 43, 15],
      [3, 141, 113, 4, 142, 114],
      [3, 70, 44, 11, 71, 45],
      [17, 47, 21, 4, 48, 22],
      [9, 39, 13, 16, 40, 14],
      [3, 135, 107, 5, 136, 108],
      [3, 67, 41, 13, 68, 42],
      [15, 54, 24, 5, 55, 25],
      [15, 43, 15, 10, 44, 16],
      [4, 144, 116, 4, 145, 117],
      [17, 68, 42],
      [17, 50, 22, 6, 51, 23],
      [19, 46, 16, 6, 47, 17],
      [2, 139, 111, 7, 140, 112],
      [17, 74, 46],
      [7, 54, 24, 16, 55, 25],
      [34, 37, 13],
      [4, 151, 121, 5, 152, 122],
      [4, 75, 47, 14, 76, 48],
      [11, 54, 24, 14, 55, 25],
      [16, 45, 15, 14, 46, 16],
      [6, 147, 117, 4, 148, 118],
      [6, 73, 45, 14, 74, 46],
      [11, 54, 24, 16, 55, 25],
      [30, 46, 16, 2, 47, 17],
      [8, 132, 106, 4, 133, 107],
      [8, 75, 47, 13, 76, 48],
      [7, 54, 24, 22, 55, 25],
      [22, 45, 15, 13, 46, 16],
      [10, 142, 114, 2, 143, 115],
      [19, 74, 46, 4, 75, 47],
      [28, 50, 22, 6, 51, 23],
      [33, 46, 16, 4, 47, 17],
      [8, 152, 122, 4, 153, 123],
      [22, 73, 45, 3, 74, 46],
      [8, 53, 23, 26, 54, 24],
      [12, 45, 15, 28, 46, 16],
      [3, 147, 117, 10, 148, 118],
      [3, 73, 45, 23, 74, 46],
      [4, 54, 24, 31, 55, 25],
      [11, 45, 15, 31, 46, 16],
      [7, 146, 116, 7, 147, 117],
      [21, 73, 45, 7, 74, 46],
      [1, 53, 23, 37, 54, 24],
      [19, 45, 15, 26, 46, 16],
      [5, 145, 115, 10, 146, 116],
      [19, 75, 47, 10, 76, 48],
      [15, 54, 24, 25, 55, 25],
      [23, 45, 15, 25, 46, 16],
      [13, 145, 115, 3, 146, 116],
      [2, 74, 46, 29, 75, 47],
      [42, 54, 24, 1, 55, 25],
      [23, 45, 15, 28, 46, 16],
      [17, 145, 115],
      [10, 74, 46, 23, 75, 47],
      [10, 54, 24, 35, 55, 25],
      [19, 45, 15, 35, 46, 16],
      [17, 145, 115, 1, 146, 116],
      [14, 74, 46, 21, 75, 47],
      [29, 54, 24, 19, 55, 25],
      [11, 45, 15, 46, 46, 16],
      [13, 145, 115, 6, 146, 116],
      [14, 74, 46, 23, 75, 47],
      [44, 54, 24, 7, 55, 25],
      [59, 46, 16, 1, 47, 17],
      [12, 151, 121, 7, 152, 122],
      [12, 75, 47, 26, 76, 48],
      [39, 54, 24, 14, 55, 25],
      [22, 45, 15, 41, 46, 16],
      [6, 151, 121, 14, 152, 122],
      [6, 75, 47, 34, 76, 48],
      [46, 54, 24, 10, 55, 25],
      [2, 45, 15, 64, 46, 16],
      [17, 152, 122, 4, 153, 123],
      [29, 74, 46, 14, 75, 47],
      [49, 54, 24, 10, 55, 25],
      [24, 45, 15, 46, 46, 16],
      [4, 152, 122, 18, 153, 123],
      [13, 74, 46, 32, 75, 47],
      [48, 54, 24, 14, 55, 25],
      [42, 45, 15, 32, 46, 16],
      [20, 147, 117, 4, 148, 118],
      [40, 75, 47, 7, 76, 48],
      [43, 54, 24, 22, 55, 25],
      [10, 45, 15, 67, 46, 16],
      [19, 148, 118, 6, 149, 119],
      [18, 75, 47, 31, 76, 48],
      [34, 54, 24, 34, 55, 25],
      [20, 45, 15, 61, 46, 16]
    ];
    QRRSBlock.getRSBlocks = function(typeNumber, errorCorrectLevel) {
      var rsBlock = QRRSBlock.getRsBlockTable(typeNumber, errorCorrectLevel);
      if (rsBlock === void 0) {
        throw new Error("bad rs block @ typeNumber:" + typeNumber + "/errorCorrectLevel:" + errorCorrectLevel);
      }
      var length = rsBlock.length / 3;
      var list = [];
      for (var i = 0; i < length; i++) {
        var count2 = rsBlock[i * 3 + 0];
        var totalCount = rsBlock[i * 3 + 1];
        var dataCount = rsBlock[i * 3 + 2];
        for (var j = 0; j < count2; j++) {
          list.push(new QRRSBlock(totalCount, dataCount));
        }
      }
      return list;
    };
    QRRSBlock.getRsBlockTable = function(typeNumber, errorCorrectLevel) {
      switch (errorCorrectLevel) {
        case QRErrorCorrectLevel.L:
          return QRRSBlock.RS_BLOCK_TABLE[(typeNumber - 1) * 4 + 0];
        case QRErrorCorrectLevel.M:
          return QRRSBlock.RS_BLOCK_TABLE[(typeNumber - 1) * 4 + 1];
        case QRErrorCorrectLevel.Q:
          return QRRSBlock.RS_BLOCK_TABLE[(typeNumber - 1) * 4 + 2];
        case QRErrorCorrectLevel.H:
          return QRRSBlock.RS_BLOCK_TABLE[(typeNumber - 1) * 4 + 3];
        default:
          return void 0;
      }
    };
    module2.exports = QRRSBlock;
  }
});

// node_modules/qrcode-terminal/vendor/QRCode/QRBitBuffer.js
var require_QRBitBuffer = __commonJS({
  "node_modules/qrcode-terminal/vendor/QRCode/QRBitBuffer.js"(exports2, module2) {
    function QRBitBuffer() {
      this.buffer = [];
      this.length = 0;
    }
    QRBitBuffer.prototype = {
      get: function(index) {
        var bufIndex = Math.floor(index / 8);
        return (this.buffer[bufIndex] >>> 7 - index % 8 & 1) == 1;
      },
      put: function(num, length) {
        for (var i = 0; i < length; i++) {
          this.putBit((num >>> length - i - 1 & 1) == 1);
        }
      },
      getLengthInBits: function() {
        return this.length;
      },
      putBit: function(bit) {
        var bufIndex = Math.floor(this.length / 8);
        if (this.buffer.length <= bufIndex) {
          this.buffer.push(0);
        }
        if (bit) {
          this.buffer[bufIndex] |= 128 >>> this.length % 8;
        }
        this.length++;
      }
    };
    module2.exports = QRBitBuffer;
  }
});

// node_modules/qrcode-terminal/vendor/QRCode/index.js
var require_QRCode = __commonJS({
  "node_modules/qrcode-terminal/vendor/QRCode/index.js"(exports2, module2) {
    var QR8bitByte = require_QR8bitByte();
    var QRUtil = require_QRUtil();
    var QRPolynomial = require_QRPolynomial();
    var QRRSBlock = require_QRRSBlock();
    var QRBitBuffer = require_QRBitBuffer();
    function QRCode(typeNumber, errorCorrectLevel) {
      this.typeNumber = typeNumber;
      this.errorCorrectLevel = errorCorrectLevel;
      this.modules = null;
      this.moduleCount = 0;
      this.dataCache = null;
      this.dataList = [];
    }
    QRCode.prototype = {
      addData: function(data) {
        var newData = new QR8bitByte(data);
        this.dataList.push(newData);
        this.dataCache = null;
      },
      isDark: function(row2, col) {
        if (row2 < 0 || this.moduleCount <= row2 || col < 0 || this.moduleCount <= col) {
          throw new Error(row2 + "," + col);
        }
        return this.modules[row2][col];
      },
      getModuleCount: function() {
        return this.moduleCount;
      },
      make: function() {
        if (this.typeNumber < 1) {
          var typeNumber = 1;
          for (typeNumber = 1; typeNumber < 40; typeNumber++) {
            var rsBlocks = QRRSBlock.getRSBlocks(typeNumber, this.errorCorrectLevel);
            var buffer = new QRBitBuffer();
            var totalDataCount = 0;
            for (var i = 0; i < rsBlocks.length; i++) {
              totalDataCount += rsBlocks[i].dataCount;
            }
            for (var x = 0; x < this.dataList.length; x++) {
              var data = this.dataList[x];
              buffer.put(data.mode, 4);
              buffer.put(data.getLength(), QRUtil.getLengthInBits(data.mode, typeNumber));
              data.write(buffer);
            }
            if (buffer.getLengthInBits() <= totalDataCount * 8)
              break;
          }
          this.typeNumber = typeNumber;
        }
        this.makeImpl(false, this.getBestMaskPattern());
      },
      makeImpl: function(test, maskPattern) {
        this.moduleCount = this.typeNumber * 4 + 17;
        this.modules = new Array(this.moduleCount);
        for (var row2 = 0; row2 < this.moduleCount; row2++) {
          this.modules[row2] = new Array(this.moduleCount);
          for (var col = 0; col < this.moduleCount; col++) {
            this.modules[row2][col] = null;
          }
        }
        this.setupPositionProbePattern(0, 0);
        this.setupPositionProbePattern(this.moduleCount - 7, 0);
        this.setupPositionProbePattern(0, this.moduleCount - 7);
        this.setupPositionAdjustPattern();
        this.setupTimingPattern();
        this.setupTypeInfo(test, maskPattern);
        if (this.typeNumber >= 7) {
          this.setupTypeNumber(test);
        }
        if (this.dataCache === null) {
          this.dataCache = QRCode.createData(this.typeNumber, this.errorCorrectLevel, this.dataList);
        }
        this.mapData(this.dataCache, maskPattern);
      },
      setupPositionProbePattern: function(row2, col) {
        for (var r = -1; r <= 7; r++) {
          if (row2 + r <= -1 || this.moduleCount <= row2 + r)
            continue;
          for (var c = -1; c <= 7; c++) {
            if (col + c <= -1 || this.moduleCount <= col + c)
              continue;
            if (0 <= r && r <= 6 && (c === 0 || c === 6) || 0 <= c && c <= 6 && (r === 0 || r === 6) || 2 <= r && r <= 4 && 2 <= c && c <= 4) {
              this.modules[row2 + r][col + c] = true;
            } else {
              this.modules[row2 + r][col + c] = false;
            }
          }
        }
      },
      getBestMaskPattern: function() {
        var minLostPoint = 0;
        var pattern = 0;
        for (var i = 0; i < 8; i++) {
          this.makeImpl(true, i);
          var lostPoint = QRUtil.getLostPoint(this);
          if (i === 0 || minLostPoint > lostPoint) {
            minLostPoint = lostPoint;
            pattern = i;
          }
        }
        return pattern;
      },
      createMovieClip: function(target_mc, instance_name, depth) {
        var qr_mc = target_mc.createEmptyMovieClip(instance_name, depth);
        var cs = 1;
        this.make();
        for (var row2 = 0; row2 < this.modules.length; row2++) {
          var y = row2 * cs;
          for (var col = 0; col < this.modules[row2].length; col++) {
            var x = col * cs;
            var dark = this.modules[row2][col];
            if (dark) {
              qr_mc.beginFill(0, 100);
              qr_mc.moveTo(x, y);
              qr_mc.lineTo(x + cs, y);
              qr_mc.lineTo(x + cs, y + cs);
              qr_mc.lineTo(x, y + cs);
              qr_mc.endFill();
            }
          }
        }
        return qr_mc;
      },
      setupTimingPattern: function() {
        for (var r = 8; r < this.moduleCount - 8; r++) {
          if (this.modules[r][6] !== null) {
            continue;
          }
          this.modules[r][6] = r % 2 === 0;
        }
        for (var c = 8; c < this.moduleCount - 8; c++) {
          if (this.modules[6][c] !== null) {
            continue;
          }
          this.modules[6][c] = c % 2 === 0;
        }
      },
      setupPositionAdjustPattern: function() {
        var pos = QRUtil.getPatternPosition(this.typeNumber);
        for (var i = 0; i < pos.length; i++) {
          for (var j = 0; j < pos.length; j++) {
            var row2 = pos[i];
            var col = pos[j];
            if (this.modules[row2][col] !== null) {
              continue;
            }
            for (var r = -2; r <= 2; r++) {
              for (var c = -2; c <= 2; c++) {
                if (Math.abs(r) === 2 || Math.abs(c) === 2 || r === 0 && c === 0) {
                  this.modules[row2 + r][col + c] = true;
                } else {
                  this.modules[row2 + r][col + c] = false;
                }
              }
            }
          }
        }
      },
      setupTypeNumber: function(test) {
        var bits = QRUtil.getBCHTypeNumber(this.typeNumber);
        var mod;
        for (var i = 0; i < 18; i++) {
          mod = !test && (bits >> i & 1) === 1;
          this.modules[Math.floor(i / 3)][i % 3 + this.moduleCount - 8 - 3] = mod;
        }
        for (var x = 0; x < 18; x++) {
          mod = !test && (bits >> x & 1) === 1;
          this.modules[x % 3 + this.moduleCount - 8 - 3][Math.floor(x / 3)] = mod;
        }
      },
      setupTypeInfo: function(test, maskPattern) {
        var data = this.errorCorrectLevel << 3 | maskPattern;
        var bits = QRUtil.getBCHTypeInfo(data);
        var mod;
        for (var v = 0; v < 15; v++) {
          mod = !test && (bits >> v & 1) === 1;
          if (v < 6) {
            this.modules[v][8] = mod;
          } else if (v < 8) {
            this.modules[v + 1][8] = mod;
          } else {
            this.modules[this.moduleCount - 15 + v][8] = mod;
          }
        }
        for (var h = 0; h < 15; h++) {
          mod = !test && (bits >> h & 1) === 1;
          if (h < 8) {
            this.modules[8][this.moduleCount - h - 1] = mod;
          } else if (h < 9) {
            this.modules[8][15 - h - 1 + 1] = mod;
          } else {
            this.modules[8][15 - h - 1] = mod;
          }
        }
        this.modules[this.moduleCount - 8][8] = !test;
      },
      mapData: function(data, maskPattern) {
        var inc2 = -1;
        var row2 = this.moduleCount - 1;
        var bitIndex = 7;
        var byteIndex = 0;
        for (var col = this.moduleCount - 1; col > 0; col -= 2) {
          if (col === 6)
            col--;
          while (true) {
            for (var c = 0; c < 2; c++) {
              if (this.modules[row2][col - c] === null) {
                var dark = false;
                if (byteIndex < data.length) {
                  dark = (data[byteIndex] >>> bitIndex & 1) === 1;
                }
                var mask = QRUtil.getMask(maskPattern, row2, col - c);
                if (mask) {
                  dark = !dark;
                }
                this.modules[row2][col - c] = dark;
                bitIndex--;
                if (bitIndex === -1) {
                  byteIndex++;
                  bitIndex = 7;
                }
              }
            }
            row2 += inc2;
            if (row2 < 0 || this.moduleCount <= row2) {
              row2 -= inc2;
              inc2 = -inc2;
              break;
            }
          }
        }
      }
    };
    QRCode.PAD0 = 236;
    QRCode.PAD1 = 17;
    QRCode.createData = function(typeNumber, errorCorrectLevel, dataList) {
      var rsBlocks = QRRSBlock.getRSBlocks(typeNumber, errorCorrectLevel);
      var buffer = new QRBitBuffer();
      for (var i = 0; i < dataList.length; i++) {
        var data = dataList[i];
        buffer.put(data.mode, 4);
        buffer.put(data.getLength(), QRUtil.getLengthInBits(data.mode, typeNumber));
        data.write(buffer);
      }
      var totalDataCount = 0;
      for (var x = 0; x < rsBlocks.length; x++) {
        totalDataCount += rsBlocks[x].dataCount;
      }
      if (buffer.getLengthInBits() > totalDataCount * 8) {
        throw new Error("code length overflow. (" + buffer.getLengthInBits() + ">" + totalDataCount * 8 + ")");
      }
      if (buffer.getLengthInBits() + 4 <= totalDataCount * 8) {
        buffer.put(0, 4);
      }
      while (buffer.getLengthInBits() % 8 !== 0) {
        buffer.putBit(false);
      }
      while (true) {
        if (buffer.getLengthInBits() >= totalDataCount * 8) {
          break;
        }
        buffer.put(QRCode.PAD0, 8);
        if (buffer.getLengthInBits() >= totalDataCount * 8) {
          break;
        }
        buffer.put(QRCode.PAD1, 8);
      }
      return QRCode.createBytes(buffer, rsBlocks);
    };
    QRCode.createBytes = function(buffer, rsBlocks) {
      var offset = 0;
      var maxDcCount = 0;
      var maxEcCount = 0;
      var dcdata = new Array(rsBlocks.length);
      var ecdata = new Array(rsBlocks.length);
      for (var r = 0; r < rsBlocks.length; r++) {
        var dcCount = rsBlocks[r].dataCount;
        var ecCount = rsBlocks[r].totalCount - dcCount;
        maxDcCount = Math.max(maxDcCount, dcCount);
        maxEcCount = Math.max(maxEcCount, ecCount);
        dcdata[r] = new Array(dcCount);
        for (var i = 0; i < dcdata[r].length; i++) {
          dcdata[r][i] = 255 & buffer.buffer[i + offset];
        }
        offset += dcCount;
        var rsPoly = QRUtil.getErrorCorrectPolynomial(ecCount);
        var rawPoly = new QRPolynomial(dcdata[r], rsPoly.getLength() - 1);
        var modPoly = rawPoly.mod(rsPoly);
        ecdata[r] = new Array(rsPoly.getLength() - 1);
        for (var x = 0; x < ecdata[r].length; x++) {
          var modIndex = x + modPoly.getLength() - ecdata[r].length;
          ecdata[r][x] = modIndex >= 0 ? modPoly.get(modIndex) : 0;
        }
      }
      var totalCodeCount = 0;
      for (var y = 0; y < rsBlocks.length; y++) {
        totalCodeCount += rsBlocks[y].totalCount;
      }
      var data = new Array(totalCodeCount);
      var index = 0;
      for (var z = 0; z < maxDcCount; z++) {
        for (var s = 0; s < rsBlocks.length; s++) {
          if (z < dcdata[s].length) {
            data[index++] = dcdata[s][z];
          }
        }
      }
      for (var xx = 0; xx < maxEcCount; xx++) {
        for (var t = 0; t < rsBlocks.length; t++) {
          if (xx < ecdata[t].length) {
            data[index++] = ecdata[t][xx];
          }
        }
      }
      return data;
    };
    module2.exports = QRCode;
  }
});

// node_modules/qrcode-terminal/lib/main.js
var require_main = __commonJS({
  "node_modules/qrcode-terminal/lib/main.js"(exports2, module2) {
    var QRCode = require_QRCode();
    var QRErrorCorrectLevel = require_QRErrorCorrectLevel();
    var black = "[40m  [0m";
    var white = "[47m  [0m";
    var toCell = function(isBlack) {
      return isBlack ? black : white;
    };
    var repeat = function(color) {
      return {
        times: function(count2) {
          return new Array(count2).join(color);
        }
      };
    };
    var fill = function(length, value) {
      var arr = new Array(length);
      for (var i = 0; i < length; i++) {
        arr[i] = value;
      }
      return arr;
    };
    module2.exports = {
      error: QRErrorCorrectLevel.L,
      generate: function(input, opts, cb) {
        if (typeof opts === "function") {
          cb = opts;
          opts = {};
        }
        var qrcode = new QRCode(-1, this.error);
        qrcode.addData(input);
        qrcode.make();
        var output = "";
        if (opts && opts.small) {
          var BLACK = true, WHITE = false;
          var moduleCount = qrcode.getModuleCount();
          var moduleData = qrcode.modules.slice();
          var oddRow = moduleCount % 2 === 1;
          if (oddRow) {
            moduleData.push(fill(moduleCount, WHITE));
          }
          var platte = {
            WHITE_ALL: "\u2588",
            WHITE_BLACK: "\u2580",
            BLACK_WHITE: "\u2584",
            BLACK_ALL: " "
          };
          var borderTop = repeat(platte.BLACK_WHITE).times(moduleCount + 3);
          var borderBottom = repeat(platte.WHITE_BLACK).times(moduleCount + 3);
          output += borderTop + "\n";
          for (var row2 = 0; row2 < moduleCount; row2 += 2) {
            output += platte.WHITE_ALL;
            for (var col = 0; col < moduleCount; col++) {
              if (moduleData[row2][col] === WHITE && moduleData[row2 + 1][col] === WHITE) {
                output += platte.WHITE_ALL;
              } else if (moduleData[row2][col] === WHITE && moduleData[row2 + 1][col] === BLACK) {
                output += platte.WHITE_BLACK;
              } else if (moduleData[row2][col] === BLACK && moduleData[row2 + 1][col] === WHITE) {
                output += platte.BLACK_WHITE;
              } else {
                output += platte.BLACK_ALL;
              }
            }
            output += platte.WHITE_ALL + "\n";
          }
          if (!oddRow) {
            output += borderBottom;
          }
        } else {
          var border = repeat(white).times(qrcode.getModuleCount() + 3);
          output += border + "\n";
          qrcode.modules.forEach(function(row3) {
            output += white;
            output += row3.map(toCell).join("");
            output += white + "\n";
          });
          output += border;
        }
        if (cb)
          cb(output);
        else
          console.log(output);
      },
      setErrorLevel: function(error) {
        this.error = QRErrorCorrectLevel[error] || this.error;
      }
    };
  }
});

// node_modules/depd/lib/compat/callsite-tostring.js
var require_callsite_tostring = __commonJS({
  "node_modules/depd/lib/compat/callsite-tostring.js"(exports2, module2) {
    "use strict";
    module2.exports = callSiteToString2;
    function callSiteFileLocation(callSite) {
      var fileName;
      var fileLocation = "";
      if (callSite.isNative()) {
        fileLocation = "native";
      } else if (callSite.isEval()) {
        fileName = callSite.getScriptNameOrSourceURL();
        if (!fileName) {
          fileLocation = callSite.getEvalOrigin();
        }
      } else {
        fileName = callSite.getFileName();
      }
      if (fileName) {
        fileLocation += fileName;
        var lineNumber = callSite.getLineNumber();
        if (lineNumber != null) {
          fileLocation += ":" + lineNumber;
          var columnNumber = callSite.getColumnNumber();
          if (columnNumber) {
            fileLocation += ":" + columnNumber;
          }
        }
      }
      return fileLocation || "unknown source";
    }
    function callSiteToString2(callSite) {
      var addSuffix = true;
      var fileLocation = callSiteFileLocation(callSite);
      var functionName = callSite.getFunctionName();
      var isConstructor = callSite.isConstructor();
      var isMethodCall = !(callSite.isToplevel() || isConstructor);
      var line = "";
      if (isMethodCall) {
        var methodName = callSite.getMethodName();
        var typeName = getConstructorName(callSite);
        if (functionName) {
          if (typeName && functionName.indexOf(typeName) !== 0) {
            line += typeName + ".";
          }
          line += functionName;
          if (methodName && functionName.lastIndexOf("." + methodName) !== functionName.length - methodName.length - 1) {
            line += " [as " + methodName + "]";
          }
        } else {
          line += typeName + "." + (methodName || "<anonymous>");
        }
      } else if (isConstructor) {
        line += "new " + (functionName || "<anonymous>");
      } else if (functionName) {
        line += functionName;
      } else {
        addSuffix = false;
        line += fileLocation;
      }
      if (addSuffix) {
        line += " (" + fileLocation + ")";
      }
      return line;
    }
    function getConstructorName(obj) {
      var receiver = obj.receiver;
      return receiver.constructor && receiver.constructor.name || null;
    }
  }
});

// node_modules/depd/lib/compat/event-listener-count.js
var require_event_listener_count = __commonJS({
  "node_modules/depd/lib/compat/event-listener-count.js"(exports2, module2) {
    "use strict";
    module2.exports = eventListenerCount2;
    function eventListenerCount2(emitter, type) {
      return emitter.listeners(type).length;
    }
  }
});

// node_modules/depd/lib/compat/index.js
var require_compat = __commonJS({
  "node_modules/depd/lib/compat/index.js"(exports2, module2) {
    "use strict";
    var EventEmitter = require("events").EventEmitter;
    lazyProperty(module2.exports, "callSiteToString", function callSiteToString2() {
      var limit = Error.stackTraceLimit;
      var obj = {};
      var prep = Error.prepareStackTrace;
      function prepareObjectStackTrace2(obj2, stack2) {
        return stack2;
      }
      Error.prepareStackTrace = prepareObjectStackTrace2;
      Error.stackTraceLimit = 2;
      Error.captureStackTrace(obj);
      var stack = obj.stack.slice();
      Error.prepareStackTrace = prep;
      Error.stackTraceLimit = limit;
      return stack[0].toString ? toString2 : require_callsite_tostring();
    });
    lazyProperty(module2.exports, "eventListenerCount", function eventListenerCount2() {
      return EventEmitter.listenerCount || require_event_listener_count();
    });
    function lazyProperty(obj, prop, getter) {
      function get2() {
        var val = getter();
        Object.defineProperty(obj, prop, {
          configurable: true,
          enumerable: true,
          value: val
        });
        return val;
      }
      Object.defineProperty(obj, prop, {
        configurable: true,
        enumerable: true,
        get: get2
      });
    }
    function toString2(obj) {
      return obj.toString();
    }
  }
});

// node_modules/depd/index.js
var require_depd = __commonJS({
  "node_modules/depd/index.js"(exports, module) {
    var callSiteToString = require_compat().callSiteToString;
    var eventListenerCount = require_compat().eventListenerCount;
    var relative = require("path").relative;
    module.exports = depd;
    var basePath = process.cwd();
    function containsNamespace(str2, namespace) {
      var vals2 = str2.split(/[ ,]+/);
      var ns = String(namespace).toLowerCase();
      for (var i = 0; i < vals2.length; i++) {
        var val = vals2[i];
        if (val && (val === "*" || val.toLowerCase() === ns)) {
          return true;
        }
      }
      return false;
    }
    function convertDataDescriptorToAccessor(obj, prop, message) {
      var descriptor = Object.getOwnPropertyDescriptor(obj, prop);
      var value = descriptor.value;
      descriptor.get = function getter() {
        return value;
      };
      if (descriptor.writable) {
        descriptor.set = function setter(val) {
          return value = val;
        };
      }
      delete descriptor.value;
      delete descriptor.writable;
      Object.defineProperty(obj, prop, descriptor);
      return descriptor;
    }
    function createArgumentsString(arity) {
      var str2 = "";
      for (var i = 0; i < arity; i++) {
        str2 += ", arg" + i;
      }
      return str2.substr(2);
    }
    function createStackString(stack) {
      var str2 = this.name + ": " + this.namespace;
      if (this.message) {
        str2 += " deprecated " + this.message;
      }
      for (var i = 0; i < stack.length; i++) {
        str2 += "\n    at " + callSiteToString(stack[i]);
      }
      return str2;
    }
    function depd(namespace) {
      if (!namespace) {
        throw new TypeError("argument namespace is required");
      }
      var stack = getStack();
      var site = callSiteLocation(stack[1]);
      var file = site[0];
      function deprecate(message) {
        log.call(deprecate, message);
      }
      deprecate._file = file;
      deprecate._ignored = isignored(namespace);
      deprecate._namespace = namespace;
      deprecate._traced = istraced(namespace);
      deprecate._warned = Object.create(null);
      deprecate.function = wrapfunction;
      deprecate.property = wrapproperty;
      return deprecate;
    }
    function isignored(namespace) {
      if (process.noDeprecation) {
        return true;
      }
      var str2 = process.env.NO_DEPRECATION || "";
      return containsNamespace(str2, namespace);
    }
    function istraced(namespace) {
      if (process.traceDeprecation) {
        return true;
      }
      var str2 = process.env.TRACE_DEPRECATION || "";
      return containsNamespace(str2, namespace);
    }
    function log(message, site) {
      var haslisteners = eventListenerCount(process, "deprecation") !== 0;
      if (!haslisteners && this._ignored) {
        return;
      }
      var caller;
      var callFile;
      var callSite;
      var depSite;
      var i = 0;
      var seen = false;
      var stack = getStack();
      var file = this._file;
      if (site) {
        depSite = site;
        callSite = callSiteLocation(stack[1]);
        callSite.name = depSite.name;
        file = callSite[0];
      } else {
        i = 2;
        depSite = callSiteLocation(stack[i]);
        callSite = depSite;
      }
      for (; i < stack.length; i++) {
        caller = callSiteLocation(stack[i]);
        callFile = caller[0];
        if (callFile === file) {
          seen = true;
        } else if (callFile === this._file) {
          file = this._file;
        } else if (seen) {
          break;
        }
      }
      var key = caller ? depSite.join(":") + "__" + caller.join(":") : void 0;
      if (key !== void 0 && key in this._warned) {
        return;
      }
      this._warned[key] = true;
      var msg = message;
      if (!msg) {
        msg = callSite === depSite || !callSite.name ? defaultMessage(depSite) : defaultMessage(callSite);
      }
      if (haslisteners) {
        var err = DeprecationError(this._namespace, msg, stack.slice(i));
        process.emit("deprecation", err);
        return;
      }
      var format = process.stderr.isTTY ? formatColor : formatPlain;
      var output = format.call(this, msg, caller, stack.slice(i));
      process.stderr.write(output + "\n", "utf8");
    }
    function callSiteLocation(callSite) {
      var file = callSite.getFileName() || "<anonymous>";
      var line = callSite.getLineNumber();
      var colm = callSite.getColumnNumber();
      if (callSite.isEval()) {
        file = callSite.getEvalOrigin() + ", " + file;
      }
      var site = [file, line, colm];
      site.callSite = callSite;
      site.name = callSite.getFunctionName();
      return site;
    }
    function defaultMessage(site) {
      var callSite = site.callSite;
      var funcName = site.name;
      if (!funcName) {
        funcName = "<anonymous@" + formatLocation(site) + ">";
      }
      var context = callSite.getThis();
      var typeName = context && callSite.getTypeName();
      if (typeName === "Object") {
        typeName = void 0;
      }
      if (typeName === "Function") {
        typeName = context.name || typeName;
      }
      return typeName && callSite.getMethodName() ? typeName + "." + funcName : funcName;
    }
    function formatPlain(msg, caller, stack) {
      var timestamp = new Date().toUTCString();
      var formatted = timestamp + " " + this._namespace + " deprecated " + msg;
      if (this._traced) {
        for (var i = 0; i < stack.length; i++) {
          formatted += "\n    at " + callSiteToString(stack[i]);
        }
        return formatted;
      }
      if (caller) {
        formatted += " at " + formatLocation(caller);
      }
      return formatted;
    }
    function formatColor(msg, caller, stack) {
      var formatted = "[36;1m" + this._namespace + "[22;39m [33;1mdeprecated[22;39m [0m" + msg + "[39m";
      if (this._traced) {
        for (var i = 0; i < stack.length; i++) {
          formatted += "\n    [36mat " + callSiteToString(stack[i]) + "[39m";
        }
        return formatted;
      }
      if (caller) {
        formatted += " [36m" + formatLocation(caller) + "[39m";
      }
      return formatted;
    }
    function formatLocation(callSite) {
      return relative(basePath, callSite[0]) + ":" + callSite[1] + ":" + callSite[2];
    }
    function getStack() {
      var limit = Error.stackTraceLimit;
      var obj = {};
      var prep = Error.prepareStackTrace;
      Error.prepareStackTrace = prepareObjectStackTrace;
      Error.stackTraceLimit = Math.max(10, limit);
      Error.captureStackTrace(obj);
      var stack = obj.stack.slice(1);
      Error.prepareStackTrace = prep;
      Error.stackTraceLimit = limit;
      return stack;
    }
    function prepareObjectStackTrace(obj, stack) {
      return stack;
    }
    function wrapfunction(fn, message) {
      if (typeof fn !== "function") {
        throw new TypeError("argument fn must be a function");
      }
      var args = createArgumentsString(fn.length);
      var deprecate = this;
      var stack = getStack();
      var site = callSiteLocation(stack[1]);
      site.name = fn.name;
      var deprecatedfn = eval("(function (" + args + ') {\n"use strict"\nlog.call(deprecate, message, site)\nreturn fn.apply(this, arguments)\n})');
      return deprecatedfn;
    }
    function wrapproperty(obj, prop, message) {
      if (!obj || typeof obj !== "object" && typeof obj !== "function") {
        throw new TypeError("argument obj must be object");
      }
      var descriptor = Object.getOwnPropertyDescriptor(obj, prop);
      if (!descriptor) {
        throw new TypeError("must call property on owner object");
      }
      if (!descriptor.configurable) {
        throw new TypeError("property must be configurable");
      }
      var deprecate = this;
      var stack = getStack();
      var site = callSiteLocation(stack[1]);
      site.name = prop;
      if ("value" in descriptor) {
        descriptor = convertDataDescriptorToAccessor(obj, prop, message);
      }
      var get2 = descriptor.get;
      var set = descriptor.set;
      if (typeof get2 === "function") {
        descriptor.get = function getter() {
          log.call(deprecate, message, site);
          return get2.apply(this, arguments);
        };
      }
      if (typeof set === "function") {
        descriptor.set = function setter() {
          log.call(deprecate, message, site);
          return set.apply(this, arguments);
        };
      }
      Object.defineProperty(obj, prop, descriptor);
    }
    function DeprecationError(namespace, message, stack) {
      var error = new Error();
      var stackString;
      Object.defineProperty(error, "constructor", {
        value: DeprecationError
      });
      Object.defineProperty(error, "message", {
        configurable: true,
        enumerable: false,
        value: message,
        writable: true
      });
      Object.defineProperty(error, "name", {
        enumerable: false,
        configurable: true,
        value: "DeprecationError",
        writable: true
      });
      Object.defineProperty(error, "namespace", {
        configurable: true,
        enumerable: false,
        value: namespace,
        writable: true
      });
      Object.defineProperty(error, "stack", {
        configurable: true,
        enumerable: false,
        get: function() {
          if (stackString !== void 0) {
            return stackString;
          }
          return stackString = createStackString.call(this, stack);
        },
        set: function setter(val) {
          stackString = val;
        }
      });
      return error;
    }
  }
});

// node_modules/setprototypeof/index.js
var require_setprototypeof = __commonJS({
  "node_modules/setprototypeof/index.js"(exports2, module2) {
    "use strict";
    module2.exports = Object.setPrototypeOf || ({__proto__: []} instanceof Array ? setProtoOf : mixinProperties);
    function setProtoOf(obj, proto) {
      obj.__proto__ = proto;
      return obj;
    }
    function mixinProperties(obj, proto) {
      for (var prop in proto) {
        if (!obj.hasOwnProperty(prop)) {
          obj[prop] = proto[prop];
        }
      }
      return obj;
    }
  }
});

// node_modules/inherits/inherits_browser.js
var require_inherits_browser = __commonJS({
  "node_modules/inherits/inherits_browser.js"(exports2, module2) {
    if (typeof Object.create === "function") {
      module2.exports = function inherits(ctor, superCtor) {
        if (superCtor) {
          ctor.super_ = superCtor;
          ctor.prototype = Object.create(superCtor.prototype, {
            constructor: {
              value: ctor,
              enumerable: false,
              writable: true,
              configurable: true
            }
          });
        }
      };
    } else {
      module2.exports = function inherits(ctor, superCtor) {
        if (superCtor) {
          ctor.super_ = superCtor;
          var TempCtor = function() {
          };
          TempCtor.prototype = superCtor.prototype;
          ctor.prototype = new TempCtor();
          ctor.prototype.constructor = ctor;
        }
      };
    }
  }
});

// node_modules/inherits/inherits.js
var require_inherits = __commonJS({
  "node_modules/inherits/inherits.js"(exports2, module2) {
    try {
      util = require("util");
      if (typeof util.inherits !== "function")
        throw "";
      module2.exports = util.inherits;
    } catch (e) {
      module2.exports = require_inherits_browser();
    }
    var util;
  }
});

// node_modules/toidentifier/index.js
var require_toidentifier = __commonJS({
  "node_modules/toidentifier/index.js"(exports2, module2) {
    module2.exports = toIdentifier;
    function toIdentifier(str2) {
      return str2.split(" ").map(function(token) {
        return token.slice(0, 1).toUpperCase() + token.slice(1);
      }).join("").replace(/[^ _0-9a-z]/gi, "");
    }
  }
});

// node_modules/http-errors/index.js
var require_http_errors = __commonJS({
  "node_modules/http-errors/index.js"(exports2, module2) {
    "use strict";
    var deprecate = require_depd()("http-errors");
    var setPrototypeOf = require_setprototypeof();
    var statuses = require_statuses();
    var inherits = require_inherits();
    var toIdentifier = require_toidentifier();
    module2.exports = createError;
    module2.exports.HttpError = createHttpErrorConstructor();
    populateConstructorExports(module2.exports, statuses.codes, module2.exports.HttpError);
    function codeClass(status) {
      return Number(String(status).charAt(0) + "00");
    }
    function createError() {
      var err;
      var msg;
      var status = 500;
      var props = {};
      for (var i = 0; i < arguments.length; i++) {
        var arg = arguments[i];
        if (arg instanceof Error) {
          err = arg;
          status = err.status || err.statusCode || status;
          continue;
        }
        switch (typeof arg) {
          case "string":
            msg = arg;
            break;
          case "number":
            status = arg;
            if (i !== 0) {
              deprecate("non-first-argument status code; replace with createError(" + arg + ", ...)");
            }
            break;
          case "object":
            props = arg;
            break;
        }
      }
      if (typeof status === "number" && (status < 400 || status >= 600)) {
        deprecate("non-error status code; use only 4xx or 5xx status codes");
      }
      if (typeof status !== "number" || !statuses[status] && (status < 400 || status >= 600)) {
        status = 500;
      }
      var HttpError = createError[status] || createError[codeClass(status)];
      if (!err) {
        err = HttpError ? new HttpError(msg) : new Error(msg || statuses[status]);
        Error.captureStackTrace(err, createError);
      }
      if (!HttpError || !(err instanceof HttpError) || err.status !== status) {
        err.expose = status < 500;
        err.status = err.statusCode = status;
      }
      for (var key in props) {
        if (key !== "status" && key !== "statusCode") {
          err[key] = props[key];
        }
      }
      return err;
    }
    function createHttpErrorConstructor() {
      function HttpError() {
        throw new TypeError("cannot construct abstract class");
      }
      inherits(HttpError, Error);
      return HttpError;
    }
    function createClientErrorConstructor(HttpError, name, code) {
      var className = name.match(/Error$/) ? name : name + "Error";
      function ClientError(message) {
        var msg = message != null ? message : statuses[code];
        var err = new Error(msg);
        Error.captureStackTrace(err, ClientError);
        setPrototypeOf(err, ClientError.prototype);
        Object.defineProperty(err, "message", {
          enumerable: true,
          configurable: true,
          value: msg,
          writable: true
        });
        Object.defineProperty(err, "name", {
          enumerable: false,
          configurable: true,
          value: className,
          writable: true
        });
        return err;
      }
      inherits(ClientError, HttpError);
      nameFunc(ClientError, className);
      ClientError.prototype.status = code;
      ClientError.prototype.statusCode = code;
      ClientError.prototype.expose = true;
      return ClientError;
    }
    function createServerErrorConstructor(HttpError, name, code) {
      var className = name.match(/Error$/) ? name : name + "Error";
      function ServerError(message) {
        var msg = message != null ? message : statuses[code];
        var err = new Error(msg);
        Error.captureStackTrace(err, ServerError);
        setPrototypeOf(err, ServerError.prototype);
        Object.defineProperty(err, "message", {
          enumerable: true,
          configurable: true,
          value: msg,
          writable: true
        });
        Object.defineProperty(err, "name", {
          enumerable: false,
          configurable: true,
          value: className,
          writable: true
        });
        return err;
      }
      inherits(ServerError, HttpError);
      nameFunc(ServerError, className);
      ServerError.prototype.status = code;
      ServerError.prototype.statusCode = code;
      ServerError.prototype.expose = false;
      return ServerError;
    }
    function nameFunc(func, name) {
      var desc = Object.getOwnPropertyDescriptor(func, "name");
      if (desc && desc.configurable) {
        desc.value = name;
        Object.defineProperty(func, "name", desc);
      }
    }
    function populateConstructorExports(exports3, codes, HttpError) {
      codes.forEach(function forEachCode(code) {
        var CodeError;
        var name = toIdentifier(statuses[code]);
        switch (codeClass(code)) {
          case 400:
            CodeError = createClientErrorConstructor(HttpError, name, code);
            break;
          case 500:
            CodeError = createServerErrorConstructor(HttpError, name, code);
            break;
        }
        if (CodeError) {
          exports3[code] = CodeError;
          exports3[name] = CodeError;
        }
      });
      exports3["I'mateapot"] = deprecate.function(exports3.ImATeapot, `"I'mateapot"; use "ImATeapot" instead`);
    }
  }
});

// node_modules/destroy/index.js
var require_destroy = __commonJS({
  "node_modules/destroy/index.js"(exports2, module2) {
    "use strict";
    var ReadStream = require("fs").ReadStream;
    var Stream = require("stream");
    module2.exports = destroy;
    function destroy(stream) {
      if (stream instanceof ReadStream) {
        return destroyReadStream(stream);
      }
      if (!(stream instanceof Stream)) {
        return stream;
      }
      if (typeof stream.destroy === "function") {
        stream.destroy();
      }
      return stream;
    }
    function destroyReadStream(stream) {
      stream.destroy();
      if (typeof stream.close === "function") {
        stream.on("open", onOpenClose);
      }
      return stream;
    }
    function onOpenClose() {
      if (typeof this.fd === "number") {
        this.close();
      }
    }
  }
});

// node_modules/etag/index.js
var require_etag = __commonJS({
  "node_modules/etag/index.js"(exports2, module2) {
    "use strict";
    module2.exports = etag;
    var crypto = require("crypto");
    var Stats = require("fs").Stats;
    var toString2 = Object.prototype.toString;
    function entitytag(entity) {
      if (entity.length === 0) {
        return '"0-2jmj7l5rSw0yVb/vlWAYkK/YBwk"';
      }
      var hash = crypto.createHash("sha1").update(entity, "utf8").digest("base64").substring(0, 27);
      var len = typeof entity === "string" ? Buffer.byteLength(entity, "utf8") : entity.length;
      return '"' + len.toString(16) + "-" + hash + '"';
    }
    function etag(entity, options) {
      if (entity == null) {
        throw new TypeError("argument entity is required");
      }
      var isStats = isstats(entity);
      var weak = options && typeof options.weak === "boolean" ? options.weak : isStats;
      if (!isStats && typeof entity !== "string" && !Buffer.isBuffer(entity)) {
        throw new TypeError("argument entity must be string, Buffer, or fs.Stats");
      }
      var tag = isStats ? stattag(entity) : entitytag(entity);
      return weak ? "W/" + tag : tag;
    }
    function isstats(obj) {
      if (typeof Stats === "function" && obj instanceof Stats) {
        return true;
      }
      return obj && typeof obj === "object" && "ctime" in obj && toString2.call(obj.ctime) === "[object Date]" && "mtime" in obj && toString2.call(obj.mtime) === "[object Date]" && "ino" in obj && typeof obj.ino === "number" && "size" in obj && typeof obj.size === "number";
    }
    function stattag(stat2) {
      var mtime = stat2.mtime.getTime().toString(16);
      var size = stat2.size.toString(16);
      return '"' + size + "-" + mtime + '"';
    }
  }
});

// node_modules/fresh/index.js
var require_fresh = __commonJS({
  "node_modules/fresh/index.js"(exports2, module2) {
    "use strict";
    var CACHE_CONTROL_NO_CACHE_REGEXP = /(?:^|,)\s*?no-cache\s*?(?:,|$)/;
    module2.exports = fresh;
    function fresh(reqHeaders, resHeaders) {
      var modifiedSince = reqHeaders["if-modified-since"];
      var noneMatch = reqHeaders["if-none-match"];
      if (!modifiedSince && !noneMatch) {
        return false;
      }
      var cacheControl = reqHeaders["cache-control"];
      if (cacheControl && CACHE_CONTROL_NO_CACHE_REGEXP.test(cacheControl)) {
        return false;
      }
      if (noneMatch && noneMatch !== "*") {
        var etag = resHeaders["etag"];
        if (!etag) {
          return false;
        }
        var etagStale = true;
        var matches = parseTokenList(noneMatch);
        for (var i = 0; i < matches.length; i++) {
          var match = matches[i];
          if (match === etag || match === "W/" + etag || "W/" + match === etag) {
            etagStale = false;
            break;
          }
        }
        if (etagStale) {
          return false;
        }
      }
      if (modifiedSince) {
        var lastModified = resHeaders["last-modified"];
        var modifiedStale = !lastModified || !(parseHttpDate(lastModified) <= parseHttpDate(modifiedSince));
        if (modifiedStale) {
          return false;
        }
      }
      return true;
    }
    function parseHttpDate(date) {
      var timestamp = date && Date.parse(date);
      return typeof timestamp === "number" ? timestamp : NaN;
    }
    function parseTokenList(str2) {
      var end = 0;
      var list = [];
      var start = 0;
      for (var i = 0, len = str2.length; i < len; i++) {
        switch (str2.charCodeAt(i)) {
          case 32:
            if (start === end) {
              start = end = i + 1;
            }
            break;
          case 44:
            list.push(str2.substring(start, end));
            start = end = i + 1;
            break;
          default:
            end = i + 1;
            break;
        }
      }
      list.push(str2.substring(start, end));
      return list;
    }
  }
});

// node_modules/mime/types.json
var require_types3 = __commonJS({
  "node_modules/mime/types.json"(exports2, module2) {
    module2.exports = {"application/andrew-inset": ["ez"], "application/applixware": ["aw"], "application/atom+xml": ["atom"], "application/atomcat+xml": ["atomcat"], "application/atomsvc+xml": ["atomsvc"], "application/bdoc": ["bdoc"], "application/ccxml+xml": ["ccxml"], "application/cdmi-capability": ["cdmia"], "application/cdmi-container": ["cdmic"], "application/cdmi-domain": ["cdmid"], "application/cdmi-object": ["cdmio"], "application/cdmi-queue": ["cdmiq"], "application/cu-seeme": ["cu"], "application/dash+xml": ["mpd"], "application/davmount+xml": ["davmount"], "application/docbook+xml": ["dbk"], "application/dssc+der": ["dssc"], "application/dssc+xml": ["xdssc"], "application/ecmascript": ["ecma"], "application/emma+xml": ["emma"], "application/epub+zip": ["epub"], "application/exi": ["exi"], "application/font-tdpfr": ["pfr"], "application/font-woff": [], "application/font-woff2": [], "application/geo+json": ["geojson"], "application/gml+xml": ["gml"], "application/gpx+xml": ["gpx"], "application/gxf": ["gxf"], "application/gzip": ["gz"], "application/hyperstudio": ["stk"], "application/inkml+xml": ["ink", "inkml"], "application/ipfix": ["ipfix"], "application/java-archive": ["jar", "war", "ear"], "application/java-serialized-object": ["ser"], "application/java-vm": ["class"], "application/javascript": ["js", "mjs"], "application/json": ["json", "map"], "application/json5": ["json5"], "application/jsonml+json": ["jsonml"], "application/ld+json": ["jsonld"], "application/lost+xml": ["lostxml"], "application/mac-binhex40": ["hqx"], "application/mac-compactpro": ["cpt"], "application/mads+xml": ["mads"], "application/manifest+json": ["webmanifest"], "application/marc": ["mrc"], "application/marcxml+xml": ["mrcx"], "application/mathematica": ["ma", "nb", "mb"], "application/mathml+xml": ["mathml"], "application/mbox": ["mbox"], "application/mediaservercontrol+xml": ["mscml"], "application/metalink+xml": ["metalink"], "application/metalink4+xml": ["meta4"], "application/mets+xml": ["mets"], "application/mods+xml": ["mods"], "application/mp21": ["m21", "mp21"], "application/mp4": ["mp4s", "m4p"], "application/msword": ["doc", "dot"], "application/mxf": ["mxf"], "application/octet-stream": ["bin", "dms", "lrf", "mar", "so", "dist", "distz", "pkg", "bpk", "dump", "elc", "deploy", "exe", "dll", "deb", "dmg", "iso", "img", "msi", "msp", "msm", "buffer"], "application/oda": ["oda"], "application/oebps-package+xml": ["opf"], "application/ogg": ["ogx"], "application/omdoc+xml": ["omdoc"], "application/onenote": ["onetoc", "onetoc2", "onetmp", "onepkg"], "application/oxps": ["oxps"], "application/patch-ops-error+xml": ["xer"], "application/pdf": ["pdf"], "application/pgp-encrypted": ["pgp"], "application/pgp-signature": ["asc", "sig"], "application/pics-rules": ["prf"], "application/pkcs10": ["p10"], "application/pkcs7-mime": ["p7m", "p7c"], "application/pkcs7-signature": ["p7s"], "application/pkcs8": ["p8"], "application/pkix-attr-cert": ["ac"], "application/pkix-cert": ["cer"], "application/pkix-crl": ["crl"], "application/pkix-pkipath": ["pkipath"], "application/pkixcmp": ["pki"], "application/pls+xml": ["pls"], "application/postscript": ["ai", "eps", "ps"], "application/prs.cww": ["cww"], "application/pskc+xml": ["pskcxml"], "application/raml+yaml": ["raml"], "application/rdf+xml": ["rdf"], "application/reginfo+xml": ["rif"], "application/relax-ng-compact-syntax": ["rnc"], "application/resource-lists+xml": ["rl"], "application/resource-lists-diff+xml": ["rld"], "application/rls-services+xml": ["rs"], "application/rpki-ghostbusters": ["gbr"], "application/rpki-manifest": ["mft"], "application/rpki-roa": ["roa"], "application/rsd+xml": ["rsd"], "application/rss+xml": ["rss"], "application/rtf": ["rtf"], "application/sbml+xml": ["sbml"], "application/scvp-cv-request": ["scq"], "application/scvp-cv-response": ["scs"], "application/scvp-vp-request": ["spq"], "application/scvp-vp-response": ["spp"], "application/sdp": ["sdp"], "application/set-payment-initiation": ["setpay"], "application/set-registration-initiation": ["setreg"], "application/shf+xml": ["shf"], "application/smil+xml": ["smi", "smil"], "application/sparql-query": ["rq"], "application/sparql-results+xml": ["srx"], "application/srgs": ["gram"], "application/srgs+xml": ["grxml"], "application/sru+xml": ["sru"], "application/ssdl+xml": ["ssdl"], "application/ssml+xml": ["ssml"], "application/tei+xml": ["tei", "teicorpus"], "application/thraud+xml": ["tfi"], "application/timestamped-data": ["tsd"], "application/vnd.3gpp.pic-bw-large": ["plb"], "application/vnd.3gpp.pic-bw-small": ["psb"], "application/vnd.3gpp.pic-bw-var": ["pvb"], "application/vnd.3gpp2.tcap": ["tcap"], "application/vnd.3m.post-it-notes": ["pwn"], "application/vnd.accpac.simply.aso": ["aso"], "application/vnd.accpac.simply.imp": ["imp"], "application/vnd.acucobol": ["acu"], "application/vnd.acucorp": ["atc", "acutc"], "application/vnd.adobe.air-application-installer-package+zip": ["air"], "application/vnd.adobe.formscentral.fcdt": ["fcdt"], "application/vnd.adobe.fxp": ["fxp", "fxpl"], "application/vnd.adobe.xdp+xml": ["xdp"], "application/vnd.adobe.xfdf": ["xfdf"], "application/vnd.ahead.space": ["ahead"], "application/vnd.airzip.filesecure.azf": ["azf"], "application/vnd.airzip.filesecure.azs": ["azs"], "application/vnd.amazon.ebook": ["azw"], "application/vnd.americandynamics.acc": ["acc"], "application/vnd.amiga.ami": ["ami"], "application/vnd.android.package-archive": ["apk"], "application/vnd.anser-web-certificate-issue-initiation": ["cii"], "application/vnd.anser-web-funds-transfer-initiation": ["fti"], "application/vnd.antix.game-component": ["atx"], "application/vnd.apple.installer+xml": ["mpkg"], "application/vnd.apple.mpegurl": ["m3u8"], "application/vnd.apple.pkpass": ["pkpass"], "application/vnd.aristanetworks.swi": ["swi"], "application/vnd.astraea-software.iota": ["iota"], "application/vnd.audiograph": ["aep"], "application/vnd.blueice.multipass": ["mpm"], "application/vnd.bmi": ["bmi"], "application/vnd.businessobjects": ["rep"], "application/vnd.chemdraw+xml": ["cdxml"], "application/vnd.chipnuts.karaoke-mmd": ["mmd"], "application/vnd.cinderella": ["cdy"], "application/vnd.claymore": ["cla"], "application/vnd.cloanto.rp9": ["rp9"], "application/vnd.clonk.c4group": ["c4g", "c4d", "c4f", "c4p", "c4u"], "application/vnd.cluetrust.cartomobile-config": ["c11amc"], "application/vnd.cluetrust.cartomobile-config-pkg": ["c11amz"], "application/vnd.commonspace": ["csp"], "application/vnd.contact.cmsg": ["cdbcmsg"], "application/vnd.cosmocaller": ["cmc"], "application/vnd.crick.clicker": ["clkx"], "application/vnd.crick.clicker.keyboard": ["clkk"], "application/vnd.crick.clicker.palette": ["clkp"], "application/vnd.crick.clicker.template": ["clkt"], "application/vnd.crick.clicker.wordbank": ["clkw"], "application/vnd.criticaltools.wbs+xml": ["wbs"], "application/vnd.ctc-posml": ["pml"], "application/vnd.cups-ppd": ["ppd"], "application/vnd.curl.car": ["car"], "application/vnd.curl.pcurl": ["pcurl"], "application/vnd.dart": ["dart"], "application/vnd.data-vision.rdz": ["rdz"], "application/vnd.dece.data": ["uvf", "uvvf", "uvd", "uvvd"], "application/vnd.dece.ttml+xml": ["uvt", "uvvt"], "application/vnd.dece.unspecified": ["uvx", "uvvx"], "application/vnd.dece.zip": ["uvz", "uvvz"], "application/vnd.denovo.fcselayout-link": ["fe_launch"], "application/vnd.dna": ["dna"], "application/vnd.dolby.mlp": ["mlp"], "application/vnd.dpgraph": ["dpg"], "application/vnd.dreamfactory": ["dfac"], "application/vnd.ds-keypoint": ["kpxx"], "application/vnd.dvb.ait": ["ait"], "application/vnd.dvb.service": ["svc"], "application/vnd.dynageo": ["geo"], "application/vnd.ecowin.chart": ["mag"], "application/vnd.enliven": ["nml"], "application/vnd.epson.esf": ["esf"], "application/vnd.epson.msf": ["msf"], "application/vnd.epson.quickanime": ["qam"], "application/vnd.epson.salt": ["slt"], "application/vnd.epson.ssf": ["ssf"], "application/vnd.eszigno3+xml": ["es3", "et3"], "application/vnd.ezpix-album": ["ez2"], "application/vnd.ezpix-package": ["ez3"], "application/vnd.fdf": ["fdf"], "application/vnd.fdsn.mseed": ["mseed"], "application/vnd.fdsn.seed": ["seed", "dataless"], "application/vnd.flographit": ["gph"], "application/vnd.fluxtime.clip": ["ftc"], "application/vnd.framemaker": ["fm", "frame", "maker", "book"], "application/vnd.frogans.fnc": ["fnc"], "application/vnd.frogans.ltf": ["ltf"], "application/vnd.fsc.weblaunch": ["fsc"], "application/vnd.fujitsu.oasys": ["oas"], "application/vnd.fujitsu.oasys2": ["oa2"], "application/vnd.fujitsu.oasys3": ["oa3"], "application/vnd.fujitsu.oasysgp": ["fg5"], "application/vnd.fujitsu.oasysprs": ["bh2"], "application/vnd.fujixerox.ddd": ["ddd"], "application/vnd.fujixerox.docuworks": ["xdw"], "application/vnd.fujixerox.docuworks.binder": ["xbd"], "application/vnd.fuzzysheet": ["fzs"], "application/vnd.genomatix.tuxedo": ["txd"], "application/vnd.geogebra.file": ["ggb"], "application/vnd.geogebra.tool": ["ggt"], "application/vnd.geometry-explorer": ["gex", "gre"], "application/vnd.geonext": ["gxt"], "application/vnd.geoplan": ["g2w"], "application/vnd.geospace": ["g3w"], "application/vnd.gmx": ["gmx"], "application/vnd.google-apps.document": ["gdoc"], "application/vnd.google-apps.presentation": ["gslides"], "application/vnd.google-apps.spreadsheet": ["gsheet"], "application/vnd.google-earth.kml+xml": ["kml"], "application/vnd.google-earth.kmz": ["kmz"], "application/vnd.grafeq": ["gqf", "gqs"], "application/vnd.groove-account": ["gac"], "application/vnd.groove-help": ["ghf"], "application/vnd.groove-identity-message": ["gim"], "application/vnd.groove-injector": ["grv"], "application/vnd.groove-tool-message": ["gtm"], "application/vnd.groove-tool-template": ["tpl"], "application/vnd.groove-vcard": ["vcg"], "application/vnd.hal+xml": ["hal"], "application/vnd.handheld-entertainment+xml": ["zmm"], "application/vnd.hbci": ["hbci"], "application/vnd.hhe.lesson-player": ["les"], "application/vnd.hp-hpgl": ["hpgl"], "application/vnd.hp-hpid": ["hpid"], "application/vnd.hp-hps": ["hps"], "application/vnd.hp-jlyt": ["jlt"], "application/vnd.hp-pcl": ["pcl"], "application/vnd.hp-pclxl": ["pclxl"], "application/vnd.hydrostatix.sof-data": ["sfd-hdstx"], "application/vnd.ibm.minipay": ["mpy"], "application/vnd.ibm.modcap": ["afp", "listafp", "list3820"], "application/vnd.ibm.rights-management": ["irm"], "application/vnd.ibm.secure-container": ["sc"], "application/vnd.iccprofile": ["icc", "icm"], "application/vnd.igloader": ["igl"], "application/vnd.immervision-ivp": ["ivp"], "application/vnd.immervision-ivu": ["ivu"], "application/vnd.insors.igm": ["igm"], "application/vnd.intercon.formnet": ["xpw", "xpx"], "application/vnd.intergeo": ["i2g"], "application/vnd.intu.qbo": ["qbo"], "application/vnd.intu.qfx": ["qfx"], "application/vnd.ipunplugged.rcprofile": ["rcprofile"], "application/vnd.irepository.package+xml": ["irp"], "application/vnd.is-xpr": ["xpr"], "application/vnd.isac.fcs": ["fcs"], "application/vnd.jam": ["jam"], "application/vnd.jcp.javame.midlet-rms": ["rms"], "application/vnd.jisp": ["jisp"], "application/vnd.joost.joda-archive": ["joda"], "application/vnd.kahootz": ["ktz", "ktr"], "application/vnd.kde.karbon": ["karbon"], "application/vnd.kde.kchart": ["chrt"], "application/vnd.kde.kformula": ["kfo"], "application/vnd.kde.kivio": ["flw"], "application/vnd.kde.kontour": ["kon"], "application/vnd.kde.kpresenter": ["kpr", "kpt"], "application/vnd.kde.kspread": ["ksp"], "application/vnd.kde.kword": ["kwd", "kwt"], "application/vnd.kenameaapp": ["htke"], "application/vnd.kidspiration": ["kia"], "application/vnd.kinar": ["kne", "knp"], "application/vnd.koan": ["skp", "skd", "skt", "skm"], "application/vnd.kodak-descriptor": ["sse"], "application/vnd.las.las+xml": ["lasxml"], "application/vnd.llamagraphics.life-balance.desktop": ["lbd"], "application/vnd.llamagraphics.life-balance.exchange+xml": ["lbe"], "application/vnd.lotus-1-2-3": ["123"], "application/vnd.lotus-approach": ["apr"], "application/vnd.lotus-freelance": ["pre"], "application/vnd.lotus-notes": ["nsf"], "application/vnd.lotus-organizer": ["org"], "application/vnd.lotus-screencam": ["scm"], "application/vnd.lotus-wordpro": ["lwp"], "application/vnd.macports.portpkg": ["portpkg"], "application/vnd.mcd": ["mcd"], "application/vnd.medcalcdata": ["mc1"], "application/vnd.mediastation.cdkey": ["cdkey"], "application/vnd.mfer": ["mwf"], "application/vnd.mfmp": ["mfm"], "application/vnd.micrografx.flo": ["flo"], "application/vnd.micrografx.igx": ["igx"], "application/vnd.mif": ["mif"], "application/vnd.mobius.daf": ["daf"], "application/vnd.mobius.dis": ["dis"], "application/vnd.mobius.mbk": ["mbk"], "application/vnd.mobius.mqy": ["mqy"], "application/vnd.mobius.msl": ["msl"], "application/vnd.mobius.plc": ["plc"], "application/vnd.mobius.txf": ["txf"], "application/vnd.mophun.application": ["mpn"], "application/vnd.mophun.certificate": ["mpc"], "application/vnd.mozilla.xul+xml": ["xul"], "application/vnd.ms-artgalry": ["cil"], "application/vnd.ms-cab-compressed": ["cab"], "application/vnd.ms-excel": ["xls", "xlm", "xla", "xlc", "xlt", "xlw"], "application/vnd.ms-excel.addin.macroenabled.12": ["xlam"], "application/vnd.ms-excel.sheet.binary.macroenabled.12": ["xlsb"], "application/vnd.ms-excel.sheet.macroenabled.12": ["xlsm"], "application/vnd.ms-excel.template.macroenabled.12": ["xltm"], "application/vnd.ms-fontobject": ["eot"], "application/vnd.ms-htmlhelp": ["chm"], "application/vnd.ms-ims": ["ims"], "application/vnd.ms-lrm": ["lrm"], "application/vnd.ms-officetheme": ["thmx"], "application/vnd.ms-outlook": ["msg"], "application/vnd.ms-pki.seccat": ["cat"], "application/vnd.ms-pki.stl": ["stl"], "application/vnd.ms-powerpoint": ["ppt", "pps", "pot"], "application/vnd.ms-powerpoint.addin.macroenabled.12": ["ppam"], "application/vnd.ms-powerpoint.presentation.macroenabled.12": ["pptm"], "application/vnd.ms-powerpoint.slide.macroenabled.12": ["sldm"], "application/vnd.ms-powerpoint.slideshow.macroenabled.12": ["ppsm"], "application/vnd.ms-powerpoint.template.macroenabled.12": ["potm"], "application/vnd.ms-project": ["mpp", "mpt"], "application/vnd.ms-word.document.macroenabled.12": ["docm"], "application/vnd.ms-word.template.macroenabled.12": ["dotm"], "application/vnd.ms-works": ["wps", "wks", "wcm", "wdb"], "application/vnd.ms-wpl": ["wpl"], "application/vnd.ms-xpsdocument": ["xps"], "application/vnd.mseq": ["mseq"], "application/vnd.musician": ["mus"], "application/vnd.muvee.style": ["msty"], "application/vnd.mynfc": ["taglet"], "application/vnd.neurolanguage.nlu": ["nlu"], "application/vnd.nitf": ["ntf", "nitf"], "application/vnd.noblenet-directory": ["nnd"], "application/vnd.noblenet-sealer": ["nns"], "application/vnd.noblenet-web": ["nnw"], "application/vnd.nokia.n-gage.data": ["ngdat"], "application/vnd.nokia.n-gage.symbian.install": ["n-gage"], "application/vnd.nokia.radio-preset": ["rpst"], "application/vnd.nokia.radio-presets": ["rpss"], "application/vnd.novadigm.edm": ["edm"], "application/vnd.novadigm.edx": ["edx"], "application/vnd.novadigm.ext": ["ext"], "application/vnd.oasis.opendocument.chart": ["odc"], "application/vnd.oasis.opendocument.chart-template": ["otc"], "application/vnd.oasis.opendocument.database": ["odb"], "application/vnd.oasis.opendocument.formula": ["odf"], "application/vnd.oasis.opendocument.formula-template": ["odft"], "application/vnd.oasis.opendocument.graphics": ["odg"], "application/vnd.oasis.opendocument.graphics-template": ["otg"], "application/vnd.oasis.opendocument.image": ["odi"], "application/vnd.oasis.opendocument.image-template": ["oti"], "application/vnd.oasis.opendocument.presentation": ["odp"], "application/vnd.oasis.opendocument.presentation-template": ["otp"], "application/vnd.oasis.opendocument.spreadsheet": ["ods"], "application/vnd.oasis.opendocument.spreadsheet-template": ["ots"], "application/vnd.oasis.opendocument.text": ["odt"], "application/vnd.oasis.opendocument.text-master": ["odm"], "application/vnd.oasis.opendocument.text-template": ["ott"], "application/vnd.oasis.opendocument.text-web": ["oth"], "application/vnd.olpc-sugar": ["xo"], "application/vnd.oma.dd2+xml": ["dd2"], "application/vnd.openofficeorg.extension": ["oxt"], "application/vnd.openxmlformats-officedocument.presentationml.presentation": ["pptx"], "application/vnd.openxmlformats-officedocument.presentationml.slide": ["sldx"], "application/vnd.openxmlformats-officedocument.presentationml.slideshow": ["ppsx"], "application/vnd.openxmlformats-officedocument.presentationml.template": ["potx"], "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet": ["xlsx"], "application/vnd.openxmlformats-officedocument.spreadsheetml.template": ["xltx"], "application/vnd.openxmlformats-officedocument.wordprocessingml.document": ["docx"], "application/vnd.openxmlformats-officedocument.wordprocessingml.template": ["dotx"], "application/vnd.osgeo.mapguide.package": ["mgp"], "application/vnd.osgi.dp": ["dp"], "application/vnd.osgi.subsystem": ["esa"], "application/vnd.palm": ["pdb", "pqa", "oprc"], "application/vnd.pawaafile": ["paw"], "application/vnd.pg.format": ["str"], "application/vnd.pg.osasli": ["ei6"], "application/vnd.picsel": ["efif"], "application/vnd.pmi.widget": ["wg"], "application/vnd.pocketlearn": ["plf"], "application/vnd.powerbuilder6": ["pbd"], "application/vnd.previewsystems.box": ["box"], "application/vnd.proteus.magazine": ["mgz"], "application/vnd.publishare-delta-tree": ["qps"], "application/vnd.pvi.ptid1": ["ptid"], "application/vnd.quark.quarkxpress": ["qxd", "qxt", "qwd", "qwt", "qxl", "qxb"], "application/vnd.realvnc.bed": ["bed"], "application/vnd.recordare.musicxml": ["mxl"], "application/vnd.recordare.musicxml+xml": ["musicxml"], "application/vnd.rig.cryptonote": ["cryptonote"], "application/vnd.rim.cod": ["cod"], "application/vnd.rn-realmedia": ["rm"], "application/vnd.rn-realmedia-vbr": ["rmvb"], "application/vnd.route66.link66+xml": ["link66"], "application/vnd.sailingtracker.track": ["st"], "application/vnd.seemail": ["see"], "application/vnd.sema": ["sema"], "application/vnd.semd": ["semd"], "application/vnd.semf": ["semf"], "application/vnd.shana.informed.formdata": ["ifm"], "application/vnd.shana.informed.formtemplate": ["itp"], "application/vnd.shana.informed.interchange": ["iif"], "application/vnd.shana.informed.package": ["ipk"], "application/vnd.simtech-mindmapper": ["twd", "twds"], "application/vnd.smaf": ["mmf"], "application/vnd.smart.teacher": ["teacher"], "application/vnd.solent.sdkm+xml": ["sdkm", "sdkd"], "application/vnd.spotfire.dxp": ["dxp"], "application/vnd.spotfire.sfs": ["sfs"], "application/vnd.stardivision.calc": ["sdc"], "application/vnd.stardivision.draw": ["sda"], "application/vnd.stardivision.impress": ["sdd"], "application/vnd.stardivision.math": ["smf"], "application/vnd.stardivision.writer": ["sdw", "vor"], "application/vnd.stardivision.writer-global": ["sgl"], "application/vnd.stepmania.package": ["smzip"], "application/vnd.stepmania.stepchart": ["sm"], "application/vnd.sun.wadl+xml": ["wadl"], "application/vnd.sun.xml.calc": ["sxc"], "application/vnd.sun.xml.calc.template": ["stc"], "application/vnd.sun.xml.draw": ["sxd"], "application/vnd.sun.xml.draw.template": ["std"], "application/vnd.sun.xml.impress": ["sxi"], "application/vnd.sun.xml.impress.template": ["sti"], "application/vnd.sun.xml.math": ["sxm"], "application/vnd.sun.xml.writer": ["sxw"], "application/vnd.sun.xml.writer.global": ["sxg"], "application/vnd.sun.xml.writer.template": ["stw"], "application/vnd.sus-calendar": ["sus", "susp"], "application/vnd.svd": ["svd"], "application/vnd.symbian.install": ["sis", "sisx"], "application/vnd.syncml+xml": ["xsm"], "application/vnd.syncml.dm+wbxml": ["bdm"], "application/vnd.syncml.dm+xml": ["xdm"], "application/vnd.tao.intent-module-archive": ["tao"], "application/vnd.tcpdump.pcap": ["pcap", "cap", "dmp"], "application/vnd.tmobile-livetv": ["tmo"], "application/vnd.trid.tpt": ["tpt"], "application/vnd.triscape.mxs": ["mxs"], "application/vnd.trueapp": ["tra"], "application/vnd.ufdl": ["ufd", "ufdl"], "application/vnd.uiq.theme": ["utz"], "application/vnd.umajin": ["umj"], "application/vnd.unity": ["unityweb"], "application/vnd.uoml+xml": ["uoml"], "application/vnd.vcx": ["vcx"], "application/vnd.visio": ["vsd", "vst", "vss", "vsw"], "application/vnd.visionary": ["vis"], "application/vnd.vsf": ["vsf"], "application/vnd.wap.wbxml": ["wbxml"], "application/vnd.wap.wmlc": ["wmlc"], "application/vnd.wap.wmlscriptc": ["wmlsc"], "application/vnd.webturbo": ["wtb"], "application/vnd.wolfram.player": ["nbp"], "application/vnd.wordperfect": ["wpd"], "application/vnd.wqd": ["wqd"], "application/vnd.wt.stf": ["stf"], "application/vnd.xara": ["xar"], "application/vnd.xfdl": ["xfdl"], "application/vnd.yamaha.hv-dic": ["hvd"], "application/vnd.yamaha.hv-script": ["hvs"], "application/vnd.yamaha.hv-voice": ["hvp"], "application/vnd.yamaha.openscoreformat": ["osf"], "application/vnd.yamaha.openscoreformat.osfpvg+xml": ["osfpvg"], "application/vnd.yamaha.smaf-audio": ["saf"], "application/vnd.yamaha.smaf-phrase": ["spf"], "application/vnd.yellowriver-custom-menu": ["cmp"], "application/vnd.zul": ["zir", "zirz"], "application/vnd.zzazz.deck+xml": ["zaz"], "application/voicexml+xml": ["vxml"], "application/wasm": ["wasm"], "application/widget": ["wgt"], "application/winhlp": ["hlp"], "application/wsdl+xml": ["wsdl"], "application/wspolicy+xml": ["wspolicy"], "application/x-7z-compressed": ["7z"], "application/x-abiword": ["abw"], "application/x-ace-compressed": ["ace"], "application/x-apple-diskimage": [], "application/x-arj": ["arj"], "application/x-authorware-bin": ["aab", "x32", "u32", "vox"], "application/x-authorware-map": ["aam"], "application/x-authorware-seg": ["aas"], "application/x-bcpio": ["bcpio"], "application/x-bdoc": [], "application/x-bittorrent": ["torrent"], "application/x-blorb": ["blb", "blorb"], "application/x-bzip": ["bz"], "application/x-bzip2": ["bz2", "boz"], "application/x-cbr": ["cbr", "cba", "cbt", "cbz", "cb7"], "application/x-cdlink": ["vcd"], "application/x-cfs-compressed": ["cfs"], "application/x-chat": ["chat"], "application/x-chess-pgn": ["pgn"], "application/x-chrome-extension": ["crx"], "application/x-cocoa": ["cco"], "application/x-conference": ["nsc"], "application/x-cpio": ["cpio"], "application/x-csh": ["csh"], "application/x-debian-package": ["udeb"], "application/x-dgc-compressed": ["dgc"], "application/x-director": ["dir", "dcr", "dxr", "cst", "cct", "cxt", "w3d", "fgd", "swa"], "application/x-doom": ["wad"], "application/x-dtbncx+xml": ["ncx"], "application/x-dtbook+xml": ["dtb"], "application/x-dtbresource+xml": ["res"], "application/x-dvi": ["dvi"], "application/x-envoy": ["evy"], "application/x-eva": ["eva"], "application/x-font-bdf": ["bdf"], "application/x-font-ghostscript": ["gsf"], "application/x-font-linux-psf": ["psf"], "application/x-font-pcf": ["pcf"], "application/x-font-snf": ["snf"], "application/x-font-type1": ["pfa", "pfb", "pfm", "afm"], "application/x-freearc": ["arc"], "application/x-futuresplash": ["spl"], "application/x-gca-compressed": ["gca"], "application/x-glulx": ["ulx"], "application/x-gnumeric": ["gnumeric"], "application/x-gramps-xml": ["gramps"], "application/x-gtar": ["gtar"], "application/x-hdf": ["hdf"], "application/x-httpd-php": ["php"], "application/x-install-instructions": ["install"], "application/x-iso9660-image": [], "application/x-java-archive-diff": ["jardiff"], "application/x-java-jnlp-file": ["jnlp"], "application/x-latex": ["latex"], "application/x-lua-bytecode": ["luac"], "application/x-lzh-compressed": ["lzh", "lha"], "application/x-makeself": ["run"], "application/x-mie": ["mie"], "application/x-mobipocket-ebook": ["prc", "mobi"], "application/x-ms-application": ["application"], "application/x-ms-shortcut": ["lnk"], "application/x-ms-wmd": ["wmd"], "application/x-ms-wmz": ["wmz"], "application/x-ms-xbap": ["xbap"], "application/x-msaccess": ["mdb"], "application/x-msbinder": ["obd"], "application/x-mscardfile": ["crd"], "application/x-msclip": ["clp"], "application/x-msdos-program": [], "application/x-msdownload": ["com", "bat"], "application/x-msmediaview": ["mvb", "m13", "m14"], "application/x-msmetafile": ["wmf", "emf", "emz"], "application/x-msmoney": ["mny"], "application/x-mspublisher": ["pub"], "application/x-msschedule": ["scd"], "application/x-msterminal": ["trm"], "application/x-mswrite": ["wri"], "application/x-netcdf": ["nc", "cdf"], "application/x-ns-proxy-autoconfig": ["pac"], "application/x-nzb": ["nzb"], "application/x-perl": ["pl", "pm"], "application/x-pilot": [], "application/x-pkcs12": ["p12", "pfx"], "application/x-pkcs7-certificates": ["p7b", "spc"], "application/x-pkcs7-certreqresp": ["p7r"], "application/x-rar-compressed": ["rar"], "application/x-redhat-package-manager": ["rpm"], "application/x-research-info-systems": ["ris"], "application/x-sea": ["sea"], "application/x-sh": ["sh"], "application/x-shar": ["shar"], "application/x-shockwave-flash": ["swf"], "application/x-silverlight-app": ["xap"], "application/x-sql": ["sql"], "application/x-stuffit": ["sit"], "application/x-stuffitx": ["sitx"], "application/x-subrip": ["srt"], "application/x-sv4cpio": ["sv4cpio"], "application/x-sv4crc": ["sv4crc"], "application/x-t3vm-image": ["t3"], "application/x-tads": ["gam"], "application/x-tar": ["tar"], "application/x-tcl": ["tcl", "tk"], "application/x-tex": ["tex"], "application/x-tex-tfm": ["tfm"], "application/x-texinfo": ["texinfo", "texi"], "application/x-tgif": ["obj"], "application/x-ustar": ["ustar"], "application/x-virtualbox-hdd": ["hdd"], "application/x-virtualbox-ova": ["ova"], "application/x-virtualbox-ovf": ["ovf"], "application/x-virtualbox-vbox": ["vbox"], "application/x-virtualbox-vbox-extpack": ["vbox-extpack"], "application/x-virtualbox-vdi": ["vdi"], "application/x-virtualbox-vhd": ["vhd"], "application/x-virtualbox-vmdk": ["vmdk"], "application/x-wais-source": ["src"], "application/x-web-app-manifest+json": ["webapp"], "application/x-x509-ca-cert": ["der", "crt", "pem"], "application/x-xfig": ["fig"], "application/x-xliff+xml": ["xlf"], "application/x-xpinstall": ["xpi"], "application/x-xz": ["xz"], "application/x-zmachine": ["z1", "z2", "z3", "z4", "z5", "z6", "z7", "z8"], "application/xaml+xml": ["xaml"], "application/xcap-diff+xml": ["xdf"], "application/xenc+xml": ["xenc"], "application/xhtml+xml": ["xhtml", "xht"], "application/xml": ["xml", "xsl", "xsd", "rng"], "application/xml-dtd": ["dtd"], "application/xop+xml": ["xop"], "application/xproc+xml": ["xpl"], "application/xslt+xml": ["xslt"], "application/xspf+xml": ["xspf"], "application/xv+xml": ["mxml", "xhvml", "xvml", "xvm"], "application/yang": ["yang"], "application/yin+xml": ["yin"], "application/zip": ["zip"], "audio/3gpp": [], "audio/adpcm": ["adp"], "audio/basic": ["au", "snd"], "audio/midi": ["mid", "midi", "kar", "rmi"], "audio/mp3": [], "audio/mp4": ["m4a", "mp4a"], "audio/mpeg": ["mpga", "mp2", "mp2a", "mp3", "m2a", "m3a"], "audio/ogg": ["oga", "ogg", "spx"], "audio/s3m": ["s3m"], "audio/silk": ["sil"], "audio/vnd.dece.audio": ["uva", "uvva"], "audio/vnd.digital-winds": ["eol"], "audio/vnd.dra": ["dra"], "audio/vnd.dts": ["dts"], "audio/vnd.dts.hd": ["dtshd"], "audio/vnd.lucent.voice": ["lvp"], "audio/vnd.ms-playready.media.pya": ["pya"], "audio/vnd.nuera.ecelp4800": ["ecelp4800"], "audio/vnd.nuera.ecelp7470": ["ecelp7470"], "audio/vnd.nuera.ecelp9600": ["ecelp9600"], "audio/vnd.rip": ["rip"], "audio/wav": ["wav"], "audio/wave": [], "audio/webm": ["weba"], "audio/x-aac": ["aac"], "audio/x-aiff": ["aif", "aiff", "aifc"], "audio/x-caf": ["caf"], "audio/x-flac": ["flac"], "audio/x-m4a": [], "audio/x-matroska": ["mka"], "audio/x-mpegurl": ["m3u"], "audio/x-ms-wax": ["wax"], "audio/x-ms-wma": ["wma"], "audio/x-pn-realaudio": ["ram", "ra"], "audio/x-pn-realaudio-plugin": ["rmp"], "audio/x-realaudio": [], "audio/x-wav": [], "audio/xm": ["xm"], "chemical/x-cdx": ["cdx"], "chemical/x-cif": ["cif"], "chemical/x-cmdf": ["cmdf"], "chemical/x-cml": ["cml"], "chemical/x-csml": ["csml"], "chemical/x-xyz": ["xyz"], "font/collection": ["ttc"], "font/otf": ["otf"], "font/ttf": ["ttf"], "font/woff": ["woff"], "font/woff2": ["woff2"], "image/apng": ["apng"], "image/bmp": ["bmp"], "image/cgm": ["cgm"], "image/g3fax": ["g3"], "image/gif": ["gif"], "image/ief": ["ief"], "image/jp2": ["jp2", "jpg2"], "image/jpeg": ["jpeg", "jpg", "jpe"], "image/jpm": ["jpm"], "image/jpx": ["jpx", "jpf"], "image/ktx": ["ktx"], "image/png": ["png"], "image/prs.btif": ["btif"], "image/sgi": ["sgi"], "image/svg+xml": ["svg", "svgz"], "image/tiff": ["tiff", "tif"], "image/vnd.adobe.photoshop": ["psd"], "image/vnd.dece.graphic": ["uvi", "uvvi", "uvg", "uvvg"], "image/vnd.djvu": ["djvu", "djv"], "image/vnd.dvb.subtitle": [], "image/vnd.dwg": ["dwg"], "image/vnd.dxf": ["dxf"], "image/vnd.fastbidsheet": ["fbs"], "image/vnd.fpx": ["fpx"], "image/vnd.fst": ["fst"], "image/vnd.fujixerox.edmics-mmr": ["mmr"], "image/vnd.fujixerox.edmics-rlc": ["rlc"], "image/vnd.ms-modi": ["mdi"], "image/vnd.ms-photo": ["wdp"], "image/vnd.net-fpx": ["npx"], "image/vnd.wap.wbmp": ["wbmp"], "image/vnd.xiff": ["xif"], "image/webp": ["webp"], "image/x-3ds": ["3ds"], "image/x-cmu-raster": ["ras"], "image/x-cmx": ["cmx"], "image/x-freehand": ["fh", "fhc", "fh4", "fh5", "fh7"], "image/x-icon": ["ico"], "image/x-jng": ["jng"], "image/x-mrsid-image": ["sid"], "image/x-ms-bmp": [], "image/x-pcx": ["pcx"], "image/x-pict": ["pic", "pct"], "image/x-portable-anymap": ["pnm"], "image/x-portable-bitmap": ["pbm"], "image/x-portable-graymap": ["pgm"], "image/x-portable-pixmap": ["ppm"], "image/x-rgb": ["rgb"], "image/x-tga": ["tga"], "image/x-xbitmap": ["xbm"], "image/x-xpixmap": ["xpm"], "image/x-xwindowdump": ["xwd"], "message/rfc822": ["eml", "mime"], "model/gltf+json": ["gltf"], "model/gltf-binary": ["glb"], "model/iges": ["igs", "iges"], "model/mesh": ["msh", "mesh", "silo"], "model/vnd.collada+xml": ["dae"], "model/vnd.dwf": ["dwf"], "model/vnd.gdl": ["gdl"], "model/vnd.gtw": ["gtw"], "model/vnd.mts": ["mts"], "model/vnd.vtu": ["vtu"], "model/vrml": ["wrl", "vrml"], "model/x3d+binary": ["x3db", "x3dbz"], "model/x3d+vrml": ["x3dv", "x3dvz"], "model/x3d+xml": ["x3d", "x3dz"], "text/cache-manifest": ["appcache", "manifest"], "text/calendar": ["ics", "ifb"], "text/coffeescript": ["coffee", "litcoffee"], "text/css": ["css"], "text/csv": ["csv"], "text/hjson": ["hjson"], "text/html": ["html", "htm", "shtml"], "text/jade": ["jade"], "text/jsx": ["jsx"], "text/less": ["less"], "text/markdown": ["markdown", "md"], "text/mathml": ["mml"], "text/n3": ["n3"], "text/plain": ["txt", "text", "conf", "def", "list", "log", "in", "ini"], "text/prs.lines.tag": ["dsc"], "text/richtext": ["rtx"], "text/rtf": [], "text/sgml": ["sgml", "sgm"], "text/slim": ["slim", "slm"], "text/stylus": ["stylus", "styl"], "text/tab-separated-values": ["tsv"], "text/troff": ["t", "tr", "roff", "man", "me", "ms"], "text/turtle": ["ttl"], "text/uri-list": ["uri", "uris", "urls"], "text/vcard": ["vcard"], "text/vnd.curl": ["curl"], "text/vnd.curl.dcurl": ["dcurl"], "text/vnd.curl.mcurl": ["mcurl"], "text/vnd.curl.scurl": ["scurl"], "text/vnd.dvb.subtitle": ["sub"], "text/vnd.fly": ["fly"], "text/vnd.fmi.flexstor": ["flx"], "text/vnd.graphviz": ["gv"], "text/vnd.in3d.3dml": ["3dml"], "text/vnd.in3d.spot": ["spot"], "text/vnd.sun.j2me.app-descriptor": ["jad"], "text/vnd.wap.wml": ["wml"], "text/vnd.wap.wmlscript": ["wmls"], "text/vtt": ["vtt"], "text/x-asm": ["s", "asm"], "text/x-c": ["c", "cc", "cxx", "cpp", "h", "hh", "dic"], "text/x-component": ["htc"], "text/x-fortran": ["f", "for", "f77", "f90"], "text/x-handlebars-template": ["hbs"], "text/x-java-source": ["java"], "text/x-lua": ["lua"], "text/x-markdown": ["mkd"], "text/x-nfo": ["nfo"], "text/x-opml": ["opml"], "text/x-org": [], "text/x-pascal": ["p", "pas"], "text/x-processing": ["pde"], "text/x-sass": ["sass"], "text/x-scss": ["scss"], "text/x-setext": ["etx"], "text/x-sfv": ["sfv"], "text/x-suse-ymp": ["ymp"], "text/x-uuencode": ["uu"], "text/x-vcalendar": ["vcs"], "text/x-vcard": ["vcf"], "text/xml": [], "text/yaml": ["yaml", "yml"], "video/3gpp": ["3gp", "3gpp"], "video/3gpp2": ["3g2"], "video/h261": ["h261"], "video/h263": ["h263"], "video/h264": ["h264"], "video/jpeg": ["jpgv"], "video/jpm": ["jpgm"], "video/mj2": ["mj2", "mjp2"], "video/mp2t": ["ts"], "video/mp4": ["mp4", "mp4v", "mpg4"], "video/mpeg": ["mpeg", "mpg", "mpe", "m1v", "m2v"], "video/ogg": ["ogv"], "video/quicktime": ["qt", "mov"], "video/vnd.dece.hd": ["uvh", "uvvh"], "video/vnd.dece.mobile": ["uvm", "uvvm"], "video/vnd.dece.pd": ["uvp", "uvvp"], "video/vnd.dece.sd": ["uvs", "uvvs"], "video/vnd.dece.video": ["uvv", "uvvv"], "video/vnd.dvb.file": ["dvb"], "video/vnd.fvt": ["fvt"], "video/vnd.mpegurl": ["mxu", "m4u"], "video/vnd.ms-playready.media.pyv": ["pyv"], "video/vnd.uvvu.mp4": ["uvu", "uvvu"], "video/vnd.vivo": ["viv"], "video/webm": ["webm"], "video/x-f4v": ["f4v"], "video/x-fli": ["fli"], "video/x-flv": ["flv"], "video/x-m4v": ["m4v"], "video/x-matroska": ["mkv", "mk3d", "mks"], "video/x-mng": ["mng"], "video/x-ms-asf": ["asf", "asx"], "video/x-ms-vob": ["vob"], "video/x-ms-wm": ["wm"], "video/x-ms-wmv": ["wmv"], "video/x-ms-wmx": ["wmx"], "video/x-ms-wvx": ["wvx"], "video/x-msvideo": ["avi"], "video/x-sgi-movie": ["movie"], "video/x-smv": ["smv"], "x-conference/x-cooltalk": ["ice"]};
  }
});

// node_modules/mime/mime.js
var require_mime = __commonJS({
  "node_modules/mime/mime.js"(exports2, module2) {
    var path = require("path");
    var fs = require("fs");
    function Mime() {
      this.types = Object.create(null);
      this.extensions = Object.create(null);
    }
    Mime.prototype.define = function(map2) {
      for (var type in map2) {
        var exts = map2[type];
        for (var i = 0; i < exts.length; i++) {
          if (process.env.DEBUG_MIME && this.types[exts[i]]) {
            console.warn((this._loading || "define()").replace(/.*\//, ""), 'changes "' + exts[i] + '" extension type from ' + this.types[exts[i]] + " to " + type);
          }
          this.types[exts[i]] = type;
        }
        if (!this.extensions[type]) {
          this.extensions[type] = exts[0];
        }
      }
    };
    Mime.prototype.load = function(file) {
      this._loading = file;
      var map2 = {}, content = fs.readFileSync(file, "ascii"), lines = content.split(/[\r\n]+/);
      lines.forEach(function(line) {
        var fields = line.replace(/\s*#.*|^\s*|\s*$/g, "").split(/\s+/);
        map2[fields.shift()] = fields;
      });
      this.define(map2);
      this._loading = null;
    };
    Mime.prototype.lookup = function(path2, fallback) {
      var ext = path2.replace(/^.*[\.\/\\]/, "").toLowerCase();
      return this.types[ext] || fallback || this.default_type;
    };
    Mime.prototype.extension = function(mimeType) {
      var type = mimeType.match(/^\s*([^;\s]*)(?:;|\s|$)/)[1].toLowerCase();
      return this.extensions[type];
    };
    var mime = new Mime();
    mime.define(require_types3());
    mime.default_type = mime.lookup("bin");
    mime.Mime = Mime;
    mime.charsets = {
      lookup: function(mimeType, fallback) {
        return /^text\/|^application\/(javascript|json)/.test(mimeType) ? "UTF-8" : fallback;
      }
    };
    module2.exports = mime;
  }
});

// node_modules/send/node_modules/ms/index.js
var require_ms2 = __commonJS({
  "node_modules/send/node_modules/ms/index.js"(exports2, module2) {
    var s = 1e3;
    var m = s * 60;
    var h = m * 60;
    var d = h * 24;
    var w = d * 7;
    var y = d * 365.25;
    module2.exports = function(val, options) {
      options = options || {};
      var type = typeof val;
      if (type === "string" && val.length > 0) {
        return parse2(val);
      } else if (type === "number" && isNaN(val) === false) {
        return options.long ? fmtLong(val) : fmtShort(val);
      }
      throw new Error("val is not a non-empty string or a valid number. val=" + JSON.stringify(val));
    };
    function parse2(str2) {
      str2 = String(str2);
      if (str2.length > 100) {
        return;
      }
      var match = /^((?:\d+)?\-?\d?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|weeks?|w|years?|yrs?|y)?$/i.exec(str2);
      if (!match) {
        return;
      }
      var n = parseFloat(match[1]);
      var type = (match[2] || "ms").toLowerCase();
      switch (type) {
        case "years":
        case "year":
        case "yrs":
        case "yr":
        case "y":
          return n * y;
        case "weeks":
        case "week":
        case "w":
          return n * w;
        case "days":
        case "day":
        case "d":
          return n * d;
        case "hours":
        case "hour":
        case "hrs":
        case "hr":
        case "h":
          return n * h;
        case "minutes":
        case "minute":
        case "mins":
        case "min":
        case "m":
          return n * m;
        case "seconds":
        case "second":
        case "secs":
        case "sec":
        case "s":
          return n * s;
        case "milliseconds":
        case "millisecond":
        case "msecs":
        case "msec":
        case "ms":
          return n;
        default:
          return void 0;
      }
    }
    function fmtShort(ms) {
      var msAbs = Math.abs(ms);
      if (msAbs >= d) {
        return Math.round(ms / d) + "d";
      }
      if (msAbs >= h) {
        return Math.round(ms / h) + "h";
      }
      if (msAbs >= m) {
        return Math.round(ms / m) + "m";
      }
      if (msAbs >= s) {
        return Math.round(ms / s) + "s";
      }
      return ms + "ms";
    }
    function fmtLong(ms) {
      var msAbs = Math.abs(ms);
      if (msAbs >= d) {
        return plural(ms, msAbs, d, "day");
      }
      if (msAbs >= h) {
        return plural(ms, msAbs, h, "hour");
      }
      if (msAbs >= m) {
        return plural(ms, msAbs, m, "minute");
      }
      if (msAbs >= s) {
        return plural(ms, msAbs, s, "second");
      }
      return ms + " ms";
    }
    function plural(ms, msAbs, n, name) {
      var isPlural = msAbs >= n * 1.5;
      return Math.round(ms / n) + " " + name + (isPlural ? "s" : "");
    }
  }
});

// node_modules/range-parser/index.js
var require_range_parser = __commonJS({
  "node_modules/range-parser/index.js"(exports2, module2) {
    "use strict";
    module2.exports = rangeParser;
    function rangeParser(size, str2, options) {
      if (typeof str2 !== "string") {
        throw new TypeError("argument str must be a string");
      }
      var index = str2.indexOf("=");
      if (index === -1) {
        return -2;
      }
      var arr = str2.slice(index + 1).split(",");
      var ranges = [];
      ranges.type = str2.slice(0, index);
      for (var i = 0; i < arr.length; i++) {
        var range = arr[i].split("-");
        var start = parseInt(range[0], 10);
        var end = parseInt(range[1], 10);
        if (isNaN(start)) {
          start = size - end;
          end = size - 1;
        } else if (isNaN(end)) {
          end = size - 1;
        }
        if (end > size - 1) {
          end = size - 1;
        }
        if (isNaN(start) || isNaN(end) || start > end || start < 0) {
          continue;
        }
        ranges.push({
          start,
          end
        });
      }
      if (ranges.length < 1) {
        return -1;
      }
      return options && options.combine ? combineRanges(ranges) : ranges;
    }
    function combineRanges(ranges) {
      var ordered = ranges.map(mapWithIndex).sort(sortByRangeStart);
      for (var j = 0, i = 1; i < ordered.length; i++) {
        var range = ordered[i];
        var current = ordered[j];
        if (range.start > current.end + 1) {
          ordered[++j] = range;
        } else if (range.end > current.end) {
          current.end = range.end;
          current.index = Math.min(current.index, range.index);
        }
      }
      ordered.length = j + 1;
      var combined = ordered.sort(sortByRangeIndex).map(mapWithoutIndex);
      combined.type = ranges.type;
      return combined;
    }
    function mapWithIndex(range, index) {
      return {
        start: range.start,
        end: range.end,
        index
      };
    }
    function mapWithoutIndex(range) {
      return {
        start: range.start,
        end: range.end
      };
    }
    function sortByRangeIndex(a2, b) {
      return a2.index - b.index;
    }
    function sortByRangeStart(a2, b) {
      return a2.start - b.start;
    }
  }
});

// node_modules/send/index.js
var require_send = __commonJS({
  "node_modules/send/index.js"(exports2, module2) {
    "use strict";
    var createError = require_http_errors();
    var debug = require_src()("send");
    var deprecate = require_depd()("send");
    var destroy = require_destroy();
    var encodeUrl = require_encodeurl();
    var escapeHtml = require_escape_html();
    var etag = require_etag();
    var fresh = require_fresh();
    var fs = require("fs");
    var mime = require_mime();
    var ms = require_ms2();
    var onFinished = require_on_finished();
    var parseRange = require_range_parser();
    var path = require("path");
    var statuses = require_statuses();
    var Stream = require("stream");
    var util = require("util");
    var extname = path.extname;
    var join3 = path.join;
    var normalize = path.normalize;
    var resolve = path.resolve;
    var sep = path.sep;
    var BYTES_RANGE_REGEXP = /^ *bytes=/;
    var MAX_MAXAGE = 60 * 60 * 24 * 365 * 1e3;
    var UP_PATH_REGEXP = /(?:^|[\\/])\.\.(?:[\\/]|$)/;
    module2.exports = send;
    module2.exports.mime = mime;
    function send(req, path2, options) {
      return new SendStream(req, path2, options);
    }
    function SendStream(req, path2, options) {
      Stream.call(this);
      var opts = options || {};
      this.options = opts;
      this.path = path2;
      this.req = req;
      this._acceptRanges = opts.acceptRanges !== void 0 ? Boolean(opts.acceptRanges) : true;
      this._cacheControl = opts.cacheControl !== void 0 ? Boolean(opts.cacheControl) : true;
      this._etag = opts.etag !== void 0 ? Boolean(opts.etag) : true;
      this._dotfiles = opts.dotfiles !== void 0 ? opts.dotfiles : "ignore";
      if (this._dotfiles !== "ignore" && this._dotfiles !== "allow" && this._dotfiles !== "deny") {
        throw new TypeError('dotfiles option must be "allow", "deny", or "ignore"');
      }
      this._hidden = Boolean(opts.hidden);
      if (opts.hidden !== void 0) {
        deprecate("hidden: use dotfiles: '" + (this._hidden ? "allow" : "ignore") + "' instead");
      }
      if (opts.dotfiles === void 0) {
        this._dotfiles = void 0;
      }
      this._extensions = opts.extensions !== void 0 ? normalizeList(opts.extensions, "extensions option") : [];
      this._immutable = opts.immutable !== void 0 ? Boolean(opts.immutable) : false;
      this._index = opts.index !== void 0 ? normalizeList(opts.index, "index option") : ["index.html"];
      this._lastModified = opts.lastModified !== void 0 ? Boolean(opts.lastModified) : true;
      this._maxage = opts.maxAge || opts.maxage;
      this._maxage = typeof this._maxage === "string" ? ms(this._maxage) : Number(this._maxage);
      this._maxage = !isNaN(this._maxage) ? Math.min(Math.max(0, this._maxage), MAX_MAXAGE) : 0;
      this._root = opts.root ? resolve(opts.root) : null;
      if (!this._root && opts.from) {
        this.from(opts.from);
      }
    }
    util.inherits(SendStream, Stream);
    SendStream.prototype.etag = deprecate.function(function etag2(val) {
      this._etag = Boolean(val);
      debug("etag %s", this._etag);
      return this;
    }, "send.etag: pass etag as option");
    SendStream.prototype.hidden = deprecate.function(function hidden(val) {
      this._hidden = Boolean(val);
      this._dotfiles = void 0;
      debug("hidden %s", this._hidden);
      return this;
    }, "send.hidden: use dotfiles option");
    SendStream.prototype.index = deprecate.function(function index(paths) {
      var index2 = !paths ? [] : normalizeList(paths, "paths argument");
      debug("index %o", paths);
      this._index = index2;
      return this;
    }, "send.index: pass index as option");
    SendStream.prototype.root = function root(path2) {
      this._root = resolve(String(path2));
      debug("root %s", this._root);
      return this;
    };
    SendStream.prototype.from = deprecate.function(SendStream.prototype.root, "send.from: pass root as option");
    SendStream.prototype.root = deprecate.function(SendStream.prototype.root, "send.root: pass root as option");
    SendStream.prototype.maxage = deprecate.function(function maxage(maxAge) {
      this._maxage = typeof maxAge === "string" ? ms(maxAge) : Number(maxAge);
      this._maxage = !isNaN(this._maxage) ? Math.min(Math.max(0, this._maxage), MAX_MAXAGE) : 0;
      debug("max-age %d", this._maxage);
      return this;
    }, "send.maxage: pass maxAge as option");
    SendStream.prototype.error = function error(status, err) {
      if (hasListeners(this, "error")) {
        return this.emit("error", createError(status, err, {
          expose: false
        }));
      }
      var res = this.res;
      var msg = statuses[status] || String(status);
      var doc = createHtmlDocument("Error", escapeHtml(msg));
      clearHeaders(res);
      if (err && err.headers) {
        setHeaders(res, err.headers);
      }
      res.statusCode = status;
      res.setHeader("Content-Type", "text/html; charset=UTF-8");
      res.setHeader("Content-Length", Buffer.byteLength(doc));
      res.setHeader("Content-Security-Policy", "default-src 'none'");
      res.setHeader("X-Content-Type-Options", "nosniff");
      res.end(doc);
    };
    SendStream.prototype.hasTrailingSlash = function hasTrailingSlash() {
      return this.path[this.path.length - 1] === "/";
    };
    SendStream.prototype.isConditionalGET = function isConditionalGET() {
      return this.req.headers["if-match"] || this.req.headers["if-unmodified-since"] || this.req.headers["if-none-match"] || this.req.headers["if-modified-since"];
    };
    SendStream.prototype.isPreconditionFailure = function isPreconditionFailure() {
      var req = this.req;
      var res = this.res;
      var match = req.headers["if-match"];
      if (match) {
        var etag2 = res.getHeader("ETag");
        return !etag2 || match !== "*" && parseTokenList(match).every(function(match2) {
          return match2 !== etag2 && match2 !== "W/" + etag2 && "W/" + match2 !== etag2;
        });
      }
      var unmodifiedSince = parseHttpDate(req.headers["if-unmodified-since"]);
      if (!isNaN(unmodifiedSince)) {
        var lastModified = parseHttpDate(res.getHeader("Last-Modified"));
        return isNaN(lastModified) || lastModified > unmodifiedSince;
      }
      return false;
    };
    SendStream.prototype.removeContentHeaderFields = function removeContentHeaderFields() {
      var res = this.res;
      var headers = getHeaderNames(res);
      for (var i = 0; i < headers.length; i++) {
        var header = headers[i];
        if (header.substr(0, 8) === "content-" && header !== "content-location") {
          res.removeHeader(header);
        }
      }
    };
    SendStream.prototype.notModified = function notModified() {
      var res = this.res;
      debug("not modified");
      this.removeContentHeaderFields();
      res.statusCode = 304;
      res.end();
    };
    SendStream.prototype.headersAlreadySent = function headersAlreadySent() {
      var err = new Error("Can't set headers after they are sent.");
      debug("headers already sent");
      this.error(500, err);
    };
    SendStream.prototype.isCachable = function isCachable() {
      var statusCode = this.res.statusCode;
      return statusCode >= 200 && statusCode < 300 || statusCode === 304;
    };
    SendStream.prototype.onStatError = function onStatError(error) {
      switch (error.code) {
        case "ENAMETOOLONG":
        case "ENOENT":
        case "ENOTDIR":
          this.error(404, error);
          break;
        default:
          this.error(500, error);
          break;
      }
    };
    SendStream.prototype.isFresh = function isFresh() {
      return fresh(this.req.headers, {
        "etag": this.res.getHeader("ETag"),
        "last-modified": this.res.getHeader("Last-Modified")
      });
    };
    SendStream.prototype.isRangeFresh = function isRangeFresh() {
      var ifRange = this.req.headers["if-range"];
      if (!ifRange) {
        return true;
      }
      if (ifRange.indexOf('"') !== -1) {
        var etag2 = this.res.getHeader("ETag");
        return Boolean(etag2 && ifRange.indexOf(etag2) !== -1);
      }
      var lastModified = this.res.getHeader("Last-Modified");
      return parseHttpDate(lastModified) <= parseHttpDate(ifRange);
    };
    SendStream.prototype.redirect = function redirect(path2) {
      var res = this.res;
      if (hasListeners(this, "directory")) {
        this.emit("directory", res, path2);
        return;
      }
      if (this.hasTrailingSlash()) {
        this.error(403);
        return;
      }
      var loc = encodeUrl(collapseLeadingSlashes(this.path + "/"));
      var doc = createHtmlDocument("Redirecting", 'Redirecting to <a href="' + escapeHtml(loc) + '">' + escapeHtml(loc) + "</a>");
      res.statusCode = 301;
      res.setHeader("Content-Type", "text/html; charset=UTF-8");
      res.setHeader("Content-Length", Buffer.byteLength(doc));
      res.setHeader("Content-Security-Policy", "default-src 'none'");
      res.setHeader("X-Content-Type-Options", "nosniff");
      res.setHeader("Location", loc);
      res.end(doc);
    };
    SendStream.prototype.pipe = function pipe(res) {
      var root = this._root;
      this.res = res;
      var path2 = decode(this.path);
      if (path2 === -1) {
        this.error(400);
        return res;
      }
      if (~path2.indexOf("\0")) {
        this.error(400);
        return res;
      }
      var parts;
      if (root !== null) {
        if (path2) {
          path2 = normalize("." + sep + path2);
        }
        if (UP_PATH_REGEXP.test(path2)) {
          debug('malicious path "%s"', path2);
          this.error(403);
          return res;
        }
        parts = path2.split(sep);
        path2 = normalize(join3(root, path2));
      } else {
        if (UP_PATH_REGEXP.test(path2)) {
          debug('malicious path "%s"', path2);
          this.error(403);
          return res;
        }
        parts = normalize(path2).split(sep);
        path2 = resolve(path2);
      }
      if (containsDotFile(parts)) {
        var access = this._dotfiles;
        if (access === void 0) {
          access = parts[parts.length - 1][0] === "." ? this._hidden ? "allow" : "ignore" : "allow";
        }
        debug('%s dotfile "%s"', access, path2);
        switch (access) {
          case "allow":
            break;
          case "deny":
            this.error(403);
            return res;
          case "ignore":
          default:
            this.error(404);
            return res;
        }
      }
      if (this._index.length && this.hasTrailingSlash()) {
        this.sendIndex(path2);
        return res;
      }
      this.sendFile(path2);
      return res;
    };
    SendStream.prototype.send = function send2(path2, stat2) {
      var len = stat2.size;
      var options = this.options;
      var opts = {};
      var res = this.res;
      var req = this.req;
      var ranges = req.headers.range;
      var offset = options.start || 0;
      if (headersSent(res)) {
        this.headersAlreadySent();
        return;
      }
      debug('pipe "%s"', path2);
      this.setHeader(path2, stat2);
      this.type(path2);
      if (this.isConditionalGET()) {
        if (this.isPreconditionFailure()) {
          this.error(412);
          return;
        }
        if (this.isCachable() && this.isFresh()) {
          this.notModified();
          return;
        }
      }
      len = Math.max(0, len - offset);
      if (options.end !== void 0) {
        var bytes = options.end - offset + 1;
        if (len > bytes)
          len = bytes;
      }
      if (this._acceptRanges && BYTES_RANGE_REGEXP.test(ranges)) {
        ranges = parseRange(len, ranges, {
          combine: true
        });
        if (!this.isRangeFresh()) {
          debug("range stale");
          ranges = -2;
        }
        if (ranges === -1) {
          debug("range unsatisfiable");
          res.setHeader("Content-Range", contentRange("bytes", len));
          return this.error(416, {
            headers: {"Content-Range": res.getHeader("Content-Range")}
          });
        }
        if (ranges !== -2 && ranges.length === 1) {
          debug("range %j", ranges);
          res.statusCode = 206;
          res.setHeader("Content-Range", contentRange("bytes", len, ranges[0]));
          offset += ranges[0].start;
          len = ranges[0].end - ranges[0].start + 1;
        }
      }
      for (var prop in options) {
        opts[prop] = options[prop];
      }
      opts.start = offset;
      opts.end = Math.max(offset, offset + len - 1);
      res.setHeader("Content-Length", len);
      if (req.method === "HEAD") {
        res.end();
        return;
      }
      this.stream(path2, opts);
    };
    SendStream.prototype.sendFile = function sendFile(path2) {
      var i = 0;
      var self = this;
      debug('stat "%s"', path2);
      fs.stat(path2, function onstat(err, stat2) {
        if (err && err.code === "ENOENT" && !extname(path2) && path2[path2.length - 1] !== sep) {
          return next(err);
        }
        if (err)
          return self.onStatError(err);
        if (stat2.isDirectory())
          return self.redirect(path2);
        self.emit("file", path2, stat2);
        self.send(path2, stat2);
      });
      function next(err) {
        if (self._extensions.length <= i) {
          return err ? self.onStatError(err) : self.error(404);
        }
        var p = path2 + "." + self._extensions[i++];
        debug('stat "%s"', p);
        fs.stat(p, function(err2, stat2) {
          if (err2)
            return next(err2);
          if (stat2.isDirectory())
            return next();
          self.emit("file", p, stat2);
          self.send(p, stat2);
        });
      }
    };
    SendStream.prototype.sendIndex = function sendIndex(path2) {
      var i = -1;
      var self = this;
      function next(err) {
        if (++i >= self._index.length) {
          if (err)
            return self.onStatError(err);
          return self.error(404);
        }
        var p = join3(path2, self._index[i]);
        debug('stat "%s"', p);
        fs.stat(p, function(err2, stat2) {
          if (err2)
            return next(err2);
          if (stat2.isDirectory())
            return next();
          self.emit("file", p, stat2);
          self.send(p, stat2);
        });
      }
      next();
    };
    SendStream.prototype.stream = function stream(path2, options) {
      var finished = false;
      var self = this;
      var res = this.res;
      var stream2 = fs.createReadStream(path2, options);
      this.emit("stream", stream2);
      stream2.pipe(res);
      onFinished(res, function onfinished() {
        finished = true;
        destroy(stream2);
      });
      stream2.on("error", function onerror(err) {
        if (finished)
          return;
        finished = true;
        destroy(stream2);
        self.onStatError(err);
      });
      stream2.on("end", function onend() {
        self.emit("end");
      });
    };
    SendStream.prototype.type = function type(path2) {
      var res = this.res;
      if (res.getHeader("Content-Type"))
        return;
      var type2 = mime.lookup(path2);
      if (!type2) {
        debug("no content-type");
        return;
      }
      var charset = mime.charsets.lookup(type2);
      debug("content-type %s", type2);
      res.setHeader("Content-Type", type2 + (charset ? "; charset=" + charset : ""));
    };
    SendStream.prototype.setHeader = function setHeader(path2, stat2) {
      var res = this.res;
      this.emit("headers", res, path2, stat2);
      if (this._acceptRanges && !res.getHeader("Accept-Ranges")) {
        debug("accept ranges");
        res.setHeader("Accept-Ranges", "bytes");
      }
      if (this._cacheControl && !res.getHeader("Cache-Control")) {
        var cacheControl = "public, max-age=" + Math.floor(this._maxage / 1e3);
        if (this._immutable) {
          cacheControl += ", immutable";
        }
        debug("cache-control %s", cacheControl);
        res.setHeader("Cache-Control", cacheControl);
      }
      if (this._lastModified && !res.getHeader("Last-Modified")) {
        var modified = stat2.mtime.toUTCString();
        debug("modified %s", modified);
        res.setHeader("Last-Modified", modified);
      }
      if (this._etag && !res.getHeader("ETag")) {
        var val = etag(stat2);
        debug("etag %s", val);
        res.setHeader("ETag", val);
      }
    };
    function clearHeaders(res) {
      var headers = getHeaderNames(res);
      for (var i = 0; i < headers.length; i++) {
        res.removeHeader(headers[i]);
      }
    }
    function collapseLeadingSlashes(str2) {
      for (var i = 0; i < str2.length; i++) {
        if (str2[i] !== "/") {
          break;
        }
      }
      return i > 1 ? "/" + str2.substr(i) : str2;
    }
    function containsDotFile(parts) {
      for (var i = 0; i < parts.length; i++) {
        var part = parts[i];
        if (part.length > 1 && part[0] === ".") {
          return true;
        }
      }
      return false;
    }
    function contentRange(type, size, range) {
      return type + " " + (range ? range.start + "-" + range.end : "*") + "/" + size;
    }
    function createHtmlDocument(title, body2) {
      return '<!DOCTYPE html>\n<html lang="en">\n<head>\n<meta charset="utf-8">\n<title>' + title + "</title>\n</head>\n<body>\n<pre>" + body2 + "</pre>\n</body>\n</html>\n";
    }
    function decode(path2) {
      try {
        return decodeURIComponent(path2);
      } catch (err) {
        return -1;
      }
    }
    function getHeaderNames(res) {
      return typeof res.getHeaderNames !== "function" ? Object.keys(res._headers || {}) : res.getHeaderNames();
    }
    function hasListeners(emitter, type) {
      var count2 = typeof emitter.listenerCount !== "function" ? emitter.listeners(type).length : emitter.listenerCount(type);
      return count2 > 0;
    }
    function headersSent(res) {
      return typeof res.headersSent !== "boolean" ? Boolean(res._header) : res.headersSent;
    }
    function normalizeList(val, name) {
      var list = [].concat(val || []);
      for (var i = 0; i < list.length; i++) {
        if (typeof list[i] !== "string") {
          throw new TypeError(name + " must be array of strings or false");
        }
      }
      return list;
    }
    function parseHttpDate(date) {
      var timestamp = date && Date.parse(date);
      return typeof timestamp === "number" ? timestamp : NaN;
    }
    function parseTokenList(str2) {
      var end = 0;
      var list = [];
      var start = 0;
      for (var i = 0, len = str2.length; i < len; i++) {
        switch (str2.charCodeAt(i)) {
          case 32:
            if (start === end) {
              start = end = i + 1;
            }
            break;
          case 44:
            list.push(str2.substring(start, end));
            start = end = i + 1;
            break;
          default:
            end = i + 1;
            break;
        }
      }
      list.push(str2.substring(start, end));
      return list;
    }
    function setHeaders(res, headers) {
      var keys2 = Object.keys(headers);
      for (var i = 0; i < keys2.length; i++) {
        var key = keys2[i];
        res.setHeader(key, headers[key]);
      }
    }
  }
});

// node_modules/serve-static/index.js
var require_serve_static = __commonJS({
  "node_modules/serve-static/index.js"(exports2, module2) {
    "use strict";
    var encodeUrl = require_encodeurl();
    var escapeHtml = require_escape_html();
    var parseUrl = require_parseurl();
    var resolve = require("path").resolve;
    var send = require_send();
    var url = require("url");
    module2.exports = serveStatic;
    module2.exports.mime = send.mime;
    function serveStatic(root, options) {
      if (!root) {
        throw new TypeError("root path required");
      }
      if (typeof root !== "string") {
        throw new TypeError("root path must be a string");
      }
      var opts = Object.create(options || null);
      var fallthrough = opts.fallthrough !== false;
      var redirect = opts.redirect !== false;
      var setHeaders = opts.setHeaders;
      if (setHeaders && typeof setHeaders !== "function") {
        throw new TypeError("option setHeaders must be function");
      }
      opts.maxage = opts.maxage || opts.maxAge || 0;
      opts.root = resolve(root);
      var onDirectory = redirect ? createRedirectDirectoryListener() : createNotFoundDirectoryListener();
      return function serveStatic2(req, res, next) {
        if (req.method !== "GET" && req.method !== "HEAD") {
          if (fallthrough) {
            return next();
          }
          res.statusCode = 405;
          res.setHeader("Allow", "GET, HEAD");
          res.setHeader("Content-Length", "0");
          res.end();
          return;
        }
        var forwardError = !fallthrough;
        var originalUrl = parseUrl.original(req);
        var path = parseUrl(req).pathname;
        if (path === "/" && originalUrl.pathname.substr(-1) !== "/") {
          path = "";
        }
        var stream = send(req, path, opts);
        stream.on("directory", onDirectory);
        if (setHeaders) {
          stream.on("headers", setHeaders);
        }
        if (fallthrough) {
          stream.on("file", function onFile() {
            forwardError = true;
          });
        }
        stream.on("error", function error(err) {
          if (forwardError || !(err.statusCode < 500)) {
            next(err);
            return;
          }
          next();
        });
        stream.pipe(res);
      };
    }
    function collapseLeadingSlashes(str2) {
      for (var i = 0; i < str2.length; i++) {
        if (str2.charCodeAt(i) !== 47) {
          break;
        }
      }
      return i > 1 ? "/" + str2.substr(i) : str2;
    }
    function createHtmlDocument(title, body2) {
      return '<!DOCTYPE html>\n<html lang="en">\n<head>\n<meta charset="utf-8">\n<title>' + title + "</title>\n</head>\n<body>\n<pre>" + body2 + "</pre>\n</body>\n</html>\n";
    }
    function createNotFoundDirectoryListener() {
      return function notFound() {
        this.error(404);
      };
    }
    function createRedirectDirectoryListener() {
      return function redirect(res) {
        if (this.hasTrailingSlash()) {
          this.error(404);
          return;
        }
        var originalUrl = parseUrl.original(this.req);
        originalUrl.path = null;
        originalUrl.pathname = collapseLeadingSlashes(originalUrl.pathname + "/");
        var loc = encodeUrl(url.format(originalUrl));
        var doc = createHtmlDocument("Redirecting", 'Redirecting to <a href="' + escapeHtml(loc) + '">' + escapeHtml(loc) + "</a>");
        res.statusCode = 301;
        res.setHeader("Content-Type", "text/html; charset=UTF-8");
        res.setHeader("Content-Length", Buffer.byteLength(doc));
        res.setHeader("Content-Security-Policy", "default-src 'none'");
        res.setHeader("X-Content-Type-Options", "nosniff");
        res.setHeader("Location", loc);
        res.end(doc);
      };
    }
  }
});

// node_modules/@calcit/ternary-tree/lib/types.js
var TernaryTreeKind;
(function(TernaryTreeKind2) {
  TernaryTreeKind2[TernaryTreeKind2["ternaryTreeBranch"] = 0] = "ternaryTreeBranch";
  TernaryTreeKind2[TernaryTreeKind2["ternaryTreeLeaf"] = 1] = "ternaryTreeLeaf";
})(TernaryTreeKind || (TernaryTreeKind = {}));
var valueHash = (x) => {
  if (typeof x === "number") {
    return x;
  } else if (typeof x === "string") {
    let h = 0;
    for (var i = 0; i < x.length; i++) {
      h = Math.imul(31, h) + (x[i].charCodeAt(0) | 0);
    }
    return h;
  }
  throw new Error("Hash solution not provided for this type(other than number and string)");
};
var hashGenerator = valueHash;
var overwriteHashGenerator = (f) => {
  hashGenerator = f;
};
var mergeValueHash = (base, x) => {
  if (typeof x === "number") {
    return Math.imul(31, base) + x;
  } else if (typeof x === "string") {
    let h = base;
    for (var i = 0; i < x.length; i++) {
      h = Math.imul(31, h) + (x[i].charCodeAt(0) | 0);
    }
    return h;
  }
  throw new Error("Hash solution not provided for this type(other than number and string)");
};

// node_modules/@calcit/ternary-tree/lib/utils.js
var dataEqual = (x, y) => {
  return x === y;
};
var overwriteComparator = (f) => {
  dataEqual = f;
};
var roughIntPow = (x, times) => {
  if (times < 1) {
    return x;
  }
  let result = 1;
  for (let idx = 0; idx < times; idx++) {
    result = result * x;
  }
  return result;
};
var divideTernarySizes = (size) => {
  if (size < 0) {
    throw new Error("Unexpected negative size");
  }
  let extra = size % 3;
  let groupSize = Math.floor(size / 3);
  var leftSize = groupSize;
  var middleSize = groupSize;
  var rightSize = groupSize;
  switch (extra) {
    case 0:
      break;
    case 1:
      middleSize = middleSize + 1;
      break;
    case 2:
      leftSize = leftSize + 1;
      rightSize = rightSize + 1;
      break;
    default:
      throw new Error(`Unexpected mod result ${extra}`);
  }
  return {left: leftSize, middle: middleSize, right: rightSize};
};
var cmp = (x, y) => {
  if (x < y) {
    return -1;
  }
  if (x > y) {
    return 1;
  }
  return 0;
};

// node_modules/@calcit/ternary-tree/lib/map.js
var emptyBranch = null;
function getMax(tree) {
  if (tree == null) {
    throw new Error("Cannot find max hash of nil");
  }
  switch (tree.kind) {
    case TernaryTreeKind.ternaryTreeLeaf:
      return tree.hash;
    case TernaryTreeKind.ternaryTreeBranch:
      return tree.maxHash;
    default:
      throw new Error("Unknown");
  }
}
function getMin(tree) {
  if (tree == null) {
    throw new Error("Cannot find min hash of nil");
  }
  switch (tree.kind) {
    case TernaryTreeKind.ternaryTreeLeaf:
      return tree.hash;
    case TernaryTreeKind.ternaryTreeBranch:
      return tree.minHash;
    default:
      throw new Error("Unknown");
  }
}
function getMapDepth(tree) {
  if (tree == null) {
    return 0;
  }
  switch (tree.kind) {
    case TernaryTreeKind.ternaryTreeLeaf:
      return 1;
    case TernaryTreeKind.ternaryTreeBranch:
      return Math.max(getMapDepth(tree.left), getMapDepth(tree.middle), getMapDepth(tree.right)) + 1;
    default:
      throw new Error("Unknown");
  }
}
function createLeaf(k, v) {
  let result = {
    kind: TernaryTreeKind.ternaryTreeLeaf,
    hash: hashGenerator(k),
    elements: [[k, v]]
  };
  return result;
}
function createLeafFromHashEntry(item) {
  let result = {
    kind: TernaryTreeKind.ternaryTreeLeaf,
    hash: item.hash,
    elements: item.pairs
  };
  return result;
}
function makeTernaryTreeMap(size, offset, xs) {
  switch (size) {
    case 0: {
      let result = emptyBranch;
      return result;
    }
    case 1: {
      let leftPair = xs[offset];
      let result = createLeafFromHashEntry(leftPair);
      return result;
    }
    case 2: {
      let leftPair = xs[offset];
      let middlePair = xs[offset + 1];
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: middlePair.hash,
        minHash: leftPair.hash,
        left: createLeafFromHashEntry(leftPair),
        middle: createLeafFromHashEntry(middlePair),
        right: emptyBranch,
        depth: 1
      };
      return result;
    }
    case 3: {
      let leftPair = xs[offset];
      let middlePair = xs[offset + 1];
      let rightPair = xs[offset + 2];
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: rightPair.hash,
        minHash: leftPair.hash,
        left: createLeafFromHashEntry(leftPair),
        middle: createLeafFromHashEntry(middlePair),
        right: createLeafFromHashEntry(rightPair),
        depth: 1
      };
      return result;
    }
    default: {
      let divided = divideTernarySizes(size);
      let left = makeTernaryTreeMap(divided.left, offset, xs);
      let middle = makeTernaryTreeMap(divided.middle, offset + divided.left, xs);
      let right = makeTernaryTreeMap(divided.right, offset + divided.left + divided.middle, xs);
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: getMax(right),
        minHash: getMin(left),
        left,
        middle,
        right,
        depth: Math.max(getMapDepth(left), getMapDepth(middle), getMapDepth(right)) + 1
      };
      return result;
    }
  }
}
function initTernaryTreeMapFromHashEntries(xs) {
  return makeTernaryTreeMap(xs.length, 0, xs);
}
function initTernaryTreeMap(t) {
  let groupBuffers = new Map();
  for (let [k, v] of t) {
    let h = hashGenerator(k);
    if (groupBuffers.has(h)) {
      let branch = groupBuffers.get(h);
      if (branch != null) {
        branch.push([k, v]);
      } else {
        throw new Error("Expected referece to pairs");
      }
    } else {
      groupBuffers.set(h, [[k, v]]);
    }
  }
  let xs = [];
  for (let [k, v] of groupBuffers) {
    if (v != null) {
      xs.push({
        hash: k,
        pairs: v
      });
    } else {
      throw new Error("Expected reference to paris");
    }
  }
  xs.sort((a2, b) => cmp(a2.hash, b.hash));
  let result = initTernaryTreeMapFromHashEntries(xs);
  return result;
}
function mapLen(tree) {
  if (tree == null) {
    return 0;
  }
  switch (tree.kind) {
    case TernaryTreeKind.ternaryTreeLeaf:
      return tree.elements.length;
    case TernaryTreeKind.ternaryTreeBranch:
      return mapLen(tree.left) + mapLen(tree.middle) + mapLen(tree.right);
    default:
      throw new Error("Unknown");
  }
}
function mapLenBound(tree, bound) {
  if (tree == null) {
    return 0;
  }
  switch (tree.kind) {
    case TernaryTreeKind.ternaryTreeLeaf:
      return tree.elements.length;
    case TernaryTreeKind.ternaryTreeBranch:
      let ret = mapLenBound(tree.left, bound);
      if (ret > bound) {
        return ret;
      }
      ret = ret + mapLenBound(tree.middle, bound);
      if (ret > bound) {
        return ret;
      }
      ret = ret + mapLenBound(tree.right, bound);
      return ret;
    default:
      throw new Error("Unknown");
  }
}
function isMapEmpty(tree) {
  if (tree == null) {
    return true;
  }
  switch (tree.kind) {
    case TernaryTreeKind.ternaryTreeLeaf:
      return false;
    case TernaryTreeKind.ternaryTreeBranch:
      return tree.left == null && tree.middle == null && tree.right == null;
    default:
      throw new Error("Unknown");
  }
}
function collectOrderedHashEntries(tree, acc, idx) {
  if (tree == null || isMapEmpty(tree)) {
  } else {
    switch (tree.kind) {
      case TernaryTreeKind.ternaryTreeLeaf: {
        acc[idx.value] = {hash: tree.hash, pairs: tree.elements};
        idx.value = idx.value + 1;
        break;
      }
      case TernaryTreeKind.ternaryTreeBranch: {
        collectOrderedHashEntries(tree.left, acc, idx);
        collectOrderedHashEntries(tree.middle, acc, idx);
        collectOrderedHashEntries(tree.right, acc, idx);
        break;
      }
      default: {
        throw new Error("Unknown");
      }
    }
  }
}
function toOrderedHashEntries(tree) {
  let acc = new Array(mapLen(tree));
  let idx = {value: 0};
  collectOrderedHashEntries(tree, acc, idx);
  return acc;
}
function contains(originalTree, item) {
  if (originalTree == null) {
    return false;
  }
  let hx = hashGenerator(item);
  let tree = originalTree;
  whileLoop:
    while (tree != null) {
      if (tree.kind === TernaryTreeKind.ternaryTreeLeaf) {
        if (hx === tree.hash) {
          let size = tree.elements.length;
          for (let idx = 0; idx < size; idx++) {
            let pair = tree.elements[idx];
            if (dataEqual(pair[0], item)) {
              return true;
            }
          }
        }
        return false;
      }
      if (tree.left == null) {
        return false;
      }
      if (tree.left.kind === TernaryTreeKind.ternaryTreeLeaf) {
        if (hx < tree.left.hash) {
          return false;
        }
        if (tree.left.hash === hx) {
          tree = tree.left;
          continue whileLoop;
        }
      } else {
        if (hx < tree.left.minHash) {
          return false;
        }
        if (hx <= tree.left.maxHash) {
          tree = tree.left;
          continue whileLoop;
        }
      }
      if (tree.middle == null) {
        return false;
      }
      if (tree.middle.kind === TernaryTreeKind.ternaryTreeLeaf) {
        if (hx < tree.middle.hash) {
          return false;
        }
        if (tree.middle.hash === hx) {
          tree = tree.middle;
          continue whileLoop;
        }
      } else {
        if (hx < tree.middle.minHash) {
          return false;
        }
        if (hx <= tree.middle.maxHash) {
          tree = tree.middle;
          continue whileLoop;
        }
      }
      if (tree.right == null) {
        return false;
      }
      if (tree.right.kind === TernaryTreeKind.ternaryTreeLeaf) {
        if (hx < tree.right.hash) {
          return false;
        }
        if (tree.right.hash === hx) {
          tree = tree.right;
          continue whileLoop;
        }
      } else {
        if (hx < tree.right.minHash) {
          return false;
        }
        if (hx <= tree.right.maxHash) {
          tree = tree.right;
          continue whileLoop;
        }
      }
      return false;
    }
  return false;
}
function mapGetDefault(originalTree, item, v0) {
  let hx = hashGenerator(item);
  let tree = originalTree;
  whileLoop:
    while (tree != null) {
      if (tree.kind === TernaryTreeKind.ternaryTreeLeaf) {
        let size = tree.elements.length;
        for (let i = 0; i < size; i++) {
          let pair = tree.elements[i];
          if (dataEqual(pair[0], item)) {
            return pair[1];
          }
        }
        return v0;
      }
      if (tree.left == null) {
        return v0;
      }
      if (tree.left.kind == TernaryTreeKind.ternaryTreeLeaf) {
        if (hx < tree.left.hash) {
          return v0;
        }
        if (tree.left.hash === hx) {
          tree = tree.left;
          continue whileLoop;
        }
      } else {
        if (hx < tree.left.minHash) {
          return v0;
        }
        if (hx <= tree.left.maxHash) {
          tree = tree.left;
          continue whileLoop;
        }
      }
      if (tree.middle == null) {
        return v0;
      }
      if (tree.middle.kind == TernaryTreeKind.ternaryTreeLeaf) {
        if (hx < tree.middle.hash) {
          return v0;
        }
        if (tree.middle.hash === hx) {
          tree = tree.middle;
          continue whileLoop;
        }
      } else {
        if (hx < tree.middle.minHash) {
          return v0;
        }
        if (hx <= tree.middle.maxHash) {
          tree = tree.middle;
          continue whileLoop;
        }
      }
      if (tree.right == null) {
        return v0;
      }
      if (tree.right.kind == TernaryTreeKind.ternaryTreeLeaf) {
        if (hx < tree.right.hash) {
          return v0;
        }
        if (tree.right.hash === hx) {
          tree = tree.right;
          continue whileLoop;
        }
      } else {
        if (hx < tree.right.minHash) {
          return v0;
        }
        if (hx <= tree.right.maxHash) {
          tree = tree.right;
          continue whileLoop;
        }
      }
      return v0;
    }
  return v0;
}
function rangeContainsHash(tree, thisHash) {
  if (tree == null) {
    return false;
  } else if (tree.kind === TernaryTreeKind.ternaryTreeLeaf) {
    return tree.hash === thisHash;
  } else {
    return thisHash >= tree.minHash && thisHash <= tree.maxHash;
  }
}
function assocExisted(tree, key, item, thisHash = null) {
  if (tree == null || isMapEmpty(tree)) {
    throw new Error("Cannot call assoc on nil");
  }
  thisHash = thisHash !== null && thisHash !== void 0 ? thisHash : hashGenerator(key);
  if (tree.kind === TernaryTreeKind.ternaryTreeLeaf) {
    if (tree.hash !== thisHash) {
      throw new Error("Expected hashes to be identical, otherwise element is missing");
    }
    let newPairs = new Array(tree.elements.length);
    let replaced = false;
    let size = tree.elements.length;
    for (let idx = 0; idx < size; idx++) {
      let pair = tree.elements[idx];
      if (dataEqual(pair[0], key)) {
        newPairs[idx] = [key, item];
        replaced = true;
      } else {
        newPairs[idx] = pair;
      }
    }
    if (replaced) {
      let result = {kind: TernaryTreeKind.ternaryTreeLeaf, hash: thisHash, elements: newPairs};
      return result;
    } else {
      throw new Error("Unexpected missing hash in assoc, invalid branch");
    }
  }
  if (thisHash < tree.minHash)
    throw new Error("Unexpected missing hash in assoc, hash too small");
  else if (thisHash > tree.maxHash)
    throw new Error("Unexpected missing hash in assoc, hash too large");
  if (tree.left == null) {
    throw new Error("Unexpected missing hash in assoc, found not branch");
  }
  if (rangeContainsHash(tree.left, thisHash)) {
    let result = {
      kind: TernaryTreeKind.ternaryTreeBranch,
      maxHash: tree.maxHash,
      minHash: tree.minHash,
      left: assocExisted(tree.left, key, item, thisHash),
      middle: tree.middle,
      right: tree.right,
      depth: 0
    };
    return result;
  }
  if (tree.middle == null) {
    throw new Error("Unexpected missing hash in assoc, found not branch");
  }
  if (rangeContainsHash(tree.middle, thisHash)) {
    let result = {
      kind: TernaryTreeKind.ternaryTreeBranch,
      maxHash: tree.maxHash,
      minHash: tree.minHash,
      left: tree.left,
      middle: assocExisted(tree.middle, key, item, thisHash),
      right: tree.right,
      depth: 0
    };
    return result;
  }
  if (tree.right == null) {
    throw new Error("Unexpected missing hash in assoc, found not branch");
  }
  if (rangeContainsHash(tree.right, thisHash)) {
    let result = {
      kind: TernaryTreeKind.ternaryTreeBranch,
      maxHash: tree.maxHash,
      minHash: tree.minHash,
      left: tree.left,
      middle: tree.middle,
      right: assocExisted(tree.right, key, item, thisHash),
      depth: 0
    };
    return result;
  }
  throw new Error("Unexpected missing hash in assoc, found not branch");
}
function assocNew(tree, key, item, thisHash = null) {
  if (tree == null || isMapEmpty(tree)) {
    return createLeaf(key, item);
  }
  thisHash = thisHash !== null && thisHash !== void 0 ? thisHash : hashGenerator(key);
  if (tree.kind === TernaryTreeKind.ternaryTreeLeaf) {
    if (thisHash > tree.hash) {
      let childBranch = {
        kind: TernaryTreeKind.ternaryTreeLeaf,
        hash: thisHash,
        elements: [[key, item]]
      };
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: thisHash,
        minHash: tree.hash,
        left: tree,
        middle: childBranch,
        right: emptyBranch,
        depth: 0
      };
      return result;
    } else if (thisHash < tree.hash) {
      let childBranch = {
        kind: TernaryTreeKind.ternaryTreeLeaf,
        hash: thisHash,
        elements: [[key, item]]
      };
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: tree.hash,
        minHash: thisHash,
        left: childBranch,
        middle: tree,
        right: emptyBranch,
        depth: 0
      };
      return result;
    } else {
      let size = tree.elements.length;
      for (let i = 0; i < size; i++) {
        let pair = tree.elements[i];
        if (dataEqual(pair[0], key)) {
          throw new Error("Unexpected existed key in assoc");
        }
      }
      let newPairs = new Array(tree.elements.length + 1);
      for (let idx = 0; idx < size; idx++) {
        let pair = tree.elements[idx];
        newPairs[idx] = pair;
      }
      newPairs[tree.elements.length] = [key, item];
      let result = {
        kind: TernaryTreeKind.ternaryTreeLeaf,
        hash: tree.hash,
        elements: newPairs
      };
      return result;
    }
  } else {
    if (thisHash < tree.minHash) {
      if (tree.right == null) {
        let childBranch = {
          kind: TernaryTreeKind.ternaryTreeLeaf,
          hash: thisHash,
          elements: [[key, item]]
        };
        let result = {
          kind: TernaryTreeKind.ternaryTreeBranch,
          maxHash: tree.maxHash,
          minHash: thisHash,
          left: childBranch,
          middle: tree.left,
          right: tree.middle,
          depth: 0
        };
        return result;
      } else {
        let childBranch = {
          kind: TernaryTreeKind.ternaryTreeLeaf,
          hash: thisHash,
          elements: [[key, item]]
        };
        let result = {
          kind: TernaryTreeKind.ternaryTreeBranch,
          maxHash: tree.maxHash,
          minHash: thisHash,
          left: childBranch,
          middle: tree,
          right: emptyBranch,
          depth: 0
        };
        return result;
      }
    }
    if (thisHash > tree.maxHash) {
      if (tree.middle == null) {
        let childBranch = {
          kind: TernaryTreeKind.ternaryTreeLeaf,
          hash: thisHash,
          elements: [[key, item]]
        };
        let result = {
          kind: TernaryTreeKind.ternaryTreeBranch,
          maxHash: thisHash,
          minHash: tree.minHash,
          left: tree.left,
          middle: childBranch,
          right: emptyBranch,
          depth: 0
        };
        return result;
      } else if (tree.right == null) {
        let childBranch = {
          kind: TernaryTreeKind.ternaryTreeLeaf,
          hash: thisHash,
          elements: [[key, item]]
        };
        let result = {
          kind: TernaryTreeKind.ternaryTreeBranch,
          maxHash: thisHash,
          minHash: tree.minHash,
          left: tree.left,
          middle: tree.middle,
          right: childBranch,
          depth: 0
        };
        return result;
      } else {
        let childBranch = {
          kind: TernaryTreeKind.ternaryTreeLeaf,
          hash: thisHash,
          elements: [[key, item]]
        };
        let result = {
          kind: TernaryTreeKind.ternaryTreeBranch,
          maxHash: thisHash,
          minHash: tree.minHash,
          left: tree,
          middle: childBranch,
          right: emptyBranch,
          depth: 0
        };
        return result;
      }
    }
    if (rangeContainsHash(tree.left, thisHash)) {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: tree.maxHash,
        minHash: tree.minHash,
        left: assocNew(tree.left, key, item, thisHash),
        middle: tree.middle,
        right: tree.right,
        depth: 0
      };
      return result;
    }
    if (rangeContainsHash(tree.middle, thisHash)) {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: tree.maxHash,
        minHash: tree.minHash,
        left: tree.left,
        middle: assocNew(tree.middle, key, item, thisHash),
        right: tree.right,
        depth: 0
      };
      return result;
    }
    if (rangeContainsHash(tree.right, thisHash)) {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: tree.maxHash,
        minHash: tree.minHash,
        left: tree.left,
        middle: tree.middle,
        right: assocNew(tree.right, key, item, thisHash),
        depth: 0
      };
      return result;
    }
    if (tree.middle == null) {
      throw new Error("unreachable. if inside range, then middle should be here");
    }
    if (thisHash < getMin(tree.middle)) {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: tree.maxHash,
        minHash: tree.minHash,
        left: assocNew(tree.left, key, item, thisHash),
        middle: tree.middle,
        right: tree.right,
        depth: 0
      };
      return result;
    } else {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: tree.maxHash,
        minHash: tree.minHash,
        left: tree.left,
        middle: tree.middle,
        right: assocNew(tree.right, key, item, thisHash),
        depth: 0
      };
      return result;
    }
  }
}
function assocMap(tree, key, item, disableBalancing = false) {
  if (tree == null || isMapEmpty(tree)) {
    return createLeaf(key, item);
  }
  if (contains(tree, key)) {
    return assocExisted(tree, key, item);
  } else {
    return assocNew(tree, key, item);
  }
}
function dissocExisted(tree, key) {
  if (tree == null) {
    throw new Error("Unexpected missing key in dissoc");
  }
  if (tree.kind === TernaryTreeKind.ternaryTreeLeaf) {
    if (tree.hash === hashGenerator(key)) {
      let size = tree.elements.length;
      if (size === 1 && dataEqual(key, tree.elements[0][0])) {
        return emptyBranch;
      } else {
        let newPairs = [];
        for (let i = 0; i < size; i++) {
          let pair = tree.elements[i];
          if (!dataEqual(pair[0], key)) {
            newPairs.push(pair);
          }
        }
        let result = {kind: TernaryTreeKind.ternaryTreeLeaf, hash: tree.hash, elements: newPairs};
        return result;
      }
    } else {
      throw new Error("Unexpected missing key in dissoc on leaf");
    }
  }
  if (mapLenBound(tree, 2) === 1) {
    if (!contains(tree, key)) {
      throw new Error("Unexpected missing key in dissoc single branch");
    }
    return emptyBranch;
  }
  let thisHash = hashGenerator(key);
  if (rangeContainsHash(tree.left, thisHash)) {
    let changedBranch = dissocExisted(tree.left, key);
    if (isMapEmpty(changedBranch)) {
      if (isMapEmpty(tree.right)) {
        return tree.middle;
      }
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: tree.maxHash,
        minHash: getMin(tree.middle),
        left: tree.middle,
        middle: tree.right,
        right: emptyBranch,
        depth: 0
      };
      return result;
    } else {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: tree.maxHash,
        minHash: getMin(changedBranch),
        left: changedBranch,
        middle: tree.middle,
        right: tree.right,
        depth: 0
      };
      return result;
    }
  }
  if (rangeContainsHash(tree.middle, thisHash)) {
    let changedBranch = dissocExisted(tree.middle, key);
    if (isMapEmpty(changedBranch)) {
      if (isMapEmpty(tree.right)) {
        return tree.left;
      }
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: tree.maxHash,
        minHash: tree.minHash,
        left: tree.left,
        middle: tree.right,
        right: emptyBranch,
        depth: 0
      };
      return result;
    } else {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: tree.maxHash,
        minHash: tree.minHash,
        left: tree.left,
        middle: changedBranch,
        right: tree.right,
        depth: 0
      };
      return result;
    }
  }
  if (rangeContainsHash(tree.right, thisHash)) {
    let changedBranch = dissocExisted(tree.right, key);
    if (changedBranch == null) {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: getMax(tree.middle),
        minHash: tree.minHash,
        left: tree.left,
        middle: tree.middle,
        right: emptyBranch,
        depth: 0
      };
      return result;
    } else {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: getMax(changedBranch),
        minHash: tree.minHash,
        left: tree.left,
        middle: tree.middle,
        right: changedBranch,
        depth: 0
      };
      return result;
    }
  }
  throw new Error("Cannot find branch in dissoc");
}
function dissocMap(tree, key) {
  if (contains(tree, key)) {
    return dissocExisted(tree, key);
  } else {
    return tree;
  }
}
function collectToPairsArray(acc, tree) {
  if (tree != null) {
    if (tree.kind === TernaryTreeKind.ternaryTreeLeaf) {
      for (let i = 0; i < tree.elements.length; i++) {
        let pair = tree.elements[i];
        acc.push(pair);
      }
    } else {
      if (tree.left != null) {
        collectToPairsArray(acc, tree.left);
      }
      if (tree.middle != null) {
        collectToPairsArray(acc, tree.middle);
      }
      if (tree.right != null) {
        collectToPairsArray(acc, tree.right);
      }
    }
  }
}
function toPairsArray(tree) {
  let result = [];
  collectToPairsArray(result, tree);
  return result;
}
function* toPairs(tree) {
  if (tree != null) {
    if (tree.kind === TernaryTreeKind.ternaryTreeLeaf) {
      for (let pair of tree.elements) {
        yield pair;
      }
    } else {
      if (tree.left != null) {
        for (let item of toPairs(tree.left)) {
          yield item;
        }
      }
      if (tree.middle != null) {
        for (let item of toPairs(tree.middle)) {
          yield item;
        }
      }
      if (tree.right != null) {
        for (let item of toPairs(tree.right)) {
          yield item;
        }
      }
    }
  }
}
function* toKeys(tree) {
  if (tree != null) {
    if (tree.kind === TernaryTreeKind.ternaryTreeLeaf) {
      for (let i = 0; i < tree.elements.length; i++) {
        let pair = tree.elements[i];
        yield pair[0];
      }
    } else {
      if (tree.left != null) {
        for (let item of toKeys(tree.left)) {
          yield item;
        }
      }
      if (tree.middle != null) {
        for (let item of toKeys(tree.middle)) {
          yield item;
        }
      }
      if (tree.right != null) {
        for (let item of toKeys(tree.right)) {
          yield item;
        }
      }
    }
  }
}
function mergeSkip(xs, ys, skipped) {
  let ret = xs;
  let counted = 0;
  for (let [key, item] of toPairs(ys)) {
    if (dataEqual(item, skipped)) {
      continue;
    }
    ret = assocMap(ret, key, item);
    if (counted > 700) {
      forceMapInplaceBalancing(ret);
      counted = 0;
    } else {
      counted = counted + 1;
    }
  }
  return ret;
}
function forceMapInplaceBalancing(tree) {
  if (tree.kind === TernaryTreeKind.ternaryTreeBranch) {
    let xs = toOrderedHashEntries(tree);
    let newTree = makeTernaryTreeMap(xs.length, 0, xs);
    tree.left = newTree.left;
    tree.middle = newTree.middle;
    tree.right = newTree.right;
  } else {
  }
}

// node_modules/@calcit/ternary-tree/lib/list.js
function getDepth(tree) {
  if (tree == null)
    return 0;
  switch (tree.kind) {
    case TernaryTreeKind.ternaryTreeLeaf:
      return 1;
    case TernaryTreeKind.ternaryTreeBranch:
      return tree.depth;
  }
}
var emptyBranch2 = null;
function decideParentDepth(...xs) {
  let depth = 0;
  for (let i = 0; i < xs.length; i++) {
    let x = xs[i];
    let y = getDepth(x);
    if (y > depth) {
      depth = y;
    }
  }
  return depth + 1;
}
function makeTernaryTreeList(size, offset, xs) {
  switch (size) {
    case 0: {
      return {kind: TernaryTreeKind.ternaryTreeBranch, size: 0, depth: 1, left: emptyBranch2, middle: emptyBranch2, right: emptyBranch2};
    }
    case 1:
      return xs[offset];
    case 2: {
      let left = xs[offset];
      let middle = xs[offset + 1];
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        size: listLen(left) + listLen(middle),
        left,
        middle,
        right: emptyBranch2,
        depth: decideParentDepth(left, middle)
      };
      return result;
    }
    case 3: {
      let left = xs[offset];
      let middle = xs[offset + 1];
      let right = xs[offset + 2];
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        size: listLen(left) + listLen(middle) + listLen(right),
        left,
        middle,
        right,
        depth: decideParentDepth(left, middle, right)
      };
      return result;
    }
    default: {
      let divided = divideTernarySizes(size);
      let left = makeTernaryTreeList(divided.left, offset, xs);
      let middle = makeTernaryTreeList(divided.middle, offset + divided.left, xs);
      let right = makeTernaryTreeList(divided.right, offset + divided.left + divided.middle, xs);
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        size: listLen(left) + listLen(middle) + listLen(right),
        depth: decideParentDepth(left, middle, right),
        left,
        middle,
        right
      };
      return result;
    }
  }
}
function initTernaryTreeList(xs) {
  let ys = new Array(xs.length);
  let size = xs.length;
  for (let idx = 0; idx < size; idx++) {
    let x = xs[idx];
    ys[idx] = {kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: x};
  }
  return makeTernaryTreeList(xs.length, 0, ys);
}
function listLen(tree) {
  if (tree == null) {
    return 0;
  } else {
    return tree.size;
  }
}
function* listToItems(tree) {
  if (tree != null) {
    switch (tree.kind) {
      case TernaryTreeKind.ternaryTreeLeaf: {
        yield tree.value;
        break;
      }
      case TernaryTreeKind.ternaryTreeBranch: {
        if (tree.left != null) {
          for (let x of listToItems(tree.left)) {
            yield x;
          }
        }
        if (tree.middle != null) {
          for (let x of listToItems(tree.middle)) {
            yield x;
          }
        }
        if (tree.right != null) {
          for (let x of listToItems(tree.right)) {
            yield x;
          }
        }
        break;
      }
    }
  }
}
function writeLeavesArray(tree, acc, idx) {
  if (tree == null) {
  } else {
    switch (tree.kind) {
      case TernaryTreeKind.ternaryTreeLeaf: {
        acc[idx.value] = tree;
        idx.value = idx.value + 1;
        break;
      }
      case TernaryTreeKind.ternaryTreeBranch: {
        if (tree.left != null) {
          writeLeavesArray(tree.left, acc, idx);
        }
        if (tree.middle != null) {
          writeLeavesArray(tree.middle, acc, idx);
        }
        if (tree.right != null) {
          writeLeavesArray(tree.right, acc, idx);
        }
        break;
      }
      default: {
        throw new Error("Unknown");
      }
    }
  }
}
function toLeavesArray(tree) {
  let acc = new Array(listLen(tree));
  let counter = {value: 0};
  writeLeavesArray(tree, acc, counter);
  return acc;
}
function listGet(originalTree, originalIdx) {
  let tree = originalTree;
  let idx = originalIdx;
  while (tree != null) {
    if (idx < 0) {
      throw new Error("Cannot index negative number");
    }
    if (tree.kind === TernaryTreeKind.ternaryTreeLeaf) {
      if (idx === 0) {
        return tree.value;
      } else {
        throw new Error(`Cannot get from leaf with index ${idx}`);
      }
    }
    if (idx > tree.size - 1) {
      throw new Error("Index too large");
    }
    let leftSize = tree.left == null ? 0 : tree.left.size;
    let middleSize = tree.middle == null ? 0 : tree.middle.size;
    let rightSize = tree.right == null ? 0 : tree.right.size;
    if (leftSize + middleSize + rightSize !== tree.size) {
      throw new Error("tree.size does not match sum case branch sizes");
    }
    if (idx <= leftSize - 1) {
      tree = tree.left;
    } else if (idx <= leftSize + middleSize - 1) {
      tree = tree.middle;
      idx = idx - leftSize;
    } else {
      tree = tree.right;
      idx = idx - leftSize - middleSize;
    }
  }
  throw new Error(`Failed to get ${idx}`);
}
function first(tree) {
  if (listLen(tree) > 0) {
    return listGet(tree, 0);
  } else {
    throw new Error("Cannot get from empty list");
  }
}
function assocList(tree, idx, item) {
  if (idx < 0) {
    throw new Error("Cannot index negative number");
  }
  if (idx > tree.size - 1) {
    throw new Error("Index too large");
  }
  if (tree.kind === TernaryTreeKind.ternaryTreeLeaf) {
    if (idx === 0) {
      return {kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: item};
    } else {
      throw new Error(`Cannot get from leaf with index ${idx}`);
    }
  }
  let leftSize = listLen(tree.left);
  let middleSize = listLen(tree.middle);
  let rightSize = listLen(tree.right);
  if (leftSize + middleSize + rightSize !== tree.size)
    throw new Error("tree.size does not match sum case branch sizes");
  if (idx <= leftSize - 1) {
    let changedBranch = assocList(tree.left, idx, item);
    let result = {
      kind: TernaryTreeKind.ternaryTreeBranch,
      size: tree.size,
      depth: decideParentDepth(changedBranch, tree.middle, tree.right),
      left: changedBranch,
      middle: tree.middle,
      right: tree.right
    };
    return result;
  } else if (idx <= leftSize + middleSize - 1) {
    let changedBranch = assocList(tree.middle, idx - leftSize, item);
    let result = {
      kind: TernaryTreeKind.ternaryTreeBranch,
      size: tree.size,
      depth: decideParentDepth(tree.left, changedBranch, tree.right),
      left: tree.left,
      middle: changedBranch,
      right: tree.right
    };
    return result;
  } else {
    let changedBranch = assocList(tree.right, idx - leftSize - middleSize, item);
    let result = {
      kind: TernaryTreeKind.ternaryTreeBranch,
      size: tree.size,
      depth: decideParentDepth(tree.left, tree.middle, changedBranch),
      left: tree.left,
      middle: tree.middle,
      right: changedBranch
    };
    return result;
  }
}
function dissocList(tree, idx) {
  if (tree == null) {
    throw new Error("dissoc does not work on null");
  }
  if (idx < 0) {
    throw new Error(`Index is negative ${idx}`);
  }
  if (listLen(tree) === 0) {
    throw new Error("Cannot remove from empty list");
  }
  if (idx > listLen(tree) - 1) {
    throw new Error(`Index too large ${idx}`);
  }
  if (listLen(tree) === 1) {
    return emptyBranch2;
  }
  if (tree.kind === TernaryTreeKind.ternaryTreeLeaf) {
    throw new Error("dissoc should be handled at branches");
  }
  let leftSize = listLen(tree.left);
  let middleSize = listLen(tree.middle);
  let rightSize = listLen(tree.right);
  if (leftSize + middleSize + rightSize !== tree.size) {
    throw new Error("tree.size does not match sum from branch sizes");
  }
  let result = emptyBranch2;
  if (idx <= leftSize - 1) {
    let changedBranch = dissocList(tree.left, idx);
    if (changedBranch == null || changedBranch.size === 0) {
      result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        size: tree.size - 1,
        depth: decideParentDepth(tree.middle, tree.right),
        left: tree.middle,
        middle: tree.right,
        right: emptyBranch2
      };
    } else {
      result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        size: tree.size - 1,
        depth: decideParentDepth(changedBranch, tree.middle, tree.right),
        left: changedBranch,
        middle: tree.middle,
        right: tree.right
      };
    }
  } else if (idx <= leftSize + middleSize - 1) {
    let changedBranch = dissocList(tree.middle, idx - leftSize);
    if (changedBranch == null || changedBranch.size === 0) {
      result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        size: tree.size - 1,
        depth: decideParentDepth(tree.left, changedBranch, tree.right),
        left: tree.left,
        middle: tree.right,
        right: emptyBranch2
      };
    } else {
      result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        size: tree.size - 1,
        depth: decideParentDepth(tree.left, changedBranch, tree.right),
        left: tree.left,
        middle: changedBranch,
        right: tree.right
      };
    }
  } else {
    let changedBranch = dissocList(tree.right, idx - leftSize - middleSize);
    if (changedBranch == null || changedBranch.size === 0) {
      changedBranch = emptyBranch2;
    }
    result = {
      kind: TernaryTreeKind.ternaryTreeBranch,
      size: tree.size - 1,
      depth: decideParentDepth(tree.left, tree.middle, changedBranch),
      left: tree.left,
      middle: tree.middle,
      right: changedBranch
    };
  }
  if (result.middle == null) {
    return result.left;
  }
  return result;
}
function rest(tree) {
  if (tree == null) {
    throw new Error("Cannot call rest on null");
  }
  if (listLen(tree) < 1) {
    throw new Error("Cannot call rest on empty list");
  }
  return dissocList(tree, 0);
}
function insert(tree, idx, item, after = false) {
  if (tree == null) {
    throw new Error("Cannot insert into null");
  }
  if (listLen(tree) === 0) {
    throw new Error("Empty node is not a correct position for inserting");
  }
  if (tree.kind === TernaryTreeKind.ternaryTreeLeaf) {
    if (after) {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        depth: getDepth(tree) + 1,
        size: 2,
        left: tree,
        middle: {kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: item},
        right: emptyBranch2
      };
      return result;
    } else {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        depth: getDepth(tree) + 1,
        size: 2,
        left: {kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: item},
        middle: tree,
        right: emptyBranch2
      };
      return result;
    }
  }
  if (listLen(tree) === 1) {
    if (after) {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        size: 2,
        depth: 2,
        left: tree.left,
        middle: {kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: item},
        right: emptyBranch2
      };
      return result;
    } else {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        size: 2,
        depth: getDepth(tree.middle) + 1,
        left: {kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: item},
        middle: tree.left,
        right: emptyBranch2
      };
      return result;
    }
  }
  if (listLen(tree) === 2 && tree.middle != null) {
    if (after) {
      if (idx === 0) {
        let result = {
          kind: TernaryTreeKind.ternaryTreeBranch,
          size: 3,
          depth: 2,
          left: tree.left,
          middle: {kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: item},
          right: tree.middle
        };
        return result;
      }
      if (idx === 1) {
        let result = {
          kind: TernaryTreeKind.ternaryTreeBranch,
          size: 3,
          depth: 2,
          left: tree.left,
          middle: tree.middle,
          right: {kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: item}
        };
        return result;
      } else {
        throw new Error("cannot insert after position 2 since only 2 elements here");
      }
    } else {
      if (idx === 0) {
        let result = {
          kind: TernaryTreeKind.ternaryTreeBranch,
          size: 3,
          depth: 2,
          left: {kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: item},
          middle: tree.left,
          right: tree.middle
        };
        return result;
      } else if (idx === 1) {
        let result = {
          kind: TernaryTreeKind.ternaryTreeBranch,
          size: 3,
          depth: 2,
          left: tree.left,
          middle: {kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: item},
          right: tree.middle
        };
        return result;
      } else {
        throw new Error("cannot insert before position 2 since only 2 elements here");
      }
    }
  }
  let leftSize = listLen(tree.left);
  let middleSize = listLen(tree.middle);
  let rightSize = listLen(tree.right);
  if (leftSize + middleSize + rightSize !== tree.size) {
    throw new Error("tree.size does not match sum case branch sizes");
  }
  if (idx === 0 && !after) {
    if (listLen(tree.left) >= listLen(tree.middle) && listLen(tree.left) >= listLen(tree.right)) {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        size: tree.size + 1,
        depth: tree.depth + 1,
        left: {kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: item},
        middle: tree,
        right: emptyBranch2
      };
      return result;
    }
  }
  if (idx === listLen(tree) - 1 && after) {
    if (listLen(tree.right) >= listLen(tree.middle) && listLen(tree.right) >= listLen(tree.left)) {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        size: tree.size + 1,
        depth: tree.depth + 1,
        left: tree,
        middle: {kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: item},
        right: emptyBranch2
      };
      return result;
    }
  }
  if (after && idx === listLen(tree) - 1 && rightSize === 0 && middleSize >= leftSize) {
    let result = {
      kind: TernaryTreeKind.ternaryTreeBranch,
      size: tree.size + 1,
      depth: tree.depth,
      left: tree.left,
      middle: tree.middle,
      right: {kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: item}
    };
    return result;
  }
  if (!after && idx === 0 && rightSize === 0 && middleSize >= rightSize) {
    let result = {
      kind: TernaryTreeKind.ternaryTreeBranch,
      size: tree.size + 1,
      depth: tree.depth,
      left: {kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: item},
      middle: tree.left,
      right: tree.middle
    };
    return result;
  }
  if (idx <= leftSize - 1) {
    let changedBranch = insert(tree.left, idx, item, after);
    let result = {
      kind: TernaryTreeKind.ternaryTreeBranch,
      size: tree.size + 1,
      depth: decideParentDepth(changedBranch, tree.middle, tree.right),
      left: changedBranch,
      middle: tree.middle,
      right: tree.right
    };
    return result;
  } else if (idx <= leftSize + middleSize - 1) {
    let changedBranch = insert(tree.middle, idx - leftSize, item, after);
    let result = {
      kind: TernaryTreeKind.ternaryTreeBranch,
      size: tree.size + 1,
      depth: decideParentDepth(tree.left, changedBranch, tree.right),
      left: tree.left,
      middle: changedBranch,
      right: tree.right
    };
    return result;
  } else {
    let changedBranch = insert(tree.right, idx - leftSize - middleSize, item, after);
    let result = {
      kind: TernaryTreeKind.ternaryTreeBranch,
      size: tree.size + 1,
      depth: decideParentDepth(tree.left, tree.middle, changedBranch),
      left: tree.left,
      middle: tree.middle,
      right: changedBranch
    };
    return result;
  }
}
function assocBefore(tree, idx, item, after = false) {
  return insert(tree, idx, item, false);
}
function assocAfter(tree, idx, item, after = false) {
  return insert(tree, idx, item, true);
}
function forceListInplaceBalancing(tree) {
  if (tree.kind === TernaryTreeKind.ternaryTreeBranch) {
    let ys = toLeavesArray(tree);
    let newTree = makeTernaryTreeList(ys.length, 0, ys);
    tree.left = newTree.left;
    tree.middle = newTree.middle;
    tree.right = newTree.right;
    tree.depth = decideParentDepth(tree.left, tree.middle, tree.right);
  } else {
  }
}
function maybeReblance(tree) {
  let currentDepth = getDepth(tree);
  if (currentDepth > 50) {
    if (roughIntPow(3, currentDepth - 50) > tree.size) {
      forceListInplaceBalancing(tree);
    }
  }
}
function prepend(tree, item, disableBalancing = false) {
  if (tree == null || listLen(tree) === 0) {
    return {kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: item};
  }
  let result = insert(tree, 0, item, false);
  if (!disableBalancing) {
    maybeReblance(result);
  }
  return result;
}
function append(tree, item, disableBalancing = false) {
  if (tree == null || listLen(tree) === 0) {
    return {kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: item};
  }
  let result = insert(tree, listLen(tree) - 1, item, true);
  if (!disableBalancing) {
    maybeReblance(result);
  }
  return result;
}
function concat(...xsGroups) {
  xsGroups = xsGroups.filter((xs) => listLen(xs) > 0);
  let result = makeTernaryTreeList(xsGroups.length, 0, xsGroups);
  maybeReblance(result);
  return result;
}
function slice(tree, startIdx, endIdx) {
  if (endIdx > listLen(tree)) {
    throw new Error("Slice range too large {endIdx} for {tree}");
  }
  if (startIdx < 0) {
    throw new Error("Slice range too small {startIdx} for {tree}");
  }
  if (startIdx > endIdx) {
    throw new Error("Invalid slice range {startIdx}..{endIdx} for {tree}");
  }
  if (startIdx === endIdx) {
    return {kind: TernaryTreeKind.ternaryTreeBranch, size: 0, depth: 0};
  }
  if (tree.kind === TernaryTreeKind.ternaryTreeLeaf)
    if (startIdx === 0 && endIdx === 1) {
      return tree;
    } else {
      throw new Error(`Invalid slice range for a leaf: ${startIdx} ${endIdx}`);
    }
  if (startIdx === 0 && endIdx === listLen(tree)) {
    return tree;
  }
  let leftSize = listLen(tree.left);
  let middleSize = listLen(tree.middle);
  let rightSize = listLen(tree.right);
  if (startIdx >= leftSize + middleSize) {
    return slice(tree.right, startIdx - leftSize - middleSize, endIdx - leftSize - middleSize);
  }
  if (startIdx >= leftSize)
    if (endIdx <= leftSize + middleSize) {
      return slice(tree.middle, startIdx - leftSize, endIdx - leftSize);
    } else {
      let middleCut = slice(tree.middle, startIdx - leftSize, middleSize);
      let rightCut = slice(tree.right, 0, endIdx - leftSize - middleSize);
      return concat(middleCut, rightCut);
    }
  if (endIdx <= leftSize) {
    return slice(tree.left, startIdx, endIdx);
  }
  if (endIdx <= leftSize + middleSize) {
    let leftCut = slice(tree.left, startIdx, leftSize);
    let middleCut = slice(tree.middle, 0, endIdx - leftSize);
    return concat(leftCut, middleCut);
  }
  if (endIdx <= leftSize + middleSize + rightSize) {
    let leftCut = slice(tree.left, startIdx, leftSize);
    let rightCut = slice(tree.right, 0, endIdx - leftSize - middleSize);
    return concat(concat(leftCut, tree.middle), rightCut);
  }
  throw new Error("Unknown");
}
function reverse(tree) {
  if (tree == null) {
    return tree;
  }
  switch (tree.kind) {
    case TernaryTreeKind.ternaryTreeLeaf:
      return tree;
    case TernaryTreeKind.ternaryTreeBranch: {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        size: tree.size,
        depth: tree.depth,
        left: reverse(tree.right),
        middle: reverse(tree.middle),
        right: reverse(tree.left)
      };
      return result;
    }
  }
}
function listMapValues(tree, f) {
  if (tree == null) {
    return tree;
  }
  switch (tree.kind) {
    case TernaryTreeKind.ternaryTreeLeaf: {
      let result = {
        kind: TernaryTreeKind.ternaryTreeLeaf,
        size: tree.size,
        value: f(tree.value)
      };
      return result;
    }
    case TernaryTreeKind.ternaryTreeBranch: {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        size: tree.size,
        depth: tree.depth,
        left: tree.left == null ? emptyBranch2 : listMapValues(tree.left, f),
        middle: tree.middle == null ? emptyBranch2 : listMapValues(tree.middle, f),
        right: tree.right == null ? emptyBranch2 : listMapValues(tree.right, f)
      };
      return result;
    }
  }
}

// node_modules/@calcit/procs/lib/calcit.procs.js
var import_parser = __toModule(require_lib());

// node_modules/@calcit/procs/lib/js-set.js
var DATA_EQUAL = (x, y) => {
  return x === y;
};
var overwriteSetComparator = (f) => {
  DATA_EQUAL = f;
};
var CalcitSet = class {
  constructor(value) {
    this.cachedHash = null;
    if (Array.isArray(value)) {
      let pairs = [];
      outer:
        for (let idx = 0; idx < value.length; idx++) {
          for (let j = 0; j < pairs.length; j++) {
            if (DATA_EQUAL(pairs[j][0], value[idx])) {
              continue outer;
            }
          }
          pairs.push([value[idx], true]);
        }
      this.value = initTernaryTreeMap(pairs);
    } else {
      this.value = value;
    }
  }
  len() {
    return mapLen(this.value);
  }
  contains(y) {
    return contains(this.value, y);
  }
  include(y) {
    var result = this.value;
    result = assocMap(result, y, true);
    return new CalcitSet(result);
  }
  exclude(y) {
    var result = this.value;
    result = dissocMap(result, y);
    return new CalcitSet(result);
  }
  difference(ys) {
    let result = this.value;
    for (let k of toKeys(ys.value)) {
      result = dissocMap(result, k);
    }
    return new CalcitSet(result);
  }
  union(ys) {
    let result = this.value;
    for (let k of toKeys(ys.value)) {
      result = assocMap(result, k, true);
    }
    return new CalcitSet(result);
  }
  intersection(ys) {
    let result = initTernaryTreeMap([]);
    for (let k of toKeys(this.value)) {
      if (ys.contains(k)) {
        result = assocMap(result, k, true);
      }
    }
    return new CalcitSet(result);
  }
  first() {
    if (mapLen(this.value) == 0) {
      return null;
    }
    return toPairsArray(this.value)[0][0];
  }
  rest() {
    if (mapLen(this.value) == 0) {
      return null;
    }
    let x0 = this.first();
    let result = dissocMap(this.value, x0);
    return new CalcitSet(result);
  }
  toString() {
    let itemsCode = "";
    for (let k of toKeys(this.value)) {
      itemsCode = `${itemsCode} ${toString(k, true)}`;
    }
    return `(#{}${itemsCode})`;
  }
  values() {
    return [...toKeys(this.value)];
  }
};

// node_modules/@calcit/procs/lib/js-map.js
var DATA_EQUAL2 = (x, y) => {
  return x === y;
};
var overwriteMapComparator = (f) => {
  DATA_EQUAL2 = f;
};
var fakeUniqueSymbol = [];
var CalcitMap = class {
  constructor(value) {
    if (value == null) {
      this.arrayMode = true;
      this.arrayValue = [];
    } else if (Array.isArray(value)) {
      this.arrayMode = true;
      this.arrayValue = value;
    } else {
      this.arrayMode = false;
      this.value = value;
    }
  }
  turnMap() {
    if (this.arrayMode) {
      var dict = [];
      let halfLength = this.arrayValue.length >> 1;
      for (let idx = 0; idx < halfLength; idx++) {
        dict.push([this.arrayValue[idx << 1], this.arrayValue[(idx << 1) + 1]]);
      }
      this.value = initTernaryTreeMap(dict);
      this.arrayMode = false;
      this.arrayValue = null;
    }
  }
  len() {
    if (this.arrayMode) {
      return this.arrayValue.length >> 1;
    } else {
      return mapLen(this.value);
    }
  }
  get(k) {
    if (this.arrayMode && this.arrayValue.length <= 16) {
      let size = this.arrayValue.length >> 1;
      for (let i = 0; i < size; i++) {
        let pos = i << 1;
        if (DATA_EQUAL2(this.arrayValue[pos], k)) {
          return this.arrayValue[pos + 1];
        }
      }
      return null;
    } else {
      this.turnMap();
      return mapGetDefault(this.value, k, null);
    }
  }
  assoc(...args) {
    if (args.length % 2 !== 0)
      throw new Error("expected even arguments");
    let size = Math.floor(args.length / 2);
    if (this.arrayMode && this.arrayValue.length <= 16) {
      let ret = this.arrayValue.slice(0);
      outer:
        for (let j = 0; j < size; j++) {
          let k = args[j << 1];
          let v = args[(j << 1) + 1];
          for (let i = 0; i < ret.length; i += 2) {
            if (DATA_EQUAL2(k, ret[i])) {
              ret[i + 1] = v;
              continue outer;
            }
          }
          ret.push(k, v);
        }
      return new CalcitMap(ret);
    } else {
      this.turnMap();
      let result = this.value;
      for (let idx = 0; idx < size; idx++) {
        let k = args[idx << 1];
        let v = args[(idx << 1) + 1];
        result = assocMap(result, k, v);
      }
      return new CalcitMap(result);
    }
  }
  dissoc(...args) {
    if (this.arrayMode && this.arrayValue.length <= 16) {
      let ret = [];
      outer:
        for (let i = 0; i < this.arrayValue.length; i += 2) {
          for (let j = 0; j < args.length; j++) {
            let k = args[j];
            if (DATA_EQUAL2(k, this.arrayValue[i])) {
              continue outer;
            }
          }
          ret.push(this.arrayValue[i], this.arrayValue[i + 1]);
        }
      return new CalcitMap(ret);
    } else {
      this.turnMap();
      let ret = this.value;
      for (let idx = 0; idx < args.length; idx++) {
        ret = dissocMap(ret, args[idx]);
      }
      return new CalcitMap(ret);
    }
  }
  toString(shorter = false) {
    let itemsCode = "";
    for (let [k, v] of this.pairs()) {
      if (shorter) {
        let keyPart = isNestedCalcitData(k) ? tipNestedCalcitData(k) : toString(k, true);
        let valuePart = isNestedCalcitData(v) ? tipNestedCalcitData(v) : toString(v, true);
        itemsCode = `${itemsCode} (${keyPart} ${valuePart})`;
      } else {
        itemsCode = `${itemsCode} (${toString(k, true)} ${toString(v, true)})`;
      }
    }
    return `({}${itemsCode})`;
  }
  isEmpty() {
    if (this.arrayMode) {
      return this.arrayValue.length === 0;
    } else {
      return isMapEmpty(this.value);
    }
  }
  pairs() {
    if (this.arrayMode) {
      let ret = [];
      let size = this.arrayValue.length >> 1;
      for (let i = 0; i < size; i++) {
        let pos = i << 1;
        ret.push([this.arrayValue[pos], this.arrayValue[pos + 1]]);
      }
      return ret;
    } else {
      return toPairsArray(this.value);
    }
  }
  keysArray() {
    if (this.arrayMode) {
      let ret = [];
      let size = this.arrayValue.length >> 1;
      for (let i = 0; i < size; i++) {
        let pos = i << 1;
        ret.push(this.arrayValue[pos]);
      }
      return ret;
    } else {
      return [...toKeys(this.value)];
    }
  }
  contains(k) {
    if (this.arrayMode && this.arrayValue.length <= 16) {
      let size = this.arrayValue.length >> 1;
      for (let i = 0; i < size; i++) {
        let pos = i << 1;
        if (DATA_EQUAL2(this.arrayValue[pos], k)) {
          return true;
        }
      }
      return false;
    } else {
      this.turnMap();
      return contains(this.value, k);
    }
  }
  merge(ys) {
    return this.mergeSkip(ys, fakeUniqueSymbol);
  }
  mergeSkip(ys, v) {
    if (ys == null) {
      return this;
    }
    if (!(ys instanceof CalcitMap)) {
      console.error("value:", v);
      throw new Error("Expected map to merge");
    }
    if (this.arrayMode && ys.arrayMode && this.arrayValue.length + ys.arrayValue.length <= 24) {
      let ret = this.arrayValue.slice(0);
      outer:
        for (let i = 0; i < ys.arrayValue.length; i = i + 2) {
          if (ys.arrayValue[i + 1] === v) {
            continue;
          }
          for (let k = 0; k < ret.length; k = k + 2) {
            if (DATA_EQUAL2(ys.arrayValue[i], ret[k])) {
              ret[k + 1] = ys.arrayValue[i + 1];
              continue outer;
            }
          }
          ret.push(ys.arrayValue[i], ys.arrayValue[i + 1]);
        }
      return new CalcitMap(ret);
    }
    this.turnMap();
    if (ys.arrayMode) {
      let ret = this.value;
      let size = ys.arrayValue.length >> 1;
      for (let i = 0; i < size; i++) {
        let pos = i << 1;
        if (ys.arrayValue[pos + 1] === v) {
          continue;
        }
        ret = assocMap(ret, ys.arrayValue[pos], ys.arrayValue[pos + 1]);
      }
      return new CalcitMap(ret);
    } else {
      return new CalcitMap(mergeSkip(this.value, ys.value, v));
    }
  }
  diffNew(ys) {
    this.turnMap();
    let zs = this.value;
    if (ys.arrayMode) {
      let size = ys.arrayValue.length >> 1;
      for (let i = 0; i < size; i++) {
        let pos = i << 1;
        let k = ys.arrayValue[pos];
        if (contains(zs, k)) {
          zs = dissocMap(zs, k);
        }
      }
      return new CalcitMap(zs);
    } else {
      let ysKeys = ys.keysArray();
      for (let i = 0; i < ysKeys.length; i++) {
        let k = ysKeys[i];
        if (contains(zs, k)) {
          zs = dissocMap(zs, k);
        }
      }
      return new CalcitMap(zs);
    }
  }
  diffKeys(ys) {
    let ret = [];
    let ks = this.keysArray();
    for (let i = 0; i < ks.length; i++) {
      let k = ks[i];
      if (!ys.contains(k)) {
        ret.push(k);
      }
    }
    return new CalcitSet(ret);
  }
  commonKeys(ys) {
    let ret = [];
    let ks = this.keysArray();
    for (let i = 0; i < ks.length; i++) {
      let k = ks[i];
      if (ys.contains(k)) {
        ret.push(k);
      }
    }
    return new CalcitSet(ret);
  }
};

// node_modules/@calcit/procs/lib/js-record.js
var CalcitRecord = class {
  constructor(name, fields, values) {
    this.name = name;
    let fieldNames = fields.map(getStringName);
    this.fields = fieldNames;
    if (values != null) {
      if (values.length != fields.length) {
        throw new Error("value length not match");
      }
      this.values = values;
    } else {
      this.values = new Array(fieldNames.length);
    }
    this.cachedHash = null;
  }
  get(k) {
    let field = getStringName(k);
    let idx = findInFields(this.fields, field);
    if (idx >= 0) {
      return this.values[idx];
    } else {
      throw new Error(`Cannot find :${field} among (${this.fields.join(",")})`);
    }
  }
  assoc(k, v) {
    let values = new Array(this.fields.length);
    let name = getStringName(k);
    for (let idx in this.fields) {
      if (this.fields[idx] === name) {
        values[idx] = v;
      } else {
        values[idx] = this.values[idx];
      }
    }
    return new CalcitRecord(this.name, this.fields, values);
  }
  merge() {
  }
  contains(k) {
    let field = getStringName(k);
    let idx = findInFields(this.fields, field);
    return idx >= 0;
  }
  toString() {
    let ret = "(%{} " + this.name;
    for (let idx in this.fields) {
      ret += " (" + this.fields[idx] + " " + toString(this.values[idx], true) + ")";
    }
    return ret + ")";
  }
};
var new_record = (name, ...fields) => {
  let fieldNames = fields.map(getStringName).sort();
  return new CalcitRecord(getStringName(name), fieldNames);
};
var fieldPairOrder = (a2, b) => {
  if (a2[0] < b[0]) {
    return -1;
  } else if (a2[0] > b[0]) {
    return 1;
  } else {
    return 0;
  }
};
var fieldsEqual = (xs, ys) => {
  if (xs === ys) {
    return true;
  }
  if (xs.length !== ys.length) {
    return false;
  }
  for (let idx = 0; idx < xs.length; idx++) {
    if (xs[idx] !== ys[idx]) {
      return false;
    }
  }
  return true;
};
var _$n__PCT__$M_ = (proto, ...xs) => {
  if (proto instanceof CalcitRecord) {
    if (xs.length % 2 !== 0) {
      throw new Error("Expected even number of key/value");
    }
    if (xs.length !== proto.fields.length * 2) {
      throw new Error("fields size does not match");
    }
    let values = new Array(proto.fields.length);
    for (let i = 0; i < proto.fields.length; i++) {
      let idx = -1;
      let k = proto.fields[i];
      for (let j = 0; j < proto.fields.length; j++) {
        if (k === getStringName(xs[j * 2])) {
          idx = j;
          break;
        }
      }
      if (idx < 0) {
        throw new Error("invalid field name for this record");
      }
      if (values[i] != null) {
        throw new Error("record field already has value, probably duplicated key");
      }
      values[i] = xs[idx * 2 + 1];
    }
    return new CalcitRecord(proto.name, proto.fields, values);
  } else {
    throw new Error("Expected prototype to be a record");
  }
};
var _$n_record_$o_get_name = (x) => {
  if (x instanceof CalcitRecord) {
    return x.name;
  } else {
    throw new Error("Expected a record");
  }
};
var _$n_record_$o_from_map = (proto, data) => {
  if (proto instanceof CalcitRecord) {
    if (data instanceof CalcitRecord) {
      if (fieldsEqual(proto.fields, data.fields)) {
        return new CalcitRecord(proto.name, proto.fields, data.values);
      } else {
        let values = [];
        for (let field of proto.fields) {
          let idx = data.fields.indexOf(field);
          if (idx < 0) {
            throw new Error(`Cannot find field ${field} among ${data.fields}`);
          }
          values.push(data.values[idx]);
        }
        return new CalcitRecord(proto.name, proto.fields, values);
      }
    } else if (data instanceof CalcitMap) {
      let pairs = [];
      for (let [k, v] of data.pairs()) {
        pairs.push([getStringName(k), v]);
      }
      pairs.sort(fieldPairOrder);
      let values = [];
      outerLoop:
        for (let field of proto.fields) {
          for (let pair of pairs) {
            if (pair[0] === field) {
              values.push(pair[1]);
              continue outerLoop;
            }
          }
          throw new Error(`Cannot find field ${field} among ${pairs}`);
        }
      return new CalcitRecord(proto.name, proto.fields, values);
    } else {
      throw new Error("Expected record or data for making a record");
    }
  } else {
    throw new Error("Expected prototype to be record");
  }
};
var _$n_record_$o_to_map = (x) => {
  if (x instanceof CalcitRecord) {
    var dict = [];
    for (let idx in x.fields) {
      dict.push([kwd(x.fields[idx]), x.values[idx]]);
    }
    return new CalcitMap(initTernaryTreeMap(dict));
  } else {
    throw new Error("Expected record");
  }
};
var _$n_record_$o_matches_$q_ = (x, y) => {
  if (!(x instanceof CalcitRecord)) {
    throw new Error("Expected record");
  }
  if (!(y instanceof CalcitRecord)) {
    throw new Error("Expected record");
  }
  if (x.name !== y.name) {
    return false;
  }
  return fieldsEqual(x.fields, y.fields);
};
function _$n_record_$o_extend_as(obj, new_name, new_key, new_value) {
  if (arguments.length !== 4)
    throw new Error(`Expected 4 arguments, got ${arguments.length}`);
  if (!(obj instanceof CalcitRecord))
    throw new Error("Expected record");
  let field = getStringName(new_key);
  let new_name_string = getStringName(new_name);
  let new_fields = [];
  let new_values = [];
  let inserted = false;
  for (let i in new_fields) {
    let k = new_fields[i];
    if (inserted) {
      new_fields.push(k);
      new_values.push(obj.values[i]);
    } else {
      if (field < k) {
        new_fields.push(field);
        new_values.push(new_value);
        new_fields.push(k);
        new_values.push(obj.values[i]);
      } else if (field > k) {
        new_fields.push(k);
        new_values.push(obj.values[i]);
      } else {
        throw new Error("Does not extend existed record field");
      }
    }
  }
  if (!inserted) {
    new_fields.push(field);
    new_values.push(new_value);
  }
  return new CalcitRecord(new_name_string, new_fields, new_values);
}

// node_modules/@calcit/procs/lib/js-list.js
var CalcitList = class {
  constructor(value) {
    if (value == null) {
      value = [];
    }
    this.cachedHash = null;
    if (Array.isArray(value)) {
      this.arrayMode = true;
      this.arrayValue = value;
      this.arrayStart = 0;
      this.arrayEnd = value.length;
      this.value = null;
    } else {
      this.arrayMode = false;
      this.value = value;
      this.arrayValue = [];
      this.arrayStart = null;
      this.arrayEnd = null;
    }
  }
  turnListMode() {
    if (this.arrayMode) {
      this.value = initTernaryTreeList(this.arrayValue.slice(this.arrayStart, this.arrayEnd));
      this.arrayValue = null;
      this.arrayStart = null;
      this.arrayEnd = null;
      this.arrayMode = false;
    }
  }
  len() {
    if (this.arrayMode) {
      return this.arrayEnd - this.arrayStart;
    } else {
      return listLen(this.value);
    }
  }
  get(idx) {
    if (this.arrayMode) {
      return this.arrayValue[this.arrayStart + idx];
    } else {
      return listGet(this.value, idx);
    }
  }
  assoc(idx, v) {
    this.turnListMode();
    return new CalcitList(assocList(this.value, idx, v));
  }
  assocBefore(idx, v) {
    this.turnListMode();
    return new CalcitList(assocBefore(this.value, idx, v));
  }
  assocAfter(idx, v) {
    this.turnListMode();
    return new CalcitList(assocAfter(this.value, idx, v));
  }
  dissoc(idx) {
    this.turnListMode();
    return new CalcitList(dissocList(this.value, idx));
  }
  slice(from, to) {
    if (this.arrayMode) {
      if (from < 0) {
        throw new Error(`from index too small: ${from}`);
      }
      if (to > this.len()) {
        throw new Error(`end index too large: ${to}`);
      }
      if (to < from) {
        throw new Error("end index too small");
      }
      let result = new CalcitList(this.arrayValue);
      result.arrayStart = this.arrayStart + from;
      result.arrayEnd = this.arrayStart + to;
      return result;
    } else {
      return new CalcitList(slice(this.value, from, to));
    }
  }
  toString(shorter = false) {
    let result = "";
    for (let item of this.items()) {
      if (shorter && isNestedCalcitData(item)) {
        result = `${result} ${tipNestedCalcitData(item)}`;
      } else {
        result = `${result} ${toString(item, true)}`;
      }
    }
    return `([]${result})`;
  }
  isEmpty() {
    return this.len() === 0;
  }
  items() {
    if (this.arrayMode) {
      return sliceGenerator(this.arrayValue, this.arrayStart, this.arrayEnd);
    } else {
      return listToItems(this.value);
    }
  }
  append(v) {
    if (this.arrayMode && this.arrayEnd === this.arrayValue.length && this.arrayStart < 32) {
      this.arrayValue.push(v);
      let newList = new CalcitList(this.arrayValue);
      newList.arrayStart = this.arrayStart;
      newList.arrayEnd = this.arrayEnd + 1;
      return newList;
    } else {
      this.turnListMode();
      return new CalcitList(append(this.value, v));
    }
  }
  prepend(v) {
    this.turnListMode();
    return new CalcitList(prepend(this.value, v));
  }
  first() {
    if (this.arrayMode) {
      if (this.arrayValue.length > this.arrayStart) {
        return this.arrayValue[this.arrayStart];
      } else {
        return null;
      }
    } else {
      return first(this.value);
    }
  }
  rest() {
    if (this.arrayMode) {
      return this.slice(1, this.arrayEnd - this.arrayStart);
    } else {
      return new CalcitList(rest(this.value));
    }
  }
  concat(ys) {
    if (!(ys instanceof CalcitList)) {
      throw new Error("Expected list");
    }
    if (this.arrayMode && ys.arrayMode) {
      let size = this.arrayEnd - this.arrayStart;
      let otherSize = ys.arrayEnd - ys.arrayStart;
      let combined = new Array(size + otherSize);
      for (let i = 0; i < size; i++) {
        combined[i] = this.get(i);
      }
      for (let i = 0; i < otherSize; i++) {
        combined[i + size] = ys.get(i);
      }
      return new CalcitList(combined);
    } else {
      this.turnListMode();
      ys.turnListMode();
      return new CalcitList(concat(this.value, ys.value));
    }
  }
  map(f) {
    if (this.arrayMode) {
      return new CalcitList(this.arrayValue.slice(this.arrayStart, this.arrayEnd).map(f));
    } else {
      return new CalcitList(listMapValues(this.value, f));
    }
  }
  toArray() {
    if (this.arrayMode) {
      return this.arrayValue.slice(this.arrayStart, this.arrayEnd);
    } else {
      return [...listToItems(this.value)];
    }
  }
  reverse() {
    this.turnListMode();
    return new CalcitList(reverse(this.value));
  }
};
function* sliceGenerator(xs, start, end) {
  for (let idx = start; idx < end; idx++) {
    yield xs[idx];
  }
}
var foldl = function(xs, acc, f) {
  if (arguments.length !== 3) {
    throw new Error("foldl takes 3 arguments");
  }
  if (f == null) {
    debugger;
    throw new Error("Expected function for folding");
  }
  if (xs instanceof CalcitList) {
    var result = acc;
    for (let idx = 0; idx < xs.len(); idx++) {
      let item = xs.get(idx);
      result = f(result, item);
    }
    return result;
  }
  if (xs instanceof CalcitSet) {
    let result2 = acc;
    xs.values().forEach((item) => {
      result2 = f(result2, item);
    });
    return result2;
  }
  if (xs instanceof CalcitMap) {
    let result2 = acc;
    xs.pairs().forEach(([k, item]) => {
      result2 = f(result2, new CalcitList([k, item]));
    });
    return result2;
  }
  throw new Error("Unknow data for foldl");
};
var foldl_shortcut = function(xs, acc, v0, f) {
  if (arguments.length !== 4) {
    throw new Error("foldl-shortcut takes 4 arguments");
  }
  if (f == null) {
    debugger;
    throw new Error("Expected function for folding");
  }
  if (xs instanceof CalcitList) {
    var state = acc;
    for (let idx = 0; idx < xs.len(); idx++) {
      let item = xs.get(idx);
      let pair = f(state, item);
      if (pair instanceof CalcitList && pair.len() === 2) {
        if (typeof pair.get(0) === "boolean") {
          if (pair.get(0)) {
            return pair.get(1);
          } else {
            state = pair.get(1);
          }
        }
      } else {
        throw new Error("Expected return value in `[bool, acc]` structure");
      }
    }
    return v0;
  }
  if (xs instanceof CalcitSet) {
    let state2 = acc;
    for (let item of xs.values()) {
      let pair = f(state2, item);
      if (pair instanceof CalcitList && pair.len() === 2) {
        if (typeof pair.get(0) === "boolean") {
          if (pair.get(0)) {
            return pair.get(1);
          } else {
            state2 = pair.get(1);
          }
        }
      } else {
        throw new Error("Expected return value in `[bool, acc]` structure");
      }
    }
    return v0;
  }
  if (xs instanceof CalcitMap) {
    let state2 = acc;
    for (let item of xs.pairs()) {
      let pair = f(state2, new CalcitList(item));
      if (pair instanceof CalcitList && pair.len() === 2) {
        if (typeof pair.get(0) === "boolean") {
          if (pair.get(0)) {
            return pair.get(1);
          } else {
            state2 = pair.get(1);
          }
        }
      } else {
        throw new Error("Expected return value in `[bool, acc]` structure");
      }
    }
    return v0;
  }
  throw new Error("Unknow data for foldl-shortcut");
};

// node_modules/@calcit/procs/lib/js-tuple.js
var CalcitTuple = class {
  constructor(a2, b) {
    this.fst = a2;
    this.snd = b;
    this.cachedHash = null;
  }
  get(n) {
    if (n == 0) {
      return this.fst;
    } else if (n == 1) {
      return this.snd;
    } else {
      throw new Error("Tuple only have 2 elements");
    }
  }
  assoc(n, v) {
    if (n == 0) {
      return new CalcitTuple(v, this.snd);
    } else if (n == 1) {
      return new CalcitTuple(this.fst, v);
    } else {
      throw new Error("Tuple only have 2 elements");
    }
  }
  toString() {
    return `(&tuple ${this.fst.toString()} ${this.snd.toString()})`;
  }
};

// node_modules/@calcit/procs/lib/calcit-data.js
var calcit_dirty_hash_key = "_calcit_cached_hash";
var CalcitKeyword = class {
  constructor(x) {
    this.value = x;
    this.cachedHash = null;
  }
  toString() {
    return `:${this.value}`;
  }
};
var CalcitSymbol = class {
  constructor(x) {
    this.value = x;
    this.cachedHash = null;
  }
  toString() {
    return `'${this.value}`;
  }
};
var CalcitRecur = class {
  constructor(xs) {
    this.args = xs;
    this.cachedHash = null;
  }
  toString() {
    return `(&recur ...)`;
  }
};
var isNestedCalcitData = (x) => {
  if (x instanceof CalcitList) {
    return x.len() > 0;
  }
  if (x instanceof CalcitMap) {
    return x.len() > 0;
  }
  if (x instanceof CalcitRecord) {
    return x.fields.length > 0;
  }
  if (x instanceof CalcitSet) {
    return false;
  }
  return false;
};
var tipNestedCalcitData = (x) => {
  if (x instanceof CalcitList) {
    return "'[]...";
  }
  if (x instanceof CalcitMap) {
    return "'{}...";
  }
  if (x instanceof CalcitRecord) {
    return "'%{}...";
  }
  if (x instanceof CalcitSet) {
    return "'#{}...";
  }
  return x.toString();
};
var CalcitRef = class {
  constructor(x, path) {
    this.value = x;
    this.path = path;
    this.listeners = new Map();
    this.cachedHash = null;
  }
  toString() {
    return `(&ref ${this.value.toString()})`;
  }
};
var getStringName = (x) => {
  if (typeof x === "string") {
    return x;
  }
  if (x instanceof CalcitKeyword) {
    return x.value;
  }
  if (x instanceof CalcitSymbol) {
    return x.value;
  }
  throw new Error("Cannot get string as name");
};
function findInFields(xs, y) {
  let lower = 0;
  let upper = xs.length - 1;
  while (upper - lower > 1) {
    let pos = lower + upper >> 1;
    let v = xs[pos];
    if (y < v) {
      upper = pos - 1;
    } else if (y > v) {
      lower = pos + 1;
    } else {
      return pos;
    }
  }
  if (y == xs[lower])
    return lower;
  if (y == xs[upper])
    return upper;
  return -1;
}
var keywordRegistery = {};
var kwd = (content) => {
  let item = keywordRegistery[content];
  if (item != null) {
    return item;
  } else {
    let v = new CalcitKeyword(content);
    keywordRegistery[content] = v;
    return v;
  }
};
var refsRegistry = new Map();
var defaultHash_nil = valueHash("nil:");
var defaultHash_number = valueHash("number:");
var defaultHash_string = valueHash("string:");
var defaultHash_keyword = valueHash("keyword:");
var defaultHash_true = valueHash("bool:true");
var defaultHash_false = valueHash("bool:false");
var defaultHash_symbol = valueHash("symbol:");
var defaultHash_fn = valueHash("fn:");
var defaultHash_ref = valueHash("ref:");
var defaultHash_tuple = valueHash("tuple:");
var defaultHash_set = valueHash("set:");
var defaultHash_list = valueHash("list:");
var defaultHash_map = valueHash("map:");
var defaultHash_record = valueHash("record:");
var defaultHash_unknown = valueHash("unknown:");
var fnHashCounter = 0;
var jsObjectHashCounter = 0;
var hashFunction = (x) => {
  if (x == null) {
    return defaultHash_nil;
  }
  if (typeof x === "number") {
    return mergeValueHash(defaultHash_number, x);
  }
  if (typeof x === "string") {
    return mergeValueHash(defaultHash_string, x);
  }
  if (x.cachedHash != null) {
    return x.cachedHash;
  }
  if (x[calcit_dirty_hash_key] != null) {
    return x[calcit_dirty_hash_key];
  }
  if (x instanceof CalcitKeyword) {
    let h = mergeValueHash(defaultHash_keyword, x.value);
    x.cachedHash = h;
    return h;
  }
  if (x === true) {
    return defaultHash_true;
  }
  if (x === false) {
    return defaultHash_false;
  }
  if (x instanceof CalcitSymbol) {
    let h = mergeValueHash(defaultHash_symbol, x.value);
    x.cachedHash = h;
    return h;
  }
  if (typeof x === "function") {
    fnHashCounter = fnHashCounter + 1;
    let h = mergeValueHash(defaultHash_fn, fnHashCounter);
    x[calcit_dirty_hash_key] = h;
    return h;
  }
  if (x instanceof CalcitRef) {
    let h = mergeValueHash(defaultHash_ref, x.path);
    x.cachedHash = h;
    return h;
  }
  if (x instanceof CalcitTuple) {
    let base = defaultHash_tuple;
    base = mergeValueHash(base, hashFunction(x.fst));
    base = mergeValueHash(base, hashFunction(x.snd));
    x.cachedHash = base;
    return base;
  }
  if (x instanceof CalcitSet) {
    let base = defaultHash_set;
    let values = x.values();
    for (let idx = 0; idx < values.length; idx++) {
      let item = values[idx];
      base = mergeValueHash(base, hashFunction(item));
    }
    return base;
  }
  if (x instanceof CalcitList) {
    let base = defaultHash_list;
    for (let item of x.items()) {
      base = mergeValueHash(base, hashFunction(item));
    }
    x.cachedHash = base;
    return base;
  }
  if (x instanceof CalcitMap) {
    let base = defaultHash_map;
    for (let [k, v] of x.pairs()) {
      base = mergeValueHash(base, hashFunction(k));
      base = mergeValueHash(base, hashFunction(v));
    }
    x.cachedHash = base;
    return base;
  }
  if (x instanceof CalcitRecord) {
    let base = defaultHash_record;
    for (let idx = 0; idx < x.fields.length; idx++) {
      base = mergeValueHash(base, hashFunction(x.fields[idx]));
      base = mergeValueHash(base, hashFunction(x.values[idx]));
    }
    x.cachedHash = base;
    return base;
  }
  console.warn(`[warn] calcit-js has no method for hashing this: ${x}`);
  let hashJsObject = defaultHash_unknown;
  jsObjectHashCounter = jsObjectHashCounter + 1;
  hashJsObject = mergeValueHash(hashJsObject, jsObjectHashCounter);
  x[calcit_dirty_hash_key] = hashJsObject;
  return hashJsObject;
};
overwriteHashGenerator(hashFunction);
var toString = (x, escaped) => {
  if (x == null) {
    return "nil";
  }
  if (typeof x === "string") {
    if (escaped) {
      if (/[\)\(\s\"]/.test(x)) {
        return JSON.stringify("|" + x);
      } else {
        return "|" + x;
      }
    } else {
      return x;
    }
  }
  if (typeof x === "number") {
    return x.toString();
  }
  if (typeof x === "boolean") {
    return x.toString();
  }
  if (typeof x === "function") {
    return `(&fn ...)`;
  }
  if (x instanceof CalcitSymbol) {
    return x.toString();
  }
  if (x instanceof CalcitKeyword) {
    return x.toString();
  }
  if (x instanceof CalcitList) {
    return x.toString();
  }
  if (x instanceof CalcitMap) {
    return x.toString();
  }
  if (x instanceof CalcitSet) {
    return x.toString();
  }
  if (x instanceof CalcitRecord) {
    return x.toString();
  }
  if (x instanceof CalcitRef) {
    return x.toString();
  }
  if (x instanceof CalcitTuple) {
    return x.toString();
  }
  console.warn("Unknown structure to string, better use `console.log`", x);
  return `${x}`;
};
var _$n_map_$o_get = function(xs, k) {
  if (arguments.length !== 2) {
    throw new Error("map &get takes 2 arguments");
  }
  if (xs instanceof CalcitMap)
    return xs.get(k);
  throw new Error("Does not support `&get` on this type");
};
var _$n__$e_ = (x, y) => {
  if (x === y) {
    return true;
  }
  if (x == null) {
    if (y == null) {
      return true;
    }
    return false;
  }
  let tx = typeof x;
  let ty = typeof y;
  if (tx !== ty) {
    return false;
  }
  if (tx === "string") {
    return x === y;
  }
  if (tx === "boolean") {
    return x === y;
  }
  if (tx === "number") {
    return x === y;
  }
  if (tx === "function") {
    return x === y;
  }
  if (x instanceof CalcitKeyword) {
    if (y instanceof CalcitKeyword) {
      return x === y;
    }
    return false;
  }
  if (x instanceof CalcitSymbol) {
    if (y instanceof CalcitSymbol) {
      return x.value === y.value;
    }
    return false;
  }
  if (x instanceof CalcitList) {
    if (y instanceof CalcitList) {
      if (x.len() !== y.len()) {
        return false;
      }
      let size = x.len();
      for (let idx = 0; idx < size; idx++) {
        let xItem = x.get(idx);
        let yItem = y.get(idx);
        if (!_$n__$e_(xItem, yItem)) {
          return false;
        }
      }
      return true;
    }
    return false;
  }
  if (x instanceof CalcitMap) {
    if (y instanceof CalcitMap) {
      if (x.len() !== y.len()) {
        return false;
      }
      for (let [k, v] of x.pairs()) {
        if (!y.contains(k)) {
          return false;
        }
        if (!_$n__$e_(v, _$n_map_$o_get(y, k))) {
          return false;
        }
      }
      return true;
    }
    return false;
  }
  if (x instanceof CalcitRef) {
    if (y instanceof CalcitRef) {
      return x.path === y.path;
    }
    return false;
  }
  if (x instanceof CalcitTuple) {
    if (y instanceof CalcitTuple) {
      return _$n__$e_(x.fst, y.fst) && _$n__$e_(x.snd, y.snd);
    }
    return false;
  }
  if (x instanceof CalcitSet) {
    if (y instanceof CalcitSet) {
      if (x.len() !== y.len()) {
        return false;
      }
      let values = x.values();
      for (let idx = 0; idx < values.length; idx++) {
        let v = values[idx];
        let found = false;
        let yValues = y.values();
        for (let idx2 = 0; idx2 < yValues.length; idx2++) {
          let yv = yValues[idx2];
          if (_$n__$e_(v, yv)) {
            found = true;
            break;
          }
        }
        if (found) {
          continue;
        } else {
          return false;
        }
      }
      return true;
    }
    return false;
  }
  if (x instanceof CalcitRecur) {
    if (y instanceof CalcitRecur) {
      console.warn("Do not compare Recur");
      return false;
    }
    return false;
  }
  if (x instanceof CalcitRecord) {
    if (y instanceof CalcitRecord) {
      if (x.name !== y.name) {
        return false;
      }
      if (!fieldsEqual(x.fields, y.fields)) {
        return false;
      }
      if (x.values.length !== y.values.length) {
        return false;
      }
      for (let idx in x.fields) {
        if (!_$n__$e_(x.values[idx], y.values[idx])) {
          return false;
        }
      }
      return true;
    }
    return false;
  }
  throw new Error("Missing handler for this type");
};
overwriteComparator(_$n__$e_);
overwriteMapComparator(_$n__$e_);
overwriteSetComparator(_$n__$e_);

// node_modules/@calcit/procs/lib/js-cirru.js
var import_writer = __toModule(require_writer());
var to_cirru_edn = (x) => {
  if (x == null) {
    return "nil";
  }
  if (typeof x === "string") {
    return `|${x}`;
  }
  if (typeof x === "number") {
    return x.toString();
  }
  if (typeof x === "boolean") {
    return x.toString();
  }
  if (x instanceof CalcitKeyword) {
    return x.toString();
  }
  if (x instanceof CalcitSymbol) {
    return x.toString();
  }
  if (x instanceof CalcitList) {
    return ["[]"].concat(x.toArray().map(to_cirru_edn));
  }
  if (x instanceof CalcitMap) {
    let buffer = ["{}"];
    for (let [k, v] of x.pairs()) {
      buffer.push([to_cirru_edn(k), to_cirru_edn(v)]);
    }
    return buffer;
  }
  if (x instanceof CalcitRecord) {
    let result = {};
    let buffer = ["%{}", x.name];
    for (let idx in x.fields) {
      buffer.push([x.fields[idx], to_cirru_edn(x.values[idx])]);
    }
    return buffer;
  }
  if (x instanceof CalcitSet) {
    let buffer = ["#{}"];
    let values = x.values();
    for (let idx = 0; idx < values.length; idx++) {
      let y = values[idx];
      buffer.push(to_cirru_edn(y));
    }
    return buffer;
  }
  if (x instanceof CalcitTuple) {
    if (x.fst instanceof CalcitSymbol && x.fst.value === "quote") {
      return ["quote", toWriterNode(x.snd)];
    } else {
      throw new Error(`Unsupported tag for EDN: ${x.fst}`);
    }
  }
  console.error(x);
  throw new Error("Unexpected data to to-cirru-edn");
};
var format_cirru_edn = (data, useInline = true) => {
  if (data == null) {
    return "\ndo nil\n";
  }
  if (typeof data === "string") {
    return "\ndo " + to_cirru_edn(data) + "\n";
  }
  if (typeof data == "boolean") {
    return "\ndo " + to_cirru_edn(data) + "\n";
  }
  if (typeof data == "string") {
    return "\ndo " + to_cirru_edn(data) + "\n";
  }
  if (data instanceof CalcitSymbol) {
    return "\ndo " + to_cirru_edn(data) + "\n";
  }
  if (data instanceof CalcitKeyword) {
    return "\ndo " + to_cirru_edn(data) + "\n";
  }
  return (0, import_writer.writeCirruCode)([to_cirru_edn(data)], {useInline});
};
var to_calcit_data = (x, noKeyword = false) => {
  if (x == null) {
    return null;
  }
  if (typeof x === "number") {
    return x;
  }
  if (typeof x === "string") {
    if (!noKeyword && x[0] === ":" && x.slice(1).match(/^[\w\d_\?\!\-]+$/)) {
      return kwd(x.slice(1));
    }
    return x;
  }
  if (x === true || x === false) {
    return x;
  }
  if (typeof x === "function") {
    return x;
  }
  if (Array.isArray(x)) {
    var result = [];
    x.forEach((v) => {
      result.push(to_calcit_data(v, noKeyword));
    });
    return new CalcitList(result);
  }
  if (x instanceof Set) {
    let result2 = [];
    x.forEach((v) => {
      result2.push(to_calcit_data(v, noKeyword));
    });
    return new CalcitSet(result2);
  }
  if (x === Object(x)) {
    let result2 = [];
    Object.keys(x).forEach((k) => {
      result2.push([to_calcit_data(k, noKeyword), to_calcit_data(x[k], noKeyword)]);
    });
    return new CalcitMap(initTernaryTreeMap(result2));
  }
  console.error(x);
  throw new Error("Unexpected data for converting");
};
var toWriterNode = (xs) => {
  if (typeof xs === "string") {
    return xs;
  }
  if (xs instanceof CalcitList) {
    return xs.toArray().map(toWriterNode);
  } else {
    throw new Error("Unexpected type for CirruWriteNode");
  }
};

// node_modules/@calcit/procs/lib/calcit.procs.js
var _a;
var calcit_version = "0.4.16";
var inNodeJs = typeof process !== "undefined" && ((_a = process === null || process === void 0 ? void 0 : process.release) === null || _a === void 0 ? void 0 : _a.name) === "node";
var type_of = (x) => {
  if (typeof x === "string") {
    return kwd("string");
  }
  if (typeof x === "number") {
    return kwd("number");
  }
  if (x instanceof CalcitKeyword) {
    return kwd("keyword");
  }
  if (x instanceof CalcitList) {
    return kwd("list");
  }
  if (x instanceof CalcitMap) {
    return kwd("map");
  }
  if (x == null) {
    return kwd("nil");
  }
  if (x instanceof CalcitRef) {
    return kwd("ref");
  }
  if (x instanceof CalcitTuple) {
    return kwd("tuple");
  }
  if (x instanceof CalcitSymbol) {
    return kwd("symbol");
  }
  if (x instanceof CalcitSet) {
    return kwd("set");
  }
  if (x instanceof CalcitRecord) {
    return kwd("record");
  }
  if (x === true || x === false) {
    return kwd("bool");
  }
  if (typeof x === "function") {
    if (x.isMacro) {
      return kwd("macro");
    }
    return kwd("fn");
  }
  if (typeof x === "object") {
    return kwd("js-object");
  }
  throw new Error(`Unknown data ${x}`);
};
function _$n_list_$o_count(x) {
  if (x instanceof CalcitList)
    return x.len();
  throw new Error(`expected a list ${x}`);
}
function _$n_str_$o_count(x) {
  if (typeof x === "string")
    return x.length;
  throw new Error(`expected a string ${x}`);
}
function _$n_map_$o_count(x) {
  if (x instanceof CalcitMap)
    return x.len();
  throw new Error(`expected a map ${x}`);
}
function _$n_record_$o_count(x) {
  if (x instanceof CalcitRecord)
    return x.fields.length;
  throw new Error(`expected a record ${x}`);
}
function _$n_set_$o_count(x) {
  if (x instanceof CalcitSet)
    return x.len();
  throw new Error(`expected a set ${x}`);
}
var _$L_ = (...xs) => {
  return new CalcitList(xs);
};
var _$n__$M_ = (...xs) => {
  if (xs.length % 2 !== 0) {
    throw new Error("&map expects even number of arguments");
  }
  return new CalcitMap(xs);
};
var defatom = (path, x) => {
  let v = new CalcitRef(x, path);
  refsRegistry.set(path, v);
  return v;
};
var peekDefatom = (path) => {
  return refsRegistry.get(path);
};
var deref = (x) => {
  let a2 = refsRegistry.get(x.path);
  if (!(a2 instanceof CalcitRef)) {
    console.warn("Can not find ref:", x);
  }
  return a2.value;
};
var _$n__ADD_ = (x, y) => {
  return x + y;
};
var _$n__$s_ = (x, y) => {
  return x * y;
};
var _$n_str_$o_contains_$q_ = (xs, x) => {
  if (typeof xs === "string") {
    if (typeof x != "number") {
      throw new Error("Expected number index for detecting");
    }
    let size = xs.length;
    if (x >= 0 && x < size) {
      return true;
    }
    return false;
  }
  throw new Error("string `contains?` expected a string");
};
var _$n_list_$o_contains_$q_ = (xs, x) => {
  if (xs instanceof CalcitList) {
    if (typeof x != "number") {
      throw new Error("Expected number index for detecting");
    }
    let size = xs.len();
    if (x >= 0 && x < size) {
      return true;
    }
    return false;
  }
  throw new Error("list `contains?` expected a list");
};
var _$n_map_$o_contains_$q_ = (xs, x) => {
  if (xs instanceof CalcitMap)
    return xs.contains(x);
  throw new Error("map `contains?` expected a map");
};
var _$n_record_$o_contains_$q_ = (xs, x) => {
  if (xs instanceof CalcitRecord)
    return xs.contains(x);
  throw new Error("record `contains?` expected a record");
};
var _$n_str_$o_includes_$q_ = (xs, x) => {
  if (typeof xs === "string") {
    if (typeof x !== "string") {
      throw new Error("Expected string");
    }
    return xs.includes(x);
  }
  throw new Error("string includes? expected a string");
};
var _$n_list_$o_includes_$q_ = (xs, x) => {
  if (xs instanceof CalcitList) {
    let size = xs.len();
    for (let v of xs.items()) {
      if (_$n__$e_(v, x)) {
        return true;
      }
    }
    return false;
  }
  throw new Error("list includes? expected a list");
};
var _$n_map_$o_includes_$q_ = (xs, x) => {
  if (xs instanceof CalcitMap) {
    for (let [k, v] of xs.pairs()) {
      if (_$n__$e_(v, x)) {
        return true;
      }
    }
    return false;
  }
  throw new Error("map includes? expected a map");
};
var _$n_set_$o_includes_$q_ = (xs, x) => {
  if (xs instanceof CalcitSet) {
    return xs.contains(x);
  }
  throw new Error("set includes? expected a set");
};
var _$n_str_$o_nth = function(xs, k) {
  if (arguments.length !== 2)
    throw new Error("nth takes 2 arguments");
  if (typeof k !== "number")
    throw new Error("Expected number index for a list");
  if (typeof xs === "string")
    return xs[k];
  throw new Error("Does not support `nth` on this type");
};
var _$n_list_$o_nth = function(xs, k) {
  if (arguments.length !== 2)
    throw new Error("nth takes 2 arguments");
  if (typeof k !== "number")
    throw new Error("Expected number index for a list");
  if (xs instanceof CalcitList)
    return xs.get(k);
  throw new Error("Does not support `nth` on this type");
};
var _$n_tuple_$o_nth = function(xs, k) {
  if (arguments.length !== 2)
    throw new Error("nth takes 2 arguments");
  if (typeof k !== "number")
    throw new Error("Expected number index for a list");
  if (xs instanceof CalcitTuple)
    return xs.get(k);
  throw new Error("Does not support `nth` on this type");
};
var _$n_record_$o_nth = function(xs, k) {
  if (arguments.length !== 2)
    throw new Error("nth takes 2 arguments");
  if (typeof k !== "number")
    throw new Error("Expected number index for a list");
  if (xs instanceof CalcitRecord) {
    if (k < 0 || k >= xs.fields.length) {
      throw new Error("Out of bound");
    }
    return new CalcitList([kwd(xs.fields[k]), xs.values[k]]);
  }
  throw new Error("Does not support `nth` on this type");
};
var _$n_record_$o_get = function(xs, k) {
  if (arguments.length !== 2) {
    throw new Error("record &get takes 2 arguments");
  }
  if (xs instanceof CalcitRecord)
    return xs.get(k);
  throw new Error("Does not support `&get` on this type");
};
var _$n_list_$o_assoc = function(xs, k, v) {
  if (arguments.length !== 3)
    throw new Error("assoc takes 3 arguments");
  if (xs instanceof CalcitList) {
    if (typeof k !== "number") {
      throw new Error("Expected number index for lists");
    }
    return xs.assoc(k, v);
  }
  throw new Error("list `assoc` expected a list");
};
var _$n_tuple_$o_assoc = function(xs, k, v) {
  if (arguments.length !== 3)
    throw new Error("assoc takes 3 arguments");
  if (xs instanceof CalcitTuple) {
    if (typeof k !== "number") {
      throw new Error("Expected number index for lists");
    }
    return xs.assoc(k, v);
  }
  throw new Error("tuple `assoc` expected a tuple");
};
var _$n_map_$o_assoc = function(xs, ...args) {
  if (arguments.length < 3)
    throw new Error("assoc takes at least 3 arguments");
  if (args.length % 2 !== 0)
    throw new Error("assoc expected odd arguments");
  if (xs instanceof CalcitMap)
    return xs.assoc(...args);
  throw new Error("map `assoc` expected a map");
};
var _$n_record_$o_assoc = function(xs, k, v) {
  if (arguments.length !== 3)
    throw new Error("assoc takes 3 arguments");
  if (xs instanceof CalcitRecord)
    return xs.assoc(k, v);
  throw new Error("record `assoc` expected a record");
};
var _$n_list_$o_assoc_before = function(xs, k, v) {
  if (arguments.length !== 3) {
    throw new Error("assoc takes 3 arguments");
  }
  if (xs instanceof CalcitList) {
    if (typeof k !== "number") {
      throw new Error("Expected number index for lists");
    }
    return xs.assocBefore(k, v);
  }
  throw new Error("Does not support `assoc-before` on this type");
};
var _$n_list_$o_assoc_after = function(xs, k, v) {
  if (arguments.length !== 3) {
    throw new Error("assoc takes 3 arguments");
  }
  if (xs instanceof CalcitList) {
    if (typeof k !== "number") {
      throw new Error("Expected number index for lists");
    }
    return xs.assocAfter(k, v);
  }
  throw new Error("Does not support `assoc-after` on this type");
};
var _$n_list_$o_dissoc = function(xs, k) {
  if (arguments.length !== 2)
    throw new Error("dissoc takes 2 arguments");
  if (xs instanceof CalcitList) {
    if (typeof k !== "number")
      throw new Error("Expected number index for lists");
    return xs.dissoc(k);
  }
  throw new Error("`dissoc` expected a list");
};
var _$n_map_$o_dissoc = function(xs, ...args) {
  if (args.length < 1)
    throw new Error("dissoc takes at least 2 arguments");
  if (xs instanceof CalcitMap) {
    return xs.dissoc(...args);
  }
  throw new Error("`dissoc` expected a map");
};
var reset_$x_ = (a2, v) => {
  if (!(a2 instanceof CalcitRef)) {
    throw new Error("Expected ref for reset!");
  }
  let prev = a2.value;
  a2.value = v;
  for (let [k, f] of a2.listeners) {
    f(v, prev);
  }
  return null;
};
function _$n_list_$o_empty_$q_(xs) {
  if (xs instanceof CalcitList)
    return xs.isEmpty();
  throw new Error(`expected a list ${xs}`);
}
function _$n_str_$o_empty_$q_(xs) {
  if (typeof xs == "string")
    return xs.length == 0;
  throw new Error(`expected a string ${xs}`);
}
function _$n_map_$o_empty_$q_(xs) {
  if (xs instanceof CalcitMap)
    return xs.isEmpty();
  throw new Error(`expected a list ${xs}`);
}
function _$n_set_$o_empty_$q_(xs) {
  if (xs instanceof CalcitSet)
    return xs.len() === 0;
  throw new Error(`expected a list ${xs}`);
}
var _$n_list_$o_first = (xs) => {
  if (xs instanceof CalcitList) {
    if (xs.isEmpty()) {
      return null;
    }
    return xs.first();
  }
  console.error(xs);
  throw new Error("Expected a list");
};
var _$n_str_$o_first = (xs) => {
  if (typeof xs === "string") {
    return xs[0];
  }
  console.error(xs);
  throw new Error("Expected a string");
};
var _$n_map_$o_first = (xs) => {
  if (xs instanceof CalcitMap) {
    let ys = xs.pairs();
    if (ys.length > 0) {
      return new CalcitList(ys[0]);
    } else {
      return null;
    }
  }
  console.error(xs);
  throw new Error("Expected a map");
};
var _$n_set_$o_first = (xs) => {
  if (xs instanceof CalcitSet) {
    return xs.first();
  }
  console.error(xs);
  throw new Error("Expected a set");
};
var _$n_list_$o_rest = (xs) => {
  if (xs instanceof CalcitList) {
    if (xs.len() === 0) {
      return null;
    }
    return xs.rest();
  }
  console.error(xs);
  throw new Error("Expected a list");
};
var _$n_str_$o_rest = (xs) => {
  if (typeof xs === "string")
    return xs.substr(1);
  console.error(xs);
  throw new Error("Expects a string");
};
var _$n_set_$o_rest = (xs) => {
  if (xs instanceof CalcitSet)
    return xs.rest();
  console.error(xs);
  throw new Error("Expect a set");
};
var _$n_map_$o_rest = (xs) => {
  if (xs instanceof CalcitMap) {
    if (xs.len() > 0) {
      let k0 = xs.pairs()[0][0];
      return xs.dissoc(k0);
    } else {
      return new CalcitMap(initTernaryTreeMap([]));
    }
  }
  console.error(xs);
  throw new Error("Expected map");
};
var recur = (...xs) => {
  return new CalcitRecur(xs);
};
var not = (x) => {
  return !x;
};
var prepend2 = (xs, v) => {
  if (!(xs instanceof CalcitList)) {
    throw new Error("Expected array");
  }
  return xs.prepend(v);
};
var append2 = (xs, v) => {
  if (!(xs instanceof CalcitList)) {
    throw new Error("Expected array");
  }
  return xs.append(v);
};
var butlast = (xs) => {
  if (xs instanceof CalcitList) {
    if (xs.len() === 0) {
      return null;
    }
    return xs.slice(0, xs.len() - 1);
  }
  if (typeof xs === "string") {
    return xs.substr(0, xs.length - 1);
  }
  console.error(xs);
  throw new Error("Data not ready for butlast");
};
var _SHA__$M_ = (...xs) => {
  var result = [];
  for (let idx in xs) {
    result.push(xs[idx]);
  }
  return new CalcitSet(result);
};
var _$n_list_$o_slice = (xs, from, to) => {
  if (xs == null) {
    return null;
  }
  let size = xs.len();
  if (to == null) {
    to = size;
  } else if (to <= from) {
    return new CalcitList([]);
  } else if (to > size) {
    to = size;
  }
  return xs.slice(from, to);
};
var _$n_list_$o_concat = (...lists) => {
  let result = new CalcitList([]);
  for (let item of lists) {
    if (item == null) {
      continue;
    }
    if (item instanceof CalcitList) {
      if (result.isEmpty()) {
        result = item;
      } else {
        result = result.concat(item);
      }
    } else {
      throw new Error("Expected list for concatenation");
    }
  }
  return result;
};
var _$n_list_$o_reverse = (xs) => {
  if (xs == null) {
    return null;
  }
  return xs.reverse();
};
var _$n__GT_ = (a2, b) => {
  return a2 > b;
};
var _$n__LT_ = (a2, b) => {
  return a2 < b;
};
var _$n__ = (a2, b) => {
  return a2 - b;
};
var _$n_number_$o_rem = (a2, b) => {
  return a2 % b;
};
var round_$q_ = (a2) => {
  return a2 == Math.round(a2);
};
var _$n_str_$o_concat = (a2, b) => {
  let buffer = "";
  if (a2 != null) {
    buffer += toString(a2, false);
  }
  if (b != null) {
    buffer += toString(b, false);
  }
  return buffer;
};
var sort = (xs, f) => {
  if (xs == null) {
    return null;
  }
  if (xs instanceof CalcitList) {
    let ys = xs.toArray();
    return new CalcitList(ys.sort(f));
  }
  throw new Error("Expected list");
};
var rand = (n, m) => {
  if (m != null) {
    return n + (m - n) * Math.random();
  }
  if (n != null) {
    return Math.random() * n;
  }
  return Math.random() * 100;
};
var floor = (n) => {
  return Math.floor(n);
};
var _$n_merge = (a2, b) => {
  if (a2 == null) {
    return b;
  }
  if (b == null) {
    return a2;
  }
  if (a2 instanceof CalcitMap) {
    if (b instanceof CalcitMap) {
      return a2.merge(b);
    } else {
      throw new Error("Expected an argument of map");
    }
  }
  if (a2 instanceof CalcitRecord) {
    if (b instanceof CalcitMap) {
      let values = [];
      for (let item of a2.values) {
        values.push(item);
      }
      for (let [k, v] of b.pairs()) {
        let field = getStringName(k);
        let idx = a2.fields.indexOf(field);
        if (idx >= 0) {
          values[idx] = v;
        } else {
          throw new Error(`Cannot find field ${field} among (${a2.fields.join(", ")})`);
        }
      }
      return new CalcitRecord(a2.name, a2.fields, values);
    }
  }
  throw new Error("Expected map or record");
};
var to_pairs = (xs) => {
  if (xs instanceof CalcitMap) {
    let result = [];
    for (let [k, v] of xs.pairs()) {
      result.push(new CalcitList([k, v]));
    }
    return new CalcitSet(result);
  } else if (xs instanceof CalcitRecord) {
    let arr_result = [];
    for (let idx in xs.fields) {
      arr_result.push(new CalcitList([kwd(xs.fields[idx]), xs.values[idx]]));
    }
    return new CalcitList(arr_result);
  } else {
    throw new Error("Expected a map");
  }
};
var pow = (n, m) => {
  return Math.pow(n, m);
};
var ceil = (n) => {
  return Math.ceil(n);
};
var round = (n) => {
  return Math.round(n);
};
var _$n_number_$o_fract = (n) => {
  return n - Math.floor(n);
};
var sqrt = (n) => {
  return Math.sqrt(n);
};
var _$n_include = (xs, y) => {
  if (!(xs instanceof CalcitSet)) {
    throw new Error("Expected a set");
  }
  if (y == null) {
    return xs;
  }
  return xs.include(y);
};
var _$n_exclude = (xs, y) => {
  if (!(xs instanceof CalcitSet)) {
    throw new Error("Expected a set");
  }
  if (y == null) {
    return xs;
  }
  return xs.exclude(y);
};
var _$n_difference = (xs, ys) => {
  if (!(xs instanceof CalcitSet)) {
    throw new Error("Expected a set");
  }
  if (!(ys instanceof CalcitSet)) {
    throw new Error("Expected a set for ys");
  }
  return xs.difference(ys);
};
var _$n_union = (xs, ys) => {
  if (!(xs instanceof CalcitSet)) {
    throw new Error("Expected a set");
  }
  if (!(ys instanceof CalcitSet)) {
    throw new Error("Expected a set for ys");
  }
  return xs.union(ys);
};
var _$n_set_$o_intersection = (xs, ys) => {
  if (!(xs instanceof CalcitSet)) {
    throw new Error("Expected a set");
  }
  if (!(ys instanceof CalcitSet)) {
    throw new Error("Expected a set for ys");
  }
  return xs.intersection(ys);
};
var _$n_str_$o_replace = (x, y, z) => {
  var result = x;
  while (result.indexOf(y) >= 0) {
    result = result.replace(y, z);
  }
  return result;
};
var split = (xs, x) => {
  return new CalcitList(xs.split(x));
};
var split_lines = (xs) => {
  return new CalcitList(xs.split("\n"));
};
var _$n_str_$o_slice = (xs, m, n) => {
  if (n <= m) {
    console.warn("endIndex too small");
    return "";
  }
  return xs.substring(m, n);
};
var _$n_str_$o_find_index = (x, y) => {
  return x.indexOf(y);
};
var parse_float = (x) => {
  return parseFloat(x);
};
var trim = (x, c) => {
  if (c != null) {
    if (c.length !== 1) {
      throw new Error("Expceted c of a character");
    }
    var buffer = x;
    var size = buffer.length;
    var idx = 0;
    while (idx < size && buffer[idx] == c) {
      idx = idx + 1;
    }
    buffer = buffer.substring(idx);
    var size = buffer.length;
    var idx = size;
    while (idx > 1 && buffer[idx - 1] == c) {
      idx = idx - 1;
    }
    buffer = buffer.substring(0, idx);
    return buffer;
  }
  return x.trim();
};
var _$n_number_$o_format = (x, n) => {
  return x.toFixed(n);
};
var get_char_code = (c) => {
  if (typeof c !== "string" || c.length !== 1) {
    throw new Error("Expected a character");
  }
  return c.charCodeAt(0);
};
var re_matches = (content, re) => {
  return new RegExp(re).test(content);
};
var parse_json = (x) => {
  return to_calcit_data(JSON.parse(x), false);
};
var _$n_set_$o_to_list = (x) => {
  return new CalcitList(x.values());
};
var aget = (x, name) => {
  return x[name];
};
var turn_keyword = (x) => {
  if (typeof x === "string") {
    return kwd(x);
  }
  if (x instanceof CalcitKeyword) {
    return x;
  }
  if (x instanceof CalcitSymbol) {
    return kwd(x.value);
  }
  console.error(x);
  throw new Error("Unexpected data for keyword");
};
var turn_symbol = (x) => {
  if (typeof x === "string") {
    return new CalcitSymbol(x);
  }
  if (x instanceof CalcitSymbol) {
    return x;
  }
  if (x instanceof CalcitKeyword) {
    return new CalcitSymbol(x.value);
  }
  console.error(x);
  throw new Error("Unexpected data for symbol");
};
var pr_str = (...args) => {
  return args.map((x) => toString(x, true)).join(" ");
};
var printable = (...args) => {
  return args.map((x) => toString(x, false)).join(" ");
};
var quit_$x_ = () => {
  if (inNodeJs) {
    process.exit(1);
  } else {
    throw new Error("quit!()");
  }
};
var turn_string = (x) => {
  if (x == null) {
    return "";
  }
  if (typeof x === "string") {
    return x;
  }
  if (x instanceof CalcitKeyword) {
    return x.value;
  }
  if (x instanceof CalcitSymbol) {
    return x.value;
  }
  if (typeof x === "number") {
    return x.toString();
  }
  if (typeof x === "boolean") {
    return x.toString();
  }
  console.error(x);
  throw new Error("Unexpected data to turn string");
};
var starts_with_$q_ = (xs, y) => {
  return xs.startsWith(y);
};
var ends_with_$q_ = (xs, y) => {
  return xs.endsWith(y);
};
var blank_$q_ = (x) => {
  if (x == null) {
    return true;
  }
  if (typeof x === "string") {
    return x.trim() === "";
  } else {
    throw new Error("Expected a string");
  }
};
var arrayToList = (xs) => {
  return new CalcitList(xs !== null && xs !== void 0 ? xs : []);
};
var listToArray = (xs) => {
  if (xs == null) {
    return null;
  }
  if (xs instanceof CalcitList) {
    return xs.toArray();
  } else {
    throw new Error("Expected list");
  }
};
var number_$q_ = (x) => {
  return typeof x === "number";
};
var string_$q_ = (x) => {
  return typeof x === "string";
};
var bool_$q_ = (x) => {
  return typeof x === "boolean";
};
var nil_$q_ = (x) => {
  return x == null;
};
var keyword_$q_ = (x) => {
  return x instanceof CalcitKeyword;
};
var map_$q_ = (x) => {
  return x instanceof CalcitMap;
};
var list_$q_ = (x) => {
  return x instanceof CalcitList;
};
var set_$q_ = (x) => {
  return x instanceof CalcitSet;
};
var fn_$q_ = (x) => {
  return typeof x === "function";
};
var record_$q_ = (x) => {
  return x instanceof CalcitRecord;
};
var tuple_$q_ = (x) => {
  return x instanceof CalcitTuple;
};
var _$n_str_$o_escape = (x) => JSON.stringify(x);
var format_to_lisp = (x) => {
  if (x == null) {
    return "nil";
  } else if (x instanceof CalcitSymbol) {
    return x.value;
  } else if (x instanceof CalcitList) {
    let chunk = "(";
    for (let item of x.items()) {
      if (chunk != "(") {
        chunk += " ";
      }
      chunk += format_to_lisp(item);
    }
    chunk += ")";
    return chunk;
  } else {
    return x.toString();
  }
};
var js_array = (...xs) => {
  return xs;
};
var _$n_js_object = (...xs) => {
  if (xs.length % 2 !== 0) {
    throw new Error("&js-object expects even number of arguments");
  }
  var ret = {};
  let halfLength = xs.length >> 1;
  for (let idx = 0; idx < halfLength; idx++) {
    let k = xs[idx << 1];
    let v = xs[(idx << 1) + 1];
    if (typeof k === "string") {
      ret[k] = v;
    } else if (k instanceof CalcitKeyword) {
      ret[turn_string(k)] = v;
    } else {
      throw new Error("Invalid key for js Object");
    }
  }
  return ret;
};
var calcit_builtin_classes = {
  number: null,
  string: null,
  set: null,
  list: null,
  map: null,
  record: null
};
var register_calcit_builtin_classes = (options) => {
  Object.assign(calcit_builtin_classes, options);
};
function invoke_method(p) {
  return (obj, ...args) => {
    let klass;
    let value = obj;
    if (obj == null) {
      throw new Error(`Cannot invoke method \`${p}\` on nil`);
    } else if (obj instanceof CalcitTuple) {
      if (obj.fst instanceof CalcitRecord) {
        klass = obj.fst;
      } else {
        throw new Error("Method invoking expected a record as class");
      }
    } else if (typeof obj === "number") {
      klass = calcit_builtin_classes.number;
    } else if (typeof obj === "string") {
      klass = calcit_builtin_classes.string;
    } else if (obj instanceof CalcitSet) {
      klass = calcit_builtin_classes.set;
    } else if (obj instanceof CalcitList) {
      klass = calcit_builtin_classes.list;
    } else if (obj instanceof CalcitRecord) {
      klass = calcit_builtin_classes.record;
    } else if (obj instanceof CalcitMap) {
      klass = calcit_builtin_classes.map;
    } else {
      if (obj[p] == null) {
        throw new Error(`Missing method \`${p}\` on object`);
      }
      return obj[p](...args);
    }
    if (klass == null) {
      throw new Error("Cannot find class for this object for invoking");
    }
    let method = klass.get(p);
    if (typeof method === "function") {
      return method(value, ...args);
    } else {
      throw new Error("Method for invoking is not a function");
    }
  };
}
var _$n_map_$o_to_list = (m) => {
  if (m instanceof CalcitMap) {
    let ys = [];
    for (let pair of m.pairs()) {
      ys.push(new CalcitList(pair));
    }
    return new CalcitList(ys);
  } else {
    throw new Error("&map:to-list expected a Map");
  }
};
var PseudoTypeIndex;
(function(PseudoTypeIndex2) {
  PseudoTypeIndex2[PseudoTypeIndex2["nil"] = 0] = "nil";
  PseudoTypeIndex2[PseudoTypeIndex2["bool"] = 1] = "bool";
  PseudoTypeIndex2[PseudoTypeIndex2["number"] = 2] = "number";
  PseudoTypeIndex2[PseudoTypeIndex2["symbol"] = 3] = "symbol";
  PseudoTypeIndex2[PseudoTypeIndex2["keyword"] = 4] = "keyword";
  PseudoTypeIndex2[PseudoTypeIndex2["string"] = 5] = "string";
  PseudoTypeIndex2[PseudoTypeIndex2["ref"] = 6] = "ref";
  PseudoTypeIndex2[PseudoTypeIndex2["tuple"] = 7] = "tuple";
  PseudoTypeIndex2[PseudoTypeIndex2["recur"] = 8] = "recur";
  PseudoTypeIndex2[PseudoTypeIndex2["list"] = 9] = "list";
  PseudoTypeIndex2[PseudoTypeIndex2["set"] = 10] = "set";
  PseudoTypeIndex2[PseudoTypeIndex2["map"] = 11] = "map";
  PseudoTypeIndex2[PseudoTypeIndex2["record"] = 12] = "record";
  PseudoTypeIndex2[PseudoTypeIndex2["fn"] = 13] = "fn";
})(PseudoTypeIndex || (PseudoTypeIndex = {}));
var typeAsInt = (x) => {
  if (x == null)
    return PseudoTypeIndex.nil;
  let t = typeof x;
  if (t === "boolean")
    return PseudoTypeIndex.bool;
  if (t === "number")
    return PseudoTypeIndex.number;
  if (x instanceof CalcitSymbol)
    return PseudoTypeIndex.symbol;
  if (x instanceof CalcitKeyword)
    return PseudoTypeIndex.keyword;
  if (t === "string")
    return PseudoTypeIndex.string;
  if (x instanceof CalcitRef)
    return PseudoTypeIndex.ref;
  if (x instanceof CalcitTuple)
    return PseudoTypeIndex.tuple;
  if (x instanceof CalcitRecur)
    return PseudoTypeIndex.recur;
  if (x instanceof CalcitList)
    return PseudoTypeIndex.list;
  if (x instanceof CalcitSet)
    return PseudoTypeIndex.set;
  if (x instanceof CalcitMap)
    return PseudoTypeIndex.map;
  if (x instanceof CalcitRecord)
    return PseudoTypeIndex.record;
  if (t === "function")
    return PseudoTypeIndex.fn;
  throw new Error("unknown type to compare");
};
var rawCompare = (x, y) => {
  if (x < y) {
    return -1;
  } else if (x > y) {
    return 1;
  } else {
    return 0;
  }
};
var _$n_compare = (a2, b) => {
  let ta = typeAsInt(a2);
  let tb = typeAsInt(b);
  if (ta === tb) {
    switch (ta) {
      case PseudoTypeIndex.nil:
        return 0;
      case PseudoTypeIndex.bool:
        return rawCompare(a2, b);
      case PseudoTypeIndex.number:
        return rawCompare(a2, b);
      case PseudoTypeIndex.symbol:
        return rawCompare(a2, b);
      case PseudoTypeIndex.keyword:
        return rawCompare(a2, b);
      case PseudoTypeIndex.string:
        return rawCompare(a2, b);
      case PseudoTypeIndex.ref:
        return rawCompare(a2.path, b.path);
      default:
        if (a2 < b) {
          return -1;
        } else if (a2 > b) {
          return 1;
        } else {
          return 0;
        }
    }
  } else {
    return rawCompare(ta, tb);
  }
};
var _$n_map_$o_diff_new = (a2, b) => {
  if (a2 instanceof CalcitMap && b instanceof CalcitMap) {
    return a2.diffNew(b);
  } else {
    throw new Error("expected 2 maps");
  }
};
var _$n_map_$o_diff_keys = (a2, b) => {
  if (a2 instanceof CalcitMap && b instanceof CalcitMap) {
    return a2.diffKeys(b);
  } else {
    throw new Error("expected 2 maps");
  }
};
var _$n_map_$o_common_keys = (a2, b) => {
  if (a2 instanceof CalcitMap && b instanceof CalcitMap) {
    return a2.commonKeys(b);
  } else {
    throw new Error("expected 2 maps");
  }
};
var _$n_list_$o_to_set = (xs) => {
  var result = [];
  let data = xs.toArray();
  for (let idx = 0; idx < data.length; idx++) {
    result.push(data[idx]);
  }
  return new CalcitSet(result);
};
var _$n_list_$o_distinct = (xs) => {
  var result = [];
  let data = xs.toArray();
  outer:
    for (let idx in data) {
      for (let j = 0; j < result.length; j++) {
        if (_$n__$e_(data[idx], result[j])) {
          continue outer;
        }
      }
      result.push(data[idx]);
    }
  return new CalcitList(result);
};

// server-out/calcit.core.js
var _PCT__$M_ = () => {
};
_PCT__$M_.isMacro = true;
function _$n__LT__$e_(a2, b) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (_$n__LT_(a2, b)) {
    return true;
  } else {
    return _$n__$e_(a2, b);
  }
}
function _$n__GT__$e_(a2, b) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (_$n__GT_(a2, b)) {
    return true;
  } else {
    return _$n__$e_(a2, b);
  }
}
var _$n_case = () => {
};
_$n_case.isMacro = true;
var and = () => {
};
and.isMacro = true;
var list_$q_2 = list_$q_;
var nil_$q_2 = nil_$q_;
var tuple_$q_2 = tuple_$q_;
function count(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (nil_$q_2(x)) {
    return 0;
  } else if (tuple_$q_2(x)) {
    return 2;
  } else if (list_$q_2(x)) {
    return _$n_list_$o_count(x);
  } else {
    return invoke_method("count")(x);
  }
}
var string_$q_2 = string_$q_;
function _$n_map_$o_add_entry(xs, pair) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  (function __fn__() {
    not(string_$q_2("&map:add-entry expected value in a pair")) ? function __fn__2() {
      let err_AUTO_1 = new Error("expects 1st argument to be string");
      err_AUTO_1.data = null;
      throw err_AUTO_1;
    }() : null;
    if (list_$q_2(pair) ? _$n__$e_(2, count(pair)) ? _$n__$e_(2, count(pair)) : false : false) {
      return null;
    } else {
      console.log(printable("Failed assertion:", format_to_lisp(new CalcitList([new CalcitSymbol("and"), new CalcitList([new CalcitSymbol("list?"), new CalcitSymbol("pair")]), new CalcitList([new CalcitSymbol("&="), 2, new CalcitList([new CalcitSymbol("count"), new CalcitSymbol("pair")])])]))));
      let err_AUTO_2 = new Error("&map:add-entry expected value in a pair (and (list? pair) (&= 2 (count pair)))");
      err_AUTO_2.data = null;
      throw err_AUTO_2;
    }
  })();
  let v__3 = pair;
  let k = _$n_list_$o_nth(v__3, 0);
  let v = _$n_list_$o_nth(v__3, 1);
  return _$n_map_$o_assoc(xs, k, v);
}
var map_$q_2 = map_$q_;
var set_$q_2 = set_$q_;
function _$n_coll_append(xs, a2) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (list_$q_2(xs)) {
    return append2(xs, a2);
  } else if (set_$q_2(xs)) {
    return _$n_include(xs, a2);
  } else if (map_$q_2(xs)) {
    return _$n_map_$o_add_entry(xs, a2);
  } else {
    let err_AUTO_3 = new Error("&coll-append expected a collection");
    err_AUTO_3.data = null;
    throw err_AUTO_3;
  }
}
var record_$q_2 = record_$q_;
function get(base, k) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (nil_$q_2(base)) {
    return null;
  } else if (string_$q_2(base)) {
    return _$n_str_$o_nth(base, k);
  } else if (map_$q_2(base)) {
    return _$n_map_$o_get(base, k);
  } else if (list_$q_2(base)) {
    return _$n_list_$o_nth(base, k);
  } else if (tuple_$q_2(base)) {
    return _$n_tuple_$o_nth(base, k);
  } else if (record_$q_2(base)) {
    return _$n_record_$o_get(base, k);
  } else if (true) {
    console.log(printable("Value:", base, k));
    let err_AUTO_4 = new Error("Expected map or list for get");
    err_AUTO_4.data = null;
    throw err_AUTO_4;
  } else {
    return null;
  }
}
var keyword_$q_2 = keyword_$q_;
function _$n_list_$o_sort_by(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (keyword_$q_2(f)) {
    return sort(xs, function f_PCT_2(a2, b) {
      if (arguments.length !== 2)
        throw new Error("argument sizes do not match");
      return _$n_compare(get(a2, f), get(b, f));
    });
  } else {
    return sort(xs, function f_PCT_2(a2, b) {
      if (arguments.length !== 2)
        throw new Error("argument sizes do not match");
      return _$n_compare(f(a2), f(b));
    });
  }
}
var number_$q_2 = number_$q_;
function _$n_max(a2, b) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  (function __fn__() {
    not(string_$q_2("expects numbers for &max")) ? function __fn__2() {
      let err_AUTO_5 = new Error("expects 1st argument to be string");
      err_AUTO_5.data = null;
      throw err_AUTO_5;
    }() : null;
    if (number_$q_2(a2) ? number_$q_2(b) : false) {
      return null;
    } else {
      console.log(printable("Failed assertion:", format_to_lisp(new CalcitList([new CalcitSymbol("if"), new CalcitList([new CalcitSymbol("number?"), new CalcitSymbol("a")]), new CalcitList([new CalcitSymbol("number?"), new CalcitSymbol("b")]), false]))));
      let err_AUTO_6 = new Error("expects numbers for &max (if (number? a) (number? b) false)");
      err_AUTO_6.data = null;
      throw err_AUTO_6;
    }
  })();
  if (_$n__GT_(a2, b)) {
    return a2;
  } else {
    return b;
  }
}
function _$n_min(a2, b) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  (function __fn__() {
    not(string_$q_2("expects numbers for &min")) ? function __fn__2() {
      let err_AUTO_7 = new Error("expects 1st argument to be string");
      err_AUTO_7.data = null;
      throw err_AUTO_7;
    }() : null;
    if (number_$q_2(a2) ? number_$q_2(b) : false) {
      return null;
    } else {
      console.log(printable("Failed assertion:", format_to_lisp(new CalcitList([new CalcitSymbol("if"), new CalcitList([new CalcitSymbol("number?"), new CalcitSymbol("a")]), new CalcitList([new CalcitSymbol("number?"), new CalcitSymbol("b")]), false]))));
      let err_AUTO_8 = new Error("expects numbers for &min (if (number? a) (number? b) false)");
      err_AUTO_8.data = null;
      throw err_AUTO_8;
    }
  })();
  if (_$n__LT_(a2, b)) {
    return a2;
  } else {
    return b;
  }
}
function reduce(xs, x0, f) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  return foldl(xs, x0, f);
}
function _SUB_(x, ...ys) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  ys = arrayToList(ys);
  if (_$n_list_$o_empty_$q_(ys)) {
    return _$n__(0, x);
  } else {
    return reduce(ys, x, _$n__);
  }
}
var foldl_compare = function foldl_compare2(xs, acc, f) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let ret_AUTO_10 = null;
  let times_AUTO_11 = 0;
  while (true) {
    if (times_AUTO_11 > 1e5)
      throw new Error("tail recursion not stopping");
    if (_$n_list_$o_empty_$q_(xs)) {
      ret_AUTO_10 = true;
    } else if (f(acc, _$n_list_$o_first(xs))) {
      ret_AUTO_10 = recur(_$n_list_$o_rest(xs), _$n_list_$o_first(xs), f);
    } else {
      ret_AUTO_10 = false;
    }
    if (ret_AUTO_10 instanceof CalcitRecur) {
      if (ret_AUTO_10.args.length !== 3)
        throw new Error("argument sizes do not match");
      [xs, acc, f] = ret_AUTO_10.args;
      times_AUTO_11 += 1;
      continue;
    } else {
      return ret_AUTO_10;
    }
  }
};
function _$e_(x, ...ys) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  ys = arrayToList(ys);
  if (_$n__$e_(1, _$n_list_$o_count(ys))) {
    return _$n__$e_(x, _$n_list_$o_first(ys));
  } else {
    return foldl_compare(ys, x, _$n__$e_);
  }
}
function _GT__$e_(x, ...ys) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  ys = arrayToList(ys);
  if (_$n__$e_(1, _$n_list_$o_count(ys))) {
    return _$n__GT__$e_(x, _$n_list_$o_first(ys));
  } else {
    return foldl_compare(ys, x, _$n__GT__$e_);
  }
}
function any_$q_(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return foldl_shortcut(xs, null, false, function f_PCT_2(_acc, x) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    if (f(x)) {
      return _$L_(true, true);
    } else {
      return _$L_(false, null);
    }
  });
}
function assoc(x, ...args) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  args = arrayToList(args);
  if (nil_$q_2(x)) {
    let err_AUTO_12 = new Error("assoc does not work on nil");
    err_AUTO_12.data = null;
    throw err_AUTO_12;
  } else if (tuple_$q_2(x)) {
    return _$n_tuple_$o_assoc(x, ...listToArray(args));
  } else if (list_$q_2(x)) {
    return _$n_list_$o_assoc(x, ...listToArray(args));
  } else {
    return invoke_method("assoc")(x, ...listToArray(args));
  }
}
function contains_$q_(x, k) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (nil_$q_2(x)) {
    return false;
  } else if (list_$q_2(x)) {
    return _$n_list_$o_contains_$q_(x, k);
  } else {
    return invoke_method("contains?")(x, k);
  }
}
function slice2(xs, n, m) {
  if (arguments.length < 2)
    throw new Error("too few arguments");
  if (arguments.length > 3)
    throw new Error("too many arguments");
  if (nil_$q_2(xs)) {
    return null;
  } else {
    return invoke_method("slice")(xs, n, m);
  }
}
function drop(xs, n) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return slice2(xs, n, _$n_list_$o_count(xs));
}
function each(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return foldl(xs, null, function f_PCT_2(_acc, x) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    return f(x);
  });
}
function empty(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (nil_$q_2(x)) {
    return null;
  } else if (list_$q_2(x)) {
    return _$L_();
  } else {
    return invoke_method("empty")(x);
  }
}
function empty_$q_(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (nil_$q_2(x)) {
    return true;
  } else if (list_$q_2(x)) {
    return _$n_list_$o_empty_$q_(x);
  } else {
    return invoke_method("empty?")(x);
  }
}
function filter(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return foldl(xs, empty(xs), function f_PCT_2(acc, x) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    if (f(x)) {
      return _$n_coll_append(acc, x);
    } else {
      return acc;
    }
  });
}
function filter_not(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return reduce(xs, empty(xs), function f_PCT_2(acc, x) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    if (f(x)) {
      return acc;
    } else {
      return _$n_coll_append(acc, x);
    }
  });
}
function find_index(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return foldl_shortcut(xs, 0, null, function f_PCT_2(idx, x) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    if (f(x)) {
      return _$L_(true, idx);
    } else {
      return _$L_(false, _$n__ADD_(1, idx));
    }
  });
}
function rest2(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (nil_$q_2(x)) {
    return null;
  } else if (list_$q_2(x)) {
    return _$n_list_$o_rest(x);
  } else {
    return invoke_method("rest")(x);
  }
}
function update(x, k, f) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  if (list_$q_2(x)) {
    if (_$n_list_$o_contains_$q_(x, k)) {
      return assoc(x, k, f(_$n_list_$o_nth(x, k)));
    } else {
      return x;
    }
  } else if (tuple_$q_2(x)) {
    if (function __fn__() {
      let v1__4 = _$n__$e_(k, 1);
      if (nil_$q_2(v1__4)) {
        return _$n__$e_(k, 2);
      } else if (_$e_(false, v1__4)) {
        return _$n__$e_(k, 2);
      } else {
        return v1__4;
      }
    }()) {
      return assoc(x, k, f(_$n_tuple_$o_nth(x, k)));
    } else {
      let err_AUTO_13 = new Error(_$n_str_$o_concat("tuple only has 0,1 fields, unknown field: ", k));
      err_AUTO_13.data = null;
      throw err_AUTO_13;
    }
  } else if (map_$q_2(x)) {
    if (contains_$q_(x, k)) {
      return assoc(x, k, f(_$n_map_$o_get(x, k)));
    } else {
      return x;
    }
  } else if (record_$q_2(x)) {
    if (contains_$q_(x, k)) {
      return assoc(x, k, f(_$n_record_$o_get(x, k)));
    } else {
      return x;
    }
  } else if (true) {
    let err_AUTO_14 = new Error(_$n_str_$o_concat("Cannot update key on item: ", x));
    err_AUTO_14.data = null;
    throw err_AUTO_14;
  } else {
    return null;
  }
}
function frequencies(xs0) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  (function __fn__() {
    not(string_$q_2("expects a list for frequencies")) ? function __fn__2() {
      let err_AUTO_15 = new Error("expects 1st argument to be string");
      err_AUTO_15.data = null;
      throw err_AUTO_15;
    }() : null;
    if (list_$q_2(xs0)) {
      return null;
    } else {
      console.log(printable("Failed assertion:", format_to_lisp(new CalcitList([new CalcitSymbol("list?"), new CalcitSymbol("xs0")]))));
      let err_AUTO_16 = new Error("expects a list for frequencies (list? xs0)");
      err_AUTO_16.data = null;
      throw err_AUTO_16;
    }
  })();
  return function f_PCT_2(acc, xs) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    let ret_AUTO_18 = null;
    let times_AUTO_19 = 0;
    while (true) {
      if (times_AUTO_19 > 1e5)
        throw new Error("tail recursion not stopping");
      let x0 = _$n_list_$o_first(xs);
      if (_$n_list_$o_empty_$q_(xs)) {
        ret_AUTO_18 = acc;
      } else {
        ret_AUTO_18 = recur(contains_$q_(acc, _$n_list_$o_first(xs)) ? update(acc, _$n_list_$o_first(xs), function f_PCT_3(_PCT_, _PCT_2) {
          if (arguments.length < 0)
            throw new Error("too few arguments");
          if (arguments.length > 2)
            throw new Error("too many arguments");
          return _$n__ADD_(_PCT_, 1);
        }) : _$n_map_$o_assoc(acc, _$n_list_$o_first(xs), 1), rest2(xs));
      }
      if (ret_AUTO_18 instanceof CalcitRecur) {
        if (ret_AUTO_18.args.length !== 2)
          throw new Error("argument sizes do not match");
        [acc, xs] = ret_AUTO_18.args;
        times_AUTO_19 += 1;
        continue;
      } else {
        return ret_AUTO_18;
      }
    }
  }(_$n__$M_(), xs0);
}
var get_in = function get_in2(base, path) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  let ret_AUTO_23 = null;
  let times_AUTO_24 = 0;
  while (true) {
    if (times_AUTO_24 > 1e5)
      throw new Error("tail recursion not stopping");
    (function __fn__() {
      not(string_$q_2("expects path in a list")) ? function __fn__2() {
        let err_AUTO_21 = new Error("expects 1st argument to be string");
        err_AUTO_21.data = null;
        throw err_AUTO_21;
      }() : null;
      if (list_$q_2(path)) {
        return null;
      } else {
        console.log(printable("Failed assertion:", format_to_lisp(new CalcitList([new CalcitSymbol("list?"), new CalcitSymbol("path")]))));
        let err_AUTO_22 = new Error("expects path in a list (list? path)");
        err_AUTO_22.data = null;
        throw err_AUTO_22;
      }
    })();
    if (nil_$q_2(base)) {
      ret_AUTO_23 = null;
    } else if (_$n_list_$o_empty_$q_(path)) {
      ret_AUTO_23 = base;
    } else if (true) {
      ret_AUTO_23 = recur(get(base, _$n_list_$o_first(path)), rest2(path));
    } else {
      ret_AUTO_23 = null;
    }
    if (ret_AUTO_23 instanceof CalcitRecur) {
      if (ret_AUTO_23.args.length !== 2)
        throw new Error("argument sizes do not match");
      [base, path] = ret_AUTO_23.args;
      times_AUTO_24 += 1;
      continue;
    } else {
      return ret_AUTO_23;
    }
  }
};
function group_by(xs0, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return function f_PCT_2(acc, xs) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    let ret_AUTO_26 = null;
    let times_AUTO_27 = 0;
    while (true) {
      if (times_AUTO_27 > 1e5)
        throw new Error("tail recursion not stopping");
      if (_$n_list_$o_empty_$q_(xs)) {
        ret_AUTO_26 = acc;
      } else {
        let x0 = _$n_list_$o_first(xs);
        let key = f(x0);
        ret_AUTO_26 = recur(contains_$q_(acc, key) ? update(acc, key, function f_PCT_3(_PCT_, _PCT_2) {
          if (arguments.length < 0)
            throw new Error("too few arguments");
          if (arguments.length > 2)
            throw new Error("too many arguments");
          return append2(_PCT_, x0);
        }) : _$n_map_$o_assoc(acc, key, _$L_(x0)), rest2(xs));
      }
      if (ret_AUTO_26 instanceof CalcitRecur) {
        if (ret_AUTO_26.args.length !== 2)
          throw new Error("argument sizes do not match");
        [acc, xs] = ret_AUTO_26.args;
        times_AUTO_27 += 1;
        continue;
      } else {
        return ret_AUTO_26;
      }
    }
  }(_$n__$M_(), xs0);
}
function include(base, ...xs) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  xs = arrayToList(xs);
  return reduce(xs, base, function f_PCT_2(acc, item) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    return _$n_include(acc, item);
  });
}
function index_of(xs, item) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return foldl_shortcut(xs, 0, null, function f_PCT_2(idx, x) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    if (_$n__$e_(item, x)) {
      return _$L_(true, idx);
    } else {
      return _$L_(false, _$n__ADD_(1, idx));
    }
  });
}
function interleave(xs0, ys0) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return function f_PCT_2(acc, xs, ys) {
    if (arguments.length !== 3)
      throw new Error("argument sizes do not match");
    let ret_AUTO_29 = null;
    let times_AUTO_30 = 0;
    while (true) {
      if (times_AUTO_30 > 1e5)
        throw new Error("tail recursion not stopping");
      if (_$n_list_$o_empty_$q_(xs) ? true : _$n_list_$o_empty_$q_(ys)) {
        ret_AUTO_29 = acc;
      } else {
        ret_AUTO_29 = recur(append2(append2(acc, _$n_list_$o_first(xs)), _$n_list_$o_first(ys)), rest2(xs), rest2(ys));
      }
      if (ret_AUTO_29 instanceof CalcitRecur) {
        if (ret_AUTO_29.args.length !== 3)
          throw new Error("argument sizes do not match");
        [acc, xs, ys] = ret_AUTO_29.args;
        times_AUTO_30 += 1;
        continue;
      } else {
        return ret_AUTO_29;
      }
    }
  }(_$L_(), xs0, ys0);
}
function join(xs0, sep) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return function f_PCT_2(acc, xs, beginning_$q_) {
    if (arguments.length !== 3)
      throw new Error("argument sizes do not match");
    let ret_AUTO_32 = null;
    let times_AUTO_33 = 0;
    while (true) {
      if (times_AUTO_33 > 1e5)
        throw new Error("tail recursion not stopping");
      if (_$n_list_$o_empty_$q_(xs)) {
        ret_AUTO_32 = acc;
      } else {
        ret_AUTO_32 = recur(append2(beginning_$q_ ? acc : append2(acc, sep), _$n_list_$o_first(xs)), _$n_list_$o_rest(xs), false);
      }
      if (ret_AUTO_32 instanceof CalcitRecur) {
        if (ret_AUTO_32.args.length !== 3)
          throw new Error("argument sizes do not match");
        [acc, xs, beginning_$q_] = ret_AUTO_32.args;
        times_AUTO_33 += 1;
        continue;
      } else {
        return ret_AUTO_32;
      }
    }
  }(_$L_(), xs0, true);
}
function join_str(xs0, sep) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return function f_PCT_2(acc, xs, beginning_$q_) {
    if (arguments.length !== 3)
      throw new Error("argument sizes do not match");
    let ret_AUTO_35 = null;
    let times_AUTO_36 = 0;
    while (true) {
      if (times_AUTO_36 > 1e5)
        throw new Error("tail recursion not stopping");
      if (_$n_list_$o_empty_$q_(xs)) {
        ret_AUTO_35 = acc;
      } else {
        ret_AUTO_35 = recur(_$n_str_$o_concat(beginning_$q_ ? acc : _$n_str_$o_concat(acc, sep), _$n_list_$o_first(xs)), _$n_list_$o_rest(xs), false);
      }
      if (ret_AUTO_35 instanceof CalcitRecur) {
        if (ret_AUTO_35.args.length !== 3)
          throw new Error("argument sizes do not match");
        [acc, xs, beginning_$q_] = ret_AUTO_35.args;
        times_AUTO_36 += 1;
        continue;
      } else {
        return ret_AUTO_35;
      }
    }
  }("", xs0, true);
}
function nth(x, i) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (tuple_$q_2(x)) {
    return _$n_tuple_$o_nth(x, i);
  } else if (list_$q_2(x)) {
    return _$n_list_$o_nth(x, i);
  } else {
    return invoke_method("nth")(x, i);
  }
}
function last(xs) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (empty_$q_(xs)) {
    return null;
  } else {
    return nth(xs, _$n__(count(xs), 1));
  }
}
function map(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (list_$q_2(xs)) {
    return foldl(xs, _$L_(), function f_PCT_2(acc, x) {
      if (arguments.length !== 2)
        throw new Error("argument sizes do not match");
      return append2(acc, f(x));
    });
  } else if (set_$q_2(xs)) {
    return foldl(xs, _SHA__$M_(), function f_PCT_2(acc, x) {
      if (arguments.length !== 2)
        throw new Error("argument sizes do not match");
      return include(acc, f(x));
    });
  } else if (map_$q_2(xs)) {
    return foldl(xs, _$n__$M_(), function f_PCT_2(acc, pair) {
      if (arguments.length !== 2)
        throw new Error("argument sizes do not match");
      let v__1 = pair;
      let k = _$n_list_$o_nth(v__1, 0);
      let v = _$n_list_$o_nth(v__1, 1);
      let result = f(_$L_(k, v));
      (function __fn__() {
        not(string_$q_2("expected pair returned when mapping hashmap")) ? function __fn__2() {
          let err_AUTO_37 = new Error("expects 1st argument to be string");
          err_AUTO_37.data = null;
          throw err_AUTO_37;
        }() : null;
        if (list_$q_2(result) ? _$n__$e_(2, _$n_list_$o_count(result)) ? _$n__$e_(2, _$n_list_$o_count(result)) : false : false) {
          return null;
        } else {
          console.log(printable("Failed assertion:", format_to_lisp(new CalcitList([new CalcitSymbol("and"), new CalcitList([new CalcitSymbol("list?"), new CalcitSymbol("result")]), new CalcitList([new CalcitSymbol("&="), 2, new CalcitList([new CalcitSymbol("&list:count"), new CalcitSymbol("result")])])]))));
          let err_AUTO_38 = new Error("expected pair returned when mapping hashmap (and (list? result) (&= 2 (&list:count result)))");
          err_AUTO_38.data = null;
          throw err_AUTO_38;
        }
      })();
      let v__2 = result;
      let k2 = _$n_list_$o_nth(v__2, 0);
      let v2 = _$n_list_$o_nth(v__2, 1);
      return _$n_map_$o_assoc(acc, k2, v2);
    });
  } else if (true) {
    console.log(printable("value:", xs));
    let err_AUTO_39 = new Error("expects list or set for map function");
    err_AUTO_39.data = null;
    throw err_AUTO_39;
  } else {
    return null;
  }
}
function map_indexed(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return foldl(xs, _$L_(), function f_PCT_2(acc, x) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    return append2(acc, f(count(acc), x));
  });
}
function max(xs) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (_$n_list_$o_empty_$q_(xs)) {
    return null;
  } else {
    return reduce(_$n_list_$o_rest(xs), _$n_list_$o_first(xs), function f_PCT_2(acc, x) {
      if (arguments.length !== 2)
        throw new Error("argument sizes do not match");
      return _$n_max(acc, x);
    });
  }
}
function min(xs) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (_$n_list_$o_empty_$q_(xs)) {
    return null;
  } else {
    return reduce(_$n_list_$o_rest(xs), _$n_list_$o_first(xs), function f_PCT_2(acc, x) {
      if (arguments.length !== 2)
        throw new Error("argument sizes do not match");
      return _$n_min(acc, x);
    });
  }
}
function pairs_map(xs) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return reduce(xs, _$n__$M_(), function f_PCT_2(acc, pair) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    (function __fn__() {
      not(string_$q_2("expects pair for pairs-map")) ? function __fn__2() {
        let err_AUTO_40 = new Error("expects 1st argument to be string");
        err_AUTO_40.data = null;
        throw err_AUTO_40;
      }() : null;
      if (list_$q_2(pair) ? _$n__$e_(2, _$n_list_$o_count(pair)) : false) {
        return null;
      } else {
        console.log(printable("Failed assertion:", format_to_lisp(new CalcitList([new CalcitSymbol("if"), new CalcitList([new CalcitSymbol("list?"), new CalcitSymbol("pair")]), new CalcitList([new CalcitSymbol("&="), 2, new CalcitList([new CalcitSymbol("&list:count"), new CalcitSymbol("pair")])]), false]))));
        let err_AUTO_41 = new Error("expects pair for pairs-map (if (list? pair) (&= 2 (&list:count pair)) false)");
        err_AUTO_41.data = null;
        throw err_AUTO_41;
      }
    })();
    return _$n_map_$o_assoc(acc, _$n_list_$o_first(pair), last(pair));
  });
}
function take(xs, n) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (_GT__$e_(n, _$n_list_$o_count(xs))) {
    return xs;
  } else {
    return slice2(xs, 0, n);
  }
}
function section_by(xs0, n) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (_GT__$e_(n, 1)) {
    return function f_PCT_2(acc, xs) {
      if (arguments.length !== 2)
        throw new Error("argument sizes do not match");
      let ret_AUTO_43 = null;
      let times_AUTO_44 = 0;
      while (true) {
        if (times_AUTO_44 > 1e5)
          throw new Error("tail recursion not stopping");
        if (_$n__LT__$e_(_$n_list_$o_count(xs), n)) {
          if (_$n_list_$o_empty_$q_(xs)) {
            ret_AUTO_43 = acc;
          } else {
            ret_AUTO_43 = append2(acc, xs);
          }
        } else {
          ret_AUTO_43 = recur(append2(acc, take(xs, n)), drop(xs, n));
        }
        if (ret_AUTO_43 instanceof CalcitRecur) {
          if (ret_AUTO_43.args.length !== 2)
            throw new Error("argument sizes do not match");
          [acc, xs] = ret_AUTO_43.args;
          times_AUTO_44 += 1;
          continue;
        } else {
          return ret_AUTO_43;
        }
      }
    }(_$L_(), xs0);
  } else {
    let err_AUTO_45 = new Error("expected positive number");
    err_AUTO_45.data = null;
    throw err_AUTO_45;
  }
}
function take_last(xs, n) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (_GT__$e_(n, _$n_list_$o_count(xs))) {
    return xs;
  } else {
    return slice2(xs, _SUB_(_$n_list_$o_count(xs), n), _$n_list_$o_count(xs));
  }
}
function zipmap(xs0, ys0) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return function f_PCT_2(acc, xs, ys) {
    if (arguments.length !== 3)
      throw new Error("argument sizes do not match");
    let ret_AUTO_47 = null;
    let times_AUTO_48 = 0;
    while (true) {
      if (times_AUTO_48 > 1e5)
        throw new Error("tail recursion not stopping");
      if (_$n_list_$o_empty_$q_(xs) ? true : _$n_list_$o_empty_$q_(ys)) {
        ret_AUTO_47 = acc;
      } else {
        ret_AUTO_47 = recur(_$n_map_$o_assoc(acc, _$n_list_$o_first(xs), _$n_list_$o_first(ys)), rest2(xs), rest2(ys));
      }
      if (ret_AUTO_47 instanceof CalcitRecur) {
        if (ret_AUTO_47.args.length !== 3)
          throw new Error("argument sizes do not match");
        [acc, xs, ys] = ret_AUTO_47.args;
        times_AUTO_48 += 1;
        continue;
      } else {
        return ret_AUTO_47;
      }
    }
  }(_$n__$M_(), xs0, ys0);
}
var conj = function conj2(xs, y0, ...ys) {
  if (arguments.length < 2)
    throw new Error("too few arguments");
  ys = arrayToList(ys);
  let ret_AUTO_50 = null;
  let times_AUTO_51 = 0;
  while (true) {
    if (times_AUTO_51 > 1e5)
      throw new Error("tail recursion not stopping");
    if (empty_$q_(ys)) {
      ret_AUTO_50 = append2(xs, y0);
    } else {
      ret_AUTO_50 = recur(append2(xs, y0), ...listToArray(ys));
    }
    if (ret_AUTO_50 instanceof CalcitRecur) {
      if (ret_AUTO_50.args.length < 2)
        throw new Error("too few arguments");
      [xs, y0, ...ys] = ret_AUTO_50.args;
      ys = arrayToList(ys);
      times_AUTO_51 += 1;
      continue;
    } else {
      return ret_AUTO_50;
    }
  }
};
function _$n_map_$o_map_list(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  console.log(printable("map-list", xs, f));
  if (map_$q_2(xs)) {
    return foldl(xs, _$L_(), function f_PCT_2(acc, pair) {
      if (arguments.length !== 2)
        throw new Error("argument sizes do not match");
      return conj(acc, f(pair));
    });
  } else {
    let err_AUTO_52 = new Error("&map:map-list expected a map");
    err_AUTO_52.data = null;
    throw err_AUTO_52;
  }
}
function keys(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return map(to_pairs(x), _$n_list_$o_first);
}
function keys_non_nil(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return function f_PCT_2(acc, pairs) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    let ret_AUTO_54 = null;
    let times_AUTO_55 = 0;
    while (true) {
      if (times_AUTO_55 > 1e5)
        throw new Error("tail recursion not stopping");
      if (_$n_set_$o_empty_$q_(pairs)) {
        ret_AUTO_54 = acc;
      } else {
        let pair = _$n_set_$o_first(pairs);
        if (nil_$q_2(last(pair))) {
          ret_AUTO_54 = recur(acc, _$n_set_$o_rest(pairs));
        } else {
          ret_AUTO_54 = recur(include(acc, _$n_list_$o_first(pair)), rest2(pairs));
        }
      }
      if (ret_AUTO_54 instanceof CalcitRecur) {
        if (ret_AUTO_54.args.length !== 2)
          throw new Error("argument sizes do not match");
        [acc, pairs] = ret_AUTO_54.args;
        times_AUTO_55 += 1;
        continue;
      } else {
        return ret_AUTO_54;
      }
    }
  }(_SHA__$M_(), to_pairs(x));
}
function map_kv(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  (function __fn__() {
    not(string_$q_2("expects a map")) ? function __fn__2() {
      let err_AUTO_56 = new Error("expects 1st argument to be string");
      err_AUTO_56.data = null;
      throw err_AUTO_56;
    }() : null;
    if (map_$q_2(xs)) {
      return null;
    } else {
      console.log(printable("Failed assertion:", format_to_lisp(new CalcitList([new CalcitSymbol("map?"), new CalcitSymbol("xs")]))));
      let err_AUTO_57 = new Error("expects a map (map? xs)");
      err_AUTO_57.data = null;
      throw err_AUTO_57;
    }
  })();
  return foldl(xs, _$n__$M_(), function f_PCT_2(acc, pair) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    let v__5 = pair;
    let k = _$n_list_$o_nth(v__5, 0);
    let v = _$n_list_$o_nth(v__5, 1);
    let result = f(k, v);
    if (list_$q_2(result)) {
      (function __fn__() {
        not(string_$q_2("expected pair returned when mapping hashmap")) ? function __fn__2() {
          let err_AUTO_58 = new Error("expects 1st argument to be string");
          err_AUTO_58.data = null;
          throw err_AUTO_58;
        }() : null;
        if (_$n__$e_(2, _$n_list_$o_count(result))) {
          return null;
        } else {
          console.log(printable("Failed assertion:", format_to_lisp(new CalcitList([new CalcitSymbol("&="), 2, new CalcitList([new CalcitSymbol("&list:count"), new CalcitSymbol("result")])]))));
          let err_AUTO_59 = new Error("expected pair returned when mapping hashmap (&= 2 (&list:count result))");
          err_AUTO_59.data = null;
          throw err_AUTO_59;
        }
      })();
      let v__6 = result;
      let k2 = _$n_list_$o_nth(v__6, 0);
      let v2 = _$n_list_$o_nth(v__6, 1);
      return _$n_map_$o_assoc(acc, k2, v2);
    } else if (nil_$q_2(result)) {
      return acc;
    } else {
      let err_AUTO_60 = new Error(_$n_str_$o_concat("map-kv expected list or nil, got: ", _$n_str_$o_concat(result, "")));
      err_AUTO_60.data = null;
      throw err_AUTO_60;
    }
  });
}
function merge(x0, ...xs) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  xs = arrayToList(xs);
  return reduce(xs, x0, _$n_merge);
}
function select_keys(m, xs) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  (function __fn__() {
    not(string_$q_2("expectd map for selecting")) ? function __fn__2() {
      let err_AUTO_61 = new Error("expects 1st argument to be string");
      err_AUTO_61.data = null;
      throw err_AUTO_61;
    }() : null;
    if (map_$q_2(m)) {
      return null;
    } else {
      console.log(printable("Failed assertion:", format_to_lisp(new CalcitList([new CalcitSymbol("map?"), new CalcitSymbol("m")]))));
      let err_AUTO_62 = new Error("expectd map for selecting (map? m)");
      err_AUTO_62.data = null;
      throw err_AUTO_62;
    }
  })();
  return foldl(xs, _$n__$M_(), function f_PCT_2(acc, k) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    return _$n_map_$o_assoc(acc, k, _$n_map_$o_get(m, k));
  });
}
function unselect_keys(m, xs) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  (function __fn__() {
    not(string_$q_2("expectd map for unselecting")) ? function __fn__2() {
      let err_AUTO_63 = new Error("expects 1st argument to be string");
      err_AUTO_63.data = null;
      throw err_AUTO_63;
    }() : null;
    if (map_$q_2(m)) {
      return null;
    } else {
      console.log(printable("Failed assertion:", format_to_lisp(new CalcitList([new CalcitSymbol("map?"), new CalcitSymbol("m")]))));
      let err_AUTO_64 = new Error("expectd map for unselecting (map? m)");
      err_AUTO_64.data = null;
      throw err_AUTO_64;
    }
  })();
  return foldl(xs, m, function f_PCT_2(acc, k) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    return _$n_map_$o_dissoc(acc, k);
  });
}
function vals(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return map(to_pairs(x), last);
}
function _$n_number_$o_rand_between(x, y) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return _$n__ADD_(x, rand(_$n__(y, x)));
}
function _$n_number_$o_rand_shift(x, y) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return _$n__ADD_(_$n__(x, y), rand(_$n__$s_(2, y)));
}
function inc(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return _$n__ADD_(x, 1);
}
function negate(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return _$n__(0, x);
}
function difference(base, ...xs) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  xs = arrayToList(xs);
  return reduce(xs, base, function f_PCT_2(acc, item) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    return _$n_difference(acc, item);
  });
}
function exclude(base, ...xs) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  xs = arrayToList(xs);
  return reduce(xs, base, function f_PCT_2(acc, item) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    return _$n_exclude(acc, item);
  });
}
function intersection(base, ...xs) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  xs = arrayToList(xs);
  return reduce(xs, base, function f_PCT_2(acc, item) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    return _$n_set_$o_intersection(acc, item);
  });
}
function union(base, ...xs) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  xs = arrayToList(xs);
  return reduce(xs, base, function f_PCT_2(acc, item) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    return _$n_union(acc, item);
  });
}
function strip_prefix(s, piece) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (starts_with_$q_(s, piece)) {
    return _$n_str_$o_slice(s, _$n_str_$o_count(piece));
  } else {
    return s;
  }
}
function strip_suffix(s, piece) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (ends_with_$q_(s, piece)) {
    return _$n_str_$o_slice(s, 0, _$n__(_$n_str_$o_count(s), _$n_str_$o_count(piece)));
  } else {
    return s;
  }
}
var _$n_doseq = () => {
};
_$n_doseq.isMacro = true;
function _$s_(x, ...ys) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  ys = arrayToList(ys);
  return reduce(ys, x, _$n__$s_);
}
var __GT_ = () => {
};
__GT_.isMacro = true;
var _SCOL_nil = () => {
};
_SCOL_nil.isMacro = true;
function _LT_(x, ...ys) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  ys = arrayToList(ys);
  if (_$n__$e_(1, _$n_list_$o_count(ys))) {
    return _$n__LT_(x, _$n_list_$o_first(ys));
  } else {
    return foldl_compare(ys, x, _$n__LT_);
  }
}
function _LT__$e_(x, ...ys) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  ys = arrayToList(ys);
  if (_$n__$e_(1, _$n_list_$o_count(ys))) {
    return _$n__LT__$e_(x, _$n_list_$o_first(ys));
  } else {
    return foldl_compare(ys, x, _$n__LT__$e_);
  }
}
function _GT_(x, ...ys) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  ys = arrayToList(ys);
  if (_$n__$e_(1, _$n_list_$o_count(ys))) {
    return _$n__GT_(x, _$n_list_$o_first(ys));
  } else {
    return foldl_compare(ys, x, _$n__GT_);
  }
}
var _BSL_ = () => {
};
_BSL_.isMacro = true;
function apply(f, args) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return f(...listToArray(args));
}
var apply_args = () => {
};
apply_args.isMacro = true;
var assert = () => {
};
assert.isMacro = true;
var _CASE_ = () => {
};
_CASE_.isMacro = true;
var case_default = () => {
};
case_default.isMacro = true;
var cond = () => {
};
cond.isMacro = true;
var def = () => {
};
def.isMacro = true;
var defrecord = () => {
};
defrecord.isMacro = true;
var defrecord_$x_ = () => {
};
defrecord_$x_.isMacro = true;
function dissoc(x, ...args) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  args = arrayToList(args);
  if (nil_$q_2(x)) {
    return null;
  } else if (list_$q_2(x)) {
    return _$n_list_$o_dissoc(x, ...listToArray(args));
  } else {
    return invoke_method("dissoc")(x, ...listToArray(args));
  }
}
var _DO_ = () => {
};
_DO_.isMacro = true;
var either = () => {
};
either.isMacro = true;
function every_$q_(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return foldl_shortcut(xs, null, true, function f_PCT_2(_acc, x) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    if (f(x)) {
      return _$L_(false, null);
    } else {
      return _$L_(true, false);
    }
  });
}
function first2(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (nil_$q_2(x)) {
    return null;
  } else if (tuple_$q_2(x)) {
    return _$n_tuple_$o_nth(x, 0);
  } else if (list_$q_2(x)) {
    return _$n_list_$o_nth(x, 0);
  } else {
    return invoke_method("first")(x);
  }
}
var fn = () => {
};
fn.isMacro = true;
var if_not = () => {
};
if_not.isMacro = true;
function includes_$q_(x, k) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (nil_$q_2(x)) {
    return false;
  } else if (list_$q_2(x)) {
    return _$n_list_$o_includes_$q_(x, k);
  } else {
    return invoke_method("includes?")(x, k);
  }
}
var js_object = () => {
};
js_object.isMacro = true;
var _LET_ = () => {
};
_LET_.isMacro = true;
var let_$L_ = () => {
};
let_$L_.isMacro = true;
var loop = () => {
};
loop.isMacro = true;
var or = () => {
};
or.isMacro = true;
function some_$q_(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return not(nil_$q_2(x));
}
var str = () => {
};
str.isMacro = true;
function symbol_$q_(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return _$n__$e_(type_of(x), kwd("symbol"));
}
var when = () => {
};
when.isMacro = true;
var when_not = () => {
};
when_not.isMacro = true;
var _$M_ = () => {
};
_$M_.isMacro = true;
var _$n_core_list_class = _$n__PCT__$M_(new_record(new CalcitSymbol("&core-list-class"), kwd("any?"), kwd("add"), kwd("append"), kwd("assoc"), kwd("assoc-after"), kwd("assoc-before"), kwd("butlast"), kwd("concat"), kwd("contains?"), kwd("includes?"), kwd("count"), kwd("drop"), kwd("each"), kwd("empty"), kwd("empty?"), kwd("filter"), kwd("filter-not"), kwd("find-index"), kwd("foldl"), kwd("frequencies"), kwd("get"), kwd("get-in"), kwd("group-by"), kwd("has-index?"), kwd("index-of"), kwd("interleave"), kwd("join"), kwd("join-str"), kwd("map"), kwd("map-indexed"), kwd("max"), kwd("min"), kwd("nth"), kwd("pairs-map"), kwd("prepend"), kwd("reduce"), kwd("reverse"), kwd("section-by"), kwd("slice"), kwd("sort"), kwd("sort-by"), kwd("take"), kwd("take-last"), kwd("to-set"), kwd("zipmap"), kwd("first"), kwd("rest"), kwd("dissoc"), kwd("distinct")), kwd("any?"), any_$q_, kwd("add"), append2, kwd("append"), append2, kwd("assoc"), _$n_list_$o_assoc, kwd("assoc-after"), _$n_list_$o_assoc_after, kwd("assoc-before"), _$n_list_$o_assoc_before, kwd("butlast"), butlast, kwd("concat"), _$n_list_$o_concat, kwd("contains?"), _$n_list_$o_contains_$q_, kwd("includes?"), _$n_list_$o_includes_$q_, kwd("count"), _$n_list_$o_count, kwd("drop"), drop, kwd("each"), each, kwd("empty"), function _$n_list_$o_empty(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return _$L_();
}, kwd("empty?"), _$n_list_$o_empty_$q_, kwd("filter"), filter, kwd("filter-not"), filter_not, kwd("find-index"), find_index, kwd("foldl"), function foldl2(xs, v0, f) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  return foldl(xs, v0, f);
}, kwd("frequencies"), frequencies, kwd("get"), _$n_list_$o_nth, kwd("get-in"), get_in, kwd("group-by"), group_by, kwd("has-index?"), _$n_list_$o_contains_$q_, kwd("index-of"), index_of, kwd("interleave"), interleave, kwd("join"), join, kwd("join-str"), join_str, kwd("map"), map, kwd("map-indexed"), map_indexed, kwd("max"), max, kwd("min"), min, kwd("nth"), _$n_list_$o_nth, kwd("pairs-map"), pairs_map, kwd("prepend"), prepend2, kwd("reduce"), reduce, kwd("reverse"), _$n_list_$o_reverse, kwd("section-by"), section_by, kwd("slice"), _$n_list_$o_slice, kwd("sort"), function sort2(x, y) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return sort(x, y);
}, kwd("sort-by"), _$n_list_$o_sort_by, kwd("take"), take, kwd("take-last"), take_last, kwd("to-set"), _$n_list_$o_to_set, kwd("zipmap"), zipmap, kwd("first"), _$n_list_$o_first, kwd("rest"), _$n_list_$o_rest, kwd("dissoc"), _$n_list_$o_dissoc, kwd("distinct"), _$n_list_$o_distinct);
var _$n_core_map_class = _$n__PCT__$M_(new_record(new CalcitSymbol("&core-map-class"), kwd("add"), kwd("assoc"), kwd("contains?"), kwd("count"), kwd("dissoc"), kwd("empty"), kwd("empty?"), kwd("get"), kwd("get-in"), kwd("includes?"), kwd("keys"), kwd("keys-non-nil"), kwd("map"), kwd("map-kv"), kwd("map-list"), kwd("merge"), kwd("select-keys"), kwd("to-list"), kwd("to-pairs"), kwd("unselect-keys"), kwd("values"), kwd("first"), kwd("rest"), kwd("diff-new"), kwd("diff-keys"), kwd("common-keys")), kwd("add"), _$n_map_$o_add_entry, kwd("assoc"), _$n_map_$o_assoc, kwd("contains?"), _$n_map_$o_contains_$q_, kwd("count"), _$n_map_$o_count, kwd("dissoc"), _$n_map_$o_dissoc, kwd("empty"), function _$n_map_$o_empty(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return _$n__$M_();
}, kwd("empty?"), _$n_map_$o_empty_$q_, kwd("get"), _$n_map_$o_get, kwd("get-in"), get_in, kwd("includes?"), _$n_map_$o_includes_$q_, kwd("keys"), keys, kwd("keys-non-nil"), keys_non_nil, kwd("map"), map, kwd("map-kv"), map_kv, kwd("map-list"), _$n_map_$o_map_list, kwd("merge"), merge, kwd("select-keys"), select_keys, kwd("to-list"), _$n_map_$o_to_list, kwd("to-pairs"), to_pairs, kwd("unselect-keys"), unselect_keys, kwd("values"), vals, kwd("first"), _$n_map_$o_first, kwd("rest"), _$n_map_$o_rest, kwd("diff-new"), _$n_map_$o_diff_new, kwd("diff-keys"), _$n_map_$o_diff_keys, kwd("common-keys"), _$n_map_$o_common_keys);
var _$n_core_number_class = _$n__PCT__$M_(new_record(new CalcitSymbol("&core-number-class"), kwd("ceil"), kwd("empty"), kwd("floor"), kwd("format"), kwd("inc"), kwd("pow"), kwd("round"), kwd("round?"), kwd("fract"), kwd("sqrt"), kwd("rand-shift"), kwd("rand-between"), kwd("negate"), kwd("rem")), kwd("ceil"), ceil, kwd("empty"), function _$n_number_$o_empty(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return 0;
}, kwd("floor"), floor, kwd("format"), _$n_number_$o_format, kwd("inc"), inc, kwd("pow"), pow, kwd("round"), round, kwd("round?"), round_$q_, kwd("fract"), _$n_number_$o_fract, kwd("sqrt"), sqrt, kwd("rand-shift"), _$n_number_$o_rand_shift, kwd("rand-between"), _$n_number_$o_rand_between, kwd("negate"), negate, kwd("rem"), _$n_number_$o_rem);
var _$n_core_record_class = _$n__PCT__$M_(new_record(new CalcitSymbol("&core-record-class"), kwd("get"), kwd("get-name"), kwd("matches?"), kwd("to-map"), kwd("count"), kwd("contains?"), kwd("nth"), kwd("assoc"), kwd("from-map"), kwd("extend-as")), kwd("get"), _$n_record_$o_get, kwd("get-name"), _$n_record_$o_get_name, kwd("matches?"), _$n_record_$o_matches_$q_, kwd("to-map"), _$n_record_$o_to_map, kwd("count"), _$n_record_$o_count, kwd("contains?"), _$n_record_$o_contains_$q_, kwd("nth"), _$n_record_$o_nth, kwd("assoc"), _$n_record_$o_assoc, kwd("from-map"), _$n_record_$o_from_map, kwd("extend-as"), _$n_record_$o_extend_as);
var _$n_core_set_class = _$n__PCT__$M_(new_record(new CalcitSymbol("&core-set-class"), kwd("add"), kwd("count"), kwd("difference"), kwd("exclude"), kwd("empty"), kwd("empty?"), kwd("include"), kwd("includes?"), kwd("contains?"), kwd("intersection"), kwd("to-list"), kwd("union"), kwd("first"), kwd("rest")), kwd("add"), include, kwd("count"), _$n_set_$o_count, kwd("difference"), difference, kwd("exclude"), exclude, kwd("empty"), function _$n_set_$o_empty(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return _SHA__$M_();
}, kwd("empty?"), _$n_set_$o_empty_$q_, kwd("include"), include, kwd("includes?"), _$n_set_$o_includes_$q_, kwd("contains?"), _$n_set_$o_includes_$q_, kwd("intersection"), intersection, kwd("to-list"), _$n_set_$o_to_list, kwd("union"), union, kwd("first"), _$n_set_$o_first, kwd("rest"), _$n_set_$o_rest);
var _$n_core_string_class = _$n__PCT__$M_(new_record(new CalcitSymbol("&core-string-class"), kwd("blank?"), kwd("count"), kwd("empty"), kwd("ends-with?"), kwd("get"), kwd("parse-float"), kwd("parse-json"), kwd("replace"), kwd("split"), kwd("split-lines"), kwd("starts-with?"), kwd("strip-prefix"), kwd("strip-suffix"), kwd("slice"), kwd("trim"), kwd("empty?"), kwd("contains?"), kwd("includes?"), kwd("nth"), kwd("first"), kwd("rest"), kwd("find-index"), kwd("get-char-code"), kwd("escape")), kwd("blank?"), blank_$q_, kwd("count"), _$n_str_$o_count, kwd("empty"), function _$n_str_$o_empty(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return "";
}, kwd("ends-with?"), ends_with_$q_, kwd("get"), _$n_str_$o_nth, kwd("parse-float"), parse_float, kwd("parse-json"), parse_json, kwd("replace"), _$n_str_$o_replace, kwd("split"), split, kwd("split-lines"), split_lines, kwd("starts-with?"), starts_with_$q_, kwd("strip-prefix"), strip_prefix, kwd("strip-suffix"), strip_suffix, kwd("slice"), _$n_str_$o_slice, kwd("trim"), trim, kwd("empty?"), _$n_str_$o_empty_$q_, kwd("contains?"), _$n_str_$o_contains_$q_, kwd("includes?"), _$n_str_$o_includes_$q_, kwd("nth"), _$n_str_$o_nth, kwd("first"), _$n_str_$o_first, kwd("rest"), _$n_str_$o_rest, kwd("find-index"), _$n_str_$o_find_index, kwd("get-char-code"), get_char_code, kwd("escape"), _$n_str_$o_escape);
register_calcit_builtin_classes({
  list: _$n_core_list_class,
  map: _$n_core_map_class,
  number: _$n_core_number_class,
  record: _$n_core_record_class,
  set: _$n_core_set_class,
  string: _$n_core_string_class
});
var runtimeVersion = calcit_version;
var cli_version = "0.4.16";
if (runtimeVersion !== cli_version) {
  console.warn(`[Warning] versions mismatch, CLI using: ${cli_version}, runtime using: ${runtimeVersion}`);
}

// server-out/respo.util.comparator.js
function compare(x, y) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (_LT_(x, y)) {
    return -1;
  } else if (_GT_(x, y)) {
    return 1;
  } else if (true) {
    return 0;
  } else {
    return null;
  }
}
function type_as_int(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (number_$q_(x)) {
    return 0;
  } else if (keyword_$q_(x)) {
    return 1;
  } else if (string_$q_(x)) {
    return 2;
  } else if (true) {
    let err_AUTO_1 = new Error("use number, keyword or string in coord!");
    err_AUTO_1.data = null;
    throw err_AUTO_1;
  } else {
    return null;
  }
}
function compare_xy(x, y) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  let type_x = type_as_int(x);
  let type_y = type_as_int(y);
  if (_$e_(type_x, type_y)) {
    if (keyword_$q_(x)) {
      return compare(turn_string(x), turn_string(y));
    } else {
      return compare(x, y);
    }
  } else {
    return compare(type_x, type_y);
  }
}

// server-out/respo.schema.js
var Component = new_record(new CalcitSymbol("Component"), kwd("name"), kwd("effects"), kwd("tree"));
var Effect = new_record(new CalcitSymbol("Effect"), kwd("name"), kwd("coord"), kwd("args"), kwd("method"));
var Element = new_record(new CalcitSymbol("Element"), kwd("name"), kwd("coord"), kwd("attrs"), kwd("style"), kwd("event"), kwd("children"));

// server-out/respo.util.detect.js
function component_$q_(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (record_$q_(x)) {
    return invoke_method("matches?")(Component, x);
  } else {
    return false;
  }
}
function effect_$q_(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (record_$q_(x)) {
    if (invoke_method("matches?")(Effect, x)) {
      return invoke_method("matches?")(Effect, x);
    } else {
      return false;
    }
  } else {
    return false;
  }
}
function element_$q_(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (record_$q_(x)) {
    return invoke_method("matches?")(Element, x);
  } else {
    return false;
  }
}

// server-out/respo.util.list.js
function filter_first(f, xs) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return first2(filter(function __fn__() {
    let v1__73 = xs;
    if (nil_$q_(v1__73)) {
      return _$L_();
    } else if (_$e_(false, v1__73)) {
      return _$L_();
    } else {
      return v1__73;
    }
  }(), function f_PCT_2(x) {
    if (arguments.length !== 1)
      throw new Error("argument sizes do not match");
    return f(x);
  }));
}
function pick_attrs(props) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (nil_$q_(props)) {
    return _$L_();
  } else {
    return sort(filter(invoke_method("to-list")(dissoc(dissoc(dissoc(props, kwd("on")), kwd("event")), kwd("style"))), function f_PCT_2(pair) {
      if (arguments.length !== 1)
        throw new Error("argument sizes do not match");
      let k = get(pair, 0);
      let v = get(pair, 1);
      return not(starts_with_$q_(turn_string(k), "on-"));
    }), function f_PCT_2(x, y) {
      if (arguments.length !== 2)
        throw new Error("argument sizes do not match");
      return compare_xy(first2(x), first2(y));
    });
  }
}
function pick_event(props) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (nil_$q_(props)) {
    return _$n__$M_();
  } else {
    return merge(function __fn__() {
      let v1__68 = get(props, kwd("on"));
      if (nil_$q_(v1__68)) {
        return _$n__$M_();
      } else if (_$e_(false, v1__68)) {
        return _$n__$M_();
      } else {
        return v1__68;
      }
    }(), map_kv(props, function f_PCT_2(k, v) {
      if (arguments.length !== 2)
        throw new Error("argument sizes do not match");
      if (starts_with_$q_(turn_string(k), "on-")) {
        return _$L_(turn_keyword(_$n_str_$o_slice(turn_string(k), 3)), v);
      } else {
        return null;
      }
    }));
  }
}
function val_exists_$q_(pair) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return some_$q_(last(pair));
}

// server-out/respo.core.js
function confirm_child(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  not(function __fn__() {
    let v1__69 = nil_$q_(x);
    if (nil_$q_(v1__69)) {
      let v1__70 = element_$q_(x);
      if (nil_$q_(v1__70)) {
        return component_$q_(x);
      } else if (_$e_(false, v1__70)) {
        return component_$q_(x);
      } else {
        return v1__70;
      }
    } else if (_$e_(false, v1__69)) {
      let v1__71 = element_$q_(x);
      if (nil_$q_(v1__71)) {
        return component_$q_(x);
      } else if (_$e_(false, v1__71)) {
        return component_$q_(x);
      } else {
        return v1__71;
      }
    } else {
      return v1__69;
    }
  }()) ? function __fn__() {
    let err_AUTO_1 = new Error(_$n_str_$o_concat("Invalid data in elements tree: ", _$n_str_$o_concat(pr_str(x), "")));
    err_AUTO_1.data = null;
    throw err_AUTO_1;
  }() : null;
  return x;
}
function create_element(tag_name, props, ...children) {
  if (arguments.length < 2)
    throw new Error("too few arguments");
  children = arrayToList(children);
  let attrs = pick_attrs(props);
  let styles = sort(invoke_method("to-list")(function __fn__() {
    let v1__67 = get(props, kwd("style"));
    if (nil_$q_(v1__67)) {
      return _$n__$M_();
    } else if (_$e_(false, v1__67)) {
      return _$n__$M_();
    } else {
      return v1__67;
    }
  }()), function f_PCT_2(x, y) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    return compare_xy(first2(x), first2(y));
  });
  let event = pick_event(props);
  let children_nodes = filter(map_indexed(children, function f_PCT_2(idx, item) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    return _$L_(idx, item);
  }), val_exists_$q_);
  return _$n__PCT__$M_(Element, kwd("name"), tag_name, kwd("coord"), null, kwd("attrs"), attrs, kwd("style"), styles, kwd("event"), event, kwd("children"), children_nodes);
}
function span(props, ...children) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  children = arrayToList(children);
  return create_element(kwd("span"), props, ...listToArray(map(children, confirm_child)));
}
function _LT__GT_(content, arg) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  if (arguments.length > 2)
    throw new Error("too many arguments");
  let style = arg;
  return span(_$n__$M_(kwd("inner-text"), content, kwd("style"), style));
}
function a(props, ...children) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  children = arrayToList(children);
  return create_element(kwd("a"), props, ...listToArray(map(children, confirm_child)));
}
function body(props, ...children) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  children = arrayToList(children);
  return create_element(kwd("body"), props, ...listToArray(map(children, confirm_child)));
}
function create_list_element(tag_name, props, child_map) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let attrs = pick_attrs(props);
  let styles = sort(invoke_method("to-list")(function __fn__() {
    let v1__72 = get(props, kwd("style"));
    if (nil_$q_(v1__72)) {
      return _$n__$M_();
    } else if (_$e_(false, v1__72)) {
      return _$n__$M_();
    } else {
      return v1__72;
    }
  }()), function f_PCT_2(x, y) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    return compare_xy(first2(x), first2(y));
  });
  let event = pick_event(props);
  return _$n__PCT__$M_(Element, kwd("name"), tag_name, kwd("coord"), null, kwd("attrs"), attrs, kwd("style"), styles, kwd("event"), event, kwd("children"), child_map);
}
var defcomp = () => {
};
defcomp.isMacro = true;
function div(props, ...children) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  children = arrayToList(children);
  return create_element(kwd("div"), props, ...listToArray(map(children, confirm_child)));
}
function extract_effects_list(markup) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  let markup_tree = get(markup, kwd("tree"));
  if (nil_$q_(markup_tree)) {
    return assoc(markup, kwd("tree"), span(null));
  } else if (list_$q_(markup_tree)) {
    let node_tree = filter_first(function f_PCT_2(x) {
      if (arguments.length !== 1)
        throw new Error("argument sizes do not match");
      if (record_$q_(x)) {
        if (function __fn__() {
          let v1__74 = component_$q_(x);
          if (nil_$q_(v1__74)) {
            return element_$q_(x);
          } else if (_$e_(false, v1__74)) {
            return element_$q_(x);
          } else {
            return v1__74;
          }
        }()) {
          let v1__75 = component_$q_(x);
          if (nil_$q_(v1__75)) {
            return element_$q_(x);
          } else if (_$e_(false, v1__75)) {
            return element_$q_(x);
          } else {
            return v1__75;
          }
        } else {
          return false;
        }
      } else {
        return false;
      }
    }, markup_tree);
    let effects_list = filter(markup_tree, effect_$q_);
    return merge(markup, _$n__$M_(kwd("tree"), node_tree, kwd("effects"), effects_list));
  } else if (true) {
    return markup;
  } else {
    return null;
  }
}
function head(props, ...children) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  children = arrayToList(children);
  return create_element(kwd("head"), props, ...listToArray(map(children, confirm_child)));
}
function html(props, ...children) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  children = arrayToList(children);
  return create_element(kwd("html"), props, ...listToArray(map(children, confirm_child)));
}
function link(props, ...children) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  children = arrayToList(children);
  return create_element(kwd("link"), props, ...listToArray(map(children, confirm_child)));
}
function list__GT_(props, children) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return create_list_element(kwd("div"), props, children);
}

// server-out/respo.comp.space.js
function comp_space(w, h) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return extract_effects_list(_$n__PCT__$M_(Component, kwd("effects"), _$L_(), kwd("name"), kwd("comp-space"), kwd("tree"), function __fn__() {
    return div(_$n__$M_(kwd("style"), some_$q_(w) ? assoc(style_space, kwd("width"), w) : assoc(style_space, kwd("height"), h)));
  }()));
}
function _$e__LT_(w, x) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return comp_space(w, x);
}
var style_space = _$n__$M_(kwd("height"), 1, kwd("width"), 1, kwd("display"), kwd("inline-block"));

// server-out/app.server.js
var $chalk = __toModule(require_source());
var import_dayjs = __toModule(require_dayjs_min());
var import_finalhandler = __toModule(require_finalhandler());
var $formidable = __toModule(require_lib2());
var $fs = __toModule(require("fs"));

// server-out/respo-ui.core.js
function hsl(h, s, l, a2) {
  if (arguments.length < 3)
    throw new Error("too few arguments");
  if (arguments.length > 4)
    throw new Error("too many arguments");
  if (some_$q_(a2)) {
    return _$n_str_$o_concat("hsl(", _$n_str_$o_concat(h, _$n_str_$o_concat(",", _$n_str_$o_concat(s, _$n_str_$o_concat("%,", _$n_str_$o_concat(l, _$n_str_$o_concat("%,", _$n_str_$o_concat(a2, _$n_str_$o_concat(")", "")))))))));
  } else {
    return _$n_str_$o_concat("hsl(", _$n_str_$o_concat(h, _$n_str_$o_concat(",", _$n_str_$o_concat(s, _$n_str_$o_concat("%,", _$n_str_$o_concat(l, _$n_str_$o_concat("%)", "")))))));
  }
}
var center = _$n__$M_(kwd("display"), "flex", kwd("flex-direction"), "column", kwd("justify-content"), "center", kwd("align-items"), "center");
var font_fancy = "Josefin Sans, Helvetica neue, Arial, sans-serif";
var row = _$n__$M_(kwd("display"), "flex", kwd("align-items"), "stretch", kwd("flex-direction"), "row");

// server-out/app.server.js
var $ip = __toModule(require_ip());
var import_latest_version = __toModule(require_latest_version());

// server-out/respo.util.format.js
function dashed__GT_camel(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return x.replace(dashed_letter_pattern, function f_PCT_2(cc, pos, prop) {
    if (arguments.length !== 3)
      throw new Error("argument sizes do not match");
    return aget(cc, 1).toUpperCase();
  });
}
function get_style_value(x, prop) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (string_$q_(x)) {
    return x;
  } else if (keyword_$q_(x)) {
    return turn_string(x);
  } else if (number_$q_(x)) {
    if (pattern_non_dimension_props.test(prop)) {
      return _$n_str_$o_concat(x, "");
    } else {
      return _$n_str_$o_concat(x, _$n_str_$o_concat("px", ""));
    }
  } else if (true) {
    return _$n_str_$o_concat(x, "");
  } else {
    return null;
  }
}
function mute_element(element) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (component_$q_(element)) {
    return update(element, kwd("tree"), mute_element);
  } else {
    return update(update(element, kwd("event"), function f_PCT_2(events) {
      if (arguments.length !== 1)
        throw new Error("argument sizes do not match");
      return _$n__$M_();
    }), kwd("children"), function f_PCT_2(children) {
      if (arguments.length !== 1)
        throw new Error("argument sizes do not match");
      return map(children, function f_PCT_3(entry) {
        if (arguments.length !== 1)
          throw new Error("argument sizes do not match");
        return _$L_(first2(entry), mute_element(last(entry)));
      });
    });
  }
}
function prop__GT_attr(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  includes_$q_(x, "?") ? function __fn__() {
    console.log(printable("[Respo] warning: property includes `?` in", x));
  }() : null;
  let v__65 = x;
  if (_$n__$e_(v__65, "class-name")) {
    return "class";
  } else if (_$n__$e_(v__65, "tab-index")) {
    return "tabindex";
  } else if (_$n__$e_(v__65, "read-only")) {
    return "readonly";
  } else if (_$n__$e_(v__65, x)) {
    return x;
  } else {
    return null;
  }
}
function purify_events(events) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return map(filter(to_pairs(events), function f_PCT_2(pair) {
    if (arguments.length !== 1)
      throw new Error("argument sizes do not match");
    let k = first2(pair);
    let v = first2(pair);
    return some_$q_(v);
  }), first2);
}
function purify_element(markup) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (nil_$q_(markup)) {
    return null;
  } else if (component_$q_(markup)) {
    return purify_element(function __fn__() {
      let t = get(markup, kwd("tree"));
      nil_$q_(t) ? function __fn__2() {
        let err_AUTO_1 = new Error("tree is empty");
        err_AUTO_1.data = null;
        throw err_AUTO_1;
      }() : null;
      return t;
    }());
  } else if (element_$q_(markup)) {
    return update(update(markup, kwd("event"), purify_events), kwd("children"), function f_PCT_2(children) {
      if (arguments.length !== 1)
        throw new Error("argument sizes do not match");
      return map(children, function f_PCT_3(pair) {
        if (arguments.length !== 1)
          throw new Error("argument sizes do not match");
        let k = first2(pair);
        let child = last(pair);
        return _$L_(k, purify_element(child));
      });
    });
  } else if (true) {
    console.warn("Unknown markup during purify:", markup);
    return null;
  } else {
    return null;
  }
}
function text__GT_html(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (some_$q_(x)) {
    return invoke_method("replace")(invoke_method("replace")(_$n_str_$o_concat(x, ""), ">", "&gt;"), "<", "&lt;");
  } else {
    return null;
  }
}
var dashed_letter_pattern = new RegExp("-[a-z]", "g");
var pattern_non_dimension_props = new RegExp("acit|ex(?:s|g|n|p|$)|rph|grid|ows|mnc|ntw|ine[ch]|zoo|^ord|itera", "i");

// server-out/respo.render.html.js
function escape_html(text) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (nil_$q_(text)) {
    return "";
  } else {
    return invoke_method("replace")(invoke_method("replace")(invoke_method("replace")(invoke_method("replace")(text, '"', "&quot;"), "<", "&lt;"), ">", "&gt;"), "\n", "&#13;&#10;");
  }
}
function style__GT_string(styles) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return join_str(map(styles, function f_PCT_2(entry) {
    if (arguments.length !== 1)
      throw new Error("argument sizes do not match");
    let k = first2(entry);
    let style_name = turn_string(k);
    let v = get_style_value(last(entry), dashed__GT_camel(style_name));
    return _$n_str_$o_concat(style_name, _$n_str_$o_concat(":", _$n_str_$o_concat(escape_html(v), _$n_str_$o_concat(";", ""))));
  }), "");
}
function entry__GT_string(entry) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  let k = first2(entry);
  let v = last(entry);
  return _$n_str_$o_concat(prop__GT_attr(turn_string(k)), _$n_str_$o_concat("=", _$n_str_$o_concat(invoke_method("escape")(function __fn__() {
    if (_$e_(k, kwd("style"))) {
      return style__GT_string(v);
    } else if (bool_$q_(v)) {
      return _$n_str_$o_concat(v, "");
    } else if (number_$q_(v)) {
      return _$n_str_$o_concat(v, "");
    } else if (keyword_$q_(v)) {
      return turn_string(v);
    } else if (string_$q_(v)) {
      return escape_html(v);
    } else if (true) {
      return _$n_str_$o_concat(v, "");
    } else {
      return null;
    }
  }()), "")));
}
function props__GT_string(props) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return join_str(map(filter(invoke_method("to-list")(props), function f_PCT_2(pair) {
    if (arguments.length !== 1)
      throw new Error("argument sizes do not match");
    let k = first2(pair);
    let v = last(pair);
    if (some_$q_(v)) {
      if (not(starts_with_$q_(turn_string(k), "on-"))) {
        return not(starts_with_$q_(turn_string(k), "on-"));
      } else {
        return false;
      }
    } else {
      return false;
    }
  }), entry__GT_string), " ");
}
function element__GT_string(element) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  let tag_name = turn_string(get(element, kwd("name")));
  let attrs = pairs_map(get(element, kwd("attrs")));
  let styles = function __fn__() {
    let v1__63 = get(element, kwd("style"));
    if (nil_$q_(v1__63)) {
      return _$n__$M_();
    } else if (_$e_(false, v1__63)) {
      return _$n__$M_();
    } else {
      return v1__63;
    }
  }();
  let text_inside = _$e_(get(element, kwd("name")), kwd("textarea")) ? escape_html(get(attrs, kwd("value"))) : function __fn__() {
    let v1__64 = get(attrs, kwd("innerHTML"));
    if (nil_$q_(v1__64)) {
      return text__GT_html(get(attrs, kwd("inner-text")));
    } else if (_$e_(false, v1__64)) {
      return text__GT_html(get(attrs, kwd("inner-text")));
    } else {
      return v1__64;
    }
  }();
  let tailored_props = function f_PCT_2(props) {
    if (arguments.length !== 1)
      throw new Error("argument sizes do not match");
    if (empty_$q_(styles)) {
      return props;
    } else {
      return assoc(props, kwd("style"), styles);
    }
  }(dissoc(dissoc(attrs, kwd("innerHTML")), kwd("inner-text")));
  let props_in_string = props__GT_string(tailored_props);
  if (_$n_set_$o_includes_$q_(self_closing, tag_name)) {
    return _$n_str_$o_concat("<", _$n_str_$o_concat(tag_name, _$n_str_$o_concat(_GT_(count(props_in_string), 0) ? " " : "", _$n_str_$o_concat(props_in_string, _$n_str_$o_concat(" >", "")))));
  } else {
    let children = map(get(element, kwd("children")), function f_PCT_2(entry) {
      if (arguments.length !== 1)
        throw new Error("argument sizes do not match");
      let child = last(entry);
      return element__GT_string(child);
    });
    return _$n_str_$o_concat("<", _$n_str_$o_concat(tag_name, _$n_str_$o_concat(_GT_(count(props_in_string), 0) ? " " : "", _$n_str_$o_concat(props_in_string, _$n_str_$o_concat(">", _$n_str_$o_concat(function __fn__() {
      let v1__66 = text_inside;
      if (nil_$q_(v1__66)) {
        return join_str(children, "");
      } else if (_$e_(false, v1__66)) {
        return join_str(children, "");
      } else {
        return v1__66;
      }
    }(), _$n_str_$o_concat("</", _$n_str_$o_concat(tag_name, _$n_str_$o_concat(">", "")))))))));
  }
}
function make_string(element) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return element__GT_string(purify_element(mute_element(element)));
}
var self_closing = _SHA__$M_("area", "base", "br", "col", "embed", "hr", "img", "input", "link", "meta", "param", "source", "track", "wbr");

// server-out/app.server.js
var $path = __toModule(require("path"));
var import_prettysize = __toModule(require_prettysize());
var $qrcode = __toModule(require_main());
var import_serve_static = __toModule(require_serve_static());

// server-out/lilac.util.js
function check_keys(message, data, xs) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let real_keys = keys(data);
  return apply(function f_PCT_2(xs2) {
    if (arguments.length !== 1)
      throw new Error("argument sizes do not match");
    let ret_AUTO_2 = null;
    let times_AUTO_3 = 0;
    while (true) {
      if (times_AUTO_3 > 1e5)
        throw new Error("tail recursion not stopping");
      if (not(empty_$q_(xs2))) {
        let k = first2(xs2);
        not(any_$q_(xs2, function f_PCT_3(x) {
          if (arguments.length !== 1)
            throw new Error("argument sizes do not match");
          return _$e_(k, x);
        })) ? function __fn__() {
          console.log(printable("Lilac warning:", message, "unexpected key", pr_str(k), ", expect", pr_str(xs2)));
        }() : null;
        ret_AUTO_2 = recur(rest2(xs2));
      } else {
        ret_AUTO_2 = null;
      }
      if (ret_AUTO_2 instanceof CalcitRecur) {
        if (ret_AUTO_2.args.length !== 1)
          throw new Error("argument sizes do not match");
        [xs2] = ret_AUTO_2.args;
        times_AUTO_3 += 1;
        continue;
      } else {
        return ret_AUTO_2;
      }
    }
  }, _$L_(real_keys));
}
function preview_data(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (string_$q_(x)) {
    return pr_str(x);
  } else if (bool_$q_(x)) {
    return _$n_str_$o_concat(x, "");
  } else if (number_$q_(x)) {
    return _$n_str_$o_concat(x, "");
  } else if (keyword_$q_(x)) {
    return _$n_str_$o_concat(x, "");
  } else if (symbol_$q_(x)) {
    return _$n_str_$o_concat("'", _$n_str_$o_concat(x, ""));
  } else if (map_$q_(x)) {
    return "a map";
  } else if (set_$q_(x)) {
    return "a set";
  } else if (list_$q_(x)) {
    return "a list";
  } else if (nil_$q_(x)) {
    return "nil";
  } else if (true) {
    return _$n_str_$o_concat("Unknown: ", _$n_str_$o_concat(_$n_str_$o_slice(_$n_str_$o_concat(x, ""), 0, 10), ""));
  } else {
    return null;
  }
}
function seq_difference(xs, ys) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return filter_not(xs, function f_PCT_2(x) {
    if (arguments.length !== 1)
      throw new Error("argument sizes do not match");
    return any_$q_(ys, function f_PCT_3(y) {
      if (arguments.length !== 1)
        throw new Error("argument sizes do not match");
      return _$e_(x, y);
    });
  });
}
function seq_equal(xs, ys) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (every_$q_(xs, function f_PCT_2(x) {
    if (arguments.length !== 1)
      throw new Error("argument sizes do not match");
    return any_$q_(ys, function f_PCT_3(y) {
      if (arguments.length !== 1)
        throw new Error("argument sizes do not match");
      return _$e_(x, y);
    });
  })) {
    if (every_$q_(ys, function f_PCT_2(y) {
      if (arguments.length !== 1)
        throw new Error("argument sizes do not match");
      return any_$q_(xs, function f_PCT_3(x) {
        if (arguments.length !== 1)
          throw new Error("argument sizes do not match");
        return _$e_(x, y);
      });
    })) {
      return every_$q_(ys, function f_PCT_2(y) {
        if (arguments.length !== 1)
          throw new Error("argument sizes do not match");
        return any_$q_(xs, function f_PCT_3(x) {
          if (arguments.length !== 1)
            throw new Error("argument sizes do not match");
          return _$e_(x, y);
        });
      });
    } else {
      return false;
    }
  } else {
    return false;
  }
}

// server-out/lilac.core.js
function any_ADD_(arg) {
  if (arguments.length < 0)
    throw new Error("too few arguments");
  if (arguments.length > 1)
    throw new Error("too many arguments");
  let options = function __fn__() {
    let v1__59 = arg;
    if (nil_$q_(v1__59)) {
      return _$n__$M_();
    } else if (_$e_(false, v1__59)) {
      return _$n__$M_();
    } else {
      return v1__59;
    }
  }();
  check_keys("checking any+", options, _$L_(kwd("some?")));
  return _$n__$M_(kwd("lilac-type"), kwd("any"), kwd("options"), options, kwd("some?"), get(options, kwd("some?")));
}
function boolean_ADD_(arg) {
  if (arguments.length < 0)
    throw new Error("too few arguments");
  if (arguments.length > 1)
    throw new Error("too many arguments");
  return _$n__$M_(kwd("lilac-type"), kwd("boolean"));
}
var format_message = function format_message2(acc, result) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  let ret_AUTO_2 = null;
  let times_AUTO_3 = 0;
  while (true) {
    if (times_AUTO_3 > 1e5)
      throw new Error("tail recursion not stopping");
    if (nil_$q_(result)) {
      ret_AUTO_2 = acc;
    } else {
      let message = _$n_str_$o_concat(get(result, kwd("message")), _$n_str_$o_concat(" at ", _$n_str_$o_concat(filter_not(get(result, kwd("coord")), symbol_$q_), "")));
      ret_AUTO_2 = recur(_$n_str_$o_concat(acc, _$n_str_$o_concat(some_$q_(acc) ? "\n" : "", _$n_str_$o_concat(message, ""))), get(result, kwd("next")));
    }
    if (ret_AUTO_2 instanceof CalcitRecur) {
      if (ret_AUTO_2.args.length !== 2)
        throw new Error("argument sizes do not match");
      [acc, result] = ret_AUTO_2.args;
      times_AUTO_3 += 1;
      continue;
    } else {
      return ret_AUTO_2;
    }
  }
};
function validate_any(data, rule, base_coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let coord = append2(base_coord, new CalcitSymbol("number"));
  let something_$q_ = function __fn__() {
    let v1__44 = get(rule, kwd("some?"));
    if (nil_$q_(v1__44)) {
      return false;
    } else if (_$e_(false, v1__44)) {
      return false;
    } else {
      return v1__44;
    }
  }();
  if (something_$q_) {
    if (some_$q_(data)) {
      return ok_result;
    } else {
      return _$n__$M_(kwd("ok?"), false, kwd("data"), data, kwd("rule"), rule, kwd("coord"), coord, kwd("message"), function __fn__() {
        let v1__45 = get_in(rule, _$L_(kwd("options"), kwd("message")));
        if (nil_$q_(v1__45)) {
          return _$n_str_$o_concat("expects something, got ", _$n_str_$o_concat(preview_data(data), ""));
        } else if (_$e_(false, v1__45)) {
          return _$n_str_$o_concat("expects something, got ", _$n_str_$o_concat(preview_data(data), ""));
        } else {
          return v1__45;
        }
      }());
    }
  } else {
    return ok_result;
  }
}
function validate_boolean(data, rule, coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  if (bool_$q_(data)) {
    return ok_result;
  } else {
    return _$n__$M_(kwd("ok?"), false, kwd("data"), data, kwd("rule"), rule, kwd("coord"), append2(coord, new CalcitSymbol("boolean")), kwd("message"), function __fn__() {
      let v1__13 = get_in(rule, _$L_(kwd("options"), kwd("message")));
      if (nil_$q_(v1__13)) {
        return _$n_str_$o_concat("expects a boolean, got ", _$n_str_$o_concat(preview_data(data), ""));
      } else if (_$e_(false, v1__13)) {
        return _$n_str_$o_concat("expects a boolean, got ", _$n_str_$o_concat(preview_data(data), ""));
      } else {
        return v1__13;
      }
    }());
  }
}
function validate_custom(data, rule, coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let method = get(rule, kwd("fn"));
  let next_coord = append2(coord, new CalcitSymbol("custom"));
  let result = method(data, rule, coord);
  if (get(result, kwd("ok?"))) {
    return result;
  } else {
    return _$n__$M_(kwd("ok?"), false, kwd("data"), data, kwd("rule"), rule, kwd("coord"), next_coord, kwd("message"), function __fn__() {
      let v1__38 = function __fn__2() {
        let v1__39 = get(result, kwd("message"));
        if (nil_$q_(v1__39)) {
          return get_in(rule, _$L_(kwd("options"), kwd("message")));
        } else if (_$e_(false, v1__39)) {
          return get_in(rule, _$L_(kwd("options"), kwd("message")));
        } else {
          return v1__39;
        }
      }();
      if (nil_$q_(v1__38)) {
        return "failed to validate with custom method";
      } else if (_$e_(false, v1__38)) {
        return "failed to validate with custom method";
      } else {
        return v1__38;
      }
    }());
  }
}
function validate_enum(data, rule, base_coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let coord = append2(base_coord, new CalcitSymbol("enum"));
  let items = get(rule, kwd("items"));
  if (includes_$q_(items, data)) {
    return ok_result;
  } else {
    return _$n__$M_(kwd("ok?"), false, kwd("data"), data, kwd("rule"), rule, kwd("coord"), coord, kwd("message"), function __fn__() {
      let v1__46 = get_in(rule, _$L_(kwd("options"), kwd("message")));
      if (nil_$q_(v1__46)) {
        return _$n_str_$o_concat("expects value of ", _$n_str_$o_concat(pr_str(items), _$n_str_$o_concat(", got ", _$n_str_$o_concat(preview_data(data), ""))));
      } else if (_$e_(false, v1__46)) {
        return _$n_str_$o_concat("expects value of ", _$n_str_$o_concat(pr_str(items), _$n_str_$o_concat(", got ", _$n_str_$o_concat(preview_data(data), ""))));
      } else {
        return v1__46;
      }
    }());
  }
}
function validate_fn(data, rule, coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let next_coord = append2(coord, new CalcitSymbol("fn"));
  if (fn_$q_(data)) {
    return ok_result;
  } else {
    return _$n__$M_(kwd("ok?"), false, kwd("data"), data, kwd("rule"), rule, kwd("coord"), next_coord, kwd("message"), function __fn__() {
      let v1__19 = get_in(rule, _$L_(kwd("options"), kwd("message")));
      if (nil_$q_(v1__19)) {
        return _$n_str_$o_concat("expects a function, got ", _$n_str_$o_concat(preview_data(data), ""));
      } else if (_$e_(false, v1__19)) {
        return _$n_str_$o_concat("expects a function, got ", _$n_str_$o_concat(preview_data(data), ""));
      } else {
        return v1__19;
      }
    }());
  }
}
function validate_is(data, rule, base_coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let coord = append2(base_coord, new CalcitSymbol("is"));
  if (_$e_(data, get(rule, kwd("item")))) {
    return ok_result;
  } else {
    return _$n__$M_(kwd("ok?"), false, kwd("data"), data, kwd("rule"), rule, kwd("coord"), coord, kwd("message"), function __fn__() {
      let v1__40 = get_in(rule, _$L_(kwd("options"), kwd("message")));
      if (nil_$q_(v1__40)) {
        return _$n_str_$o_concat("expects just ", _$n_str_$o_concat(preview_data(get(rule, kwd("item"))), _$n_str_$o_concat(", got ", _$n_str_$o_concat(preview_data(data), ""))));
      } else if (_$e_(false, v1__40)) {
        return _$n_str_$o_concat("expects just ", _$n_str_$o_concat(preview_data(get(rule, kwd("item"))), _$n_str_$o_concat(", got ", _$n_str_$o_concat(preview_data(data), ""))));
      } else {
        return v1__40;
      }
    }());
  }
}
function validate_keyword(data, rule, coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let next_coord = append2(coord, new CalcitSymbol("keyword"));
  if (keyword_$q_(data)) {
    return ok_result;
  } else {
    return _$n__$M_(kwd("ok?"), false, kwd("data"), data, kwd("rule"), rule, kwd("coord"), next_coord, kwd("message"), function __fn__() {
      let v1__20 = get_in(rule, _$L_(kwd("options"), kwd("message")));
      if (nil_$q_(v1__20)) {
        return _$n_str_$o_concat("expects a keyword, got ", _$n_str_$o_concat(preview_data(data), ""));
      } else if (_$e_(false, v1__20)) {
        return _$n_str_$o_concat("expects a keyword, got ", _$n_str_$o_concat(preview_data(data), ""));
      } else {
        return v1__20;
      }
    }());
  }
}
function validate_nil(data, rule, coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let next_coord = append2(coord, new CalcitSymbol("nil"));
  if (nil_$q_(data)) {
    return ok_result;
  } else {
    return _$n__$M_(kwd("ok?"), false, kwd("data"), data, kwd("rule"), rule, kwd("coord"), next_coord, kwd("message"), function __fn__() {
      let v1__18 = get_in(rule, _$L_(kwd("options"), kwd("message")));
      if (nil_$q_(v1__18)) {
        return _$n_str_$o_concat("expects a nil, got ", _$n_str_$o_concat(preview_data(data), ""));
      } else if (_$e_(false, v1__18)) {
        return _$n_str_$o_concat("expects a nil, got ", _$n_str_$o_concat(preview_data(data), ""));
      } else {
        return v1__18;
      }
    }());
  }
}
function validate_number(data, rule, base_coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let coord = append2(base_coord, new CalcitSymbol("number"));
  let min_v = get(rule, kwd("min"));
  let max_v = get(rule, kwd("max"));
  if (number_$q_(data)) {
    if ((some_$q_(min_v) ? _GT__$e_(data, min_v) : true) ? (some_$q_(max_v) ? _LT__$e_(data, max_v) : true) ? some_$q_(max_v) ? _LT__$e_(data, max_v) : true : false : false) {
      return ok_result;
    } else {
      return _$n__$M_(kwd("ok?"), false, kwd("data"), data, kwd("rule"), rule, kwd("coord"), coord, kwd("message"), function __fn__() {
        let v1__22 = get_in(rule, _$L_(kwd("options"), kwd("message")));
        if (nil_$q_(v1__22)) {
          return _$n_str_$o_concat("expects number not in the range, got ", _$n_str_$o_concat(preview_data(data), ""));
        } else if (_$e_(false, v1__22)) {
          return _$n_str_$o_concat("expects number not in the range, got ", _$n_str_$o_concat(preview_data(data), ""));
        } else {
          return v1__22;
        }
      }());
    }
  } else {
    return _$n__$M_(kwd("ok?"), false, kwd("data"), data, kwd("rule"), rule, kwd("coord"), coord, kwd("message"), function __fn__() {
      let v1__23 = get_in(rule, _$L_(kwd("options"), kwd("message")));
      if (nil_$q_(v1__23)) {
        return _$n_str_$o_concat("expects a number, got ", _$n_str_$o_concat(preview_data(data), ""));
      } else if (_$e_(false, v1__23)) {
        return _$n_str_$o_concat("expects a number, got ", _$n_str_$o_concat(preview_data(data), ""));
      } else {
        return v1__23;
      }
    }());
  }
}
function validate_string(data, rule, base_coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let coord = append2(base_coord, new CalcitSymbol("string"));
  let re = get(rule, kwd("re"));
  let nonblank_$q_ = function __fn__() {
    let v1__14 = get(rule, kwd("nonblank?"));
    if (nil_$q_(v1__14)) {
      return false;
    } else if (_$e_(false, v1__14)) {
      return false;
    } else {
      return v1__14;
    }
  }();
  if (string_$q_(data)) {
    if (some_$q_(re)) {
      if (re_matches(data, re)) {
        return ok_result;
      } else {
        return _$n__$M_(kwd("ok?"), false, kwd("data"), data, kwd("rule"), rule, kwd("coord"), coord, kwd("message"), function __fn__() {
          let v1__15 = get_in(rule, _$L_(kwd("options"), kwd("message")));
          if (nil_$q_(v1__15)) {
            return _$n_str_$o_concat("expects a string in ", _$n_str_$o_concat(re, _$n_str_$o_concat(", got ", _$n_str_$o_concat(preview_data(data), ""))));
          } else if (_$e_(false, v1__15)) {
            return _$n_str_$o_concat("expects a string in ", _$n_str_$o_concat(re, _$n_str_$o_concat(", got ", _$n_str_$o_concat(preview_data(data), ""))));
          } else {
            return v1__15;
          }
        }());
      }
    } else if (some_$q_(nonblank_$q_)) {
      if (nonblank_$q_ ? _$e_("", trim(data)) ? _$e_("", trim(data)) : false : false) {
        return _$n__$M_(kwd("ok?"), false, kwd("data"), data, kwd("rule"), rule, kwd("coord"), coord, kwd("message"), function __fn__() {
          let v1__16 = get_in(rule, _$L_(kwd("options"), kwd("message")));
          if (nil_$q_(v1__16)) {
            return _$n_str_$o_concat("expects nonblank string , got ", _$n_str_$o_concat(preview_data(data), ""));
          } else if (_$e_(false, v1__16)) {
            return _$n_str_$o_concat("expects nonblank string , got ", _$n_str_$o_concat(preview_data(data), ""));
          } else {
            return v1__16;
          }
        }());
      } else {
        return ok_result;
      }
    } else if (true) {
      return ok_result;
    } else {
      return null;
    }
  } else {
    return _$n__$M_(kwd("ok?"), false, kwd("data"), data, kwd("rule"), rule, kwd("coord"), coord, kwd("message"), function __fn__() {
      let v1__17 = get_in(rule, _$L_(kwd("options"), kwd("message")));
      if (nil_$q_(v1__17)) {
        return _$n_str_$o_concat("expected a string, but got ", _$n_str_$o_concat(preview_data(data), ""));
      } else if (_$e_(false, v1__17)) {
        return _$n_str_$o_concat("expected a string, but got ", _$n_str_$o_concat(preview_data(data), ""));
      } else {
        return v1__17;
      }
    }());
  }
}
function validate_symbol(data, rule, base_coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let coord = append2(base_coord, new CalcitSymbol("symbol"));
  if (symbol_$q_(data)) {
    return ok_result;
  } else {
    return _$n__$M_(kwd("ok?"), false, kwd("data"), data, kwd("rule"), rule, kwd("coord"), coord, kwd("message"), function __fn__() {
      let v1__21 = get_in(rule, _$L_(kwd("options"), kwd("message")));
      if (nil_$q_(v1__21)) {
        return _$n_str_$o_concat("expects a symbol, got ", _$n_str_$o_concat(preview_data(data), ""));
      } else if (_$e_(false, v1__21)) {
        return _$n_str_$o_concat("expects a symbol, got ", _$n_str_$o_concat(preview_data(data), ""));
      } else {
        return v1__21;
      }
    }());
  }
}
function validate_tuple(data, rule, coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let items = get(rule, kwd("items"));
  let next_coord = append2(coord, new CalcitSymbol("tuple"));
  let check_size_$q_ = function __fn__() {
    let v1__41 = get(rule, kwd("check-size?"));
    if (nil_$q_(v1__41)) {
      return false;
    } else if (_$e_(false, v1__41)) {
      return false;
    } else {
      return v1__41;
    }
  }();
  let check_values = function f_PCT_2() {
    if (arguments.length !== 0)
      throw new Error("argument sizes do not match");
    return apply(function generated_loop(xs, ys, idx) {
      if (arguments.length !== 3)
        throw new Error("argument sizes do not match");
      let ret_AUTO_5 = null;
      let times_AUTO_6 = 0;
      while (true) {
        if (times_AUTO_6 > 1e5)
          throw new Error("tail recursion not stopping");
        if (empty_$q_(xs)) {
          if (check_size_$q_) {
            if (empty_$q_(ys) ? _$e_(count(items), count(data)) ? _$e_(count(items), count(data)) : false : false) {
              ret_AUTO_5 = _$n__$M_(kwd("ok?"), true);
            } else {
              ret_AUTO_5 = _$n__$M_(kwd("ok?"), false, kwd("coord"), next_coord, kwd("rule"), rule, kwd("data"), ys, kwd("message"), function __fn__() {
                let v1__42 = get_in(rule, _$L_(kwd("options"), kwd("message")));
                if (nil_$q_(v1__42)) {
                  return _$n_str_$o_concat("expects tuple of ", _$n_str_$o_concat(count(items), _$n_str_$o_concat(" items, got ", _$n_str_$o_concat(count(data), ""))));
                } else if (_$e_(false, v1__42)) {
                  return _$n_str_$o_concat("expects tuple of ", _$n_str_$o_concat(count(items), _$n_str_$o_concat(" items, got ", _$n_str_$o_concat(count(data), ""))));
                } else {
                  return v1__42;
                }
              }());
            }
          } else {
            ret_AUTO_5 = ok_result;
          }
        } else {
          let r0 = first2(xs);
          let y0 = first2(ys);
          let child_coord = append2(next_coord, idx);
          let result = validate_lilac(y0, r0, child_coord);
          if (get(result, kwd("ok?"))) {
            ret_AUTO_5 = recur(rest2(xs), rest2(ys), inc(idx));
          } else {
            ret_AUTO_5 = _$n__$M_(kwd("ok?"), false, kwd("coord"), next_coord, kwd("rule"), rule, kwd("data"), y0, kwd("message"), function __fn__() {
              let v1__43 = get_in(rule, _$L_(kwd("options"), kwd("message")));
              if (nil_$q_(v1__43)) {
                return 'failed validating in "tuple"';
              } else if (_$e_(false, v1__43)) {
                return 'failed validating in "tuple"';
              } else {
                return v1__43;
              }
            }(), kwd("next"), result);
          }
        }
        if (ret_AUTO_5 instanceof CalcitRecur) {
          if (ret_AUTO_5.args.length !== 3)
            throw new Error("argument sizes do not match");
          [xs, ys, idx] = ret_AUTO_5.args;
          times_AUTO_6 += 1;
          continue;
        } else {
          return ret_AUTO_5;
        }
      }
    }, _$L_(items, data, 0));
  };
  if (list_$q_(data)) {
    return check_values();
  } else {
    return _$n__$M_(kwd("ok?"), false, kwd("data"), data, kwd("rule"), rule, kwd("coord"), coord, kwd("message"), _$n_str_$o_concat("expects a vector for tuple, got ", _$n_str_$o_concat(preview_data(data), "")));
  }
}
function validate_set(data, rule, base_coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let item_rule = get(rule, kwd("item"));
  let coord = append2(base_coord, new CalcitSymbol("set"));
  if (set_$q_(data)) {
    return apply(function generated_loop(xs, idx) {
      if (arguments.length !== 2)
        throw new Error("argument sizes do not match");
      let ret_AUTO_8 = null;
      let times_AUTO_9 = 0;
      while (true) {
        if (times_AUTO_9 > 1e5)
          throw new Error("tail recursion not stopping");
        if (empty_$q_(xs)) {
          ret_AUTO_8 = ok_result;
        } else {
          let x0 = first2(xs);
          let child_coord = append2(coord, idx);
          let result = validate_lilac(x0, item_rule, child_coord);
          if (get(result, kwd("ok?"))) {
            ret_AUTO_8 = recur(rest2(xs), inc(idx));
          } else {
            ret_AUTO_8 = result;
          }
        }
        if (ret_AUTO_8 instanceof CalcitRecur) {
          if (ret_AUTO_8.args.length !== 2)
            throw new Error("argument sizes do not match");
          [xs, idx] = ret_AUTO_8.args;
          times_AUTO_9 += 1;
          continue;
        } else {
          return ret_AUTO_8;
        }
      }
    }, _$L_(data, 0));
  } else {
    return _$n__$M_(kwd("ok?"), false, kwd("data"), data, kwd("rule"), rule, kwd("coord"), coord, kwd("message"), function __fn__() {
      let v1__34 = get_in(rule, _$L_(kwd("options"), kwd("message")));
      if (nil_$q_(v1__34)) {
        return _$n_str_$o_concat("expects a set, got ", _$n_str_$o_concat(preview_data(data), ""));
      } else if (_$e_(false, v1__34)) {
        return _$n_str_$o_concat("expects a set, got ", _$n_str_$o_concat(preview_data(data), ""));
      } else {
        return v1__34;
      }
    }());
  }
}
function validate_record(data, rule, base_coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let coord = append2(base_coord, new CalcitSymbol("record"));
  let pairs = get(rule, kwd("pairs"));
  let exact_keys_$q_ = function __fn__() {
    let v1__24 = get(rule, kwd("exact-keys?"));
    if (nil_$q_(v1__24)) {
      return false;
    } else if (_$e_(false, v1__24)) {
      return false;
    } else {
      return v1__24;
    }
  }();
  let check_keys_$q_ = function __fn__() {
    let v1__25 = get(rule, kwd("check-keys?"));
    if (nil_$q_(v1__25)) {
      return false;
    } else if (_$e_(false, v1__25)) {
      return false;
    } else {
      return v1__25;
    }
  }();
  let all_optional_$q_ = function __fn__() {
    let v1__26 = get(rule, kwd("all-optional?"));
    if (nil_$q_(v1__26)) {
      return false;
    } else if (_$e_(false, v1__26)) {
      return false;
    } else {
      return v1__26;
    }
  }();
  let default_message = get_in(rule, _$L_(kwd("options"), kwd("message")));
  let wanted_keys = keys(pairs);
  let existed_keys = function __fn__() {
    let v1__27 = map_$q_(data);
    if (nil_$q_(v1__27)) {
      return record_$q_(data);
    } else if (_$e_(false, v1__27)) {
      return record_$q_(data);
    } else {
      return v1__27;
    }
  }() ? keys(data) : null;
  let check_values = function f_PCT_2() {
    if (arguments.length !== 0)
      throw new Error("argument sizes do not match");
    return apply(function generated_loop(xs) {
      if (arguments.length !== 1)
        throw new Error("argument sizes do not match");
      let ret_AUTO_11 = null;
      let times_AUTO_12 = 0;
      while (true) {
        if (times_AUTO_12 > 1e5)
          throw new Error("tail recursion not stopping");
        if (empty_$q_(xs)) {
          ret_AUTO_11 = ok_result;
        } else {
          let x0 = first2(xs);
          let k0 = first2(x0);
          let r0 = last(x0);
          let child_coord = append2(coord, k0);
          let v = get(data, k0);
          if (all_optional_$q_ ? nil_$q_(v) ? nil_$q_(v) : false : false) {
            ret_AUTO_11 = recur(rest2(xs));
          } else {
            let result = validate_lilac(v, r0, child_coord);
            if (get(result, kwd("ok?"))) {
              ret_AUTO_11 = recur(rest2(xs));
            } else {
              ret_AUTO_11 = result;
            }
          }
        }
        if (ret_AUTO_11 instanceof CalcitRecur) {
          if (ret_AUTO_11.args.length !== 1)
            throw new Error("argument sizes do not match");
          [xs] = ret_AUTO_11.args;
          times_AUTO_12 += 1;
          continue;
        } else {
          return ret_AUTO_11;
        }
      }
    }, _$L_(to_pairs(pairs)));
  };
  if (not(function __fn__() {
    let v1__28 = map_$q_(data);
    if (nil_$q_(v1__28)) {
      if (record_$q_(data)) {
        if (some_$q_(get(rule, kwd("proto"))) ? invoke_method("matches?")(get(rule, kwd("proto")), data) : true) {
          if (some_$q_(get(rule, kwd("proto")))) {
            return invoke_method("matches?")(get(rule, kwd("proto")), data);
          } else {
            return true;
          }
        } else {
          return false;
        }
      } else {
        return false;
      }
    } else if (_$e_(false, v1__28)) {
      if (record_$q_(data)) {
        if (some_$q_(get(rule, kwd("proto"))) ? invoke_method("matches?")(get(rule, kwd("proto")), data) : true) {
          if (some_$q_(get(rule, kwd("proto")))) {
            return invoke_method("matches?")(get(rule, kwd("proto")), data);
          } else {
            return true;
          }
        } else {
          return false;
        }
      } else {
        return false;
      }
    } else {
      return v1__28;
    }
  }())) {
    return _$n__$M_(kwd("ok?"), false, kwd("data"), data, kwd("rule"), rule, kwd("coord"), coord, kwd("message"), function __fn__() {
      let v1__29 = get_in(rule, _$L_(kwd("options"), kwd("message")));
      if (nil_$q_(v1__29)) {
        return _$n_str_$o_concat("expects a record, got ", _$n_str_$o_concat(preview_data(data), ""));
      } else if (_$e_(false, v1__29)) {
        return _$n_str_$o_concat("expects a record, got ", _$n_str_$o_concat(preview_data(data), ""));
      } else {
        return v1__29;
      }
    }());
  } else if (exact_keys_$q_) {
    if (seq_equal(existed_keys, wanted_keys)) {
      return check_values();
    } else {
      return _$n__$M_(kwd("ok?"), false, kwd("data"), data, kwd("rule"), rule, kwd("coord"), coord, kwd("message"), function __fn__() {
        let v1__30 = default_message;
        if (nil_$q_(v1__30)) {
          let extra_keys = seq_difference(existed_keys, wanted_keys);
          let missing_keys = seq_difference(wanted_keys, existed_keys);
          if (not(empty_$q_(extra_keys))) {
            return _$n_str_$o_concat("unexpected record keys ", _$n_str_$o_concat(extra_keys, _$n_str_$o_concat(" for ", _$n_str_$o_concat(wanted_keys, ""))));
          } else {
            return _$n_str_$o_concat("missing record keys ", _$n_str_$o_concat(missing_keys, _$n_str_$o_concat(" of ", _$n_str_$o_concat(wanted_keys, ""))));
          }
        } else if (_$e_(false, v1__30)) {
          let extra_keys = seq_difference(existed_keys, wanted_keys);
          let missing_keys = seq_difference(wanted_keys, existed_keys);
          if (not(empty_$q_(extra_keys))) {
            return _$n_str_$o_concat("unexpected record keys ", _$n_str_$o_concat(extra_keys, _$n_str_$o_concat(" for ", _$n_str_$o_concat(wanted_keys, ""))));
          } else {
            return _$n_str_$o_concat("missing record keys ", _$n_str_$o_concat(missing_keys, _$n_str_$o_concat(" of ", _$n_str_$o_concat(wanted_keys, ""))));
          }
        } else {
          return v1__30;
        }
      }());
    }
  } else if (check_keys_$q_) {
    let extra_keys = seq_difference(existed_keys, wanted_keys);
    if (empty_$q_(extra_keys)) {
      return check_values();
    } else {
      return _$n__$M_(kwd("ok?"), false, kwd("data"), data, kwd("rule"), rule, kwd("coord"), coord, kwd("message"), function __fn__() {
        let v1__31 = default_message;
        if (nil_$q_(v1__31)) {
          return _$n_str_$o_concat("unexpected record keys ", _$n_str_$o_concat(extra_keys, _$n_str_$o_concat(" for ", _$n_str_$o_concat(wanted_keys, ""))));
        } else if (_$e_(false, v1__31)) {
          return _$n_str_$o_concat("unexpected record keys ", _$n_str_$o_concat(extra_keys, _$n_str_$o_concat(" for ", _$n_str_$o_concat(wanted_keys, ""))));
        } else {
          return v1__31;
        }
      }());
    }
  } else if (true) {
    return check_values();
  } else {
    return null;
  }
}
function validate_pick_type(data, rule, coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let dict = get(rule, kwd("dict"));
  let next_coord = append2(coord, new CalcitSymbol("pick-type"));
  let type_field = get(rule, kwd("type-field"));
  let data_type = get(data, type_field);
  if (nil_$q_(get(dict, data_type))) {
    return _$n__$M_(kwd("ok?"), false, kwd("coord"), next_coord, kwd("rule"), rule, kwd("data"), data, kwd("message"), function __fn__() {
      let v1__47 = get_in(rule, _$L_(kwd("options"), kwd("message")));
      if (nil_$q_(v1__47)) {
        return _$n_str_$o_concat("found no matched type in pick-type: ", _$n_str_$o_concat(data_type, ""));
      } else if (_$e_(false, v1__47)) {
        return _$n_str_$o_concat("found no matched type in pick-type: ", _$n_str_$o_concat(data_type, ""));
      } else {
        return v1__47;
      }
    }());
  } else {
    let next_rule = get(dict, data_type);
    let result = validate_lilac(data, next_rule, next_coord);
    if (get(result, kwd("ok?"))) {
      return result;
    } else {
      return _$n__$M_(kwd("ok?"), false, kwd("coord"), next_coord, kwd("rule"), rule, kwd("data"), data, kwd("message"), function __fn__() {
        let v1__48 = get_in(rule, _$L_(kwd("options"), kwd("message")));
        if (nil_$q_(v1__48)) {
          return _$n_str_$o_concat("failed to match in pick-type", "");
        } else if (_$e_(false, v1__48)) {
          return _$n_str_$o_concat("failed to match in pick-type", "");
        } else {
          return v1__48;
        }
      }(), kwd("next"), result);
    }
  }
}
function validate_or(data, rule, coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let items = get(rule, kwd("items"));
  let next_coord = append2(coord, new CalcitSymbol("or"));
  return apply(function generated_loop(xs, branches) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    let ret_AUTO_14 = null;
    let times_AUTO_15 = 0;
    while (true) {
      if (times_AUTO_15 > 1e5)
        throw new Error("tail recursion not stopping");
      if (empty_$q_(xs)) {
        ret_AUTO_14 = _$n__$M_(kwd("ok?"), false, kwd("coord"), next_coord, kwd("rule"), rule, kwd("data"), data, kwd("message"), function __fn__() {
          let v1__36 = get_in(rule, _$L_(kwd("options"), kwd("message")));
          if (nil_$q_(v1__36)) {
            return 'found no matched case in "or"';
          } else if (_$e_(false, v1__36)) {
            return 'found no matched case in "or"';
          } else {
            return v1__36;
          }
        }(), kwd("branches"), branches, kwd("next"), last(branches));
      } else {
        let r0 = first2(xs);
        let result = validate_lilac(data, r0, next_coord);
        if (get(result, kwd("ok?"))) {
          ret_AUTO_14 = result;
        } else {
          ret_AUTO_14 = recur(rest2(xs), append2(branches, result));
        }
      }
      if (ret_AUTO_14 instanceof CalcitRecur) {
        if (ret_AUTO_14.args.length !== 2)
          throw new Error("argument sizes do not match");
        [xs, branches] = ret_AUTO_14.args;
        times_AUTO_15 += 1;
        continue;
      } else {
        return ret_AUTO_14;
      }
    }
  }, _$L_(items, _$L_()));
}
function validate_optional(data, rule, base_coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let item = get(rule, kwd("item"));
  let coord = append2(base_coord, new CalcitSymbol("optional"));
  if (nil_$q_(data)) {
    return ok_result;
  } else {
    return validate_lilac(data, item, coord);
  }
}
function validate_not(data, rule, base_coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let coord = append2(base_coord, new CalcitSymbol("not"));
  let item = get(rule, kwd("item"));
  let result = validate_lilac(data, item, coord);
  if (get(result, kwd("ok?"))) {
    return _$n__$M_(kwd("ok?"), false, kwd("data"), data, kwd("rule"), rule, kwd("coord"), coord, kwd("message"), function __fn__() {
      let v1__35 = get_in(rule, _$L_(kwd("options"), kwd("message")));
      if (nil_$q_(v1__35)) {
        return 'expects a inverted value in "not"';
      } else if (_$e_(false, v1__35)) {
        return 'expects a inverted value in "not"';
      } else {
        return v1__35;
      }
    }(), kwd("next"), result);
  } else {
    return ok_result;
  }
}
function validate_map(data, rule, base_coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let key_rule = get(rule, kwd("key-shape"));
  let item_rule = get(rule, kwd("item"));
  let coord = append2(base_coord, new CalcitSymbol("map"));
  if (map_$q_(data)) {
    return apply(function generated_loop(xs) {
      if (arguments.length !== 1)
        throw new Error("argument sizes do not match");
      let ret_AUTO_17 = null;
      let times_AUTO_18 = 0;
      while (true) {
        if (times_AUTO_18 > 1e5)
          throw new Error("tail recursion not stopping");
        if (empty_$q_(xs)) {
          ret_AUTO_17 = ok_result;
        } else {
          let x0 = first2(xs);
          let k = first2(x0);
          let v = last(x0);
          let child_coord = append2(coord, k);
          let k_result = validate_lilac(k, key_rule, child_coord);
          let result = validate_lilac(v, item_rule, child_coord);
          if (get(k_result, kwd("ok?"))) {
            if (get(result, kwd("ok?"))) {
              ret_AUTO_17 = recur(rest2(xs));
            } else {
              ret_AUTO_17 = result;
            }
          } else {
            ret_AUTO_17 = k_result;
          }
        }
        if (ret_AUTO_17 instanceof CalcitRecur) {
          if (ret_AUTO_17.args.length !== 1)
            throw new Error("argument sizes do not match");
          [xs] = ret_AUTO_17.args;
          times_AUTO_18 += 1;
          continue;
        } else {
          return ret_AUTO_17;
        }
      }
    }, _$L_(to_pairs(data)));
  } else {
    return _$n__$M_(kwd("ok?"), false, kwd("data"), data, kwd("rule"), rule, kwd("coord"), coord, kwd("message"), function __fn__() {
      let v1__32 = get_in(rule, _$L_(kwd("options"), kwd("message")));
      if (nil_$q_(v1__32)) {
        return _$n_str_$o_concat("expects a map, got ", _$n_str_$o_concat(preview_data(data), ""));
      } else if (_$e_(false, v1__32)) {
        return _$n_str_$o_concat("expects a map, got ", _$n_str_$o_concat(preview_data(data), ""));
      } else {
        return v1__32;
      }
    }());
  }
}
function validate_list(data, rule, base_coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let item_rule = get(rule, kwd("item"));
  let coord = append2(base_coord, new CalcitSymbol("list"));
  if (list_$q_(data)) {
    return apply(function generated_loop(xs, idx) {
      if (arguments.length !== 2)
        throw new Error("argument sizes do not match");
      let ret_AUTO_20 = null;
      let times_AUTO_21 = 0;
      while (true) {
        if (times_AUTO_21 > 1e5)
          throw new Error("tail recursion not stopping");
        if (empty_$q_(xs)) {
          ret_AUTO_20 = ok_result;
        } else {
          let x0 = first2(xs);
          let child_coord = append2(coord, idx);
          let result = validate_lilac(x0, item_rule, child_coord);
          if (get(result, kwd("ok?"))) {
            ret_AUTO_20 = recur(rest2(xs), inc(idx));
          } else {
            ret_AUTO_20 = result;
          }
        }
        if (ret_AUTO_20 instanceof CalcitRecur) {
          if (ret_AUTO_20.args.length !== 2)
            throw new Error("argument sizes do not match");
          [xs, idx] = ret_AUTO_20.args;
          times_AUTO_21 += 1;
          continue;
        } else {
          return ret_AUTO_20;
        }
      }
    }, _$L_(data, 0));
  } else {
    return _$n__$M_(kwd("ok?"), false, kwd("data"), data, kwd("rule"), rule, kwd("coord"), coord, kwd("message"), function __fn__() {
      let v1__33 = get_in(rule, _$L_(kwd("options"), kwd("message")));
      if (nil_$q_(v1__33)) {
        return _$n_str_$o_concat("expects a list, got ", _$n_str_$o_concat(preview_data(data), ""));
      } else if (_$e_(false, v1__33)) {
        return _$n_str_$o_concat("expects a list, got ", _$n_str_$o_concat(preview_data(data), ""));
      } else {
        return v1__33;
      }
    }());
  }
}
function validate_lilac(data, rule, arg) {
  if (arguments.length < 2)
    throw new Error("too few arguments");
  if (arguments.length > 3)
    throw new Error("too many arguments");
  let coord = function __fn__() {
    let v1__12 = arg;
    if (nil_$q_(v1__12)) {
      return _$L_();
    } else if (_$e_(false, v1__12)) {
      return _$L_();
    } else {
      return v1__12;
    }
  }();
  let kind = get(rule, kwd("lilac-type"));
  let method = get(core_methods, kind);
  let user_method = get(deref(_$s_custom_methods), kind);
  let result = function __fn__() {
    if (fn_$q_(method)) {
      return method(data, rule, coord);
    } else if (fn_$q_(user_method)) {
      return user_method(data, rule, coord);
    } else if (true) {
      console.log(printable("Unknown method:", kind, "of", rule));
      return quit_$x_(1);
    } else {
      return null;
    }
  }();
  if (get(result, kwd("ok?"))) {
    return result;
  } else {
    return assoc(result, kwd("formatted-message"), format_message("", result));
  }
}
function validate_component(data, rule, coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let lazy_fn = get(rule, kwd("fn"));
  let next_coord = append2(coord, turn_symbol(get(rule, kwd("name"))));
  let next_rule = apply(lazy_fn, get(rule, kwd("args")));
  return validate_lilac(data, next_rule, next_coord);
}
function validate_and(data, rule, base_coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let items = get(rule, kwd("items"));
  let next_coord = append2(base_coord, new CalcitSymbol("and"));
  return apply(function generated_loop(xs) {
    if (arguments.length !== 1)
      throw new Error("argument sizes do not match");
    let ret_AUTO_23 = null;
    let times_AUTO_24 = 0;
    while (true) {
      if (times_AUTO_24 > 1e5)
        throw new Error("tail recursion not stopping");
      if (empty_$q_(xs)) {
        ret_AUTO_23 = ok_result;
      } else {
        let r0 = first2(xs);
        let result = validate_lilac(data, r0, next_coord);
        if (get(result, kwd("ok?"))) {
          ret_AUTO_23 = recur(rest2(xs));
        } else {
          ret_AUTO_23 = _$n__$M_(kwd("ok?"), false, kwd("coord"), next_coord, kwd("rule"), rule, kwd("data"), data, kwd("message"), function __fn__() {
            let v1__37 = get_in(rule, _$L_(kwd("options"), kwd("message")));
            if (nil_$q_(v1__37)) {
              return 'failed validating in "and"';
            } else if (_$e_(false, v1__37)) {
              return 'failed validating in "and"';
            } else {
              return v1__37;
            }
          }(), kwd("next"), result);
        }
      }
      if (ret_AUTO_23 instanceof CalcitRecur) {
        if (ret_AUTO_23.args.length !== 1)
          throw new Error("argument sizes do not match");
        [xs] = ret_AUTO_23.args;
        times_AUTO_24 += 1;
        continue;
      } else {
        return ret_AUTO_23;
      }
    }
  }, _$L_(items));
}
var dev_check = () => {
};
dev_check.isMacro = true;
function keyword_ADD_(arg) {
  if (arguments.length < 0)
    throw new Error("too few arguments");
  if (arguments.length > 1)
    throw new Error("too many arguments");
  let options = function __fn__() {
    let v1__58 = arg;
    if (nil_$q_(v1__58)) {
      return _$n__$M_();
    } else if (_$e_(false, v1__58)) {
      return _$n__$M_();
    } else {
      return v1__58;
    }
  }();
  return _$n__$M_(kwd("lilac-type"), kwd("keyword"), kwd("options"), options);
}
function map_ADD_(key_shape, item, arg) {
  if (arguments.length < 2)
    throw new Error("too few arguments");
  if (arguments.length > 3)
    throw new Error("too many arguments");
  let options = function __fn__() {
    let v1__56 = arg;
    if (nil_$q_(v1__56)) {
      return _$n__$M_();
    } else if (_$e_(false, v1__56)) {
      return _$n__$M_();
    } else {
      return v1__56;
    }
  }();
  return _$n__$M_(kwd("lilac-type"), kwd("map"), kwd("key-shape"), key_shape, kwd("item"), item, kwd("options"), options);
}
function nil_ADD_() {
  if (arguments.length !== 0)
    throw new Error("argument sizes do not match");
  return _$n__$M_(kwd("lilac-type"), kwd("nil"));
}
function number_ADD_(arg) {
  if (arguments.length < 0)
    throw new Error("too few arguments");
  if (arguments.length > 1)
    throw new Error("too many arguments");
  let options = function __fn__() {
    let v1__53 = arg;
    if (nil_$q_(v1__53)) {
      return _$n__$M_();
    } else if (_$e_(false, v1__53)) {
      return _$n__$M_();
    } else {
      return v1__53;
    }
  }();
  check_keys("checking number+", options, _$L_(kwd("max"), kwd("min")));
  return _$n__$M_(kwd("lilac-type"), kwd("number"), kwd("max"), get(options, kwd("max")), kwd("min"), get(options, kwd("min")), kwd("options"), options);
}
function optional_ADD_(item, arg) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  if (arguments.length > 2)
    throw new Error("too many arguments");
  let options = function __fn__() {
    let v1__54 = arg;
    if (nil_$q_(v1__54)) {
      return _$n__$M_();
    } else if (_$e_(false, v1__54)) {
      return _$n__$M_();
    } else {
      return v1__54;
    }
  }();
  return _$n__$M_(kwd("lilac-type"), kwd("optional"), kwd("item"), item, kwd("options"), options);
}
function or_ADD_(items, arg) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  if (arguments.length > 2)
    throw new Error("too many arguments");
  let options = function __fn__() {
    let v1__57 = arg;
    if (nil_$q_(v1__57)) {
      return _$n__$M_();
    } else if (_$e_(false, v1__57)) {
      return _$n__$M_();
    } else {
      return v1__57;
    }
  }();
  (function __fn__() {
    not(string_$q_("expects items of or+ in vector")) ? function __fn__2() {
      let err_AUTO_25 = new Error("expects 1st argument to be string");
      err_AUTO_25.data = null;
      throw err_AUTO_25;
    }() : null;
    if (list_$q_(items)) {
      return null;
    } else {
      console.log(printable("Failed assertion:", format_to_lisp(new CalcitList([new CalcitSymbol("list?"), new CalcitSymbol("items")]))));
      let err_AUTO_26 = new Error("expects items of or+ in vector (list? items)");
      err_AUTO_26.data = null;
      throw err_AUTO_26;
    }
  })();
  return _$n__$M_(kwd("lilac-type"), kwd("or"), kwd("items"), items, kwd("options"), options);
}
function record_ADD_(pairs, arg) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  if (arguments.length > 2)
    throw new Error("too many arguments");
  let options = function __fn__() {
    let v1__49 = arg;
    if (nil_$q_(v1__49)) {
      return _$n__$M_();
    } else if (_$e_(false, v1__49)) {
      return _$n__$M_();
    } else {
      return v1__49;
    }
  }();
  check_keys("checking record+", options, _$L_(kwd("exact-keys?"), kwd("check-keys?"), kwd("all-optional?"), kwd("proto")));
  return _$n__$M_(kwd("lilac-type"), kwd("record"), kwd("pairs"), pairs, kwd("options"), options, kwd("exact-keys?"), function __fn__() {
    let v1__50 = get(options, kwd("exact-keys?"));
    if (nil_$q_(v1__50)) {
      return false;
    } else if (_$e_(false, v1__50)) {
      return false;
    } else {
      return v1__50;
    }
  }(), kwd("check-keys?"), function __fn__() {
    let v1__51 = get(options, kwd("check-keys?"));
    if (nil_$q_(v1__51)) {
      return false;
    } else if (_$e_(false, v1__51)) {
      return false;
    } else {
      return v1__51;
    }
  }(), kwd("all-optional?"), function __fn__() {
    let v1__52 = get(options, kwd("all-optional?"));
    if (nil_$q_(v1__52)) {
      return false;
    } else if (_$e_(false, v1__52)) {
      return false;
    } else {
      return v1__52;
    }
  }(), kwd("proto"), get(options, kwd("proto")));
}
function string_ADD_(arg) {
  if (arguments.length < 0)
    throw new Error("too few arguments");
  if (arguments.length > 1)
    throw new Error("too many arguments");
  let options = function __fn__() {
    let v1__55 = arg;
    if (nil_$q_(v1__55)) {
      return _$n__$M_();
    } else if (_$e_(false, v1__55)) {
      return _$n__$M_();
    } else {
      return v1__55;
    }
  }();
  check_keys("checking string+", options, _$L_(kwd("nonblank?"), kwd("re")));
  return _$n__$M_(kwd("lilac-type"), kwd("string"), kwd("re"), get(options, kwd("re")), kwd("nonblank?"), get(options, kwd("nonblank?")), kwd("options"), options);
}
var _$s_custom_methods = peekDefatom("lilac.core/*custom-methods") ?? defatom("lilac.core/*custom-methods", _$n__$M_());
var _$s_in_dev_$q_ = peekDefatom("lilac.core/*in-dev?") ?? defatom("lilac.core/*in-dev?", true);
var ok_result = _$n__$M_(kwd("ok?"), true);
var core_methods = _$n__$M_(kwd("boolean"), validate_boolean, kwd("string"), validate_string, kwd("nil"), validate_nil, kwd("fn"), validate_fn, kwd("keyword"), validate_keyword, kwd("symbol"), validate_symbol, kwd("number"), validate_number, kwd("record"), validate_record, kwd("map"), validate_map, kwd("list"), validate_list, kwd("set"), validate_set, kwd("not"), validate_not, kwd("or"), validate_or, kwd("and"), validate_and, kwd("custom"), validate_custom, kwd("component"), validate_component, kwd("is"), validate_is, kwd("optional"), validate_optional, kwd("tuple"), validate_tuple, kwd("any"), validate_any, kwd("enum"), validate_enum, kwd("pick-type"), validate_pick_type);

// server-out/skir.core.js
var $http = __toModule(require("http"));

// server-out/skir.util.js
function key__GT_str(v) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (keyword_$q_(v)) {
    return turn_string(v);
  } else if (string_$q_(v)) {
    return v;
  } else if (list_$q_(v)) {
    return pr_str(v);
  } else if (map_$q_(v)) {
    return pr_str(v);
  } else if (true) {
    return _$n_str_$o_concat(v, "");
  } else {
    return null;
  }
}
function promise_$q_(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return _$e_(x, invoke_method("resolve")(Promise, x));
}

// server-out/skir.core.js
function req__GT_edn(req) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return _$n__$M_(kwd("method"), function __fn__() {
    let v__10 = req.method;
    if (_$n__$e_(v__10, "GET")) {
      return kwd("get");
    } else if (_$n__$e_(v__10, "HEAD")) {
      return kwd("head");
    } else if (_$n__$e_(v__10, "POST")) {
      return kwd("post");
    } else if (_$n__$e_(v__10, "PUT")) {
      return kwd("put");
    } else if (_$n__$e_(v__10, "DELETE")) {
      return kwd("delete");
    } else if (_$n__$e_(v__10, "CONNECT")) {
      return kwd("connect");
    } else if (_$n__$e_(v__10, "OPTIONS")) {
      return kwd("options");
    } else if (_$n__$e_(v__10, "TRACE")) {
      return kwd("trace");
    } else if (_$n__$e_(v__10, "PATCH")) {
      return kwd("patch");
    } else {
      return req.method;
    }
  }(), kwd("url"), req.url, kwd("headers"), to_calcit_data(req.headers), kwd("body"), null, kwd("original-request"), req);
}
function write_response_$x_(res, edn_res) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  deref(_$s_in_dev_$q_) ? function __fn__() {
    let result__11 = validate_lilac(edn_res, lilac_response);
    if (not(get(result__11, kwd("ok?")))) {
      console.log(printable(get(result__11, kwd("formatted-message")), "\n", _$n_str_$o_concat("(dev-check ", _$n_str_$o_concat(new CalcitSymbol("edn-res"), _$n_str_$o_concat(" ", _$n_str_$o_concat(new CalcitSymbol("lilac-response"), _$n_str_$o_concat("), where props is: ", _$n_str_$o_concat(edn_res, ""))))))));
    } else {
      return null;
    }
  }() : null;
  res.statusCode = get(edn_res, kwd("code"));
  res.statusMessage = get(edn_res, kwd("message"));
  foldl(get(edn_res, kwd("headers")), null, function doseq_fn_PCT_(_acc, pair) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    let v__60 = pair;
    let k = _$n_list_$o_nth(v__60, 0);
    let v = _$n_list_$o_nth(v__60, 1);
    return res.setHeader(key__GT_str(k), key__GT_str(v));
  });
  return res.end(function __fn__() {
    let body2 = get(edn_res, kwd("body"));
    if (list_$q_(body2)) {
      return format_cirru_edn(body2);
    } else if (map_$q_(body2)) {
      return format_cirru_edn(body2);
    } else if (nil_$q_(body2)) {
      return "";
    } else if (string_$q_(body2)) {
      return body2;
    } else if (Array.isArray(body2)) {
      return JSON.stringify(body2);
    } else if (true) {
      return JSON.stringify(body2);
    } else {
      return null;
    }
  }());
}
function handle_request_$x_(req, res, handler) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  try {
    let edn_req = req__GT_edn(req);
    let response = handler(edn_req, res);
    if (map_$q_(response)) {
      return write_response_$x_(res, response);
    } else if (fn_$q_(response)) {
      return response(function f_PCT_2(response_data) {
        if (arguments.length !== 1)
          throw new Error("argument sizes do not match");
        return write_response_$x_(res, response_data);
      });
    } else if (promise_$q_(response)) {
      return invoke_method("then")(response, function f_PCT_2(result) {
        if (arguments.length !== 1)
          throw new Error("argument sizes do not match");
        return write_response_$x_(res, result);
      });
    } else if (_$e_(response, kwd("effect"))) {
      return null;
    } else if (true) {
      console.log(printable("Response:", response));
      let err_AUTO_1 = new Error("Unknown response!");
      err_AUTO_1.data = null;
      throw err_AUTO_1;
    } else {
      return null;
    }
  } catch (errMsg_AUTO_2) {
    return function f_PCT_2(err) {
      if (arguments.length !== 1)
        throw new Error("argument sizes do not match");
      console.error(err);
      res.statusCode = 500;
      res.statusMessage = "Server Error";
      return res.end(_$n_str_$o_concat(pr_str(err), _$n_str_$o_concat("\n", _$n_str_$o_concat("\n", _$n_str_$o_concat(err.stack, "")))));
    }(errMsg_AUTO_2.toString());
  }
}
function create_server_$x_(handler, user_options) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  if (arguments.length > 2)
    throw new Error("too many arguments");
  reset_$x_(_$s_req_handler, handler);
  let options = merge(default_options, user_options);
  let server = $http.createServer(function f_PCT_2(req, res) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    return handle_request_$x_(req, res, deref(_$s_req_handler));
  });
  return server.listen(get(options, kwd("port")), get(options, kwd("host")), function f_PCT_2() {
    if (arguments.length !== 0)
      throw new Error("argument sizes do not match");
    return get(options, kwd("after-start"))(options);
  });
}
var _$s_req_handler = peekDefatom("skir.core/*req-handler") ?? defatom("skir.core/*req-handler", null);
var default_options = _$n__$M_(kwd("port"), 4e3, kwd("after-start"), function f_PCT_(options) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  console.log(printable(_$n_str_$o_concat("Server listening on ", _$n_str_$o_concat(get(options, kwd("port")), ""))));
}, kwd("host"), "0.0.0.0");
var lilac_response = record_ADD_(_$n__$M_(kwd("code"), number_ADD_(), kwd("message"), optional_ADD_(string_ADD_()), kwd("headers"), optional_ADD_(map_ADD_(or_ADD_(_$L_(keyword_ADD_(), string_ADD_())), or_ADD_(_$L_(keyword_ADD_(), string_ADD_(), boolean_ADD_(), nil_ADD_())))), kwd("body"), any_ADD_()), _$n__$M_(kwd("check-keys?"), true));

// server-out/app.server.js
async function check_version_$x_() {
  if (arguments.length !== 0)
    throw new Error("argument sizes do not match");
  let pkg = invoke_method("parse")(JSON, $fs.readFileSync($path.join(__dirname, "../package.json")));
  let version = pkg.version;
  let npm_version = await (0, import_latest_version.default)(pkg.name);
  if (_$e_(npm_version, version)) {
    console.log(printable("Running latest version", version));
  } else {
    console.log(printable($chalk.yellow(_$n_str_$o_concat("New version ", _$n_str_$o_concat(npm_version, _$n_str_$o_concat(" available, current one is ", _$n_str_$o_concat(version, _$n_str_$o_concat(" . Please upgrade!", _$n_str_$o_concat("\n\nyarn global add file-sucker\n", "")))))))));
  }
}
async function load_stats_$x_(xs) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  let tasks = js_array();
  foldl(xs, null, function doseq_fn_PCT_(_acc, x) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    return tasks.push(new Promise(function f_PCT_2(resolve, reject) {
      if (arguments.length !== 2)
        throw new Error("argument sizes do not match");
      return $fs.stat(x, function f_PCT_3(err, stat2) {
        if (arguments.length !== 2)
          throw new Error("argument sizes do not match");
        return resolve(_$n__$M_(kwd("name"), x, kwd("size"), stat2.size, kwd("created-time"), stat2.ctime));
      });
    }));
  });
  return Promise.all(tasks);
}
function on_download_$x_(req, res) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  req.url = invoke_method("replace")(req.url, "/files/", "/");
  console.log(printable("url", req.url));
  serve_files_$x_(req, res, (0, import_finalhandler.default)(req, res));
  return kwd("effect");
}
function turn_list(arr) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return function f_PCT_2(xs, as) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    let ret_AUTO_2 = null;
    let times_AUTO_3 = 0;
    while (true) {
      if (times_AUTO_3 > 1e5)
        throw new Error("tail recursion not stopping");
      if (_$e_(0, as.length)) {
        ret_AUTO_2 = xs;
      } else {
        ret_AUTO_2 = recur(conj(xs, as[0]), as.slice(1));
      }
      if (ret_AUTO_2 instanceof CalcitRecur) {
        if (ret_AUTO_2.args.length !== 2)
          throw new Error("argument sizes do not match");
        [xs, as] = ret_AUTO_2.args;
        times_AUTO_3 += 1;
        continue;
      } else {
        return ret_AUTO_2;
      }
    }
  }(_$L_(), arr);
}
async function on_file_indexed_$x_(req, res) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  let filenames = filter(to_calcit_data($fs.readdirSync(".")), function f_PCT_2(filename) {
    if (arguments.length !== 1)
      throw new Error("argument sizes do not match");
    return invoke_method("isFile")($fs.lstatSync(filename));
  });
  let files_info = await load_stats_$x_(filenames);
  let result = make_string(html(_$n__$M_(), head(_$n__$M_(), create_element(kwd("meta"), _$n__$M_(kwd("content"), "width=device-width, initial-scale=1, maximum-scale=1.0, user-scalable=no", kwd("name"), "viewport")), create_element(kwd("meta"), _$n__$M_(kwd("charset"), "utf8")), link(_$n__$M_(kwd("rel"), "stylesheet", kwd("href"), "http://cdn.tiye.me/favored-fonts/josefin-sans.css"))), body(_$n__$M_(), div(_$n__$M_(), empty_$q_(filenames) ? div(_$n__$M_(kwd("style"), merge(center, _$n__$M_(kwd("padding"), 80))), _LT__GT_("No files", _$n__$M_(kwd("font-family"), font_fancy, kwd("color"), hsl(0, 0, 80), kwd("font-size"), 40, kwd("font-weight"), 300))) : null, list__GT_(_$n__$M_(kwd("style"), _$n__$M_(kwd("padding"), "24px 8px")), map_indexed(invoke_method("sort-by")(turn_list(files_info), function f_PCT_2(x) {
    if (arguments.length !== 1)
      throw new Error("argument sizes do not match");
    return negate(get(x, kwd("created-time")));
  }), function f_PCT_2(idx, file) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    return _$L_(idx, div(_$n__$M_(kwd("style"), merge(row, _$n__$M_(kwd("line-height"), "40px"))), a(_$n__$M_(kwd("href"), _$n_str_$o_concat("/files/", _$n_str_$o_concat(get(file, kwd("name")), "")), kwd("inner-text"), get(file, kwd("name")), kwd("style"), _$n__$M_(kwd("text-decoration"), kwd("none"), kwd("font-family"), font_fancy, kwd("font-size"), 16, kwd("max-width"), "50vw", kwd("overflow"), kwd("hidden"), kwd("text-overflow"), kwd("ellipsis")))), _$e__LT_(16, null), _LT__GT_((0, import_prettysize.default)(get(file, kwd("size"))), _$n__$M_(kwd("font-family"), font_fancy, kwd("color"), hsl(0, 0, 70), kwd("font-size"), 12)), _$e__LT_(16, null), _LT__GT_(invoke_method("format")((0, import_dayjs.default)(get(file, kwd("created-time"))), "MM-DD HH:mm"), _$n__$M_(kwd("font-family"), font_fancy, kwd("color"), hsl(0, 0, 70), kwd("font-size"), 12))));
  }))))));
  return _$n__$M_(kwd("code"), 200, kwd("headers"), _$n__$M_("Content-Type", "text/html"), kwd("body"), result);
}
function on_page_$x_(req, res) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  serve(req, res, (0, import_finalhandler.default)(req, res));
  return kwd("effect");
}
function on_upload_$x_(req, res) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  res.setHeader("Access-Control-Allow-Origin", req.headers.origin);
  res.setHeader("Access-Control-Allow-Methods", "POST,GET,OPTIONS");
  let v__61 = req.method;
  if (_$n__$e_(v__61, "POST")) {
    return function f_PCT_2(send_$x_) {
      if (arguments.length !== 1)
        throw new Error("argument sizes do not match");
      let form = new $formidable.IncomingForm();
      let size_limit = _$s_(4, 1024, 1024, 1024);
      console.log(printable("New request of file transferring..."));
      form.maxFieldsSize = size_limit;
      form.maxFileSize = size_limit;
      return form.parse(req, function f_PCT_3(error, fields, files) {
        if (arguments.length !== 3)
          throw new Error("argument sizes do not match");
        some_$q_(error) ? function __fn__() {
          let err_AUTO_4 = new Error(error);
          err_AUTO_4.data = null;
          throw err_AUTO_4;
        }() : null;
        let file = files.file;
        console.log(printable("Received file:", file.name));
        return $fs.rename(file.path, $path.join(process.env.PWD, file.name), function f_PCT_4(rename_error) {
          if (arguments.length !== 1)
            throw new Error("argument sizes do not match");
          some_$q_(rename_error) ? function __fn__() {
            let err_AUTO_5 = new Error(rename_error);
            err_AUTO_5.data = null;
            throw err_AUTO_5;
          }() : null;
          return send_$x_(_$n__$M_(kwd("code"), 200, kwd("headers"), _$n__$M_(), kwd("message"), "Uploaded"));
        });
      });
    };
  } else if (_$n__$e_(v__61, "GET")) {
    return _$n__$M_(kwd("code"), 200, kwd("body"), "use POST");
  } else if (_$n__$e_(v__61, "OPTIONS")) {
    return _$n__$M_(kwd("code"), 200, kwd("body"), "ok");
  } else {
    return _$n__$M_(kwd("code"), 404, kwd("body"), "method not supported");
  }
}
function on_request_$x_(req_edn, res) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  let req = get(req_edn, kwd("original-request"));
  if (_$e_("/upload", req.url)) {
    return on_upload_$x_(req, res);
  } else if (function __fn__() {
    let v1__62 = _$e_(req.url, "/files");
    if (nil_$q_(v1__62)) {
      return _$e_(req.url, "/files/");
    } else if (_$e_(false, v1__62)) {
      return _$e_(req.url, "/files/");
    } else {
      return v1__62;
    }
  }()) {
    return on_file_indexed_$x_(req, res);
  } else if (invoke_method("starts-with?")(req.url, "/files/")) {
    return on_download_$x_(req, res);
  } else if (true) {
    return on_page_$x_(req, res);
  } else {
    return null;
  }
}
function main_$x_() {
  if (arguments.length !== 0)
    throw new Error("argument sizes do not match");
  let port = function __fn__() {
    let v1__7 = process.env.PORT;
    if (nil_$q_(v1__7)) {
      let v1__8 = process.env.port;
      if (nil_$q_(v1__8)) {
        return 4e3;
      } else if (_$e_(false, v1__8)) {
        return 4e3;
      } else {
        return v1__8;
      }
    } else if (_$e_(false, v1__7)) {
      let v1__9 = process.env.port;
      if (nil_$q_(v1__9)) {
        return 4e3;
      } else if (_$e_(false, v1__9)) {
        return 4e3;
      } else {
        return v1__9;
      }
    } else {
      return v1__7;
    }
  }();
  return create_server_$x_(function f_PCT_2(_PCT_, _PCT_2) {
    if (arguments.length < 0)
      throw new Error("too few arguments");
    if (arguments.length > 2)
      throw new Error("too many arguments");
    return on_request_$x_(_PCT_, _PCT_2);
  }, _$n__$M_(kwd("port"), port, kwd("after-start"), function f_PCT_2(options) {
    if (arguments.length !== 1)
      throw new Error("argument sizes do not match");
    let address2 = _$n_str_$o_concat("\n", _$n_str_$o_concat("http://", _$n_str_$o_concat($ip.address(), _$n_str_$o_concat(":", _$n_str_$o_concat(port, _$n_str_$o_concat("\n", ""))))));
    console.log(printable("Open page on your phone and send file:", "\n", address2));
    $qrcode.generate(address2, _$n_js_object(kwd("small"), true), console.log);
    return check_version_$x_();
  }));
}
var serve_files_$x_ = (0, import_serve_static.default)(process.env.PWD, _$n_js_object("index", js_array()));
var serve = (0, import_serve_static.default)($path.join(__dirname, "../dist"), _$n_js_object("index", js_array("index.html")));

// server.js
var import_meta = {};
main_$x_();
if (import_meta.hot) {
  import_meta.hot.accept("./server-out/app.server.js", (main) => {
    main.reload_$x_();
  });
}
/*!
 * @description Recursive object extending
 * @author Viacheslav Lotsmanov <lotsmanov89@gmail.com>
 * @license MIT
 *
 * The MIT License (MIT)
 *
 * Copyright (c) 2013-2018 Viacheslav Lotsmanov
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to
 * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
 * the Software, and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
 * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
 * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
/*!
 * depd
 * Copyright(c) 2014 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * depd
 * Copyright(c) 2014-2015 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * depd
 * Copyright(c) 2014-2017 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * depd
 * Copyright(c) 2015 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * destroy
 * Copyright(c) 2014 Jonathan Ong
 * MIT Licensed
 */
/*!
 * ee-first
 * Copyright(c) 2014 Jonathan Ong
 * MIT Licensed
 */
/*!
 * encodeurl
 * Copyright(c) 2016 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * escape-html
 * Copyright(c) 2012-2013 TJ Holowaychuk
 * Copyright(c) 2015 Andreas Lubbe
 * Copyright(c) 2015 Tiancheng "Timothy" Gu
 * MIT Licensed
 */
/*!
 * etag
 * Copyright(c) 2014-2016 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * finalhandler
 * Copyright(c) 2014-2017 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * fresh
 * Copyright(c) 2012 TJ Holowaychuk
 * Copyright(c) 2016-2017 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * http-errors
 * Copyright(c) 2014 Jonathan Ong
 * Copyright(c) 2016 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * on-finished
 * Copyright(c) 2013 Jonathan Ong
 * Copyright(c) 2014 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * parseurl
 * Copyright(c) 2014 Jonathan Ong
 * Copyright(c) 2014-2017 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * range-parser
 * Copyright(c) 2012-2014 TJ Holowaychuk
 * Copyright(c) 2015-2016 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * send
 * Copyright(c) 2012 TJ Holowaychuk
 * Copyright(c) 2014-2016 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * serve-static
 * Copyright(c) 2010 Sencha Inc.
 * Copyright(c) 2011 TJ Holowaychuk
 * Copyright(c) 2014-2016 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * statuses
 * Copyright(c) 2014 Jonathan Ong
 * Copyright(c) 2016 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * toidentifier
 * Copyright(c) 2016 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * unpipe
 * Copyright(c) 2015 Douglas Christopher Wilson
 * MIT Licensed
 */
